unit ZLEKontrolaRealizacjiRecznaIlosciowaSelectFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLEKontrolaRealizacjiRecznaSelectFormUnit, Menus, UNIComponentsUnit,
  StdCtrls, ToolWin, ComCtrls, ExtCtrls, UNIDBConstComboBoxUnit, Mask;

type
  TZLEKontrolaRealizacjiRecznaIlosciowaSelectForm = class(TZLEKontrolaRealizacjiRecznaSelectForm)
  private
    { Private declarations }
  protected
    procedure WczytajSkladnikiKontroli(oSkladniki, oWartosci: TConstStringList); override;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;
  
{ TZLEKontrolaRealizacjiRecznaIlosciowaSelectForm }

procedure TZLEKontrolaRealizacjiRecznaIlosciowaSelectForm.WczytajSkladnikiKontroli(
  oSkladniki, oWartosci: TConstStringList);
var oQuery: TUNIQuery;
begin
  oQuery := nil;

  try
    oQuery := ZLEDM.ZLEOdpytajODane( sZLEIL,
                                     sZLEALIAS_IL_SKLADIL_ID+';'+
                                     sZLEALIAS_SKLADIL_NAZWA+';'+
                                     sZLEALIAS_IL_ILOSC,
                                     '(@'+sZLEALIAS_IL_OKRES_ID+'='+Parameters.Values[sUNIOKRES_ID]+')and'+
                                     '(@'+sZLEALIAS_IL_ZLECENIEPOZ_ID+'='+Parameters.Values[sZLEZLECENIEPOZ_ID]+')and'+
                                     '(@'+sZLEALIAS_SKLADIL_RODZAJ+'='+QuotedStr(cZLERodzajSklad_RecznyID)+')',
                                     false );
    if oQuery <> nil then with oQuery do begin
      while not Eof do begin
        oSkladniki.Add( FieldByName(sZLESKLADIL_NAZWA).AsString,
                        FieldByName(sZLESKLADIL_ID).AsString );
        if not FieldByName(sZLEIL_ILOSC).IsNull then
          oWartosci.Add( FieldByName(sZLEIL_ILOSC).AsString,
                         FieldByName(sZLESKLADIL_ID).AsString );
        Next;
      end;
    end;
  finally
    if oQuery <> nil then oQuery.Free;
  end;
  inherited;
end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiRecznaIlosciowaSelectForm,
                            'Edycja skadnika ilociowego dla realizacji',
                            sZLEModulID );
end.
