unit ZLEParametrySelectFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNISelectFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  QueryBuilderUnit, UNIDataModuleUnit, DBTables, UNIExtDataModuleUnit,
  ExtCtrls, Mask, DB, UNIDBConstComboBoxUnit, CheckLst, UNIFormUnit, KeyManagerUnit,
  UNIGodzEdit, ZLEParserUnit, UNISimpleEditorUnit;



type
  TZLEParametrySelectForm = class(TUNISelectForm)
    MainPageControl: TUNIPageControl;
    OgolneTabSheet: TTabSheet;
    OgolnePanel: TUNIPanel;
    FunkcjeListyTabSheet: TTabSheet;
    FunkcjeListyPanel: TUNIPanel;
    PozycjeCheckBox: TUNICheckBox;
    KontrolaKosztowCheckBox: TUNICheckBox;
    KontrolaIlosciCheckBox: TUNICheckBox;
    KosztyMaterialoweCheckBox: TUNICheckBox;
    KosztyRobociznyCheckBox: TUNICheckBox;
    WystawioneFakturyCheckBox: TUNICheckBox;
    RozliczenieZasobowCheckBox: TUNICheckBox;
    ZasobyCheckBox: TUNICheckBox;
    DanePlSheet: TTabSheet;
    DanePlPanel: TUNIPanel;
    GlownePanel: TUNIPanel;
    DomyslnyStatusLabel: TUNILabel;
    DomyslnyStatusComboBox: TUNIComboBox;
    UNILabel1: TUNILabel;
    TypZleceniaLookupAliasEdit: TUNILookupAliasEdit;
    WymaganaOsobaZatwierdzajacaCheckBox: TUNICheckBox;
    ASORegLabel: TUNILabel;
    ASORegComboBox: TUNIComboBox;
    EwidencjaZuzPaliwaCheckBox: TUNICheckBox;
    RenumeracjaPozycjiCheckBox: TUNICheckBox;
    OddzialPanel: TUNIPanel;
    OddzialGroupBox: TUNIGroupBox;
    OddzialLabel: TUNILabel;
    OddzialLookupAliasEdit: TUNILookupAliasEdit;
    WymaganyOddzialCheckBox: TUNICheckBox;
    WystawioneFakturyZakupuCheckBox: TUNICheckBox;
    UzytkownikaLookupAliasEdit: TUNILookupAliasEdit;
    LNumerator2Label: TUNILabel;
    OgraniczonaListeZasobowCheckBox: TUNICheckBox;
    WspolneZleceniaCheckBox: TUNICheckBox;
    FormatGodzinLiczbaCheckBox: TUNICheckBox;
    WylaczonyFiltrCheckBox: TUNICheckBox;
    KryteriaTabSheet: TTabSheet;
    KryteriaPanel: TUNIPanel;
    InstalacjeTypLabel: TUNILabel;
    WycenaPracyZasobowCheckBox: TUNICheckBox;
    WymaganaPozycjaEwidCheckBox: TUNICheckBox;
    ZamkniecieKontCheckBox: TUNICheckBox;
    KosztyZakupuCheckBox: TUNICheckBox;
    KosztyKDECPCheckBox: TUNICheckBox;
    SkladnikiECPTabSheet: TTabSheet;
    SkladnikiECPPanel: TUNIPanel;
    RozliczAktStawkaCheckBox: TUNICheckBox;
    KopiujZlecenieBezPozycjiCheckBox: TUNICheckBox;
    ZLEAktywnePrzyciskiCheckBox: TUNICheckBox;
    KontrolaUprawnienCheckBox: TUNICheckBox;
    SrodkiTrwaleCheckBox: TUNICheckBox;
    OgolneCDTabSheet: TTabSheet;
    OgolneCDPanel: TUNIPanel;
    PoziomNarzutowGroupBox: TUNIGroupBox;
    PoziomJednOrgCheckBox: TUNICheckBox;
    PoziomTypZlecCheckBox: TUNICheckBox;
    PoziomOddzialCheckBox: TUNICheckBox;
    NarzutyCheckBox: TUNICheckBox;
    AutoPrzeliczanieGroupBox: TUNIGroupBox;
    GodzinaLabel: TUNILabel;
    UNILabel7: TUNILabel;
    WlaczoneCheckBox: TUNICheckBox;
    PrzeliczanieGodzEdit: TUNIGodzEdit;
    OkresLookupAliasEdit: TUNILookupAliasEdit;
    NumeratorExtGroupBox: TUNIGroupBox;
    DomyslnyPrefixLabel: TUNILabel;
    NumeratorExtCheckBox: TUNICheckBox;
    PrefixComboBox: TUNIComboBox;
    OsobnaNumCheckBox: TUNICheckBox;
    WymaganaStawkaZasobuCheckBox: TUNICheckBox;
    ZleceniaNadrzedneCheckBox: TUNICheckBox;
    GrupowanieDanychCheckBox: TUNICheckBox;
    WydrukZleceniaCheckBox: TUNICheckBox;
    SprawyPanel: TUNIPanel;
    SprawyGroupBox: TUNIGroupBox;
    SprawaKontrahentLabel: TUNILabel;
    WydzialLabel: TUNILabel;
    SprawaPrefixLabel: TUNILabel;
    PodpowiadanieSprawyCheckBox: TUNICheckBox;
    NazwaParametruPanel: TUNIPanel;
    PolePanel: TUNIPanel;
    KontrahentEdit: TUNIEdit;
    WydzialEdit: TUNIEdit;
    PrefixEdit: TUNIEdit;
    RegulaStawkaPanel: TUNIPanel;
    TrescLabel: TUNILabel;
    TransportCheckBox: TUNICheckBox;
    KosztyMatZakupCheckBox: TUNICheckBox;
    ECPPracownicyWieleFirmCheckBox: TUNICheckBox;
    UnikalnoscElemInfCheckBox: TUNICheckBox;
    DopiszKosztyZakupuCheckBox: TUNICheckBox;
    ZleceniaPodrzedneCheckBox: TUNICheckBox;
    ZlecTworzZapotrzCheckBox: TUNICheckBox;
    InstalacjeTypZlecLookupAliasEdit: TUNILookupAliasEdit;
    UproszczonySlownikZlecenCheckBox: TUNICheckBox;
    MaskaSymboluCheckBox: TUNICheckBox;
    MaskaSymboluEdit: TUNIEdit;
    BlokadaEdycjiZakonczCheckBox: TUNICheckBox;
    BlokadaZmianySymboluCheckBox: TUNICheckBox;
    ReczneWprowadzanieSymboluCheckBox: TUNICheckBox;
    WlaczonaKomunikacjaECPCheckBox: TUNICheckBox;
    RozliczanieAkorduECPCheckBox: TUNICheckBox;
    WlaczonaKomunikacjaRozliczECPCheckBox: TUNICheckBox;
    UwzglednijBlokadeKDECPCheckBox: TUNICheckBox;
    SkladnikCzasuLabel: TUNILabel;
    SkladnikCzasuPracyLookupAliasEdit: TUNILookupAliasEdit;
    StanowiskoLabel: TUNILabel;
    StanowiskoLookupAliasEdit: TUNILookupAliasEdit;
    ZlecenieBezPozycjiZeSprawCheckBox: TUNICheckBox;
    procedure SelectButtonClick(Sender: TObject);
    procedure TypZleceniaLookupAliasEditButtonClick(Sender: TObject);
    procedure TypZleceniaLookupAliasEditDelKey(Sender: TObject);
    function  TypZleceniaLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure OddzialLookupAliasEditButtonClick(Sender: TObject);
    procedure OddzialLookupAliasEditDelKey(Sender: TObject);
    function  OddzialLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure WlaczoneCheckBoxClick(Sender: TObject);
    procedure UzytkownikaLookupAliasEditButtonClick(Sender: TObject);
    function  UzytkownikaLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure UzytkownikaLookupAliasEditDelKey(Sender: TObject);
    procedure FormatGodzinLiczbaCheckBoxClick(Sender: TObject);
    procedure InstalacjeTypZlecLookupAliasEditButtonClick(Sender: TObject);
    procedure InstalacjeTypZlecLookupAliasEditDelKey(Sender: TObject);
    function  InstalacjeTypZlecLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure NumeratorExtCheckBoxClick(Sender: TObject);
    procedure PodpowiadanieSprawyCheckBoxClick(Sender: TObject);
    procedure NarzutyCheckBoxClick(Sender: TObject);
    procedure OkresLookupAliasEditButtonClick(Sender: TObject);
    function OkresLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure OkresLookupAliasEditDelKey(Sender: TObject);
    procedure SkladnikCzasuPracyLookupAliasEditButtonClick(
      Sender: TObject);
    procedure SkladnikCzasuPracyLookupAliasEditDelKey(Sender: TObject);
    function SkladnikCzasuPracyLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure WlaczonaKomunikacjaECPCheckBoxClick(Sender: TObject);
    procedure WlaczonaKomunikacjaRozliczECPCheckBoxClick(Sender: TObject);
    procedure BlokadaZmianySymboluCheckBoxClick(Sender: TObject);
    procedure UwzglednijBlokadeKDECPCheckBoxClick(Sender: TObject);
    procedure MaskaSymboluEditKeyPress(Sender: TObject; var Key: Char);
    procedure MaskaSymboluCheckBoxClick(Sender: TObject);
    procedure KosztyMaterialoweCheckBoxClick(Sender: TObject);
    procedure KosztyZakupuCheckBoxClick(Sender: TObject);
    procedure StanowiskoLookupAliasEditButtonClick(Sender: TObject);
    procedure StanowiskoLookupAliasEditDelKey(Sender: TObject);
    function StanowiskoLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure RozliczanieAkorduECPCheckBoxClick(Sender: TObject);
  private
    iTypZleceniaId: Integer;
    iPrzeliczOkresID: Integer;
    iInstalacjeTypZlecId:Integer;
    iDomyslnyOddzialID: Integer;
    cslAsoReg: TConstStringList;
    bFormatLiczbowy: Boolean;
    bPrzelicz: Boolean;
    NumUzytID: Integer;
    bIstniejaNarzuty: Boolean;
    bIstniejaStanowiska: Boolean;
    iPanelPlIndex, iPanelECPIndex: Integer;
    iSkladnikCzasuPracyID: Integer;
    iMnemonikStanowiskoID: Integer;

    FParser:         TZLEParser;
    FRichEdit:        TUNISimpleEditorRichEdit;
    FParamKindList:   TUniStringList;
    FParamValuesList: TUNIStringList;
    FOperationList{, FCritertionList, FFunctionList}: TUNIStringList;
    //FOstatniaSyntetyka, sZnakiOld: string;
    Pozycja : Integer;

    procedure GetLastWord(var sText, sFirstWord: String);
    //function GetMnemonikValuesList( sText: String ): TUNIQuery;
    function GetList( sFunctionName, sKind, sText: String;
                      const cSeparator: Char): TUNIStringList;

    function  GetFunctionsList(const oCurrFunction: TUNIFunction;
                               var   sWholeCurrParam: string;
                               var   sCurrWord: string;
                               const sPrevWord: string;
                               const cSeparator: char;
                               var   sWordToInsert: string;
                               bShowList: boolean): TUNIStringList;
    procedure GetAdditionalHint(const oCurrFunction: TUNIFunction;
                                const sWholeCurrParam: string;
                                var sAdditionalHint: string);
    function  GetCurrWordHint (const asCurrWord: string;
                               const aiCurrWordPos: integer;
                               const aiCurrWordLen: integer): string;

    procedure CreateFunctionList;
    procedure CreateParamKindList;
    procedure RichEventOnEnter(oSender: TObject);
    procedure RichEventOnExit(oSender: TObject);
    procedure RichEditChange(Sender: TObject);
    function  CheckRegula( bBezKomentarzy: Boolean = false): Boolean;
    function  PoprawnaDlugosc(sMaska: String):Boolean;
    procedure Refresh;

    procedure StworzListy;
    procedure UsunListy;

    procedure InitializeControls();
    //procedure InitializeObjectFields(); virtual;
    //procedure SetDefaults(); virtual;
    procedure GetParams();
    procedure SetParams();
  protected
    procedure UstawWlasciwosci;
    procedure InternalOpen; override;
    //procedure SelectButtonPressed; override;
    //function  Validate(): Boolean; override;
    procedure GetPositionAndParentForContainedForm( const nr:integer ; var APosition: TRect ; var AParent: TWinControl ; var AAlign:TAlign); override;
  public
    FRegula: string;
    procedure UstawRegule(sRegula: string);
    procedure BeforeShow; override;
    destructor Destroy; override;
    property Regula : string read FRegula write UstawRegule;
    function Validate(): Boolean; override;
    property PanelPlIndex: Integer  read iPanelPlIndex;
    property PanelECPIndex: Integer read iPanelECPIndex;
  end;

implementation

{$R *.DFM}

uses
  Variants,
  FormManagerUnit,
  UNIMainFormUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  UniDataManagerUnit,
  UniSysDataManagerUnit,
  contnrs,
  Dodatki,
  SecurityManagerUnit,
  SystemDefUnit,
  ASODefUnit,
  FKDefUnit,
  BOKDefUnit,
  KDECPDefUnit,
  PLLIDefUnit,
  SQLManagerUnit,
  UNIStaleUnit,
  DBClient,
  UNIDBGridFormUnit,
  INFDefUnit,
  STDefUnit,
  WODDefUnit,
  LWPDefUnit,
  ZaDefUnit,
  TSDefUnit,
  MAGDefUnit,
  MFZDefUnit,
  MFSDefUnit,
  KDPRADefUnit,
  KDPRADataManagerExtUnit,
  KDDefUnit,
  KDDataManagerExtUnit,
  ZLEParametryTreeFormUnit,
  UNISysDefUnit,
  ZAODefUnit;

{ TZLEParametrySelectForm }

procedure TZLEParametrySelectForm.Refresh;
begin
  MaskaSymboluEdit.Enabled:=MaskaSymboluCheckBox.Checked;
end;

function TZLEParametrySelectForm.CheckRegula;
var s: String;
begin
  result := false;
  if FParser.ScriptCheck('Test', FRichEdit.Lines, False) = 0 then begin
    s := '';
    case VarType(FParser.ResultOfScript) of
      varSmallint, varInteger: s := IntToStr(FParser.ResultOfScript);
      varSingle, varDouble, varCurrency: s := FloatToStr(FParser.ResultOfScript);
      varDate: s := DateToStr(FParser.ResultOfScript);
      varBoolean: if FParser.ResultOfScript = True then s := 'TRUE' else s := 'FALSE';
      varString: s := FParser.ResultOfScript;
    end;
    result := true;
    if not bBezKomentarzy then Komunikat(cInformation, 'Regua jest poprawna: ' + s);
  end else begin
    FRichEdit.SetFocus;
    FRichEdit.SelStart := FParser.Errors[FParser.Errors.Count - 1].Position;
    FRichEdit.SelLength := FParser.Errors[FParser.Errors.Count - 1].Size;
    Komunikat(
      cWarning,
      'Linia: ' + IntToStr(FParser.Errors[FParser.Errors.Count - 1].Line) + '. ' +
      'Kolumna: ' + IntToStr(FParser.Errors[FParser.Errors.Count - 1].Column) + '. ' +
      FParser.Errors[FParser.Errors.Count - 1].ErrorMessage
    );
  end;
end;

function TZLEParametrySelectForm.Validate: Boolean;
begin
  result := inherited Validate();

  if not result then Exit;

  if (FRegula <> '') and (not CheckRegula(true)) then begin
      result := false;
      exit;
  end;

  {if NumeratorExtCheckBox.Checked and (PrefixComboBox.ItemIndex = -1) then begin
     result := False;
     if PrefixComboBox.Enabled then
        PrefixComboBox.SetFocus;

     Exit;
  end;}
end;

function TZLEParametrySelectForm.GetList( sFunctionName, sKind, sText: String;
                                                   const cSeparator: Char): TUNIStringList;
var oQuery: TUNIQuery;
    i: Integer;
    bReplaceMinus: Boolean;
    sFirstWord: String;
    //sSQL, sWhere: String;
begin
  result := nil;
  oQuery := nil;
  bReplaceMinus := False;

  try
    if sKind = 'OKRESOBR' then begin
      oQuery := UniSysDataManager.UNIOdpytajODane( sUNIOKRES, sUNISYSALIAS_Okres_Obrachunkowy_Numer,//'',
                                                   '@'+sUNISYSALIAS_Okres_Obrachunkowy_Rok_ID+' = '+IntToStr(vAktywnyRokObrachunkowyID),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'MIESIAC' then begin
      FParamValuesList.Clear;
      for i := 1 to 12 do FParamValuesList.Add(IntToStr(i));
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'WGJEDN' then begin
      FParamValuesList.Clear;
      FParamValuesList.Add('TAK');
      FParamValuesList.Add('NIE');
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'COFNIJOKRES' then begin
      FParamValuesList.Clear;
      FParamValuesList.Add('0');
      FParamValuesList.Add('1');
      FParamValuesList.Add('2');
      FParamValuesList.Add('3');
      FParamValuesList.Add('4');
      FParamValuesList.Add('5');
      FParamValuesList.Add('6');
      FParamValuesList.Add('7');
      FParamValuesList.Add('8');
      FParamValuesList.Add('9');
      FParamValuesList.Add('10');
      FParamValuesList.Add('11');
      FParamValuesList.Add('11');
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'ZLECENIE' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ZLEDataManager.ZLEOdpytajODane( sZLEZLECENIE, sZLEALIAS_ZLECENIE_SYMBOL,
                                             '@'+sZLEALIAS_ZLECENIE_SYMBOL+' like '+QuotedStr(sText+'%'),
                                             false);
    end
    else if sKind = 'ROK' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIROK, sUNISYSALIAS_Rok_Rok,
                                                   '@'+sUNISYSALIAS_Rok_Rok+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if (sKind = 'POZROZDZ') then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
{      oQuery := ZLEDM.ZLEOdpytajODane( sZLEPLROZDEF, sZLEALIAS_PLROZDEF_SYMBOL,
                                       '(@'+sZLEALIAS_PLROZDEF_SYMBOL+' like '+QuotedStr(sText+'%')+')',
                                       false);}

      oQuery := SQLManager.CreateQuery('SELECT PLROZ.PLROZDEF_SYMBOL FROM ' +
                                        SQLManager.GetTableName(sPLROZDEF) + ' PLROZ, ' +
                                        SQLManager.GetTableName(sZLEPLROZDEF) + ' ZLEROZDEF '+
                                       'WHERE ZLEROZDEF.' + sPLROZDEF_ID + '= PLROZ.' + sPLROZDEF_ID + ' AND ' +
                                       '(PLROZ.' + sPLROZDEF_SYMBOL + ' LIKE '+QuotedStr(sText+'%')+')');
    end
    else if sKind = 'BRAK_PODPOWIEDZI' then Exit
    else begin
      Komunikat(cWarning,'Bdny parametr funkcji',MB_OK+MB_APPLMODAL);
      Exit;
    end;

    if oQuery = nil then Exit;
    FParamValuesList.Clear;
    oQuery.Open;
    while not oQuery.Eof do begin
      case bReplaceMinus of
        True: FParamValuesList.Add(StringReplace(oQuery.Fields[0].AsString,'-','',[rfReplaceAll]));
        False: FParamValuesList.Add(oQuery.Fields[0].AsString);
      end;
      oQuery.Next;
    end;
    if FParamValuesList.Count > 0 then result := FParamValuesList;
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

(***************
function TZLEParametrySelectForm.GetMnemonikValuesList(
  sText: String): TUNIQuery;
var oQuery: TUNIQuery;
    sMnemonik, sMnemonikId: String;
    sSQL, sWhere: String;
    sTableName: String;
    sPole, sIndeksPola: String;
    iIndeksPola: Integer;
begin
  result := nil;
  oQuery := nil;

  GetLastWord(sText,sMnemonik); // pobiera pierwsze i ostatnie sowo z listy postaci
                                 //[<string>,..,<string>]

  try
    oQuery := UNISysDataManager.UNIOdpytajODane( sFKMNEMONIKI, sFKAlias_Mnemoniki_Id,
                            '@'+sFKAlias_Mnemoniki_Mnemonik+' = '+QuotedStr(sMnemonik),
                            true, vAktywnaFirma);
    if (oQuery = nil)or(oQuery.RecordCount = 0)or(oQuery.Fields[0].AsString = '') then Exit;
    sMnemonikId := oQuery.Fields[0].AsString;
  finally
    if oQuery <> nil then oQuery.Free();
  end;
  if sMnemonik = sMnemonikKontaSyntetyczne then begin
    //sownik-niesownik syntetyk
    sWhere:='';
    if vWielofirmowosc and (vAktywnaFirma <> 0) and vPlanKontRozlaczny then begin
      sWhere := sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma);
    end;
    //przygotowanie treci zapytania
    if sWhere <> '' then sWhere := sWhere+' and ';
    sWhere := sWhere+sFKPLANKONT_SYMBOL+' like '+QuotedStr(sText+'%');
    sSQL:= SQLManager.GetSelectWithInnerJoins(sFKPLANKONT_SYMBOL,
                            [vFKPLANKONT], [''], [''], sWhere);
  end else begin
    //pozostae przypadki, czyli normalne sowniki
    sTableName:=SQLMAnager.OpenQueryWithResult(
             'select '+ sFKMNEMONIKI_TABELA+' from %s where '+
             sFKMNEMONIKI_ID+'='+sMnemonikId, [sFKMNEMONIKI]);

    if sTableName='' then Exit
    else begin
      // z ktorego pola w slowniku odczytac konto
      sIndeksPola:=SQLManager.OpenQueryWithResult(
               'select '+ sFKMNEMONIKI_INDEKS+' from %s where '+
               sFKMNEMONIKI_ID+'='+sMnemonikId, [sFKMNEMONIKI]);
      if sIndeksPola ='' then Exit
      else iIndeksPola:=StrToInt(sIndeksPola);
    end;

    if iIndeksPola=0 then sPole:='SYMBOL'
    else sPole:='POLE'+IntToStr(iIndeksPola);

    if (sTableName = sFKUZ) then begin
      sWhere:=sFKMNEMONIKI_ID+' = '+sMnemonikId
      //tu nie wystpuje UNIODDZIAL
    end else begin
      sWhere:='';
      if vWielofirmowosc and (vAktywnaFirma <> 0) then begin
        //tu wystpuje UNIODDZIAL, ale NIE W KADYM sowniku
        if SQLManager.OpenQueryWithResult(
             'select '+ sFKMNEMONIKI_CZY_FIRM+' from %s where '+
             sFKMNEMONIKI_ID+'='+sMnemonikId, [sFKMNEMONIKI]) <> 'N' then begin
          if sWhere <> '' then sWhere := sWhere+' and ';
          sWhere := sWhere+sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma);
        end;
      end
    end;
    //przygotowanie treci zapytania
    if sWhere <> '' then sWhere := sWhere+' and ';
    sWhere := sWhere+sTableName+'_'+sPole+' like '+QuotedStr(sText+'%');
    sSQL:= SQLManager.GetSelectWithInnerJoins( sTableName+'_'+sPole,
                                               [sTableName], [''], [''], sWhere);
  end;

  result := SQLManager.CreateQuery(sSQL);
end;
********************)

procedure TZLEParametrySelectForm.GetLastWord(var sText,
  sFirstWord: String);
var iPos: Integer;
begin
  sText := StringReplace(sText,'[','',[]);
  sText := StringReplace(sText,']','',[]);
  iPos := Pos(',',sText);
  if iPos = 0 then sFirstWord := sText
  else sFirstWord := Copy(sText,1,iPos-1);
  while iPos <> 0 do begin
    System.Delete(sText,1,iPos);
    iPos := Pos(',',sText);
  end;
end;

procedure TZLEParametrySelectForm.CreateFunctionList;
begin
  FOperationList := TUNIStringList.Create;
  with FOperationList do begin
    if DataManagers.Available(sPLLIModulID) then begin
      AddObject(cWARTPL, TUNIFunction.Create(cWARTPL,  ['POZROZDZ=['], ''''));
    end;
  end;
end;

procedure TZLEParametrySelectForm.CreateParamKindList;
begin
  //ustalenie rodzaju parametru
  FParamKindList := TUniStringList.Create;
  with FParamKindList do begin
    //Add('ZAP=BRAK_PODPOWIEDZI');
    //Add('ROK=ROK');
    //Add('OKRESNR=OKRESOBR');
    //Add('WYDZIAL=WYDZIAL');
    //Add('ZLECENIE=ZLECENIE');
    Add('POZROZDZ=POZROZDZ');
    //Add('WGJEDN=WGJEDN');
    //Add('COFNIJOKRES=COFNIJOKRES');
  end;
end;

procedure TZLEParametrySelectForm.GetParams;
var
  oQuery: TUNIQuery;
begin
  //ustawia kontrolki na podstawie parametrw ZLE
  with ZLEDM do begin
    iTypZleceniaId := vZLEDomyslnyTypZlecenia;
    TypZleceniaLookupAliasEdit.InitiateData(iTypZleceniaId);
    iPrzeliczOkresID := vZLEPrzeliczOkresID;
    OkresLookupAliasEdit.InitiateData(iPrzeliczOkresID);
    iInstalacjeTypZlecId := vZLEInstalacjeTypZlec;
    InstalacjeTypZlecLookupAliasEdit.InitiateData(iInstalacjeTypZlecId);
    DomyslnyStatusComboBox.ItemIndex := cslZLEStatusZlecenia.IndexOfSkrot(vZLEDomyslnyStatusZlecenia);
    WymaganaOsobaZatwierdzajacaCheckBox.Checked := vZLEWymaganaOsobaZamykajacaZlecenie;
    PozycjeCheckBox.Checked := vZLEPozycjeWlaczone;
    KontrolaKosztowCheckBox.Checked := vZLEKontrolaKosztowWlaczona;
    KontrolaIlosciCheckBox.Checked := vZLEKontrolaIlosciWlaczona and DataManagers.Available(sASOModulID); //Na razie nie dziaa bez asortymentu
    KontrolaIlosciCheckBox.Visible := DataManagers.Available(sASOModulID); //Na razie nie dziaa bez asortymentu
    KosztyMaterialoweCheckBox.Checked := vZLEKosztyMaterialoweWlaczone and DataManagers.Available(sMAGModulID);

    KosztyMatZakupCheckBox.Checked := vZLEKosztyMaterialoweWlaczone and vZLEKosztyMatZakupWlaczone and DataManagers.Available(sZAModulID);
    KosztyMatZakupCheckBox.Enabled := vZLEKosztyMaterialoweWlaczone and DataManagers.Available(sZAModulID);
    KosztyMatZakupCheckBox.Visible := DataManagers.Available(sZAModulID);

    KosztyRobociznyCheckBox.Checked := vZLEKosztyRobociznyWlaczone;
    WystawioneFakturyCheckBox.Checked := vZLEWystawioneFakturyWlaczone and DataManagers.Available(sMFSModulID);
    WystawioneFakturyCheckBox.Visible := DataManagers.Available(sMFSModulID);
    WystawioneFakturyZakupuCheckBox.Checked := vZLEWystawioneFakturyZakupuWlaczone and DataManagers.Available(sMFZModulID);
    WystawioneFakturyZakupuCheckBox.Visible := DataManagers.Available(sMFZModulID);
    ZasobyCheckBox.Checked := vZLEZasobyWlaczone;
    RozliczenieZasobowCheckBox.Checked := vZLERozliczenieWlaczone and DataManagers.Available(sASOModulID);
    RozliczenieZasobowCheckBox.Visible := DataManagers.Available(sASOModulID);
    EwidencjaZuzPaliwaCheckBox.Checked := vZLEZlecenieRozl_ZuzPaliwa;
    RenumeracjaPozycjiCheckBox.Checked := vZLEZleceniePoz_RenumeracjaLP;
    WymaganyOddzialCheckBox.Checked := vZLEWymaganyOddzial;
    iDomyslnyOddzialID := vZLEDomyslnyOddzialID;
    WymaganaStawkaZasobuCheckBox.Checked  := vZLEWymaganaStawkaZasobu;
    WlaczoneCheckBox.Checked := vZLEPrzeliczanieWlaczone;
    PrzeliczanieGodzEdit.Text := vZLEPrzeliczanieGodzina;
    PrzeliczanieGodzEdit.Enabled := vZLEPrzeliczanieWlaczone;
    GrupowanieDanychCheckBox.Checked := vZLEGrupowanieDanych;
    OgraniczonaListeZasobowCheckBox.Checked := vZLEOgraniczonaListaZasobow;
    WspolneZleceniaCheckBox.Checked := vZLEWspolneZlecenia;
    WylaczonyFiltrCheckBox.Checked := vZLEWylaczonyFiltrDlaTypu;
    WycenaPracyZasobowCheckBox.Visible  := DataManagers.Available(sLWPModulID);
    WycenaPracyZasobowCheckBox.Checked  := WycenaPracyZasobowCheckBox.Visible and vZLEWycenaPracyZasobowWlaczona;
    WymaganaPozycjaEwidCheckBox.Checked := vZLEWymaganaPozycjaEwid;
    ZleceniaNadrzedneCheckBox.Checked := vZLEZleceniaNadrzedne;
    KosztyZakupuCheckBox.Checked := vZLEKosztyZakupuWlaczone and DataManagers.Available(sZAModulID);
    DopiszKosztyZakupuCheckBox.Checked := vZLEKosztyZakupuWlaczone and vZLEDopiszKosztyZakupuWlaczone and DataManagers.Available(sZAModulID);
    DopiszKosztyZakupuCheckBox.Enabled := vZLEKosztyZakupuWlaczone and DataManagers.Available(sZAModulID);
    DopiszKosztyZakupuCheckBox.Visible := DataManagers.Available(sZAModulID);

    UproszczonySlownikZlecenCheckBox.Checked := vZLEUproszczonySlownikZlecenWlaczony;
    ZlecenieBezPozycjiZeSprawCheckBox.Visible := DataManagers.Available(sBOKModulID);
    ZlecenieBezPozycjiZeSprawCheckBox.Checked := vZLEZleceniaBezPozycjiZeSpraw;

    KosztyKDECPCheckBox.Visible := DataManagers.Available(sKDECPModulID);
    KosztyKDECPCheckBox.Checked := vZLEKosztyKDECPWlaczone;
    WydrukZleceniaCheckBox.Checked := vZLEWydrukZlecenia;
    RozliczAktStawkaCheckBox.Checked := vZLERozliczAktStawka;
    ZLEAktywnePrzyciskiCheckBox.Checked := vZLEWlaczAktywnePrzyciki;
    KontrolaUprawnienCheckBox.Checked := vZLEKontrolaUprawnionych;
    iSkladnikCzasuPracyID := vZLESkladnikECPDomyslnyID;
    iMnemonikStanowiskoID := vZLESlownikStanowiskMnemID;

    OkresLookupAliasEdit.Enabled := vZLEPrzeliczanieWlaczone;
    if vZLEPrzeliczanieWlaczone and (vZLEPrzeliczOkresID > 0) then
       OkresLookupAliasEdit.InitiateData(vZLEPrzeliczOkresID);

    KopiujZlecenieBezPozycjiCheckBox.Checked := vZLEKopiujZlecenieBezPozycji;
    BlokadaEdycjiZakonczCheckBox.Checked := vZLEBlokadaEdycjiZakoncz;

    if DataManagers.Available(sFKModulID) then
         ZamkniecieKontCheckBox.Checked := vZLEZamkniecieKont
    else ZamkniecieKontCheckBox.Checked := False;

    MaskaSymboluCheckBox.Checked := vZLEMaskaSymboluWlaczona;
    MaskaSymboluEdit.Enabled := vZLEMaskaSymboluWlaczona;
    MaskaSymboluEdit.Text := vZLEMaskaSymbolu;

    ECPPracownicyWieleFirmCheckBox.Visible := UNISYSDM.vWielofirmowosc; // and False; //Na razie nie widoczne!!
    ECPPracownicyWieleFirmCheckBox.Checked := vZLEECPPracownicyWieleFirm;
    UnikalnoscElemInfCheckBox.Visible := DataManagers.Available(sINFModulID);
    UnikalnoscElemInfCheckBox.Checked := vZLEUnikalnoscElemInf;

    ZleceniaPodrzedneCheckBox.Checked := vZLEZleceniaPodrzedneWlaczone;

    PodpowiadanieSprawyCheckBox.Checked := False;
    KontrahentEdit.Text := '';
    WydzialEdit.Text := '';
    PrefixEdit.Text := '';

    if DataManagers.Available(sBOKModulID) and vZLESprawyPodpowiadanie then begin
        PodpowiadanieSprawyCheckBox.Checked := True;
        KontrahentEdit.Text := vZLESprawyKontrahent;
        WydzialEdit.Text := vZLESprawyWydzial;
        PrefixEdit.Text := vZLESprawyPrefix;
    end;

    if DataManagers.Available(sSTModulID) and vZLESrodkiTrwaleWlaczone then begin
             SrodkiTrwaleCheckBox.Checked := True;
    end else SrodkiTrwaleCheckBox.Checked := False;

    if DataManagers.Available(sTSModulID) and vZLETransportWlaczony then begin
             TransportCheckBox.Checked := True;
    end else TransportCheckBox.Checked := False;

    ZlecTworzZapotrzCheckBox.Checked  := (UNISysDM.UNICzyAktywnyModul(sZAOModulID) and vZLETworzZapotrzWlaczone);

    if DataManagers.Available(sKDECPModulID) then begin
       WlaczonaKomunikacjaECPCheckBox.Checked        := vZLEWysylanieECPWlaczone;
       if vZLEWysylanieECPWlaczone then begin
         RozliczanieAkorduECPCheckBox.Checked := vZLERozliczanieAkorduECPWlaczone;
         RozliczanieAkorduECPCheckBox.Enabled := True;
       end else begin
         RozliczanieAkorduECPCheckBox.Checked := False;
         RozliczanieAkorduECPCheckBox.Enabled := False;
       end;
       WlaczonaKomunikacjaRozliczECPCheckBox.Checked := vZLEWysylanieRozliczECPWlaczone;
       UwzglednijBlokadeKDECPCheckBox.Enabled := (vZLEWysylanieECPWlaczone or vZLEWysylanieRozliczECPWlaczone);
       UwzglednijBlokadeKDECPCheckBox.Checked := UwzglednijBlokadeKDECPCheckBox.Enabled and vZLEUwzglednijBlokadeKDECP;

       if vZLERozliczanieAkorduECPWlaczone then begin
         StanowiskoLookupAliasEdit.Enabled     := True;
         if iMnemonikStanowiskoID > 0 then
            StanowiskoLookupAliasEdit.InitiateData(iMnemonikStanowiskoID);
       end else begin
         StanowiskoLookupAliasEdit.Enabled     := False;
       end;
       SkladnikCzasuPracyLookupAliasEdit.Enabled     := (vZLEWysylanieECPWlaczone or vZLEWysylanieRozliczECPWlaczone);
       if SkladnikCzasuPracyLookupAliasEdit.Enabled and (iSkladnikCzasuPracyID > 0) then
          SkladnikCzasuPracyLookupAliasEdit.InitiateData(iSkladnikCzasuPracyID);
    end else begin
       WlaczonaKomunikacjaECPCheckBox.Visible        := False;
       RozliczanieAkorduECPCheckBox.Visible          := False;
       WlaczonaKomunikacjaRozliczECPCheckBox.Visible := False;
       UwzglednijBlokadeKDECPCheckBox.Visible        := False;
       SkladnikCzasuPracyLookupAliasEdit.Visible     := False;
       StanowiskoLabel.Visible                       := False;
       StanowiskoLookupAliasEdit.Visible             := False;
       UwzglednijBlokadeKDECPCheckBox.Checked        := False;
       UwzglednijBlokadeKDECPCheckBox.Enabled        := False;
       WlaczonaKomunikacjaECPCheckBox.Checked        := False;
       WlaczonaKomunikacjaRozliczECPCheckBox.Checked := False;
       SkladnikCzasuPracyLookupAliasEdit.Enabled     := False;
       {ZLEDM.vZLEWysylanieECPWlaczone                := False;
       ZLEDM.vZLEWysylanieRozliczECPWlaczone         := False;
       ZLEDM.vZLEUwzglednijBlokadeKDECP              := False;}
       //Clear??
       //SkladnikCzasuPracyLookupAliasEdit.InitiateData(vZLESkladnikECPDomyslny);
    end;

    {if DataManagers.Available(sPLLIModulID) then
       Regula := ZLEDM.vZLEStawkaRegula;}

    bFormatLiczbowy := vZLEFormatGodzinLiczba;
    FormatGodzinLiczbaCheckBox.Checked := vZLEFormatGodzinLiczba;

    NumUzytID:= vZLENumeratorZasobow;
    if NumUzytID<>0 then begin
      oQuery:= UniSysDM.UNIOdpytajODane(sUNIAUTNUM,
                                        sUNISYSALIAS_Numerator_Nazwa,
                                        '@' + sUNISYSALIAS_Numerator_ID + '=' + IntToStr(NumUzytID),
                                        false,
                                        0);
      if oQuery<>nil then
      try
        if not oQuery.IsEmpty then
           UzytkownikaLookupAliasEdit.Text := oQuery.Fields[0].AsString;
      finally
        FreeAndNil(oQuery);
      end;
    end;

    NumeratorExtCheckBox.Checked := vZLENumeratorExt;
    if not NumeratorExtCheckBox.Checked then begin
       PrefixComboBox.ItemIndex := -1;
       PrefixComboBox.Enabled := False;
       OsobnaNumCheckBox.Checked := False;
       OsobnaNumCheckBox.Enabled := False;
    end else begin
       PrefixComboBox.ItemIndex := vZLEPrefixSlownikID;
       PrefixComboBox.Enabled := True;
       OsobnaNumCheckBox.Checked := vZLEOsobnaNum;
       OsobnaNumCheckBox.Enabled := True;
    end;

    BlokadaZmianySymboluCheckBox.Checked := vZLEBlokadaZmianySymbolu;
    if BlokadaZmianySymboluCheckBox.Checked then begin
      ReczneWprowadzanieSymboluCheckBox.Enabled := True;
      ReczneWprowadzanieSymboluCheckBox.Checked := vZLEReczneWprowadzanieSymbolu;
    end else begin
      ReczneWprowadzanieSymboluCheckBox.Checked := False;
      ReczneWprowadzanieSymboluCheckBox.Enabled := False;
    end;

    if vZLENarzuty then begin
        NarzutyCheckBox.Enabled := (not bIstniejaNarzuty);
        NarzutyCheckBox.Checked := vZLENarzuty;
        PoziomJednOrgCheckBox.Enabled := (not bIstniejaNarzuty);
        PoziomJednOrgCheckBox.Checked := vZLEPoziomNarzutowJednOrg;
        PoziomTypZlecCheckBox.Enabled := (not bIstniejaNarzuty);
        PoziomTypZlecCheckBox.Checked := vZLEPoziomNarzutowTypZlec;
        if ((UNISYSDM.vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) or UNISYSDM.vWielofirmowosc) then begin
            PoziomOddzialCheckBox.Visible := True;
            PoziomOddzialCheckBox.Enabled := (not bIstniejaNarzuty);
            PoziomOddzialCheckBox.Checked := vZLEPoziomNarzutowOddzial;
        end else begin
           PoziomOddzialCheckBox.Enabled := False;
           PoziomOddzialCheckBox.Visible := False;
           PoziomOddzialCheckBox.Checked := False;
        end;
    end else begin
        NarzutyCheckBox.Enabled := True;
        NarzutyCheckBox.Checked := False;
        PoziomJednOrgCheckBox.Enabled := False;
        PoziomJednOrgCheckBox.Checked := False;
        PoziomtypZlecCheckBox.Enabled := False;
        PoziomtypZlecCheckBox.Checked := False;
        if ((UNISYSDM.vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) or UNISYSDM.vWielofirmowosc) then begin
            PoziomOddzialCheckBox.Visible := True;
            PoziomOddzialCheckBox.Enabled := False;
            PoziomOddzialCheckBox.Checked := False;
        end else begin
           PoziomOddzialCheckBox.Enabled := False;
           PoziomOddzialCheckBox.Visible := False;
           PoziomOddzialCheckBox.Checked := False;
        end;
    end;
  end;
end;

procedure TZLEParametrySelectForm.InitializeControls;
var
  sSQL: String;
  q: TUNIQuery;
begin
  //inicjalizacja kontrolek
  DomyslnyStatusComboBox.Items.AddStrings( cslZLEStatusZlecenia );
  with TypZleceniaLookupAliasEdit do begin
    AliasManager := ZLEDataManager.AliasManager;
    Alias_ID := sZLEALIAS_TYPZLECENIA_ID;
    Alias_Name := sZLEALIAS_TYPZLECENIA_SYMBOL;
  end;
  with InstalacjeTypZlecLookupAliasEdit do begin
    AliasManager := ZLEDataManager.AliasManager;
    Alias_ID := sZLEALIAS_TYPZLECENIA_ID;
    Alias_Name := sZLEALIAS_TYPZLECENIA_SYMBOL;
    AdditionalAliases := sZLEALIAS_TYPZLECENIA_NUM_ID+';'+sZLEALIAS_TYPZLECENIA_SIECELEMENT;
  end;
  with OkresLookupAliasEdit do begin
    AliasManager := UNISYSDataManager.AliasManager;
    Alias_ID := sUNISYSALIAS_Okres_Obrachunkowy_ID;
    Alias_Name := sUNISYSALIAS_Okres_Obrachunkowy_Nazwa;
    AdditionalAliases := sUNISYSALIAS_Okres_Obrachunkowy_Rok_Opis;
  end;

  if DataManagers.Available(sKDPRAModulID) then begin
    with SkladnikCzasuPracyLookupAliasEdit do begin
      AliasManager := KDPRADataManager.AliasManager;
      Alias_ID := sKDAlias_SKLADNIKCZASU_ID;
      Alias_Name := sKDAlias_SKLADNIKCZASU_SYMBOL;
      AdditionalAliases := sKDAlias_SKLADNIKCZASU_NAZWA;
    end;
  end else begin
    SkladnikCzasuPracyLookupAliasEdit.Enabled := False;
    WlaczonaKomunikacjaECPCheckBox.Enabled := False;
  end;
  if DataManagers.Available(sKDECPModulID) then begin
    with StanowiskoLookupAliasEdit do begin
      AliasManager := UNISYSDataManager.AliasManager;
      Alias_ID := sFKALIAS_MNEMONIKI_ID;
      Alias_Name := sFKALIAS_MNEMONIKI_NAZWA;
    end;
  end else begin
    StanowiskoLookupAliasEdit.Enabled := False;
    RozliczanieAkorduECPCheckBox.Enabled := False;
  end;

  SelectButton.Caption := 'Zatwierd';


  if DataManagers.Available(sASOModulID) then begin
    sSql :=
      'SELECT ' +
      'r.' + sASOREG_ID + ', ' +
      'u.' + sUNIMODULZSI_KOD + ', ' +
      'u.' + sUNIMODULZSI_NAZWA +
      ' FROM ' +
      SQLManager.GetTableName(sASOREG) + ' r, ' +
      SQLManager.GetTableName(sUNIMODULZSI) + ' u ' +
      ' WHERE ' +
      'r.' + sUNIMODULZSI_ID + ' = u.' + sUNIMODULZSI_ID + ' AND ' +
      'r.' + sASOREG_CZY_AKT + '=' + #39 + sUNICONST_ALTERNATYWA_TAK + #39;
    try
      cslAsoReg := TConstStringList.Create;
      cslAsoReg.Clear;
      q := SQLManager.CreateQuery(sSQL);
      q.Open;
      while not q.EOF do begin
        cslAsoReg.Add(q.Fields[1].AsString + ' - ' + q.Fields[2].AsString, q.Fields[0].AsString);
        q.Next;
      end;
      ASORegComboBox.Items:= cslAsoReg;
      if ZLEDM.vZLEAsoReg_ID = -1 then
        ASORegComboBox.ItemIndex := -1
      else
        ASORegComboBox.ItemIndex := cslAsoReg.IndexOfSkrot(IntToStr(ZLEDM.vZLEAsoReg_ID));
    finally
      if q <> Nil then FreeAndNil(q);
    end;
  end else begin // Brak moduu ASO
    ASORegLabel.Visible := False;
    ASORegComboBox.Visible := False;
  end;


  OddzialPanel.Visible := vWieloodzialowosc;
  if vWieloodzialowosc then begin
    with OddzialLookupAliasEdit do begin
      aFieldName    := sUNIODDZIAL_ID;
      AliasManager  := UniSysDataManager.AliasManager;
      Alias_ID      := sUNISYSALIAS_Oddzial_ID;
      Alias_Name    := sUNISYSALIAS_Oddzial_Symbol;
    end;  // with OddzialLookupAliasEdit
  end;
  WspolneZleceniaCheckBox.Visible := vWielofirmowosc;


  if DataManagers.Available(sINFModulID) and DataManagers.Available(sWODModulID) then begin
     InstalacjeTypLabel.Visible := True;
     InstalacjeTypZlecLookupAliasEdit.Visible := True;
  end else begin
     InstalacjeTypZlecLookupAliasEdit.Visible := False;
     InstalacjeTypLabel.Visible := False;
  end;

  PrefixComboBox.Items.Clear();
  PrefixComboBox.Items.AddStrings(cslZLEConstPrefix);
  if not ((UNISYSDM.vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) or vWielofirmowosc) then begin
     PrefixComboBox.Items.Delete(PrefixComboBox.Items.IndexOf(sUNIODDZIAL));
  end;

  (**
  if SQLManager.OpenQueryWithResult('SELECT ' + sUNIAUTNUM_ID +
                                   ' FROM %s ' +
                                   ' WHERE ' + sUNIAUTNUM_KOD + ' = ' + QuotedStr('ZL') + ' AND ' +
                                               sUNIAUTNUM_AKTYWNY + '= 0',
                                   [sUNIAUTNUM]) <> '' then
  begin
       NumeratorExtCheckBox.Enabled := False;
       PrefixComboBox.Enabled := False;
       OsobnaNumCheckBox.Enabled := False;
         //Zakomentowac!!
       {if vWielofirmowosc then
          PrefixComboBox.Enabled := True;}
  end else begin
       NumeratorExtCheckBox.Enabled := True;
       PrefixComboBox.Enabled := True;
       OsobnaNumCheckBox.Enabled := True;
  end;
  ****)

  {Dla testw wczam moliwo definicji -
   Edycja tylko gdy nie ma zdefiniowanego numeratora symboli zlece}
  NumeratorExtCheckBox.Enabled := True;
  PrefixComboBox.Enabled := True;
  OsobnaNumCheckBox.Enabled := True;

  if not DataManagers.Available(sZAModulID) then begin
     KosztyZakupuCheckBox.Checked := False;
     DopiszKosztyZakupuCheckBox.Checked := False;
  end;

  KosztyZakupuCheckBox.Visible := DataManagers.Available(sZAModulID);
  DopiszKosztyZakupuCheckBox.Visible := DataManagers.Available(sZAModulID);
  SrodkiTrwaleCheckBox.Visible := DataManagers.Available(sSTModulID);
  TransportCheckBox.Visible    := DataManagers.Available(sTSModulID);
  ZlecTworzZapotrzCheckBox.Visible  := UNISysDM.UNICzyAktywnyModul(sZAOModulID);

  WystawioneFakturyCheckBox.Visible := DataManagers.Available(sMFSModulID);
  WystawioneFakturyZakupuCheckBox.Visible := DataManagers.Available(sMFZModulID);
  KosztyMaterialoweCheckBox.Visible := DataManagers.Available(sMAGModulID);

  KontrolaIlosciCheckBox.Visible := DataManagers.Available(sASOModulID); //Na razie nie dziaa bez asortymentu
  WystawioneFakturyCheckBox.Visible := DataManagers.Available(sMFSModulID);
  WystawioneFakturyZakupuCheckBox.Visible := DataManagers.Available(sMFZModulID);
  RozliczenieZasobowCheckBox.Visible := DataManagers.Available(sASOModulID);

  if DataManagers.Available(sFKModulID) then begin
     ZamkniecieKontCheckBox.Visible := True;
     ZamkniecieKontCheckBox.Enabled := True;
  end else begin
     ZamkniecieKontCheckBox.Visible := False;
     ZamkniecieKontCheckBox.Enabled := False;
  end;
  PodpowiadanieSprawyCheckBox.Enabled := DataManagers.Available(sBOKModulID);

  PoziomOddzialCheckBox.Visible := ((UNISYSDM.vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) or UNISYSDM.vWielofirmowosc);

  bIstniejaNarzuty := False;
  q := SQLManager.CreateQuery('SELECT COUNT(*) FROM %s ', [sZLEWSPNARZUTY]);
  try
    q.Open();
    if not q.IsEmpty then
       if q.Fields[0].AsInteger > 0 then
          begin
               bIstniejaNarzuty := True;
               NarzutyCheckBox.Enabled := False;
               PoziomTypZlecCheckBox.Enabled := False;
               PoziomJednOrgCheckBox.Enabled := False;
               PoziomOddzialCheckBox.Enabled := False;
          end;
  finally
    if q <> nil then FreeAndNil(q);
  end;

  bIstniejaStanowiska := False;
  q := SQLManager.CreateQuery('SELECT COUNT(*) FROM %s ' +
                              'WHERE ' + sZLEZASOBYPRACA_STANOWISKO_ID + ' IS NOT NULL',
                              [sZLEZASOBYPRACA]);
  try
    q.Open();
    if not q.IsEmpty then
       if q.Fields[0].AsInteger > 0 then
          begin
               bIstniejaStanowiska := True;
               StanowiskoLookupAliasEdit.Enabled := False;
          end;
  finally
    if q <> nil then FreeAndNil(q);
  end;

  SkladnikCzasuPracyLookupAliasEdit.Visible := DataManagers.Available(sKDPRAModulID);
  SkladnikCzasuLabel.Visible := DataManagers.Available(sKDPRAModulID);
  WlaczonaKomunikacjaECPCheckBox.Visible := DataManagers.Available(sKDPRAModulID);

  //KosztyZakupuCheckBox.Visible := DataManagers.Available(sMFZModulID);
  MainPageControl.ActivePage := OgolneTabSheet;
end;

procedure TZLEParametrySelectForm.InternalOpen;
var
  omOpenMode: TOpenMode;
  Idx: Integer;
begin
  iPanelPlIndex := -1;
  iPanelECPIndex := -1;

  InitializeControls();

  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end else
    Caption := 'Parametry';

  inherited;
  SkladnikCzasuPracyLookupAliasEdit.AdditionalCondition := sKDSKLADNIKCZASU_TYPPOLA1 + ' = ' + QuotedStr(sTYPPOLA_GODZINY);
  ZLEDM.OdczytajParametry();
  GetParams();

  Idx := 0;
  if DataManagers.Available(sPLLIModulID) then begin
    with FContainedForms do begin
      omOpenMode := (omList or omContained or omVirtual);
      iPanelPlIndex := Idx;
      Inc(Idx);
      AddObject('', FormManager.OpenDBGrid(self,'TZLEPlRozDefGridForm', omOpenMode));
    end;
  end else begin
      DanePlSheet.TabVisible := False;
  end;

  if DataManagers.Available(sKDECPModulID) then begin
    with FContainedForms do begin
      omOpenMode := (omList or omContained or omVirtual);
      iPanelECPIndex := Idx;
      //Inc(Idx);
      AddObject('', FormManager.OpenDBGrid(self,'TZLESkladnikiECPDefDBGridForm', omOpenMode));
    end;
  end else begin
      SkladnikiECPTabSheet.TabVisible := False;
  end;

  if vWieloodzialowosc then begin
     if ZLEDM.vZLEDomyslnyOddzialID > 0 then
        OddzialLookupAliasEdit.InitiateData(ZLEDM.vZLEDomyslnyOddzialID);
  end;

end;

procedure TZLEParametrySelectForm.KosztyMaterialoweCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  KosztyMatZakupCheckBox.Enabled := KosztyMatZakupCheckBox.Visible and KosztyMaterialoweCheckBox.Checked and DataManagers.Available(sZAModulID);
end;

procedure TZLEParametrySelectForm.KosztyZakupuCheckBoxClick(Sender: TObject);
begin
  inherited;
  DopiszKosztyZakupuCheckBox.Enabled := DopiszKosztyZakupuCheckBox.Visible and KosztyZakupuCheckBox.Checked and DataManagers.Available(sZAModulID);
end;

procedure TZLEParametrySelectForm.MaskaSymboluCheckBoxClick(Sender: TObject);
begin
  inherited;
  Refresh;
end;

procedure TZLEParametrySelectForm.MaskaSymboluEditKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (not PoprawnaDlugosc(MaskaSymboluEdit.Text)) and (Key <> #8) then
    Key:=#0
  else
    inherited;
end;

function TZLEParametrySelectForm.PoprawnaDlugosc(sMaska: String): Boolean;
var iLicznik, iIndex: Integer;
begin
  iLicznik := 0;
  for iIndex := 1 to Length(sMaska) do begin
    if not ((sMaska[iIndex] = '-') or (sMaska[iIndex] = '.')) then Inc(iLicznik);
  end;
  result := iLicznik < UNISYSDM.vMaxDLSymboluZle;
end;

procedure TZLEParametrySelectForm.GetPositionAndParentForContainedForm( const nr:integer ; var APosition: TRect ; var AParent: TWinControl ; var AAlign:TAlign);
begin
  if nr = iPanelPlIndex then begin
      AParent := DanePlPanel;
      APosition := DanePlPanel.ClientRect;
      AAlign := alClient;
  end else
  if nr = iPanelECPIndex then begin
      AParent := SkladnikiECPPanel;
      APosition := SkladnikiECPPanel.ClientRect;
      AAlign := alClient;
  end;
end;

procedure TZLEParametrySelectForm.SelectButtonClick(Sender: TObject);
var
  bTrans: boolean;
  sTmp : String;
begin
  if not Validate() then begin
     Komunikat(cWarning, 'Bdnie zdefiniowany numerator rozszerzony');
     ModalResult := mrNone;
     //Abort;
     Exit;
  end;
  //odswie parametry w ZLEDM
  SetParams();

  if bPrzelicz then begin
    bTrans  := not SQLManager.InTransaction;
    if bTrans then SQLManager.StartTransaction;
    try

       {Obecnie tylko jedna tabela ZLEZASOBYPRACA}
       (***************************
       if ZLEDM.vZLEFormatGodzinLiczba then
            sTmp := sZLEZASOBYPRACA_CZAS_PRACY + ' / 60.0'
       else sTmp := 'TRUNC(' + sZLEZASOBYPRACA_CZAS_PRACY + ' * 60)';



       SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEZASOBYPRACA) + ' ' +
                               'SET ' + sZLEZASOBYPRACA_CZAS_PRACY + ' = ' + sTmp);
       ***************************)
       if ZLEDM.vZLEFormatGodzinLiczba then
            sTmp := sZLEZASOBYPRACA_CZAS_PRACY + ' = ' + sZLEZASOBYPRACA_CZAS_PRACY + ' / 60.0, ' +
                    sZLEZASOBYPRACA_CZAS_PRACY_NOM + ' = ' + sZLEZASOBYPRACA_CZAS_PRACY_NOM + ' / 60.0'
       else sTmp := sZLEZASOBYPRACA_CZAS_PRACY + ' = TRUNC(' + sZLEZASOBYPRACA_CZAS_PRACY + ' * 60), ' +
                    sZLEZASOBYPRACA_CZAS_PRACY_NOM + ' = TRUNC(' + sZLEZASOBYPRACA_CZAS_PRACY_NOM + ' * 60)';

       SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEZASOBYPRACA) + ' SET ' + sTmp);

       if bTrans then SQLManager.Commit;
    except
       if bTrans then SQLManager.Rollback;
       raise;
    end;
  end;

  //zapisz parametry do bazy
  ZLEDM.ZapiszParametry();

  if DataManagers.Available(sPLLIModulID) then begin
     ZLEDM.vZLEStawkaRegula := Regula;

     with FContainedForms do begin
       bTrans  := not SQLManager.InTransaction;
       if bTrans then SQLManager.StartTransaction;
       try
         (Objects[iPanelPlIndex] as TUNIDBGridForm).DataModule.Post;
         if bTrans then SQLManager.Commit;

       except
          on E:EDMException do begin
             if bTrans then SQLManager.Rollback;
             if Pos(sZLEPLROZDEF+c_UNK, E.Message) > 0 then begin
                MainPageControl.ActivePage := DanePlSheet;
                Komunikat(cError, 'Istnieje ju taki element!');
                abort;
             end else
                raise;
          end;
          else begin
            if bTrans then SQLManager.Rollback;
            raise;
          end;
       end;
     end;
  end;

  if DataManagers.Available(sKDECPModulID) then begin
     with FContainedForms do begin
       bTrans  := not SQLManager.InTransaction;
       if bTrans then SQLManager.StartTransaction;
       try
         (Objects[iPanelECPIndex] as TUNIDBGridForm).DataModule.Post;
         if bTrans then SQLManager.Commit;

       except
          on E:EDMException do begin
             if bTrans then SQLManager.Rollback;
             if Pos(sZLESKLADNIKIECPDEF+c_UNK, E.Message) > 0 then begin
                MainPageControl.ActivePage := SkladnikiECPTabSheet;
                Komunikat(cError, 'Istnieje ju taki element!');
                abort;
             end else
                raise;
          end;
          else begin
            if bTrans then SQLManager.Rollback;
            raise;
          end;
       end;
     end;
  end;

  inherited;
end;

procedure TZLEParametrySelectForm.SetParams;
begin
  //ustawia parametry ZLE na podstawie kontrolek
  with ZLEDM do begin
    vZLEDomyslnyStatusZlecenia := cslZLEStatusZlecenia.ZwrocSkrot(DomyslnyStatusComboBox.ItemIndex);
    vZLEDomyslnyTypZlecenia := iTypZleceniaId;
    vZLEPrzeliczOkresID := iPrzeliczOkresID;
    vZLEInstalacjeTypZlec := iInstalacjeTypZlecId;
    vZLEWymaganaOsobaZamykajacaZlecenie := WymaganaOsobaZatwierdzajacaCheckBox.Checked;
    if DataManagers.Available(sASOModulID) then begin
      if ASORegComboBox.ItemIndex = -1 then
           vZLEAsoReg_ID := -1
      else vZLEAsoReg_ID := StrToInt(cslAsoReg.ZwrocSkrot(ASORegComboBox.ItemIndex));
    end else vZLEAsoReg_ID := -1;

    vZLEPozycjeWlaczone := PozycjeCheckBox.Checked;
    vZLEKontrolaKosztowWlaczona := KontrolaKosztowCheckBox.Checked;
    vZLEKontrolaIlosciWlaczona := KontrolaIlosciCheckBox.Checked;
    vZLEKosztyMaterialoweWlaczone := KosztyMaterialoweCheckBox.Checked;
    vZLEKosztyMatZakupWlaczone := KosztyMatZakupCheckBox.Checked and DataManagers.Available(sZAModulID);

    vZLEKosztyRobociznyWlaczone := KosztyRobociznyCheckBox.Checked;
    vZLEWystawioneFakturyWlaczone := WystawioneFakturyCheckBox.Checked;
    vZLEWystawioneFakturyZakupuWlaczone := WystawioneFakturyZakupuCheckBox.Checked;
    vZLEZasobyWlaczone := ZasobyCheckBox.Checked;
    vZLERozliczenieWlaczone := RozliczenieZasobowCheckBox.Checked;
    vZLEZlecenieRozl_ZuzPaliwa := EwidencjaZuzPaliwaCheckBox.Checked;
    vZLEZleceniePoz_RenumeracjaLP := RenumeracjaPozycjiCheckBox.Checked;
    vZLEWymaganyOddzial := WymaganyOddzialCheckBox.Checked;
    vZLEDomyslnyOddzialID := iDomyslnyOddzialID;
    RejestracjaczasupracyMenuItem.Enabled := vZLEKosztyRobociznyWlaczone;
    vZLEWymaganaStawkaZasobu  := WymaganaStawkaZasobuCheckBox.Checked;
    vZLEGrupowanieDanych  := GrupowanieDanychCheckBox.Checked;
    vZLEOgraniczonaListaZasobow  := OgraniczonaListeZasobowCheckBox.Checked;
    vZLEWspolneZlecenia := WspolneZleceniaCheckBox.Checked;
    vZLEWylaczonyFiltrDlaTypu := WylaczonyFiltrCheckBox.Checked;
    vZLEWycenaPracyZasobowWlaczona  := WycenaPracyZasobowCheckBox.Checked;
    vZLEZleceniaNadrzedne := ZleceniaNadrzedneCheckBox.Checked;
    vZLEKosztyZakupuWlaczone := KosztyZakupuCheckBox.Checked and DataManagers.Available(sZAModulID);
    vZLEDopiszKosztyZakupuWlaczone := DopiszKosztyZakupuCheckBox.Checked and DataManagers.Available(sZAModulID);
    vZLEKosztyKDECPWlaczone := KosztyKDECPCheckBox.Checked;
    vZLEWydrukZlecenia := WydrukZleceniaCheckBox.Checked;
    vZLERozliczAktStawka := RozliczAktStawkaCheckBox.Checked;
    vZLEKopiujZlecenieBezPozycji := KopiujZlecenieBezPozycjiCheckBox.Checked;
    vZLEBlokadaEdycjiZakoncz := BlokadaEdycjiZakonczCheckBox.Checked;
    vZLEWlaczAktywnePrzyciki := ZLEAktywnePrzyciskiCheckBox.Checked;
    vZLEKontrolaUprawnionych := KontrolaUprawnienCheckBox.Checked;
    vZLEUwzglednijBlokadeKDECP := (vZLEWysylanieECPWlaczone or vZLEWysylanieRozliczECPWlaczone) and UwzglednijBlokadeKDECPCheckBox.Checked;
    vZLEUproszczonySlownikZlecenWlaczony := UproszczonySlownikZlecenCheckBox.Checked;

    if DataManagers.Available(sBOKModulID) then
      vZLEZleceniaBezPozycjiZeSpraw := ZlecenieBezPozycjiZeSprawCheckBox.Checked;

    vZLEMaskaSymboluWlaczona := MaskaSymboluCheckBox.Checked;
    if vZLEMaskaSymboluWlaczona then
       vZLEMaskaSymbolu := MaskaSymboluEdit.Text
    else vZLEMaskaSymbolu := '';

    vZLEECPPracownicyWieleFirm := UNISYSDM.vWielofirmowosc and ECPPracownicyWieleFirmCheckBox.Checked;
    vZLEUnikalnoscElemInf := DataManagers.Available(sINFModulID) and UnikalnoscElemInfCheckBox.Checked;

    vZLEZleceniaPodrzedneWlaczone := ZleceniaPodrzedneCheckBox.Checked;

    bPrzelicz := False;
    if bFormatLiczbowy <> vZLEFormatGodzinLiczba then
       bPrzelicz := True;
    vZLEFormatGodzinLiczba := FormatGodzinLiczbaCheckBox.Checked;

    if WlaczoneCheckBox.Checked and (PrzeliczanieGodzEdit.Text <> '00:00') then begin
       vZLEPrzeliczanieWlaczone  := WlaczoneCheckBox.Checked;
       vZLEPrzeliczanieGodzina   := PrzeliczanieGodzEdit.Text;
    end else begin
       vZLEPrzeliczanieWlaczone  := False;
       vZLEPrzeliczanieGodzina   := PrzeliczanieGodzEdit.Text;
    end;
    if NumUzytID <> ZLEDM.vZLENumeratorZasobow then begin
      ZLEDM.vZLENumeratorZasobow := NumUzytID;
      UNISYSDM.SetSystemIniInteger(0, sZLEModulID, '', sINIZLENumeratorZasobow, ZLEDM.vZLENumeratorZasobow);
    end;

    if DataManagers.Available(sSTModulID) and SrodkiTrwaleCheckBox.Checked  then
         vZLESrodkiTrwaleWlaczone := True
    else vZLESrodkiTrwaleWlaczone := False;

    if DataManagers.Available(sTSModulID) and TransportCheckBox.Checked  then
         vZLETransportWlaczony := True
    else vZLETransportWlaczony := False;

    vZLETworzZapotrzWlaczone  := (UNISysDM.UNICzyAktywnyModul(sZAOModulID) and ZlecTworzZapotrzCheckBox.Checked);

    vZLENumeratorExt := NumeratorExtCheckBox.Checked;
    vZLEPrefixSlownikID := PrefixComboBox.ItemIndex;
    vZLEOsobnaNum := OsobnaNumCheckBox.Checked;
    vZLEWymaganaPozycjaEwid := WymaganaPozycjaEwidCheckBox.Checked;

    {if NumeratorExtCheckBox.Checked then begin
       vZLEBlokadaZmianySymbolu := False;
       vZLEReczneWprowadzanieSymbolu := False;
    end else begin}
       vZLEBlokadaZmianySymbolu := BlokadaZmianySymboluCheckBox.Checked;
       //Rczne wprowadzanie mona wczyc tylko wtedy gdy jest wczona blokada zmiany
       vZLEReczneWprowadzanieSymbolu := ReczneWprowadzanieSymboluCheckBox.Checked and BlokadaZmianySymboluCheckBox.Checked;
    //end;

    if DataManagers.Available(sFKModulID) then
         vZLEZamkniecieKont := ZamkniecieKontCheckBox.Checked
    else vZLEZamkniecieKont := False;

    if DataManagers.Available(sBOKModulID) and PodpowiadanieSprawyCheckBox.Checked then begin
      vZLESprawyPodpowiadanie := True;
      vZLESprawyKontrahent := Trim(KontrahentEdit.Text);
      vZLESprawyWydzial := Trim(WydzialEdit.Text);
      vZLESprawyPrefix := Trim(PrefixEdit.Text);
    end else begin
      vZLESprawyPodpowiadanie := False;
      vZLESprawyKontrahent := '';
      vZLESprawyWydzial := '';
      vZLESprawyPrefix := '';
    end;

    if NarzutyCheckBox.Checked then begin
        vZLENarzuty := NarzutyCheckBox.Checked;
        vZLEPoziomNarzutowJednOrg := PoziomJednOrgCheckBox.Checked;
        if ((UNISYSDM.vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) or UNISYSDM.vWielofirmowosc) then
             vZLEPoziomNarzutowOddzial := PoziomOddzialCheckBox.Checked
        else vZLEPoziomNarzutowOddzial := False;

        vZLEPoziomNarzutowTypZlec := PoziomtypZlecCheckBox.Checked;
    end else begin
        vZLENarzuty := False;
        vZLEPoziomNarzutowJednOrg := False;
        vZLEPoziomNarzutowOddzial := False;
        vZLEPoziomNarzutowTypZlec := False;
    end;


    if DataManagers.Available(sKDECPModulID) then begin
      vZLEWysylanieRozliczECPWlaczone := WlaczonaKomunikacjaRozliczECPCheckBox.Checked;
      vZLEWysylanieECPWlaczone := WlaczonaKomunikacjaECPCheckBox.Checked;
      vZLERozliczanieAkorduECPWlaczone := vZLEWysylanieECPWlaczone and RozliczanieAkorduECPCheckBox.Checked;
      vZLEUwzglednijBlokadeKDECP := vZLEWysylanieECPWlaczone and UwzglednijBlokadeKDECPCheckBox.Checked;

      if (WlaczonaKomunikacjaECPCheckBox.Checked or WlaczonaKomunikacjaRozliczECPCheckBox.Checked) then begin
         vZLESkladnikECPDomyslnyID := iSkladnikCzasuPracyID;
         if vZLERozliczanieAkorduECPWlaczone then
           vZLESlownikStanowiskMnemID := iMnemonikStanowiskoID;
      end else begin
         vZLESkladnikECPDomyslnyID := -1;
         vZLESlownikStanowiskMnemID := -1;
      end;
    end;

    ZLEDM.vZLEStawkaRegula := Regula;
  end;
  (Application.MainForm as TUNIMainForm).DisconnectMainMenu();
  (Application.MainForm as TUNIMainForm).ConnectMainMenu(sZLEModulID);
end;

procedure TZLEParametrySelectForm.TypZleceniaLookupAliasEditButtonClick(
  Sender: TObject);
var oQuery: TUNIQuery;
begin
  inherited;
  oQuery := ZLEDM.ZLEPokazIObsluzTypZlecenia( sZLEALIAS_TYPZLECENIA_ID+';'+
                                              sZLEALIAS_TYPZLECENIA_SYMBOL,
                                              '', True, false, 0,
                                              iTypZleceniaId );
  try
    TypZleceniaLookupAliasEditSetData(oQuery);
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLEParametrySelectForm.TypZleceniaLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    iTypZleceniaId := AliasSrc.FieldByName(sZLETYPZLEC_ID).AsInteger;
    TypZleceniaLookupAliasEdit.Text := AliasSrc.FieldByName(sZLETYPZLEC_SYMBOL).AsString;
  end;
  inherited;
  result := True;
end;

procedure TZLEParametrySelectForm.TypZleceniaLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  iTypZleceniaId := -1;
  TypZleceniaLookupAliasEdit.Text := '';
end;

procedure TZLEParametrySelectForm.OddzialLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery: TUNIQuery;
begin
  oQuery  := UNISysDM.UNIPokazIObsluzDane(sUNIODDZIAL,
    '', false, false,
    sUNISYSALIAS_Oddzial_ID + ';' + sUNISYSALIAS_Oddzial_Symbol,
    0{, IntToStr(iDomyslnyOddzialID)}
  );
  if oQuery <> nil then begin
    OddzialLookupAliasEditSetData(oQuery);
    oQuery.Free;
  end;
end;

procedure TZLEParametrySelectForm.OddzialLookupAliasEditDelKey(
  Sender: TObject);
begin
    iDomyslnyOddzialID           := -1;
    OddzialLookupAliasEdit.Text  := '';
end;

function TZLEParametrySelectForm.OddzialLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    iDomyslnyOddzialID           := AliasSrc.Fields[0].AsInteger;
    OddzialLookupAliasEdit.Text  := AliasSrc.Fields[1].AsString;
  end;

  result := true;
end;

procedure TZLEParametrySelectForm.WlaczoneCheckBoxClick(Sender: TObject);
begin
  inherited;
  PrzeliczanieGodzEdit.Enabled := WlaczoneCheckBox.Checked;
  OkresLookupAliasEdit.Enabled := WlaczoneCheckBox.Checked;
end;

procedure TZLEParametrySelectForm.UzytkownikaLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery: TUNIQuery;
begin
  oQuery := UniSysDataManager.UNIPokazIObsluzAutomatyNum(
    sUNINUMERATORModuluZlecenWielofirmowe,
    UNISysDM.vMaxDLSymboluZle,
    sUNICONST_ALTERNATYWA_NIE,
    sUNISYSALIAS_Numerator_ID + ';' + sUNISYSALIAS_Numerator_Nazwa,
    '', false, 0 {NumUzytID},
    True, True,
    0, sUNISysAutomatyNumerowaniaMnemonikTryb_TylkoWieloletnie + ',' +
       sUNISysAutomatyNumerowaniaMnemonikTryb_TylkoRoczne);
  if oQuery=nil then exit;
  try
    if not oQuery.IsEmpty then UzytkownikaLookupAliasEditSetData(oQuery);
  finally
    oQuery.Free;
  end; 
end;

function TZLEParametrySelectForm.UzytkownikaLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  //inherited;
  NumUzytID:= AliasSrc.Fields[0].AsInteger;
  UzytkownikaLookupAliasEdit.Text:= AliasSrc.Fields[1].AsString;
  result:= true;
end;

procedure TZLEParametrySelectForm.UzytkownikaLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  NumUzytID := 0;
  UzytkownikaLookupAliasEdit.Text := '';
end;

procedure TZLEParametrySelectForm.FormatGodzinLiczbaCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  if bFormatLiczbowy <> FormatGodzinLiczbaCheckBox.Checked then
     if Komunikat(cWarning, 'Po zmianie parametru zostan przeliczone dane w bazie.'#13+
                            'Czy jeste pewien, e chcesz zmieni format godzin?',
                            MB_YESNO or MB_DEFBUTTON2) = ID_YES then begin
        bFormatLiczbowy := FormatGodzinLiczbaCheckBox.Checked;
     end else begin
        FormatGodzinLiczbaCheckBox.Checked := bFormatLiczbowy;
     end;
end;

procedure TZLEParametrySelectForm.InstalacjeTypZlecLookupAliasEditButtonClick(
  Sender: TObject);
var oQuery: TUNIQuery;
begin
  inherited;
  oQuery := ZLEDM.ZLEPokazIObsluzTypZlecenia( sZLEALIAS_TYPZLECENIA_ID+';'+
                                              sZLEALIAS_TYPZLECENIA_NUM_ID+';'+
                                              sZLEALIAS_TYPZLECENIA_SIECELEMENT+';'+
                                              sZLEALIAS_TYPZLECENIA_SYMBOL,
                                              '', True, false, 0,
                                              iInstalacjeTypZlecId );
  try
    InstalacjeTypZlecLookupAliasEditSetData(oQuery);
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

procedure TZLEParametrySelectForm.InstalacjeTypZlecLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  iInstalacjeTypZlecId := -1;
  InstalacjeTypZlecLookupAliasEdit.Text := '';
end;

function TZLEParametrySelectForm.InstalacjeTypZlecLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := false;
  if AliasSrc <> nil then begin
     {Sprawdzamy czy wybrany Typ zlecenia spenia wymogi wykorzystania w instalacjach}
     if DataManagers.Available(sINFModulID) then begin
        if AliasSrc.FieldByName(sZLETYPZLEC_SIECELEMENT_A).AsString = cZLEAktywnosc_NieAktywnyID then begin
           Komunikat(cInformation, 'Wybrany typ zlecenia nie spenia wymogw'#13+
                                   'Powd - brak elementu sieci');
           Exit;
        end;
     end;

     if AliasSrc.FieldByName(sUNIAUTNUM_ID).IsNull then begin
        Komunikat(cInformation, 'Wybrany typ zlecenia nie spenia wymogw'#13+
                                'Powd - brak numeratora');
        Exit;
     end;

     iInstalacjeTypZlecId := AliasSrc.FieldByName(sZLETYPZLEC_ID).AsInteger;
     InstalacjeTypZlecLookupAliasEdit.Text := AliasSrc.FieldByName(sZLETYPZLEC_SYMBOL).AsString;
  end;
  inherited;
  result := True;
end;

procedure TZLEParametrySelectForm.NumeratorExtCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  PrefixComboBox.Enabled    := NumeratorExtCheckBox.Checked;
  OsobnaNumCheckBox.Enabled := NumeratorExtCheckBox.Checked;
  if not NumeratorExtCheckBox.Checked then begin
     PrefixComboBox.ItemIndex := -1;
     OsobnaNumCheckBox.Checked := False;
  end;
end;

procedure TZLEParametrySelectForm.PodpowiadanieSprawyCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  if PodpowiadanieSprawyCheckBox.Checked then begin
     KontrahentEdit.Enabled := True;
     WydzialEdit.Enabled := True;
     PrefixEdit.Enabled := True;
  end else begin
     KontrahentEdit.Enabled := False;
     WydzialEdit.Enabled := False;
     PrefixEdit.Enabled := False;
  end;
end;

procedure TZLEParametrySelectForm.NarzutyCheckBoxClick(Sender: TObject);
begin
  inherited;
  if NarzutyCheckBox.Checked then begin
     PoziomTypZlecCheckBox.Enabled := True;
     PoziomJednOrgCheckBox.Enabled := True;
     PoziomOddzialCheckBox.Visible := ((UNISYSDM.vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) or UNISYSDM.vWielofirmowosc);
     PoziomOddzialCheckBox.Enabled := ((UNISYSDM.vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) or UNISYSDM.vWielofirmowosc);
  end else begin
     PoziomTypZlecCheckBox.Enabled := False;
     PoziomJednOrgCheckBox.Enabled := False;
     PoziomOddzialCheckBox.Enabled := False;
  end;
end;

procedure TZLEParametrySelectForm.OkresLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q:  TDataset;
  sOkresID: String;
begin
  sOkresID := '';
  if iPrzeliczOkresID >0 then sOkresID := IntToStr(iPrzeliczOkresID);

  Q:= UNISysDM.UNIPokazIWybierzOkresObrachunkowy(
    vAktywnyRokObrachunkowyID,'',
    sUNISYSALIAS_Okres_Obrachunkowy_ID+';'+sUNISYSALIAS_Okres_Obrachunkowy_Nazwa+';'+sUNISYSALIAS_Okres_Obrachunkowy_Rok_Opis,false,
    sOkresID);
  if Q<> nil then
  try
    OkresLookupAliasEditSetData(Q);
  finally
    Q.free;
  end;
end;

function TZLEParametrySelectForm.OkresLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  result:= true;
  with AliasSrc do begin
    OkresLookupAliasEdit.Text := AliasSrc.FieldByName(sUNIOKRES_NAZWA).AsString;
    iPrzeliczOkresID := AliasSrc.FieldByName(sUNIOKRES_ID).AsInteger;
  end;
end;

procedure TZLEParametrySelectForm.OkresLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  iPrzeliczOkresID := 0;
  OkresLookupAliasEdit.Text := '';
end;

procedure TZLEParametrySelectForm.SkladnikCzasuPracyLookupAliasEditButtonClick(
  Sender: TObject);
var oQuery: TUNIQuery;
begin
  inherited;
  oQuery := KDDM.KDPokazIObsluzDane(sKDSKLADNIKCZASU,
                                     sKDAlias_SKLADNIKCZASU_ID + ';' +
                                     sKDAlias_SKLADNIKCZASU_SYMBOL + ';' +
                                     sKDAlias_SKLADNIKCZASU_NAZWA,
                                     sKDSKLADNIKCZASU_TYPPOLA1 + ' = ' + QuotedStr(sTYPPOLA_GODZINY),
                                     true,
                                     false,
                                     UNISYSDM.vAktywnaFirma{,
                                     laeSklNadg50.Tag,
                                     TKeyValues.CreateAs([cModulID + '=' + sKDRCPModulID])});
  try
    SkladnikCzasuPracyLookupAliasEditSetData(oQuery);
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

procedure TZLEParametrySelectForm.SkladnikCzasuPracyLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  iSkladnikCzasuPracyID := 0;
  SkladnikCzasuPracyLookupAliasEdit.Text := '';
end;

function TZLEParametrySelectForm.SkladnikCzasuPracyLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    iSkladnikCzasuPracyID := AliasSrc.FieldByName(sKDSKLADNIKCZASU_ID).AsInteger;
    SkladnikCzasuPracyLookupAliasEdit.Text := AliasSrc.FieldByName(sKDSKLADNIKCZASU_SYMBOL).AsString;
  end;
  inherited;
  result := True;
end;

procedure TZLEParametrySelectForm.WlaczonaKomunikacjaECPCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  if WlaczonaKomunikacjaECPCheckBox.Checked then begin
     SkladnikCzasuPracyLookupAliasEdit.Enabled := True;
     UwzglednijBlokadeKDECPCheckBox.Enabled    := True;
     RozliczanieAkorduECPCheckBox.Enabled      := True;
     //ZLEDM.vZLEWysylanieECPWlaczone            := True;
  end else begin
     SkladnikCzasuPracyLookupAliasEdit.Enabled := WlaczonaKomunikacjaRozliczECPCheckBox.Checked; //ZLEDM.vZLEWysylanieRozliczECPWlaczone;
     UwzglednijBlokadeKDECPCheckBox.Enabled    := WlaczonaKomunikacjaRozliczECPCheckBox.Checked; //ZLEDM.vZLEWysylanieRozliczECPWlaczone;
     RozliczanieAkorduECPCheckBox.Enabled      := False;
     //ZLEDM.vZLEWysylanieECPWlaczone            := False;
  end;
end;

procedure TZLEParametrySelectForm.WlaczonaKomunikacjaRozliczECPCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  if WlaczonaKomunikacjaRozliczECPCheckBox.Checked then begin
     SkladnikCzasuPracyLookupAliasEdit.Enabled := True;
     UwzglednijBlokadeKDECPCheckBox.Enabled    := True;
     //ZLEDM.vZLEWysylanieRozliczECPWlaczone     := True;
  end else begin
     SkladnikCzasuPracyLookupAliasEdit.Enabled := WlaczonaKomunikacjaECPCheckBox.Checked; //ZLEDM.vZLEWysylanieECPWlaczone;
     UwzglednijBlokadeKDECPCheckBox.Enabled    := WlaczonaKomunikacjaECPCheckBox.Checked; //ZLEDM.vZLEWysylanieECPWlaczone;
     //ZLEDM.vZLEWysylanieRozliczECPWlaczone     := False;
  end;
end;

procedure TZLEParametrySelectForm.BeforeShow;
begin
  inherited;
//  SetControlsProperites;
  FParser := TZLEParser.Create(Self, True);
  with FParser do begin
    bSymulacja := False;
    if vWielofirmowosc then iFirmaID:= vAktywnaFirma;
    iOkresNr:= 1;
    sRok:= UNISysDM.vAktywnyRokObrachunkowy;
    sRokId:= inttostr(UNISysDM.vAktywnyRokObrachunkowyID);
  end;

  Pozycja   := 0;
  UstawWlasciwosci;
  FRichEdit.TabOrder := 0;

  Refresh;

  {Chwilowo wyczamy widocznosc reguy}
  //RegulaStawkaPanel.Visible := False;
  //BlokadaZmianySymboluCheckBox.Visible := False;
  //ReczneWprowadzanieSymboluCheckBox.Visible := False;
end;

procedure TZLEParametrySelectForm.UstawWlasciwosci;
var
  rProp: TUNISimpleEditorRichEditProperties;
begin
  ZeroMemory(Addr(rProp), sizeof(rProp));
  rProp.pFun1   := GetFunctionsList;
  rProp.pFun2   := GetAdditionalHint;
  rProp.pFun3   := GetCurrWordHint;
  rProp.oParent := TrescLabel.Parent;
  rProp.iTop    := TrescLabel.Top+20;
  rProp.iLeft   := TrescLabel.Left;
  rProp.iWidth  := RegulaStawkaPanel.Width - 20;
  rProp.iHeight := RegulaStawkaPanel.Height - 30; // TUNIPanel(DekretacjaCenaZeroCheckBox.Parent).Height - 20;// DekretacjaCenaZeroCheckBox.Height*3;
  rProp.bWordWrap := true;
  FRichEdit := TUNISimpleEditorRichEdit.Create(self);
  if OpenMode = omView then
    FRichEdit.Enabled := false;
  StworzListy;
  FRichEdit.SetProperties(rProp);

  FRichEdit.TabOrder := 0;
  FRichEdit.Visible := true;
  FRichEdit.RealOnEnter := RichEventOnEnter;
  FRichEdit.RealOnExit := RichEventOnExit;
  FRichEdit.OnChange := RichEditChange;

  if ZLEDM.vZLEStawkaRegula <> '' then
     FRichEdit.Text := ZLEDM.vZLEStawkaRegula
  else FRichEdit.Text := 'result := ';

  TrescLabel.FocusControl := FRichEdit;

end;

destructor TZLEParametrySelectForm.Destroy;
begin
  UsunListy;
  FreeAndNil(FRichEdit);
  inherited;
end;

procedure TZLEParametrySelectForm.GetAdditionalHint(
  const oCurrFunction: TUNIFunction; const sWholeCurrParam: string;
  var sAdditionalHint: string);
begin

end;

function TZLEParametrySelectForm.GetCurrWordHint(
  const asCurrWord: string; const aiCurrWordPos,
  aiCurrWordLen: integer): string;
begin

end;

procedure TZLEParametrySelectForm.RichEditChange(Sender: TObject);
{var
  sZnaki :string;
  i : Integer;}
begin
  (*
  sZnaki := FRichEdit.Text;
  if (Length(sZnaki) > 1)then begin
    if FRegula <> sZnaki then begin
     {if (Length(sZnaki)-Length(FRegula))=1 then begin
       if sZnaki[Length(sZnaki)]=' ' then begin
         sZnaki := Copy(sZnaki, 1, Length(sZnaki)-1);
         FRichEdit.Text := sZnaki;
       end else
         if not (sZnaki[Length(sZnaki)] in ['+']) then begin
           sZnaki := Copy(sZnaki, 1, Length(sZnaki)-1);
           FRichEdit.Text := sZnaki;
           Komunikat(cWarning, 'Zy operator, moliwe operatory to +');
         end;
     end;}
     FRegula := sZnaki;
    end;
  end;
  *)
end;

procedure TZLEParametrySelectForm.RichEventOnEnter(oSender: TObject);
begin
  SelectButton.Default := false;
  CancelButton.Cancel := false;
  if Owner is TZLEParametryTreeForm then begin
     (Owner as TZLEParametryTreeForm).SelectButton.Default := False;
     (Owner as TZLEParametryTreeForm).CancelButton.Cancel  := False;
  end;
end;

procedure TZLEParametrySelectForm.RichEventOnExit(oSender: TObject);
begin
  SelectButton.Default := true;
  CancelButton.Cancel := true;
  if Owner is TZLEParametryTreeForm then begin
     (Owner as TZLEParametryTreeForm).SelectButton.Default := True;
     (Owner as TZLEParametryTreeForm).CancelButton.Cancel  := True;
  end;

  FRichEdit.PlainText := true;

  try
    if FRegula <> FRichEdit.Text then
      UstawRegule(FRichEdit.Text);
  finally
    FRichEdit.PlainText := false;
  end;
end;

procedure TZLEParametrySelectForm.RozliczanieAkorduECPCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  if RozliczanieAkorduECPCheckBox.Checked then begin
    StanowiskoLookupAliasEdit.Enabled := not bIstniejaStanowiska;
  end else begin
    StanowiskoLookupAliasEdit.Enabled := False;
  end;
end;

procedure TZLEParametrySelectForm.StanowiskoLookupAliasEditButtonClick(
  Sender: TObject);
  var
  Q: TUNIQuery;
  sWarunek: string;
begin
  sWarunek := '';
  Q := UNISYSDataManager.UNIPokazIObsluzDane(
    sFKMNEMONIKI {sTabela},
    sWarunek     {sWarunek: string},
    False        {bBlok},
    False        {bWyborWielu: boolean},
    sFKALIAS_MNEMONIKI_ID + ';' +
    sFKALIAS_MNEMONIKI_NAZWA {sAtrybuty: string},
    vAktywnaFirma {iFirmaID: integer},
    '' //IntToStr(ZLEDM.vZLESlownikStanowiskMnemID)
  );
  if Q <> NIL then
    try
      StanowiskoLookupAliasEditSetData(Q);
    finally
      FreeAndNil(Q);
    end;
end;

procedure TZLEParametrySelectForm.StanowiskoLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  iMnemonikStanowiskoID := -1;
  StanowiskoLookupAliasEdit.Text := '';
end;

function TZLEParametrySelectForm.StanowiskoLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := true;
  inherited;
  if AliasSrc <> nil then
    if AliasSrc.FieldByName(sFKMNEMONIKI_ID).AsInteger <> iMnemonikStanowiskoID then begin
      iMnemonikStanowiskoID := AliasSrc.FieldByName(sFKMNEMONIKI_ID).AsInteger;
      StanowiskoLookupAliasEdit.Text := AliasSrc.FieldByName(sFKMNEMONIKI_Nazwa).AsString;
    end;
end;

procedure TZLEParametrySelectForm.StworzListy;
begin
  CreateFunctionList;
  CreateParamKindList;
  FParamValuesList := TUNIStringList.Create();
end;

procedure TZLEParametrySelectForm.UsunListy;
var
  i: integer;
begin
  if FParser<>nil then FreeAndNil(FParser);
  if FOperationList <> nil then begin
    for i:=0 to FOperationList.Count-1 do begin
      FOperationList.Objects[i].Free;
    end;
    FreeAndNil(FOperationList);
  end;
  if FParamValuesList<>nil then FreeAndNil(FParamValuesList);
  if FParamKindList<>nil then FreeAndNil(FParamKindList);
end;

function TZLEParametrySelectForm.GetFunctionsList(
  const oCurrFunction: TUNIFunction; var sWholeCurrParam,
  sCurrWord: string; const sPrevWord: string; const cSeparator: char;
  var sWordToInsert: string; bShowList: boolean): TUNIStringList;
begin
  result := nil;
  if oCurrFunction = nil then begin
    result := FOperationList;
  end else
  if bShowList then begin
    if cSeparator = '=' then begin //jeeli separatorem jest "=" to podpowiadamy moliwe warto parametru
                                      //o nazwie sPrevWord
       result := GetList( AnsiUpperCase(oCurrFunction.FunName),
                          FParamKindList.Values[AnsiUpperCase(sPrevWord)], sCurrWord, cSeparator );
    end else result := oCurrFunction.ParamsNames; //w przeciwnym przypadku podpowiadamy list moliwych parametrw
  end;
end;

procedure TZLEParametrySelectForm.UstawRegule(sRegula: string);
begin
  FRegula := sRegula;
  {if not CheckRegula(True) then begin
    //if FRichEdit.Enabled and FRichEdit.Visible then FRichEdit.SetFocus();
  end;}
//  FRichEdit.Text := Regula;
end;

procedure TZLEParametrySelectForm.BlokadaZmianySymboluCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  if BlokadaZmianySymboluCheckBox.Checked then begin
     ReczneWprowadzanieSymboluCheckBox.Enabled := True;
     //NumeratorExtCheckBox.Enabled := False;
     //PrefixComboBox.Enabled := False;
     //OsobnaNumCheckBox.Enabled := False;
  end else begin
     ReczneWprowadzanieSymboluCheckBox.Checked := False;
     ReczneWprowadzanieSymboluCheckBox.Enabled := False;
  end;
end;

procedure TZLEParametrySelectForm.UwzglednijBlokadeKDECPCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  {--}
end;

initialization
  FormManager.RegisterForm( TZLEParametrySelectForm, 'Parametry moduu ZLE', sZLEModulID );
end.
