unit ZLEPobierzTekstFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIFormUnit, StdCtrls, UNIComponentsUnit, Menus, ToolWin, ComCtrls,
  ExtCtrls;

type
  TZLEPobierzTekstForm = class(TUNIForm)
    TekstEdit: TUNIEdit;
    UNILabel1: TUNILabel;
    ZatwierdzButton: TUNIButton;
    AnulujButton: TUNIButton;
    procedure ZatwierdzButtonClick(Sender: TObject);
    procedure AnulujButtonClick(Sender: TObject);
  private
    { Private declarations }
  protected
    procedure InternalOpen; override;
  public
    { Public declarations }
  end;

var
  ZLEPobierzTekstForm: TZLEPobierzTekstForm;

implementation

{$R *.DFM}
uses
 ZLEDefUnit, Dodatki, KeyManagerUnit, FormManagerUnit;


procedure TZLEPobierzTekstForm.InternalOpen;
begin
   inherited;
   if Parameters.Values['TEKST'] <> '' then
      TekstEdit.Text := Parameters.Values['TEKST'];
   
end;


procedure TZLEPobierzTekstForm.ZatwierdzButtonClick(Sender: TObject);
begin
  if (TekstEdit.Text <> '') then begin
      with Parameters do begin
        Clear;
        Add('TEKST=' + TekstEdit.Text);
      end;
  end else begin
      with Parameters do begin
        Clear;
        Add('TEKST=');
      end;
  end;
  inherited;
end;

procedure TZLEPobierzTekstForm.AnulujButtonClick(Sender: TObject);
begin

  with Parameters do begin
     Clear;
     Add('TEKST=');
  end;
  inherited;
end;

initialization
  FormManager.RegisterForm(TZLEPobierzTekstForm, sZLEModulID);
end.

