unit ZLEPoleZmWskDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who        What
---------------------------------------------------------------------------------------------
2005-12-20 Tomjen     Utworzenie
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, Mask, DBCtrls;

type
  TZLEPoleZmWskDBDetailForm = class(TUNIDBDetailForm)
    ZLEPoleZmDefLabel: TUNILabel;
    ZLEPoleZmDefNazwaDBEdit: TUNIDBEdit;
  private
  protected
    procedure BeforeShow; override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
  public
    class function  ClassIsSingle: boolean; override;
  end;

var
  ZLEPoleZmWskDBDetailForm: TZLEPoleZmWskDBDetailForm;

implementation

uses
  FormManagerUnit,
  ZLEDefUnit,
  ZLEPoleZmWskUnit;

{$R *.DFM}

procedure TZLEPoleZmWskDBDetailForm.BeforeShow;
begin
  inherited;
  HideStatusPanel;
end;

class function TZLEPoleZmWskDBDetailForm.ClassIsSingle: boolean;
begin
  Result := true;
end;

function TZLEPoleZmWskDBDetailForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLEPoleZmWsk.CreateOpen( self, DefaultMasterKeyValues, AOpenMode);
end;

initialization
  FormManager.RegisterForm(TZLEPoleZmWskDBDetailForm, sZLEModulID);
end.
