unit ZLEPrefixDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-06-12 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, Mask, DBCtrls,UNIStaleUnit, UNIDataModuleUnit;

type
  TZLEPrefixDBDetailForm = class(TUNIDBDetailForm)
    SymbolPanel: TUNIPanel;
    SymbolLabel: TUNILabel;
    NazwaLabel: TUNILabel;
    SymbolDBEdit: TUNIDBEdit;
    NazwaDBEdit: TUNIDBEdit;
    Pole1Panel: TUNIPanel;
    Pole1Label: TUNILabel;
    Pole1DBEdit: TUNIDBEdit;
    Pole2Panel: TUNIPanel;
    Pole2Label: TUNILabel;
    Pole2DBEdit: TUNIDBEdit;
    Pole3Panel: TUNIPanel;
    Pole3Label: TUNILabel;
    Pole3DBEdit: TUNIDBEdit;
  private
    procedure InitializeControls();
    procedure SetDefaults();
  protected
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen(); override;
  end;

var
  ZLEPrefixDBDetailForm: TZLEPrefixDBDetailForm;

implementation

{$R *.DFM}

uses FormManagerUnit, ZLEPrefixUnit, UNISysDataManagerUnit,
     FKDefUnit, ZLEDefUnit, Dodatki;

function TZLEPrefixDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLEPrefixDataModule.CreateOpen( self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZLEPrefixDBDetailForm.InitializeControls;
begin
  Pole1DBEdit.DataField := sZLEPrefix_Pole1;
  Pole2DBEdit.DataField := sZLEPrefix_Pole2;
  Pole3DBEdit.DataField := sZLEPrefix_Pole3;
  UNISysDM.FKUstawPolaMnemonika(sMnemonikZLEPrefix,
                                Pole1Panel,Pole2Panel,Pole3Panel,
                                SymbolDBEdit,
                                Pole1DBEdit,Pole2DBEdit,Pole3DBEdit);
end;

procedure TZLEPrefixDBDetailForm.InternalOpen;
begin
  InitializeControls();
  inherited;
  if OpenMode = omNew then SetDefaults();
end;

procedure TZLEPrefixDBDetailForm.SetDefaults;
begin
  //DMAQFbN(sUNIMODULZSI_ID).AsString := Parameters.Values[sUNIMODULZSI_ID];
end;

initialization
  FormManager.RegisterForm(TZLEPrefixDBDetailForm, sZLEModulID);
end.
