unit ZLESkladnikKontroliDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit;

type
  TZLESkladnikKontroliDBGridForm = class(TUNIDBGridForm)
  private
    procedure OpenDetail( AOpenMode: TOpenMode );
  protected
    FNazwaKlasy: String;
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
  public
    procedure InternalOpen(); override;
    property NazwaKlasy: String read FNazwaKlasy;
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  KeyManagerUnit,
  UNISysDefUnit,
  ZLEDefUnit;

{ TZLESkladnikKontroliDBGridForm }

procedure TZLESkladnikKontroliDBGridForm.Delete;
begin
  OpenDetail( omDelete );
end;

procedure TZLESkladnikKontroliDBGridForm.InternalOpen;
begin
  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;
  
  inherited;

end;

procedure TZLESkladnikKontroliDBGridForm.New;
begin
  OpenDetail( omNew );
end;

procedure TZLESkladnikKontroliDBGridForm.Open;
begin
  OpenDetail( omEdit );
end;

procedure TZLESkladnikKontroliDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var oParams: TKeyValues;
begin
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    if NazwaKlasy = cKlasaSkladnikWartosciowy then
      Add( cFORM_CAPTION+'='+'Skadnik kontroli wartociowej')
    else if NazwaKlasy = cKlasaSkladnikIlosciowy then
      Add( cFORM_CAPTION+'='+'Skadnik kontroli ilociowej');
    Add( sUNIODDZIAL_ID+'='+Parameters.Values[sUNIODDZIAL_ID]);
  end;

  //na razie formatki detail modalne
  AOpenMode := AOpenMode + omShowModal;
  FormManager.OpenDBDetail( Self, NazwaKlasy+cSuffixKlasyDBDetail, AOpenMode,
                            oParams );

  DataModule.ReOpenDataSets();
end;

procedure TZLESkladnikKontroliDBGridForm.View;
begin
  OpenDetail( omView );
end;

end.
