unit ZLESkladnikKontroliWartosciowejDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLESkladnikKontroliDBGridFormUnit, Db, DBTables, UNIComponentsUnit,
  URDataSet, UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls,
  DBCtrls, ToolWin, ExtCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZLESkladnikKontroliWartosciowejDBGridForm = class(TZLESkladnikKontroliDBGridForm)
  private
    procedure InitializeControls();
  protected
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
  public
    procedure InternalOpen(); override;
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  SecurityManagerUnit,
  ZLEDefUnit,
  ZLESkladnikKontroliWartosciowejUnit;

{ TZLESkladnikKontroliWartosciowejDBGridForm }

function TZLESkladnikKontroliWartosciowejDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLESkladnikKontroliWartosciowejDataModule.CreateOpen( Self, DefaultMasterKeyValues, AOpenMode ); 
end;

procedure TZLESkladnikKontroliWartosciowejDBGridForm.InitializeControls;
begin

end;

procedure TZLESkladnikKontroliWartosciowejDBGridForm.InternalOpen;
begin
  InitializeControls();
  
  inherited;

  FNazwaKlasy := cKlasaSkladnikWartosciowy;
  
end;

procedure TZLESkladnikKontroliWartosciowejDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_SKL_KONTR_WART_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_SKL_KONTR_WART_DOPISZ));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_SKL_KONTR_WART_ZMIEN));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_SKL_KONTR_WART_USUN));
  end;
end;

initialization
  FormManager.RegisterForm( TZLESkladnikKontroliWartosciowejDBGridForm,
                            'Lista skadnikw kontroli wartociowej',
                            sZLEModulID );

end.
