unit ZLESkladnikiECPDefUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When         Who      What
---------------------------------------------------------------------------------------------
2009-02-19  Tomjen     Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLESkladnikiECPDefDataModule = class(TUNIDataModule)
  protected
    procedure GetKeys; override;
    function  GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    procedure ReOpenDataSets; override;
  end;

var
  ZLESkladnikiECPDefDataModule: TZLESkladnikiECPDefDataModule;

implementation

uses
  ZLEDefUnit,
  SQLManagerUnit,
  UNIStaleUnit,
  QueryBuilderUnit,
  KDPRADefUnit,
  KDPRADataManagerExtUnit,
  KDECPDefUnit,
  KDECPDataManagerExtUnit;

{$R *.DFM}
procedure TZLESkladnikiECPDefDataModule.GetKeys;
begin
    with FKeys do begin
        Clear;
        AddPrimary(sZLESKLADNIKIECPDEF_ID);
    end;
end;

function TZLESkladnikiECPDefDataModule.GetTableName: string;
begin
  Result:=sZLESKLADNIKIECPDEF;
end;

procedure TZLESkladnikiECPDefDataModule.InitializeGridQueryDefs;
begin
  with GridColDefs do begin
    Clear;
    Add(sKDSKLADNIKCZASU_SYMBOL     ,'P' , 'Symbol' , true, true, taLeftJustify , 100);
    Add(sKDSKLADNIKCZASU_NAZWA      ,'P' , 'Nazwa'  , true, true, taLeftJustify , 200);
    AddRequiredAndUnvisible(sZLESKLADNIKIECPDEF_ID, 'Z', '');
    AddRequiredAndUnvisible(sKDSKLADNIKCZASU_ID, 'Z', '');

  end;  // with GridColDefs
  with GridTabDefs do begin
    Clear;
    Add('Z' , GetTableName);
    Add('P' , sKDSKLADNIKCZASU);

  end;  // with GridTabDefs
  with GridJoinDefs do Begin
    Clear;
    AddExpres('Z.' + sKDSKLADNIKCZASU_ID + ' = P.' + sKDSKLADNIKCZASU_ID, qjkInner, false);
    AddCondition('P.' + sKDSKLADNIKCZASU_TYPPOLA1 + '=' + QuotedStr(sTYPPOLA_GODZINY), true);
  end;  // with GridJoinDefs
  inherited;

end;

procedure TZLESkladnikiECPDefDataModule.ReOpenDataSets;
begin
 // ChangeMasterKey;
  inherited;
end;

end.
