unit ZLEUpdateUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.

Changes
---------------------------------------------------------------------------------------------
When       Who    What
---------------------------------------------------------------------------------------------
2004-11-22 gdeyk  Utworzone
2004-12-05 kk     31.2 - utworzenie tabeli sZLECOSOBYgODZ
2006-10-16 Tomjen Updaty 37.1-37.3 - nowa tabela ZLEPLROZDEF oraz dolozenie pol
                  do istniejacych tabel oraz domeny sZLECONST_PARSERBLAD
2007-02-05 Tomjen Tabela ZLEILOPIS
2007-06-20 Adam   Aktualizacja 37.8
2007-07-25 Adam   Aktualizacja 37.9
2007-09-11 Adam   Aktualizacja 37.10
2007-09-26 Adam   Aktualizacja 37.11
2007-10-15 Adam   Aktualizacja 37.12
2007-10-29 Tomjen Aktualizacja 37.13
2007-11-13 Adam   Aktualizacja 37.14
2007-11-21 Adam   Aktualizacja 37.17
2007-11-19 Tomjen Aktualizacja 37.18
2007-12-05 Tomjen Aktualizacja 37.19
2007-12-05 Tomjen Aktualizacja 37.20
2007-12-10 Adam   Aktualizacja 37.21
2007-12-10 Tomjen Aktualizacja 37.22
2007-12-17 Tomjen Aktualizacja 37.23
2008-01-03 Tomjen Aktualizacja 37.24
2008-01-11 Adam   Aktualizacja 37.25
2008-01-15 Tomjen Aktualizacja 37.26
2008-01-15 Tomjen Aktualizacja 37.27
2008-01-17 Tomjen Aktualizacja 37.28
2008-01-25 Tomjen Aktualizacja 37.29
2008-01-28 Tomjen Aktualizacja 37.30
2008-02-12 Adam   Aktualizacja 37.31
2008-02-28 Adam   Aktualizacja 37.33
2008-02-28 Tomjen Aktualizacja 37.34
2008-03-10 Adam   Aktualizacja 37.35
2008-03-19 Tomjen Aktualizacja 37.36
2008-03-25 Tomjen Aktualizacja 37.37
2008-04-08 Tomjen Aktualizacja 37.38
2008-05-21 Tomjen Aktualizacja 37.39
2008-06-17 Adam   Aktualizacja 37.40
2008-06-18 Tomjen Aktualizacja 37.41
2008-06-18 Adam   Aktualizacja 37.42
2008-07-14 Adam   Aktualizacja 37.45
2008-07-18 Adam   Aktualizacja 37.47
2008-07-22 Adam   Aktualizacja 37.48
2008-07-25 Tomjen Aktualizacja 37.49
2008-07-29 Adam   Aktualizacja 37.50
2008-08-01 Adam   Aktualizacja 37.51
2008-08-20 Tomjen Aktualizacja 37.52
2008-08-26 Adam   Aktualizacja 37.53 - Dodane pola LWPRECEPPOZOPER_ID i LWPRECEPPOZOPERZAM_ID do tabeli ZLEZLECENIEMAT
2008-08-28 Adam   Aktualizacja 37.54 - Dodane pole ZLEZLECENIEWYC_STATUS
2008-09-01 Adam   Aktualizacja 37.55 - Dodana tabela ZLEZASOBYPRACAMAGP
2008-10-21 Tomjen Aktualizacja 37.56 - Dodana tabela ZLEWSPNARZUTY
2008-11-08 Tomjen Aktualizacja 37.57 - aktualizacja ZLE_PACKAGE
2008-12-05 Tomjen Aktualizacja 37.59 - aktualizacja uprawnien
2009-01-06 Tomjen Aktualizacja 37.60 - dodanie pola ZLEKRYTERIA_OGRANICZ do tabeli ZLEKRYTERIA
2009-03-05 Adam   Aktualizacja 37.62 - poprawiony indeks unikalny na tabeli ZLEZLECENIEZASOB
2009-03-19 Tomjen Kolejno skadnikw w kontroli ilociowej i wartociowej
2009-03-31 Adam   Aktualizacja 37.64 - aktualizacja ZLE_PACKAGE
2009-05-06 Adam   Aktualizacja 37.67 - aktualizacja ZLE_PACKAGE
2009-05-12 Adam   Aktualizacja 37.68 - uzupenienie funkcjonalnoci
2009-06-26 Adam   Aktualizacja 37.69 - dodane pole LWPPLANPRODEL_ID do tabeli ZLEZLECENIEOBCY
2009-08-10 Adam   Aktualizacja 37.70 - aktualizacja ZLEXML_PACKAGE
2009-08-17 Tomjen Aktualizacja 37.71 - dodanie pola wartosc do pozycji zlecenia
2009-08-24 Tomjen Aktualizacja 37.72 - zmiany w ECP zlece
2009-09-14 Adam   Aktualizacja 37.74 - aktualizacja ZLEXML_PACKAGE
2009-09-15 Adam   Aktualizacja 37.75 - aktualizacja ZLEXML_PACKAGE - wycofanie poprawek z aktualizacji 37.74
2009-10-02 Adam   Aktualizacja 37.76 - zmiana typu constraintw w ZLEZLECENIEOBCY
2009-10-05 Adam   Aktualizacja 37.77 - dodane pole sZLEZLECENIEOBCY_BLAD
2009-10-08 Adam   Aktualizacja 37.78 - nowe funkcjonalnoci
2009-10-26 Tomjen Aktualizacja 37.79 - nowe funkcjonalnoci
2009-11-05 Tomjen Aktualizacja 37.80 - funkcja WART_PRACY z nowymi parametrami
2009-12-16 Adam   Aktualizacja 37.81 - aktualizacja ZLEXML_PACKAGE
2010-01-21 Tomjen Aktualizacja 37.82 -  Kontrola wykorzystania mnemonika XPJ
2010-01-26 Tomjen Aktualizacja 37.83 -  Dodanie pola ZLEZLECENIEPOZ_DATA
2010-03-08 Adam   Aktualizacja 37.84 - Zmiana typu pola ZLEZLECENIE_OBCY_ID na varchar2(21)
2010-03-11 Tomjen Aktualizacja 37.85 - Uprawnienia i Srodki trwae w zleceniach
2010-03-22 Adam   Aktualizacja 37.86 - Dodane pole typ raportu w rejestracji pracy zasobw
2010-03-22 Tomjen Aktualizacja 37.87 - Wspolpraca z ECP
2010-04-13 Tomjen Aktualizacja 37.88 - uzupelnienie okresu w rozliczeniach
2010-04-30 Adam   Aktualizacja 37.89 - Aktualizacja pakietu ZLEXML
2010-06-17 Tomjen Aktualizacja 37.90 - uzupelnienie osoby w rozliczeniach
2010-08-24 Tomjen Aktualizacja 37.91 - zastpienie tabel ZLEPOLAZM* widokami
2010-08-25 Tomjen Aktualizacja 37.92 - aktualizacja ZLE_PACKAGE
2010-09-06 Adam   Aktualizacja 37.93 - Dodane funkcjonalnoci do brakw
2010-09-09 Tomjen Aktualizacja 37.94 - nowa tabela ZLERAPORTEDIT
2010-09-20 Tomjen Aktualizacja 37.95 - Dodane funkcjonalnoci dla pol uzytkownika
2010-10-22 Tomjen Aktualizacja 37.96 - usunicie constraint ZLERAPORTEDIT + c_FRK + '1'
2010-11-04 Tomjen Aktualizacja 37.97 - dodanie pola KDSKLADNIKCZASU_ID do tabeli ZLEZASOBYPRACA
2010-11-09 Tomjen Aktualizacja 37.98 - Dodane funkcjonalnoci do kalendarzy
2010-12-15 Tomjen Aktualizacja 37.100- Dodane funkcjonalnoci - uproszczona lista zlecen
2010-12-30 Tomjen Aktualizacja 37.101- Dodane funkcjonalnoci - transport i sprzt
2011-03-02 Tomjen Aktualizacja 37.102- dodanie pola sZLEZASOBYPRACA_UWAGI do tabeli sZLEZASOBYPRACA
2011-03-02 Tomjen Aktualizacja 37.103- Aktualizacja ZLE_PACKAGE
2011-05-16 Tomjen Aktualizacja 37.104- Uprawnienie modyfikacji daty blokady RCP
2011-05-23 Tomjen Aktualizacja 37.105- Uprawnienie - blokada edycji zakoczonego zlecenia
2011-05-23 Tomjen Aktualizacja 37.106 - dodanie pola ZLEZASOBYPRACA_DATA_DO do tabeli ZLEZASOBYPRACA
2011-05-30 Tomjen Aktualizacja 37.107 - dodanie pola sZLEZLECENIEPOZ_CENA do tabeli sZLEZLECENIEPOZ
2011-06-27 Tomjen Aktualizacja 37.108 - Nowa tabela ZLETYPZLECUSERS oraz nowe uprawnienia
2011-08-18 Tomjen Aktualizacja 37.109 - Nowe pola w tabeli sZLEZASOBYPRACA
2011-09-14 Tomjen Aktualizacja 37.110 - Poprawienie wartoci w ECP zlece
2011-12-19 Tomjen Aktualizacja 37.111 - Nowe pole w tabeli sZLESKLADIL sZLESKLADIL_NIEOKRESOWY
2012-05-30 Tomjen Aktualizacja 37.114 - Aktualizacja funkcji ZLE_POBIERZ_ID_OBCY
}
interface

uses Classes, SysUtils, db;

procedure DajListeAktualizacji( oLista: TStringList );
function UruchomAktualizacje(nr: string): boolean;

procedure DopiszMnemonik( const ac_sMnemonik, ac_sNazwa, ac_sTabela,
                                ac_sLokalizacja: String;
                                a_bFirmowy: Boolean = False;
                                a_sOpis: String = '' );

implementation

uses
  Dodatki,
  SQLManagerUnit,
  SecurityManagerUnit,
  UNIComponentsUnit,
  UNIDataManagerUnit,
  UNISysDataManagerUnit,
  UNIStaleUnit,
  LWPDefUnit,
  UNISYSDefUnit,
  SystemDefUnit,
  ASODefUnit,
  BOKDefUnit,
  LFKDefUnit,
  INFDefUnit,
  FKDefUnit,
  KDPRADefUnit,
  ZLEDefUnit,
  SPDefUnit,
  UNIINTDefUnit,
  ZLEDataManagerUnit,
  forms,
  math,
  ProgressFormUnit,
  UniqueKeyUnit;

procedure DajListeAktualizacji( oLista: TStringList );
begin
  with oLista do begin
    Add('32.1');
    Add('32.2');
    Add('33.1');
    AddObject( '34.0', TUpdateItem.Create( 'Tworzenie tabeli ZLEZASOB','2005-02-22' ));
    AddObject( '34.1', TUpdateItem.Create( 'Tworzenie tabeli ZLEZLECENIEZASOB','2005-02-23' ));
    AddObject( '34.2', TUpdateItem.Create( 'Tworzenie tabeli ZLEZLECENIEROZL','2005-02-26' ));
    AddObject( '34.3', TUpdateItem.Create( 'Uzupenienie pl technicznych','2005-02-27' ));
    AddObject( '35.0', TUpdateItem.Create( 'Usunicie indeksu unikalnego','2005-05-19' ));
    AddObject( '35.1', TUpdateItem.Create( 'Dodanie pl dekretacyjnych do pozycji','2005-06-28' ));
    AddObject( '35.2', TUpdateItem.Create( 'Dodanie liczby porzdkowej do pozycji','2005-07-11' ));
    AddObject( '35.3', TUpdateItem.Create( 'Przenumerowanie pozycji zlece','2005-07-11' ));
    AddObject( '35.4', TUpdateItem.Create( 'Uzupenienie funkcjonalnoci','2005-07-11' ));
    AddObject( '35.5', TUpdateItem.Create( 'Zmodyfikowanie ZLEZLECENIEROZL_F1 ''cascade''','2005-08-11' ));
    AddObject( '35.6', TUpdateItem.Create( 'Zmodyfikowanie ZLEZLECENIEZASOB_F1 ''cascade''','2005-08-11' ));

    AddObject( '36.0', TUpdateItem.Create( 'Rozszerzenie definicji tabeli '+sZLESKLADWART,'2005-11-21' ));
    AddObject( '36.1', TUpdateItem.Create( 'Parametr - Ewidencja Zuycia Paliwa','2005-11-30' ));
    AddObject( '36.2', TUpdateItem.Create( 'Zlecenia - Pola Uytkownika','2005-12-20' ));
    AddObject( '36.3', TUpdateItem.Create( 'Zlecenia - Usuniecie Constrainta','2006-02-15' ));

    AddObject( '37.0', TUpdateItem.Create( 'Zlecenia - Pola uytkownika typu data zapisywane w wyniku rzutowania Daty na String zamiast dotychczasowego rzutowania daty jako Integera na String','2006-02-15' ));
    AddObject( '37.1', TUpdateItem.Create( 'Zlecenia - Warto pracy z pac','2006-10-05' ));
    AddObject( '37.2', TUpdateItem.Create( 'Zlecenia - dodanie pola Ilo pracy do tabeli ' +sZLEOSOBYGODZ ,'2006-10-10' ));
    AddObject( '37.3', TUpdateItem.Create( 'Zlecenia - dodanie pola ' + sZLEWART_BLAD + ' do tabeli ' +sZLEWART + ' oraz domeny ' + sZLECONST_PARSERBLAD,'2006-10-16' ));
    AddObject( '37.4', TUpdateItem.Create( 'Zlecenia - wyduenie pola ' + sZLEPOLAZM_WART + ' w tabeli ' +sZLEPOLAZM,'2006-11-17' ));
    AddObject( '37.5', TUpdateItem.Create( 'Zlecenia - Usuniecie Constrainta ZLEZLECENIEROZL_F1','2006-12-18' ));
    AddObject( '37.6', TUpdateItem.Create( 'Zlecenia - Dodanie pola JEDNOSTKA ORG. do zasobw','2007-01-31' ));
    AddObject( '37.7', TUpdateItem.Create( 'Zlecenia - Nowa tabela ' + sZLEILOPIS,'2007-02-05' ));
    AddObject( '37.8', TUpdateItem.Create( 'Pole Stawka w zasobie moe by puste (zalenie od parametru)', '2007-06-20' ));
    AddObject( '37.9', TUpdateItem.Create( 'Dodane pole ZLEZLECENIEPOZ_ILOSC', '2007-07-25' ));

    AddObject( '37.10', TUpdateItem.Create('Dodana tabela ZLEZLECENIEMAT', '2007-09-11' ));
    AddObject( '37.11', TUpdateItem.Create('Dodanie pl LWPRECEPPOZZASOB_ID i ZLEZASOB_OBCIAZENIE_MAX do tabel ZLEZLECENIEZASOB i ZLEZASOB', '2007-09-26' ));
    AddObject( '37.12', TUpdateItem.Create('Dodanie pl ZLEZLECENIEZASOB_PLAN i ZLEZLECENIEZASOB_OBCIAZ do tabeli ZLEZLECENIEZASOB', '2007-10-15' ));
    AddObject( '37.13', TUpdateItem.Create('Ewidencja czasu pracy zasobw', '2007-10-29' ));
    AddObject( '37.14', TUpdateItem.Create('Dodana grupa kalendarzowa do zasobu', '2007-11-13' ));
    AddObject( '37.15', TUpdateItem.Create('Zmina formatu pl ''ZLEOSOBYGODZ_ILOSC'' i ''ZLEOSOBYGODZ_IL_PRACY'' - zamiast godzin - minuty', '2007-11-06' ));
    AddObject( '37.16', TUpdateItem.Create('Zmina formatu pl ''ZLEZLECENIEROZL_GODZINY'' - zamiast godzin - minuty', '2007-11-09' ));
    AddObject( '37.17', TUpdateItem.Create('Dodana wydajno oraz jednostka czasu obcienia i wydajnoci do zasobu zlecenia produkcyjnego', '2007-11-21' ));
    AddObject( '37.18', TUpdateItem.Create('Ewidencja czasu pracy zasobw - c.d.', '2007-11-19' ));
    AddObject( '37.19', TUpdateItem.Create('Zmiana formatu pola ZLEOSOBYGODZ_IL_PRACY', '2007-12-05' ));
    AddObject( '37.20', TUpdateItem.Create('Zmiana wymagalnoci pola ZLEZLECENIE_ID w tabeli ZLEZASOBYPRACA', '2007-12-06' ));

    AddObject( '37.21', TUpdateItem.Create('Zmieniony indeks unikalny ZLEZLECENIEZASOB_UNK1', '2007-12-10' ));
    AddObject( '37.22', TUpdateItem.Create('Dopisanie pl ZLEZASOB_SYMBOL, ZLEZASOB_LICZNIK, UNIAUTNUM do tabeli ZLEZASOB', '2007-12-10' ));
    AddObject( '37.23', TUpdateItem.Create('Dopisanie pola ' + sLWPRECEPPOZ_ID + ' do tabeli ZLEZASOB oraz numaratora zasobw', '2007-12-17' ));
    AddObject( '37.24', TUpdateItem.Create('Zmiana wymagalnoci pola ASORTYMENT w pozycji zlecenie', '2008-01-03'));
    AddObject( '37.25', TUpdateItem.Create('Dodana tabela kosztw pracy zasobw na zleceniu', '2008-01-11'));
    AddObject( '37.26', TUpdateItem.Create('Dodanie mnemonika Zasoby', '2008-01-15'));
    AddObject( '37.27', TUpdateItem.Create('Parametr - format pola godzin w rozliczeniach', '2008-01-15'));
    AddObject( '37.28', TUpdateItem.Create('Dodanie pola ZLEZLECENIEPOZ_ID do tabeli ZLEOSOBYGODZ', '2008-01-17'));
    AddObject( '37.29', TUpdateItem.Create('Kryteria w zleceniach', '2008-01-25'));
    AddObject( '37.30', TUpdateItem.Create('Sownik oddziaw w numeratorze zlece', '2008-01-28'));

    AddObject( '37.31', TUpdateItem.Create('Uzupenienie funkcjonalnoci','2008-02-12' ));
    AddObject( '37.32', TUpdateItem.Create('Utworzenie ZLE_Package','2008-02-22' ));
    AddObject( '37.33', TUpdateItem.Create('Poprawa wpisw wyceny zlece', '2008-02-28'));
    AddObject( '37.34', TUpdateItem.Create('Sprawdzenie wizw tabeli ZLEZASOBYPRACA', '2008-02-28'));
    AddObject( '37.35', TUpdateItem.Create('Zwikszenie precyzji pola ' + sZLEZLECENIEWYC_KOSZT, '2008-03-10'));
    AddObject( '37.36', TUpdateItem.Create('Dodanie pola format do kryterium', '2008-03-19'));
    AddObject( '37.37', TUpdateItem.Create('Warunki kryteriw', '2008-03-25'));
    AddObject( '37.38', TUpdateItem.Create('Usunicie indeksu ' + sZLEZLECENIEPOZ +c_UNK + '1', '2008-04-08'));
    AddObject( '37.39', TUpdateItem.Create('Dodanie pola obiekt infrastruktury do kryterium', '2008-05-21'));
    AddObject( '37.40', TUpdateItem.Create('Dodana tabela ' + sZLEZLECENIEOBCY, '2008-06-17'));

    AddObject( '37.41', TUpdateItem.Create('Dodanie mnemonika Prefiks zlece', '2008-06-18'));
    AddObject( '37.42', TUpdateItem.Create('Uzupenienie funkcjonalnoci', '2008-06-18'));
    AddObject( '37.43', TUpdateItem.Create('Dodane pole ' + sZLEZASOBYPRACA_STATUS, '2008-07-08'));
    AddObject( '37.44', TUpdateItem.Create('Uzupenienie funkcjonalnoci', '2008-07-09'));
    AddObject( '37.45', TUpdateItem.Create('Aktualizacja ZLE_Package','2008-07-14', 1));
    AddObject( '37.46', TUpdateItem.Create('Dodane konto materiaowe do materiaw zlecenia', '2008-07-15', 1));
    AddObject( '37.47', TUpdateItem.Create('Aktualizacja ZLE_Package', '2008-07-18', 1));
    AddObject( '37.48', TUpdateItem.Create('Aktualizacja ZLE_Package', '2008-07-22', 2));
    AddObject( '37.49', TUpdateItem.Create('Dodanie pola format do kosztw wartociowych', '2008-07-25'));
    AddObject( '37.50', TUpdateItem.Create('Aktualizacja ZLE_Package', '2008-07-29', 2));

    AddObject( '37.51', TUpdateItem.Create('Aktualizacja ZLE_Package', '2008-08-01'));
    AddObject( '37.52', TUpdateItem.Create('Aktualizacja ZLE_Package i ZLEXML_Package', '2008-08-20', 2));
    AddObject( '37.53', TUpdateItem.Create('Aktualizacja tabeli ZLEZLECENIEMAT', '2008-08-26' ));
    AddObject( '37.54', TUpdateItem.Create('Dodane pole ' + sZLEZLECENIEWYC_STATUS + ' i uzupenienie funkcjonalnoci', '2008-08-28'));
    AddObject( '37.55', TUpdateItem.Create('Dodana tabela ' + sZLEZASOBYPRACAMAGP + ' i uzupenienie funkcjonalnoci', '2008-09-01'));
    AddObject( '37.56', TUpdateItem.Create('Dodana tabela ' + sZLEWSPNARZUTY + ' i uzupenienie funkcjonalnoci', '2008-10-21'));
    AddObject( '37.57', TUpdateItem.Create('Aktualizacja ZLE_Package', '2008-11-08', 2));
    AddObject( '37.58', TUpdateItem.Create('Zmiana definicji regu w kryteriach', '2008-11-13'));
    AddObject( '37.59', TUpdateItem.Create('Uzupenienie funkcjonalnoci', '2008-12-05'));
    AddObject( '37.60', TUpdateItem.Create('Dodanie pole ' + sZLEKRYTERIA_OGRANICZ + ' do tabeli ' + sZLEKRYTERIA, '2009-01-06'));

    AddObject( '37.61', TUpdateItem.Create('Dodana tabela ' + sZLESKLADNIKIECPDEF, '2009-02-19'));
    AddObject( '37.62', TUpdateItem.Create('poprawiony indeks unikalny na tabeli ' + sZLEZLECENIEZASOB, '2009-03-05'));
    AddObject( '37.63', TUpdateItem.Create('Kolejno skadnikw w kontroli ilociowej i wartociowej', '2009-03-19'));
    AddObject( '37.64', TUpdateItem.Create('Aktualizacja ZLE_Package', '2009-03-31'));
    AddObject( '37.65', TUpdateItem.Create('Definicja predefiniowanych zakadek dla pl uytkownika', '2010-07-08', 3));
    AddObject( '37.66', TUpdateItem.Create('Przeniesienie pl uytkownika do UNISYS', '2010-07-08', 4));
    // ?? Co z tym updatem  -- AddObject( '37.67', TUpdateItem.Create('Aktualizacja domeny ZLECONST_STATUS', '2009-04-30'));
    AddObject( '37.67', TUpdateItem.Create('Aktualizacja ZLE_Package', '2009-05-06'));
    AddObject( '37.68', TUpdateItem.Create('Uzupenienie funkcjonalnoci', '2009-05-12'));
    AddObject( '37.69', TUpdateItem.Create('Dodane pole LWPPLANPRODEL_ID do tabeli ZLEZLECENIEOBCY', '2009-05-12'));
    AddObject( '37.70', TUpdateItem.Create('Aktualizacja ZLEXML_Package', '2009-08-10', 1));

    AddObject( '37.71', TUpdateItem.Create('Dodanie wartosci do pozycji zlecenia', '2009-08-17'));
    AddObject( '37.72', TUpdateItem.Create('Zmiany w ECP zlece', '2009-10-15'));
    AddObject( '37.73', TUpdateItem.Create('Przebudowa pakietu '+sZLEXML_PACKAGE,'2007-09-07')); //kkowalczuk
    AddObject( '37.74', TUpdateItem.Create('Aktualizacja ZLEXML_Package', '2009-09-14'));
    AddObject( '37.75', TUpdateItem.Create('Aktualizacja ZLEXML_Package', '2009-09-15'));
    AddObject( '37.76', TUpdateItem.Create('Zmiana typu constraint na restrict w ' + sZLEZLECENIEOBCY, '2009-10-02'));
    AddObject( '37.77', TUpdateItem.Create('dodane pole ' + sZLEZLECENIEOBCY_BLAD, '2009-10-05'));
    AddObject( '37.78', TUpdateItem.Create('Uzupenienie funkcjonalnoci', '2009-10-08'));
    AddObject( '37.79', TUpdateItem.Create('Uzupenienie funkcjonalnoci', '2009-10-26',2));
    AddObject( '37.80', TUpdateItem.Create('Nowe parametry dla funkcji WART_PRACY, ILOSC_PRACY oraz ILOSC_GODZ', '2009-11-06'));

    AddObject( '37.81', TUpdateItem.Create('Aktualizacja ZLEXML_Package', '2009-12-16'));
    AddObject( '37.82', TUpdateItem.Create('Kontrola wykorzystania mnemonika XPJ', '2010-01-21'));
    AddObject( '37.83', TUpdateItem.Create('Dodanie pola ' + sZLEZLECENIEPOZ_DATA + ' do tabeli ' + sZLEZLECENIEPOZ, '2010-01-26'));
    AddObject( '37.84', TUpdateItem.Create('Zmiana typu pola ZLEZLECENIE_OBCY_ID na varchar2(21)','2010-03-08'));
    AddObject( '37.85', TUpdateItem.Create('Uprawnienia i Srodki trwae w zleceniach', '2010-03-11'));
    AddObject( '37.86', TUpdateItem.Create('Dodane pole "Typ raportu" w rejestracji pracy zasobw', '2010-03-30', 1));
    AddObject( '37.87', TUpdateItem.Create('Wsppraca z moduem KDECP w zleceniach', '2010-03-22'));
    AddObject( '37.88', TUpdateItem.Create('Uzupenienie okresu w rozliczeniach', '2010-04-13'));
    AddObject( '37.89', TUpdateItem.Create('Aktualizacja pakietu ZLEXML', '2010-04-30'));
    AddObject( '37.90', TUpdateItem.Create('Uzupenienie osoby w rozliczeniach', '2010-06-17'));

    AddObject( '37.91', TUpdateItem.Create('Zastapienie tabel ZLEPOLAZM* widokami', '2010-07-08',5));
    AddObject( '37.92', TUpdateItem.Create('Aktualizacja ZLE_Package', '2010-08-25'));
    AddObject( '37.93', TUpdateItem.Create('Dodane funkcjonalnoci sownika brakw', '2010-09-06'));
    AddObject( '37.94', TUpdateItem.Create('Dodana tabela ' + sZLERAPORTEDIT, '2010-09-09'));
    AddObject( '37.95', TUpdateItem.Create('Uzupenienie funkcjonalnoci', '2010-09-20'));
    AddObject( '37.96', TUpdateItem.Create('Usunicie ograniczenia ' + sZLERAPORTEDIT + c_FRK + '1', '2010-10-22'));
    AddObject( '37.97', TUpdateItem.Create('Dodanie pola ' + sKDSKLADNIKCZASU_ID + ' do tabeli ' + sZLEZASOBYPRACA, '2010-11-04'));
    AddObject( '37.98', TUpdateItem.Create('Uzupenienie funkcjonalnoci', '2010-11-09'));
    AddObject( '37.99', TUpdateItem.Create('Import kalendarzy czasu pracy zasobw z pliku tekstowego', '2010-12-06'));
    AddObject( '37.100', TUpdateItem.Create('Uzupenienie funkcjonalnoci', '2010-12-15'));

    AddObject( '37.101', TUpdateItem.Create('Uzupenienie funkcjonalnoci', '2010-12-30'));
    AddObject( '37.102', TUpdateItem.Create('Dodanie pola ' + sZLEZASOBYPRACA_UWAGI + ' do tabeli ' + sZLEZASOBYPRACA, '2011-03-02'));
    AddObject( '37.103', TUpdateItem.Create('Aktualizacja ZLE_Package', '2011-03-02'));
    AddObject( '37.104', TUpdateItem.Create('Uzupenienie funkcjonalnoci - Uprawnienie modyfikacji daty blokady RCP', '2011-05-16'));
    AddObject( '37.105', TUpdateItem.Create('Uzupenienie funkcjonalnoci - Uprawnienie - blokada edycji zakoczonego zlecenia', '2011-05-23'));
    AddObject( '37.106', TUpdateItem.Create('Dodanie pola ' + sZLEZASOBYPRACA_DATA_DO + ' do tabeli ' + sZLEZASOBYPRACA, '2011-05-23'));
    AddObject( '37.107', TUpdateItem.Create('Dodanie pola ' + sZLEZLECENIEPOZ_CENA + ' do tabeli ' + sZLEZLECENIEPOZ, '2011-05-30'));
    AddObject( '37.108', TUpdateItem.Create('Nowa tabela ' + sZLETYPZLECUSERS + ' oraz nowe uprawnienia', '2011-06-27'));
    AddObject( '37.109', TUpdateItem.Create('Nowe pola w tabeli ' + sZLEZASOBYPRACA, '2011-08-18'));
    AddObject( '37.110', TUpdateItem.Create('Poprawienie danych w tabeli ECP zlece', '2011-09-14'));

    AddObject( '37.111', TUpdateItem.Create('Nowe pola w tabeli ' + sZLESKLADIL, '2011-12-19'));
    AddObject( '37.112', TUpdateItem.Create('Rozliczanie akordu w ECP zlece', '2012-01-18'));
    AddObject( '37.113', TUpdateItem.Create('Aktualizacja pakietw i funkcji osadzonych', '2012-05-29'));
    AddObject( '37.114', TUpdateItem.Create('Aktualizacja funkcji osadzonej ZLE_POBIERZ_ID_OBCY', '2012-05-30'));
  end;
end;

function UruchomAktualizacje(nr: string): boolean;
var
  sSQL, sRegula, sTmp: String;
  oSplit: TSplit;
  iIndex: Integer;
  ConstraintDefs: TUNIConstraintDefs;
  oIndexDefs: TIndexDefs;
  oFieldDefs: TUNIFieldDefs;
  FC: TFunkCollection;
  oQuery, oUpdate, oUpdateQuery: TUNIQuery;
  i, j, Code, iNumID, iLicznik, iRes: Integer;
  bTrans, bNarzut: Boolean;
  oSP: TUniStoredProc;
begin
  result := true;
  if nr = '32.1' then begin
    sSQL := 'ALTER TABLE %s MODIFY '+sZLECONST_SKLADNIK_ID+' VARCHAR2(1)';
    SQLManager.ExecuteQuery( sSQL, [sZLECONST_SKLADNIK] );

    sSQL := 'select tablespace_name FROM all_tables '+
            'where (table_name='+QuotedStr(sZLESKLADIL)+')and'+
            '(owner='+QuotedStr(SecurityManager.AdminSchema)+')';
    if SQLManager.OpenQueryWithResult( sSQL ) <> 'UNISOFT2DATA' then begin
      //zmiana tablespace tabeli ZLESKLADIL
      SQLManager.ZalozTabliceZDataManagera( sZLEModulID, sZLESKLADIL, sZLESKLADIL+'2' );
      sSQL := 'INSERT INTO %s SELECT '+ZLEDM.DajNazwyPolTabeli( sZLESKLADIL )+' '+'FROM %s';
      SQLManager.ExecuteQuery( sSQL, [sZLESKLADIL+'2',sZLESKLADIL] );
      sSQL := 'DROP TABLE %s CASCADE CONSTRAINTS';
      SQLManager.ExecuteQuery( sSQL, [sZLESKLADIL] );
      sSQL := 'ALTER TABLE %s RENAME TO '+sZLESKLADIL;
      SQLManager.ExecuteQuery( sSQL, [sZLESKLADIL+'2'] );
      sSQL := 'ALTER TABLE %s RENAME CONSTRAINT '+sZLESKLADIL+'2'+c_PRK+' TO '+sZLESKLADIL+c_PRK;
      SQLManager.ExecuteQuery( sSQL, [sZLESKLADIL] );
      SQLManager.ZalozNaTabliceConstaintsZDataManagera( sZLEModulID, sZLESKLADIL );
      sSQL := 'ALTER TABLE %s ADD CONSTRAINT '+sZLEIL+c_FRK+'3'+' FOREIGN KEY('+sZLESKLADIL_ID+') '+
              'REFERENCES %s('+sZLESKLADIL_ID+')';
      SQLManager.ExecuteQuery( sSQL, [sZLEIL,sZLESKLADIL] );
      sSQL := 'ALTER TABLE %s ADD CONSTRAINT '+sZLETYPSKLADIL+c_FRK+'2'+' FOREIGN KEY('+sZLESKLADIL_ID+') '+
              'REFERENCES %s('+sZLESKLADIL_ID+')';
      SQLManager.ExecuteQuery( sSQL, [sZLETYPSKLADIL,sZLESKLADIL] );
    end;

    sSQL := 'select tablespace_name FROM all_tables '+
            'where (table_name='+QuotedStr(sZLESKLADWART)+')and'+
            '(owner='+QuotedStr(SecurityManager.AdminSchema)+')';
    if SQLManager.OpenQueryWithResult( sSQL ) <> 'UNISOFT2DATA' then begin
      //zmiana tablespace tabeli ZLESKLADWART
      SQLManager.ZalozTabliceZDataManagera( sZLEModulID, sZLESKLADWART, sZLESKLADWART+'2' );
      sSQL := 'INSERT INTO %s SELECT '+ZLEDM.DajNazwyPolTabeli( sZLESKLADWART )+' '+'FROM %s';
      SQLManager.ExecuteQuery( sSQL, [sZLESKLADWART+'2',sZLESKLADWART] );
      sSQL := 'DROP TABLE %s CASCADE CONSTRAINTS';
      SQLManager.ExecuteQuery( sSQL, [sZLESKLADWART] );
      sSQL := 'ALTER TABLE %s RENAME TO '+sZLESKLADWART;
      SQLManager.ExecuteQuery( sSQL, [sZLESKLADWART+'2'] );
      sSQL := 'ALTER TABLE %s RENAME CONSTRAINT '+sZLESKLADWART+'2'+c_PRK+' TO '+sZLESKLADWART+c_PRK;
      SQLManager.ExecuteQuery( sSQL, [sZLESKLADWART] );
      SQLManager.ZalozNaTabliceConstaintsZDataManagera( sZLEModulID, sZLESKLADWART );
      sSQL := 'ALTER TABLE %s ADD CONSTRAINT '+sZLEWART+c_FRK+'3'+' FOREIGN KEY('+sZLESKLADWART_ID+') '+
              'REFERENCES %s('+sZLESKLADWART_ID+')';
      SQLManager.ExecuteQuery( sSQL, [sZLEWART,sZLESKLADWART] );
      sSQL := 'ALTER TABLE %s ADD CONSTRAINT '+sZLETYPSKLADW+c_FRK+'2'+' FOREIGN KEY('+sZLESKLADWART_ID+') '+
              'REFERENCES %s('+sZLESKLADWART_ID+')';
      SQLManager.ExecuteQuery( sSQL, [sZLETYPSKLADW,sZLESKLADWART] );
    end;
  end else
  if nr = '32.2' then begin
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEOSOBYGODZ, sZLEOSOBYGODZ);
    SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEOSOBYGODZ);
  end else
  if nr = '33.1' then begin
    try
      ConstraintDefs := TUNIConstraintDefs.Create();
      ZLEDM.DajDefinicjeConstraints( sZLETYPSKLADW, ConstraintDefs );
      SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa( sZLETYPSKLADW, ConstraintDefs.Items[ConstraintDefs.IndexOf(sZLETYPSKLADW+c_FRK+'1')] );
      ZLEDM.DajDefinicjeConstraints( sZLETYPSKLADIL, ConstraintDefs );
      SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa( sZLETYPSKLADIL, ConstraintDefs.Items[ConstraintDefs.IndexOf(sZLETYPSKLADIL+c_FRK+'1')] );
    finally
      if ConstraintDefs <> nil then ConstraintDefs.Free;
    end;
  end else
  if nr = '34.0' then begin
    SQLManager.FixDomain( sZLECONST_RODZAJZASOBU, cslZLERodzajZasobu );
    SQLManager.ZalozTabliceZDataManagera( sZLEModulID, sZLEZASOB, sZLEZASOB );
    SQLManager.ZalozNaTabliceConstaintsZDataManagera( sZLEModulID, sZLEZASOB );
    sSQL := 'ALTER TABLE %s ADD ('+sBOKSPRAWA_ID+' '+SQLManager.GetSQLType(uftInteger)+','+
                                   sZLEZLECENIEPOZ_POZIOMINF+' '+SQLManager.GetSQLType(uftString,2)+','+
                                   sZLEZLECENIEPOZ_INF_ID+' '+SQLManager.GetSQLType(uftInteger)+')';
    SQLManager.ExecuteQuery( sSQL, [sZLEZLECENIEPOZ]);
    try
      ConstraintDefs := TUNIConstraintDefs.Create();
      ZLEDM.DajDefinicjeConstraints( sZLEZLECENIEPOZ, ConstraintDefs );
      if ConstraintDefs.IndexOf(sZLEZLECENIEPOZ+c_FRK+'3') <> -1 then
        SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa( sZLEZLECENIEPOZ, ConstraintDefs.Items[ConstraintDefs.IndexOf(sZLEZLECENIEPOZ+c_FRK+'3')] );
    finally
      if ConstraintDefs <> nil then ConstraintDefs.Free;
    end;
  end else
  if nr = '34.1' then begin
    SQLManager.ZalozTabliceZDataManagera( sZLEModulID, sZLEZLECENIEZASOB, sZLEZLECENIEZASOB );
    SQLManager.ZalozNaTabliceConstaintsZDataManagera( sZLEModulID, sZLEZLECENIEZASOB );
  end else
  if nr = '34.2' then begin
    SQLManager.ZalozTabliceZDataManagera( sZLEModulID, sZLEZLECENIEROZL, sZLEZLECENIEROZL );
    SQLManager.ZalozNaTabliceConstaintsZDataManagera( sZLEModulID, sZLEZLECENIEROZL );
  end else
  if nr = '34.3' then begin
    sSQL := 'ALTER TABLE %%s ADD( %0:s_UZ_AU_ID '+SQLManager.GetSQLType(uftInteger)+' DEFAULT 1 NOT NULL,'+
                                '%0:s_DATA_AU '+SQLManager.GetSQLType(uftDateTime)+' DEFAULT CURRENT_DATE NOT NULL,'+
                                '%0:s_UZ_ZM_ID '+SQLManager.GetSQLType(uftInteger)+','+
                                '%0:s_DATA_ZM '+SQLManager.GetSQLType(uftDateTime)+')';
    oSplit := TSplit.Create(ZLEDM.DajNazwyTablic(),';','');
    try
      for iIndex := 0 to oSplit.Count-1 do
        try
          SQLManager.ExecuteQuery( Format( sSQL, [oSplit.Items[iIndex]] ),
                                   [oSplit.Items[iIndex]] );
        except
          //zabezpieczamy si przed istnieniem ju powyszych pl
        end;
    finally
      if oSplit <> nil then oSplit.Free;
    end;
  end else
  if nr = '35.0' then begin
    oFieldDefs := TUNIFieldDefs.Create();
    oIndexDefs := TIndexDefs.Create(nil);
    try
      sSQL := 'DROP INDEX %s'+c_UNK+'1';
      SQLManager.ExecuteQuery( sSQL, [sZLEZLECENIEPOZ] );
    except
    end;
    try
      ZLEDM.DajDefinicjeTablicy( sZLEZLECENIEPOZ, oFieldDefs, oIndexDefs );
      if oIndexDefs.IndexOf( c_UNK+'1' ) > -1 then begin
        sSQL := SQLManager.DajSkryptIndeksu( sZLEZLECENIEPOZ, oIndexDefs.Find( c_UNK+'1' ) );
        SQLManager.ExecuteQuery( sSQL );
      end;
    finally
      oFieldDefs.Free;
      oIndexDefs.Free;
    end;
  end else
  if nr = '35.1' then begin
    //ZLEDM.UpdateTable( sZLEZLECENIEPOZ, sZLEZLECENIEPOZ_SYMBOL );
    ZLEDM.UpdateTable( sZLEZLECENIEPOZ, sLFKWZORDEKR_ID, False, True );
  end else
  if nr = '35.2' then begin
    try
      sSQL := 'DROP INDEX %s'+c_UNK+'2';
      SQLManager.ExecuteQuery( sSQL, [sZLEZLECENIEPOZ] );
    except
    end;
    sSQL := 'ALTER TABLE %s DROP COLUMN ZLEZLECENIEPOZ_SYMBOL';
    try
      SQLManager.ExecuteQuery( sSQL, [sZLEZLECENIEPOZ] );
    except
    end;
    ZLEDM.UpdateTable( sZLEZLECENIEPOZ, sZLEZLECENIEPOZ_LP, True );
    try
      oQuery := ZLEDM.ZLEOdpytajODane( sZLEZLECENIE, sZLEAlias_Zlecenie_Id, '',
                                       False );
      sSQL := 'update %s set '+sZLEZLECENIEPOZ_LP+'=rownum '+
              'where '+sZLEZLECENIE_ID+'=:'+sZLEZLECENIE_ID;
      oUpdate := TUNIQuery.Create(nil);
      SQLManager.PrepareQuery( oUpdate, sSQL, [sZLEZLECENIEPOZ] );
      if oQuery <> nil then
        while not oQuery.Eof do begin
          oUpdate.ParamByName(sZLEZLECENIE_ID).AsInteger := oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
          oUpdate.ExecSQL( False );
          oQuery.Next;
        end;
    finally
      FreeAndNil(oUpdate);
      FreeAndNil(oQuery);
    end;
    oFieldDefs := TUNIFieldDefs.Create();
    oIndexDefs := TIndexDefs.Create(nil);
    try
      ZLEDM.DajDefinicjeTablicy( sZLEZLECENIEPOZ, oFieldDefs, oIndexDefs );
      if oIndexDefs.IndexOf( c_UNK+'2' ) > -1 then begin
        sSQL := SQLManager.DajSkryptIndeksu( sZLEZLECENIEPOZ, oIndexDefs.Find( c_UNK+'2' ) );
        SQLManager.ExecuteQuery( sSQL );
      end;
    finally
      oFieldDefs.Free;
      oIndexDefs.Free;
    end;
  end else
  if nr = '35.3' then begin
  end else
  if nr = '35.4' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else
  if nr = '35.5' then begin
    ConstraintDefs := TUNIConstraintDefs.Create();
    try
      ZLEDM.DajDefinicjeConstraints(sZLEZLECENIEROZL, ConstraintDefs);
      SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa(sZLEZLECENIEROZL, ConstraintDefs[ConstraintDefs.IndexOf(sZLEZLECENIEROZL + c_FRK + '1')]);
    finally
      FreeAndNil(ConstraintDefs);
    end;
  end else
  if nr = '35.6' then begin
    ConstraintDefs := TUNIConstraintDefs.Create();
    try
      ZLEDM.DajDefinicjeConstraints(sZLEZLECENIEZASOB, ConstraintDefs);
      SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa(sZLEZLECENIEZASOB, ConstraintDefs[ConstraintDefs.IndexOf(sZLEZLECENIEZASOB + c_FRK + '1')]);
    finally
      FreeAndNil(ConstraintDefs);
    end;
  end else
  if nr = '36.0' then begin
    ZLEDM.UpdateTable( sZLESKLADWART, sZLESKLADWART_SYMULACJA, True, True );
  end else
  if nr = '36.1' then begin
    {Dolozenie pola sZLEZLECENIEROZL_ZUZ_PALIWA do tabeli sZLEZLECENIEROZL}
    if SQLManager.SprawdzIstnienieTabeli(sZLEZLECENIEROZL) then
       if (not SQLManager.SprawdzIstnieniePola(sZLEZLECENIEROZL, sZLEZLECENIEROZL_ZUZ_PALIWA)) then begin
          try
            ZLEDM.UpdateTable(sZLEZLECENIEROZL, sZLEZLECENIEROZL_ZUZ_PALIWA, False, False);
          except
            Komunikat(CError, 'Blad podczas dopisywania pola do tabeli');
          end;

          {Zainicjowanie zmiennych sINIZLEZlecenieRozl_ZuzPaliwa oraz sINIZLEZleceniePoz_RenumeracjaLP}
          try
            UNISYSDM.SetSystemIniBoolean( UNISYSDM.vAktywnaFirma, sZLEMOdulID, '',
                       sINIZLEZlecenieRozl_ZuzPaliwa, False );
            UNISYSDM.SetSystemIniBoolean( UNISYSDM.vAktywnaFirma, sZLEMOdulID, '',
                       sINIZLEZleceniePoz_RenumeracjaLP, True );
          except

          end;
       end;
  end else
  if nr = '36.2' then begin
  //  'Pola definiowane w zleceniach', '2005-12-20'
    { 1. Tabela sZLEPOLAZMDEF }
    try
        if not SQLManager.SprawdzIstnienieTabeli(sZLEPOLAZMDEF) then begin
            SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEPOLAZMDEF, sZLEPOLAZMDEF);
            SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEPOLAZMDEF);
        end;
    except
    end;

    { 2. Tabela sZLEPOLAZMWSK }
    try
        if not SQLManager.SprawdzIstnienieTabeli(sZLEPOLAZMWSK) then begin
            SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEPOLAZMWSK, sZLEPOLAZMWSK);
            SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEPOLAZMWSK);
        end;
    except
    end;

    { 3. Tabela sZLEPOLAZM }
    try
        if not SQLManager.SprawdzIstnienieTabeli(sZLEPOLAZM) then begin
            SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEPOLAZM, sZLEPOLAZM);
            SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEPOLAZM);
        end;
    except
    end;

  end else
  if nr = '36.3' then begin

    try
      if SQLManager.SprawdzIstnienieConstrainta(sZLEPOLAZM + c_FRK+'1') then begin
        try
           sSQL := 'ALTER TABLE ' + SQLManager.GetTableName(sZLEPOLAZM) + ' DROP CONSTRAINT ' + sZLEPOLAZM + c_FRK + '1';
           SQLManager.ExecuteQuery(sSQL);
        except
        end;
      end;
    except
    end;
  end else
  if nr = '37.0' then begin
    oQuery := SQLManager.CreateQuery(
      'SELECT zm.* FROM ' +
      SQLManager.GetTableName(sZLEPOLAZM) + ' zm, ' + SQLManager.GetTableName(sZLEPOLAZMDEF) + ' def ' +
      'WHERE ' +
      'zm.' + sZLEPOLAZMDEF_ID + '=def.' + sZLEPOLAZMDEF_ID + ' and ' +
      'def.' + sZLEPOLAZMDEF_TYPDANYCH + '=''' + cZLETypDanych_DateID + ''''
    );
    oUpdate := SQLManager.UpdateQueryStep1(
      sZLEPOLAZM,
      sZLEPOLAZM_WART,
      sZLEPOLAZM_ID + '=:' + sZLEPOLAZM_ID
    );
    oUpdate.ParamByName(sZLEPOLAZM_WART).DataType := ftString;
    oUpdate.ParamByName(sZLEPOLAZM_ID).DataType := ftInteger;
    try
      oQuery.Open;
      oQuery.FetchAll;
      oQuery.First;
      SQLManager.StartTransaction;
      try
        ProgressStart(Nil, 0, 'Konwerja pl dodatkowych zlece', True, 0);
        ProgressForm.L1.Caption := 'Trwa konwersja. Prosz czeka...';
        ProgressForm.L2.Caption := '';
        ProgressForm.L3.Caption := '';
        ProgressForm.Position := poScreenCenter;
        ProgressForm.l1.Font.Size := 9;
        ProgressForm.l1.Font.Style := [];
        ProgressForm.l2.Font.Size := 9;
        ProgressForm.l2.Font.Style := [];
        ProgressForm.l3.Font.Size := 9;
        ProgressForm.l3.Font.Style := [];
        ProgressForm.Height := ProgressForm.l3.Top + (2 * ProgressForm.l3.Height);
        ProgressForm.PB.Visible := True;

        j := 0;
        while not oQuery.EOF do begin
          ProgressForm.ProgressUpdate('Konwerja pl dodatkowych zlecen', '', '', max(1, Trunc(((j + 1) * 100) / oQuery.RecordCount)));
          if not oQuery.FieldByName(sZLEPOLAZM_WART).IsNull then begin
            Val(oQuery.FieldByName(sZLEPOLAZM_WART).AsString, i, Code);
            if Code = 0 then begin
              oUpdate.ParamByName(sZLEPOLAZM_WART).AsString := DateToStr(i);
              oUpdate.ParamByName(sZLEPOLAZM_ID).AsInteger := oQuery.FieldByName(sZLEPOLAZM_ID).AsInteger;
              SQLManager.UpdateQueryStep2( oUpdate );
            end;
          end;
          oQuery.Next;
          Inc(j);
        end;
        ProgressForm.L1.Caption := 'Trwa zatwierdzanie zmian. Prosz czeka...';
        ProgressForm.Update;
        SQLManager.Commit;
        ProgressEnd;
      except
        SQLManager.Rollback;
        Raise;
      end;
    finally
      FreeAndNil(oQuery);
      FreeAndNil(oUpdate);
      if ProgressForm <> Nil then ProgressEnd;
    end;
  end else
  if nr = '37.1' then begin
    try
        if not SQLManager.SprawdzIstnienieTabeli(sZLEPLROZDEF) then begin
            SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEPLROZDEF, sZLEPLROZDEF);
            SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEPLROZDEF);
        end;
    except
    end;
  end else
  if nr = '37.2' then begin
     ZLEDM.UpdateTable(sZLEOSOBYGODZ,sZLEOSOBYGODZ_IL_PRACY, True, True);
  end else
  if nr = '37.3' then begin
     SQLManager.FixDomain( sZLECONST_PARSERBLAD, cslZLEParserBlad );
     ZLEDM.UpdateTable(sZLEWART, sZLEWART_BLAD, True, True);
     ZLEDM.UpdateTable(sZLEIL, sZLEIL_BLAD, True, True);
  end else
  if nr = '37.4' then begin
     if SQLManager.SprawdzIstnienieTabeli(sZLEPOLAZM) then begin
        if SQLManager.SprawdzIstnieniePola(sZLEPOLAZM, sZLEPOLAZM_WART) then begin
           SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sZLEPOLAZM_WART + ' VARCHAR(255)', [sZLEPOLAZM]);
        end;
     end;
  end else
  if nr = '37.5' then begin
    try
      if SQLManager.SprawdzIstnienieIndeksu(sZLEZLECENIEROZL + c_UNK + '1') then begin
        try
           sSQL := 'DROP INDEX ' + SQLManager.GetTableName(sZLEZLECENIEROZL) + c_UNK + '1';
           SQLManager.ExecuteQuery(sSQL);
        except
        end;
      end;
    except
    end;
  end else
  if nr = '37.6' then begin
     ZLEDM.UpdateTable(sZLEZASOB, sUNIJEDNOSTKAORG_ID, True, True);
  end else
  if nr = '37.7' then begin
     SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEILOPIS, sZLEILOPIS);
  end else if nr = '37.8' then begin
    SQLManager.ExecuteQuery(
      'ALTER TABLE %s MODIFY ' + sZLEZASOB_STAWKA + ' NULL',
      [sZLEZASOB]
    );
  end else if nr = '37.9' then begin
    ZLEDM.UpdateTable(sZLEZLECENIEPOZ, sZLEZLECENIEPOZ_ILOSC, True, True);
  end else if nr = '37.10' then begin
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEZLECENIEMAT, sZLEZLECENIEMAT);
    SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEZLECENIEMAT);
  end else if nr = '37.11' then begin
     ZLEDM.UpdateTable(sZLEZLECENIEZASOB, sLWPRECEPPOZZASOB_ID, True, True);
     ZLEDM.UpdateTable(sZLEZASOB, sZLEZASOB_OBCIAZENIE_MAX, True);
     ZLEDM.UpdateTable(sZLEZASOB, sLWPJEDNCZAS_ID, True, True);
  end else if nr = '37.12' then begin
     ZLEDM.UpdateTable(sZLEZLECENIEZASOB, sZLEZLECENIEZASOB_PLAN, True);
     ZLEDM.UpdateTable(sZLEZLECENIEZASOB, sZLEZLECENIEZASOB_OBCIAZ, True);
  end else if nr = '37.13' then begin
     {Na razie tylko to pole w tabeli}
     ZLEDM.UpdateTable(sZLEOSOBYGODZ, sZLEZASOB_ID, True, True);

     try
       SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sKDOSOBA_ID + ' NULL', [sZLEOSOBYGODZ]);
     except
       // Bd pomijamy
     end;
  end else if nr = '37.14' then begin
    ZLEDM.UpdateTable(sZLEZASOB, sKDGRUPAKAL_ID, True, True);
  end else if nr = '37.15' then begin
    if SQLManager.InTransaction then
      Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');
    try
      SQLManager.ExecuteQuery(
        'ALTER TABLE %s ADD ' + sZLEOSOBYGODZ_IL_PRACY + 'TEMP NUMBER(10, 1) DEFAULT 0',
        [sZLEOSOBYGODZ]
      );
    except
    end;

    try
      SQLManager.StartTransaction;
      SQLManager.ExecuteQuery(
        'UPDATE ' + SQLManager.GetTableName(sZLEOSOBYGODZ) + ' SET ' +
        sZLEOSOBYGODZ_ILOSC + '=TRUNC(' + sZLEOSOBYGODZ_ILOSC + '*60),' +
        sZLEOSOBYGODZ_IL_PRACY + 'TEMP=TRUNC(' + sZLEOSOBYGODZ_IL_PRACY + '*60)'
      );
      SQLManager.ExecuteQuery(
        'UPDATE ' + SQLManager.GetTableName(sZLEOSOBYGODZ) + ' SET ' +
        sZLEOSOBYGODZ_IL_PRACY + '=NULL'
      );
      SQLManager.ExecuteQuery(
        'ALTER TABLE %s MODIFY ' + sZLEOSOBYGODZ_IL_PRACY + ' NUMBER(10, 1) DEFAULT 0',
        [sZLEOSOBYGODZ]
      );
      SQLManager.ExecuteQuery(
        'UPDATE ' + SQLManager.GetTableName(sZLEOSOBYGODZ) + ' SET ' +
        sZLEOSOBYGODZ_IL_PRACY + '=' + sZLEOSOBYGODZ_IL_PRACY + 'TEMP'
      );
      SQLManager.Commit;
      try
        SQLManager.ExecuteQuery(
          'ALTER TABLE %s DROP COLUMN ' + sZLEOSOBYGODZ_IL_PRACY + 'TEMP',
          [sZLEOSOBYGODZ]
        );
      except
      end;
    except
      SQLManager.Rollback;
      Raise;
    end;
  end else if nr = '37.16' then begin
    if SQLManager.InTransaction then
      Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');
    try
      SQLManager.ExecuteQuery(
        'ALTER TABLE %s ADD ' + sZLEZLECENIEROZL_GODZINY + 'TEMP NUMBER(10, 1) DEFAULT 0',
        [sZLEZLECENIEROZL]
      );
    except
    end;

    try
      SQLManager.StartTransaction;
      SQLManager.ExecuteQuery(
        'UPDATE ' + SQLManager.GetTableName(sZLEZLECENIEROZL) + ' SET ' +
        sZLEZLECENIEROZL_GODZINY + 'TEMP=TRUNC(' + sZLEZLECENIEROZL_GODZINY + '*60)'
      );
      SQLManager.ExecuteQuery(
        'ALTER TABLE %s DROP COLUMN ' + sZLEZLECENIEROZL_GODZINY,
        [sZLEZLECENIEROZL]
      );
      SQLManager.ExecuteQuery(
        'ALTER TABLE %s ADD ' + sZLEZLECENIEROZL_GODZINY + ' NUMBER(10, 1) DEFAULT 0 NOT NULL',
        [sZLEZLECENIEROZL]
      );
      SQLManager.ExecuteQuery(
        'UPDATE ' + SQLManager.GetTableName(sZLEZLECENIEROZL) + ' SET ' +
        sZLEZLECENIEROZL_GODZINY + '=' + sZLEZLECENIEROZL_GODZINY + 'TEMP'
      );
      SQLManager.Commit;
      try
        SQLManager.ExecuteQuery(
          'ALTER TABLE %s DROP COLUMN ' + sZLEZLECENIEROZL_GODZINY + 'TEMP',
          [sZLEZLECENIEROZL]
        );
      except
      end;
    except
      SQLManager.Rollback;
      Raise;
    end;
  end else if nr = '37.17' then begin
    ZLEDM.UpdateTable(sZLEZLECENIEZASOB, sLWPJEDNCZAS_ID, True, True);
    ZLEDM.UpdateTable(sZLEZLECENIEZASOB, sZLEZLECENIEZASOB_WYD, True);
    ZLEDM.UpdateTable(sZLEZLECENIEZASOB, sZLEZLECENIEZASOB_WYDJED, True, True);
  end else if nr = '37.18' then begin
     SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEZASOBYPRACA, sZLEZASOBYPRACA);
     SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEZASOBYPRACA);
     SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEBRAKI, sZLEBRAKI);
     SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEBRAKI);
     SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEZASOBYBRAKI, sZLEZASOBYBRAKI);
     SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEZASOBYBRAKI);
     SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEOSOBY, sZLEOSOBY);
     SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEOSOBY);

     ZLEDM.UpdateTable(sZLEOSOBYGODZ, sZLEOSOBY_ID, True, True);
  end else if nr = '37.19' then begin
    if SQLManager.InTransaction then
      Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

    try
      SQLManager.ExecuteQuery('ALTER TABLE %s ADD ' + sZLEOSOBYGODZ_IL_PRACY + 'TEMP NUMBER(10, 6) DEFAULT 0.0 NULL',
                              [sZLEOSOBYGODZ]);
    except
    end;

    try
      SQLManager.StartTransaction;
      SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEOSOBYGODZ) + ' SET ' +
                               sZLEOSOBYGODZ_IL_PRACY + 'TEMP=' + sZLEOSOBYGODZ_IL_PRACY + '/60.0');
      SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEOSOBYGODZ) + ' SET ' +
                               sZLEOSOBYGODZ_IL_PRACY + '=NULL');
      SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sZLEOSOBYGODZ_IL_PRACY + ' NUMBER(10, 6) DEFAULT 0.0',
                              [sZLEOSOBYGODZ]);
      SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEOSOBYGODZ) + ' SET ' +
                               sZLEOSOBYGODZ_IL_PRACY + '=' + sZLEOSOBYGODZ_IL_PRACY + 'TEMP');
      SQLManager.Commit;
      try
        SQLManager.ExecuteQuery('ALTER TABLE %s DROP COLUMN ' + sZLEOSOBYGODZ_IL_PRACY + 'TEMP',
                                [sZLEOSOBYGODZ]);
      except
      end;
    except
      SQLManager.Rollback;
      Raise;
    end;
  end else if nr = '37.20' then begin
    try
      SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sZLEZLECENIE_ID + ' NULL', [sZLEZASOBYPRACA]);
    except
    end;
  end else if nr = '37.21' then begin
    ZLEDM.DropIndexes(sZLEZLECENIEZASOB, sZLEZLECENIE + c_UNK+'1');
    ZLEDM.CreateIndexes(sZLEZLECENIEZASOB, true);
  end else if nr = '37.22' then begin
    ZLEDM.UpdateTable(sZLEZASOB, sZLEZASOB_SYMBOL, True, True);
    ZLEDM.UpdateTable(sZLEZASOB, sZLEZASOB_LICZNIK, True, True);
    ZLEDM.UpdateTable(sZLEZASOB, sUNIAUTNUM_ID, True, True);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sLWPRECEPPOZ_ID, True, True);
  end else if nr = '37.23' then begin
    if SQLManager.InTransaction then
      Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

    if ZLEDM.vZLENumeratorZasobow <= 0 then begin
      try
        SQLManager.StartTransaction;
        iNumID := UNISYSDM.UNIDopiszNumerator( sUNINUMERATORModuluZlecenWielofirmowe {sNumeratorKod},
                                   0 {vAktywnaFirma  iOddzialID - Wielofirmowy},
                                   'Z[DN]' {sWzorzec},
                                   'W' {sRodzaj},
                                   'Zasoby' {sNazwa},
                                   6 {iDlugosc},
                                   '0' {sZnakWypelnienia},
                                   'T' {sPulaWolnychNumerow},
                                   'N' {sBlokada},
                                   True,
                                   0);
        ZLEDM.vZLENumeratorZasobow := iNumID;
        UNISYSDM.SetSystemIniInteger( 0 {vAktywnaFirma}, sZLEModulID, '',
                             sINIZLENumeratorZasobow, ZLEDM.vZLENumeratorZasobow );

        {Aktualizacja Symbolu zasobu nowym numeratorem}
        oQuery := SQLManager.CreateQuery('SELECT ' + sZLEZASOB_ID + ' ' +
                                         'FROM %s ' +
                                         'ORDER BY ' + sZLEZASOB_ID,
                                         [sZLEZASOB]);
        try
          oQuery.Open;
          if oQuery <> nil then
             while not oQuery.Eof do
             begin
                try
                  oUpdateQuery := SQLManager.UpdateQueryStep1(sZLEZASOB,
                                                              sZLEZASOB_SYMBOL + ', ' +
                                                              sZLEZASOB_LICZNIK + ',' +
                                                              sZLEZASOB_UZ_ZM_ID + ',' +
                                                              sZLEZASOB_DATA_ZM + ',' +
                                                              sUNIAUTNUM_ID,
                                                              sZLEZASOB_ID + '=' + IntToStr(oQuery.FieldByName(sZLEZASOB_ID).AsInteger));

                  oUpdateQuery.ParamByName(sZLEZASOB_SYMBOL).DataType  := ftString;
                  oUpdateQuery.ParamByName(sZLEZASOB_LICZNIK).DataType := ftInteger;
                  oUpdateQuery.ParamByName(sUNIAUTNUM_ID).DataType     := ftInteger;

                  oUpdateQuery.ParamByName(sZLEZASOB_SYMBOL).AsString   := UNISysDM.UNIPodajNumerExt( ZLEDM.vZLENumeratorZasobow, 0, 0, 0, 0, '', iLicznik);
                  oUpdateQuery.ParamByName(sZLEZASOB_LICZNIK).AsInteger := iLicznik;
                  oUpdateQuery.ParamByName(sUNIAUTNUM_ID).AsInteger     := ZLEDM.vZLENumeratorZasobow;
                  oUpdateQuery.ParamByName(sZLEZASOB_UZ_ZM_ID).AsInteger := SecurityManager.UserId;
                  oUpdateQuery.ParamByName(sZLEZASOB_DATA_ZM).AsDateTime := UNINow;

                  SQLManager.UpdateQueryStep2(oUpdateQuery);
                finally
                  if oUpdateQuery <> nil then FreeAndNil(oUpdateQuery);
                end;
                oQuery.Next;
             end;
        finally
          if oQuery <> nil then FreeAndNil(oQuery);
        end;
        SQLManager.Commit;
      except
        ZLEDM.vZLENumeratorZasobow := -1;
        SQLManager.Rollback;
        Raise;
      end;
    end;
  end else if nr = '37.24' then begin
    try
      SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sASOASORT_ID + ' NUMBER(10,1) NULL',
                               [sZLEZLECENIEPOZ]);
    except
    end;
  end else if nr = '37.25' then begin
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEZLECENIEWYC, sZLEZLECENIEWYC);
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr='37.26' then begin
    if SQLManager.InTransaction then
      Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

    bTrans  := not SQLManager.InTransaction();
    if bTrans then SQLManager.StartTransaction();
    try
      ZLEDM.UpdateTable(sZLEZASOB, sZLEZASOB_POLE1, True, True);
      ZLEDM.UpdateTable(sZLEZASOB, sZLEZASOB_POLE2, True, True);
      ZLEDM.UpdateTable(sZLEZASOB, sZLEZASOB_POLE3, True, True);
      DopiszMnemonik( sMnemonikZLEZasoby, 'Zasoby produkcyjne', sZLEZASOB, sZLEModulID);
      {Dugosc mnemonik = 6 - dugo symbolu z numeratora}
      SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sFKMNEMONIKI) + ' ' +
                              'SET ' + sFKMNEMONIKI_DLUGOSC + ' = 6 ' +
                              'WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(sMnemonikZLEZasoby) + ' AND ' +
                                       sFKMNEMONIKI_INDEKS + ' = 0');
      if bTrans then SQLManager.Commit();
    except
      if oQuery <> nil then FreeAndNil(oQuery);
      if bTrans then SQLManager.Rollback();
    end;
  end else if nr='37.27' then begin
    if SQLManager.InTransaction then
      Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

    {1. Tabela ZLEOSOBYGODZ}
    try
      SQLManager.ExecuteQuery('ALTER TABLE %s ADD ' + sZLEOSOBYGODZ_ILOSC + 'TEMP NUMBER(20, 6) DEFAULT 0',
                              [sZLEOSOBYGODZ]);
    except
    end;

    try
      SQLManager.StartTransaction;
      SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEOSOBYGODZ) + ' ' +
                              'SET ' + sZLEOSOBYGODZ_ILOSC + 'TEMP=' + sZLEOSOBYGODZ_ILOSC);
      SQLManager.ExecuteQuery('ALTER TABLE %s DROP COLUMN ' + sZLEOSOBYGODZ_ILOSC, [sZLEOSOBYGODZ]);
      SQLManager.ExecuteQuery('ALTER TABLE %s ADD ' +
                               sZLEOSOBYGODZ_ILOSC + ' NUMBER(20, 6) DEFAULT 0.0 NOT NULL',
                              [sZLEOSOBYGODZ]);
      SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEOSOBYGODZ) + ' ' +
                              'SET ' + sZLEOSOBYGODZ_ILOSC + '=' + sZLEOSOBYGODZ_ILOSC + 'TEMP');
      SQLManager.Commit;
      try
        SQLManager.ExecuteQuery('ALTER TABLE %s DROP COLUMN ' + sZLEOSOBYGODZ_ILOSC + 'TEMP',
                                [sZLEOSOBYGODZ]);
      except
      end;
    except
      SQLManager.Rollback;
      Raise;
    end;

    {2. Tabela ZLEZLECENIEROZL}
    try
      SQLManager.ExecuteQuery('ALTER TABLE %s ADD ' + sZLEZLECENIEROZL_GODZINY + 'TEMP NUMBER(20, 6) DEFAULT 0',
                              [sZLEZLECENIEROZL]);
    except
    end;

    try
      SQLManager.StartTransaction;
      SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEZLECENIEROZL) + ' ' +
                              'SET ' + sZLEZLECENIEROZL_GODZINY + 'TEMP=' + sZLEZLECENIEROZL_GODZINY);
      SQLManager.ExecuteQuery('ALTER TABLE %s DROP COLUMN ' + sZLEZLECENIEROZL_GODZINY, [sZLEZLECENIEROZL]);
      SQLManager.ExecuteQuery('ALTER TABLE %s ADD ' +
                               sZLEZLECENIEROZL_GODZINY + ' NUMBER(20, 6) DEFAULT 0.0 NOT NULL',
                              [sZLEZLECENIEROZL]);
      SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEZLECENIEROZL) + ' ' +
                              'SET ' + sZLEZLECENIEROZL_GODZINY + '=' + sZLEZLECENIEROZL_GODZINY + 'TEMP');
      SQLManager.Commit;
      try
        SQLManager.ExecuteQuery('ALTER TABLE %s DROP COLUMN ' + sZLEZLECENIEROZL_GODZINY + 'TEMP',
                                [sZLEZLECENIEROZL]);
      except
      end;
    except
      SQLManager.Rollback;
      Raise;
    end;
  end else if nr = '37.28' then begin
    ZLEDM.UpdateTable(sZLEOSOBYGODZ, sZLEZLECENIEPOZ_ID, True, True);
  end else if nr = '37.29' then begin
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEKRYTERIA, sZLEKRYTERIA);
    SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEKRYTERIA);
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEKRYTPOZ, sZLEKRYTPOZ);
    SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEKRYTPOZ);

    FC := TFunkCollection.Create(TFunkItem);
    try
      //Aktualizacja uprawnie
//      SQLManager.StartTransaction;
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
//      SQLManager.Commit;
      {  SQLManager.Rollback;
        Raise; }
    finally
      if FC <> nil then FC.Free;
    end;
  end else if nr = '37.30' then begin
    if ZLEDM.vZLEWymaganyOddzial and vWieloodzialowosc then begin
      try
        SQLManager.StartTransaction;
        SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sUNIAUTNUM) + ' ' +
                                'SET ' + sFKMNEMONIKI_ID + ' = (SELECT ' + sFKMNEMONIKI_ID +
                                                              ' FROM ' +
                                                                   SQLManager.GetTableName(sFKMNEMONIKI) +
                                                              ' WHERE ' +
                                                                   sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(sMnemonikOddzialy) + ' AND ' +
                                                                   sFKMNEMONIKI_INDEKS + ' = 0) ' +
                                'WHERE ' + sUNIAUTNUM_KOD + ' = ' + QuotedStr(sUNINUMERATORModuluZlecen));
        SQLManager.Commit;
      except
        SQLManager.Rollback;
        Raise;
      end;
    end;
  end else if nr = '37.31' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.32' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
  end else if(nr = '37.33') and DataManagers.Available(sLWPModulID) then begin
    oQuery  := nil;
    SQLManager.ExecuteQuery(
      'create table %s as (select WY.* from %s WY)',
      [sZLEZLECENIEWYC + 'TEMP', sZLEZLECENIEWYC]
    );
    try
      bTrans  := not SQLManager.InTransaction();
      if bTrans then SQLManager.StartTransaction();
      try
          // usunicie aktualnych, zdublowanych wpisw
        SQLManager.ExecuteQuery(
          'delete from %s WY' +
          ' where ' +
            'WY.' + sZLEZLECENIEWYC_ID + ' in('  +
              'SELECT ' +
                'WY2.'  + sZLEZLECENIEWYC_ID +
              ' FROM '  +
                '%s WY2, ' +
                '(' +
                  'SELECT ' +
                    'WY3.'  + sZLEZLECENIE_ID + ', WY3.'  + sZLEZASOB_ID  + ', ' +
                    'WY3.'  + sLWPRECEPPOZ_ID +
                  ' FROM %s WY3' +
                  ' GROUP BY ' +
                    'WY3.'  + sZLEZLECENIE_ID + ', WY3.'  + sZLEZASOB_ID  + ', ' +
                    'WY3.'  + sLWPRECEPPOZ_ID +
                  ' HAVING ' +
                    'Count(*) > 1'  +
                ') V' +
              ' where ' +
                'WY2.'  + sZLEZLECENIE_ID + ' = V.' + sZLEZLECENIE_ID + ' and ' +
                'WY2.'  + sZLEZASOB_ID    + ' = V.' + sZLEZASOB_ID    + ' and ' +
                'WY2.'  + sLWPRECEPPOZ_ID + ' = V.' + sLWPRECEPPOZ_ID +
            ')',
          [sZLEZLECENIEWYC, sZLEZLECENIEWYC, sZLEZLECENIEWYC]
        );
        sSQL    := '';
        oQuery  := SQLManager.CreateQuery(
          'SELECT ' +
            'WY.'  + sZLEZLECENIE_ID +
          ' FROM %s WY' +
          ' GROUP BY ' +
            'WY.'  + sZLEZLECENIE_ID + ', WY.'  + sZLEZASOB_ID  + ', ' +
            'WY.'  + sLWPRECEPPOZ_ID +
          ' HAVING ' +
            'Count(*) > 1',
          [sZLEZLECENIEWYC + 'TEMP']
        );
        oQuery.Open();
        while(not oQuery.Eof) do begin
          if(Length(sSQL) > 0) then
            sSQL  := sSQL + ', ' + oQuery.Fields[0].AsString
          else
            sSQL  := oQuery.Fields[0].AsString;
          oQuery.Next();
        end;  // while(not oQuery.Eof)
        oQuery.Free();
        ZLEDM.AktualizujWyceneZlecen(sSQL);
        if bTrans then SQLManager.Commit();
      except
        if bTrans then SQLManager.Rollback();
        oQuery.Free();
        raise;
      end;
    finally
      SQLManager.ExecuteQuery(
        'drop table %s',
        [sZLEZLECENIEWYC + 'TEMP']
      );
    end;
  end else if nr = '37.34' then begin
    if (DataManagers.Available(sLWPModulID)) then begin
      if not SQLManager.SprawdzIstnienieConstrainta(sZLEZASOBYPRACA + c_FRK+'3') then
      try
        {1. Sprawdzamy czy istnieja Elementy planu produkcji, ktore juz nie istnieja w tabeli LWPPLANPRODEL}
        SQLManager.ExecuteQuery('UPDATE %s zzp ' +
                                'SET zzp.' + sLWPPLANPRODEL_ID + ' = NULL ' +
                                'WHERE NOT EXISTS(SELECT lwp1.' + sLWPPLANPRODEL_ID +
                                                ' FROM %s lwp1 ' +
                                                ' WHERE lwp1.' + sLWPPLANPRODEL_ID + ' = zzp.' + sLWPPLANPRODEL_ID + ')',
                                [sZLEZASOBYPRACA, sLWPPLANPRODEL]);
        {2. Zakadamy wizy}
        ConstraintDefs := TUNIConstraintDefs.Create();
        ZLEDM.DajDefinicjeConstraints( sZLEZASOBYPRACA, ConstraintDefs );
        if ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '3') <> -1 then
           SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa( sZLEZASOBYPRACA,
                          ConstraintDefs.Items[ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '3')]);
      finally
        if ConstraintDefs <> nil then ConstraintDefs.Free;
      end;
    end;
  end else if nr = '37.35' then begin
    SQLManager.ExecuteQuery(
      'alter table %s rename column ' + sZLEZLECENIEWYC_KOSZT + ' to ' + sZLEZLECENIEWYC_KOSZT + '_TEMP',
      [sZLEZLECENIEWYC]
    );
    try
      ZLEDM.UpdateTable(sZLEZLECENIEWYC, sZLEZLECENIEWYC_KOSZT);
      SQLManager.ExecuteQuery(
        'update %s W' +
        ' set W.' + sZLEZLECENIEWYC_KOSZT + ' = W.' + sZLEZLECENIEWYC_KOSZT + '_TEMP',
        [sZLEZLECENIEWYC]
      );
      SQLManager.ExecuteQuery(
        'alter table %s drop column ' + sZLEZLECENIEWYC_KOSZT + '_TEMP',
        [sZLEZLECENIEWYC]
      );
    except
      raise;
    end;
  end else if nr = '37.36' then begin
    ZLEDM.UpdateTable(sZLEKRYTERIA, sZLEKRYTERIA_FORMAT, True, True);
  end else if nr = '37.37' then begin
     SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEKRYTERIAWAR, sZLEKRYTERIAWAR);
     SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEKRYTERIAWAR);


  end else if nr = '37.38' then begin
    try
      if SQLManager.SprawdzIstnienieIndeksu(sZLEZLECENIEPOZ + c_UNK + '1') then begin
        try
           sSQL := 'DROP INDEX ' + SQLManager.GetTableName(sZLEZLECENIEPOZ) + c_UNK + '1';
           SQLManager.ExecuteQuery(sSQL);
        except
        end;
      end;
    except
    end;
  end else if nr = '37.39' then begin
    ZLEDM.UpdateTable(sZLEKRYTERIA, sINFCONST_OBIEKT_ID, True, True);
    ZLEDM.UpdateTable(sZLEKRYTERIA, sZLEKRYTERIA_ISTN_MNEMONIK, True, True);
  end else if nr = '37.40' then begin
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEZLECENIEOBCY, sZLEZLECENIEOBCY);
    SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEZLECENIEOBCY);
  end else if nr='37.41' then begin
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEPREFIX, sZLEPREFIX);
    UniqueKey[sZLEPREFIX] := 1;

    if SQLManager.InTransaction then
      Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

    bTrans  := not SQLManager.InTransaction();
    if bTrans then SQLManager.StartTransaction();
    try
      FC := TFunkCollection.Create(TFunkItem);
      try
        {funkcjonalnoci}
        ZLEDM.GetFunctionality(FC);
        SecurityManager.ProcessFunctionalities(FC);
      finally
        FC.Free;
      end;

      {Dopisanie domeny}
      SQLManager.FixDomain( sZLECONST_PREFIX, cslZLEConstPrefix );
      DopiszMnemonik( sMnemonikZLEPrefix, 'Prefiks zlece', sZLEPREFIX, sZLEModulID);

      if bTrans then SQLManager.Commit();
    except
      if oQuery <> nil then FreeAndNil(oQuery);
      if bTrans then SQLManager.Rollback();
    end;
  end else if nr = '37.42' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.43' then begin
    SQLManager.FixDomain( sZLECONST_ZASOBPRACAST, cslZLEConstZasobPracaStatus);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLEZASOBYPRACA_STATUS, true);
      // ustawienie statusu wczeniej zapisanych rekordw na Zaakceptowany
    SQLManager.ExecuteQuery(
      'update %s ZP set ZP.' + sZLEZASOBYPRACA_STATUS + ' = ''' + cZLEConstZasobPracaStatus_ZaakceptowanyID + '''',
      [sZLEZASOBYPRACA]
    );
  end else if nr = '37.44' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.45' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
  end else if nr = '37.46' then begin
    ZLEDM.UpdateTable(sZLEZLECENIEMAT, sASOASORTKMAT_ID, true, true);
  end else if nr = '37.47' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
  end else if nr = '37.48' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
  end else if nr = '37.49' then begin
     {Zmiana formatu pola ZLEWART_WARTOSC}
     if SQLManager.InTransaction then
        Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

     try
        SQLManager.ExecuteQuery('ALTER TABLE %s ADD ' + sZLEWART_WARTOSC + '_TEMP NUMBER(20, 6) DEFAULT 0', [sZLEWART]);
     except
        Raise Exception.Create('Nie udao si dooenie pola do tabeli ZLEWART');
     end;

     try
        SQLManager.StartTransaction;
        SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEWART) + ' ' +
                                'SET ' + sZLEWART_WARTOSC + '_TEMP = ' + sZLEWART_WARTOSC);
        SQLManager.ExecuteQuery('ALTER TABLE %s DROP COLUMN ' + sZLEWART_WARTOSC, [sZLEWART]);
        SQLManager.ExecuteQuery('ALTER TABLE %s ADD ' +
                                 sZLEWART_WARTOSC + ' NUMBER(20, 6) DEFAULT 0.0 NOT NULL',
                                [sZLEWART]);
        SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sZLEWART) + ' ' +
                                'SET ' + sZLEWART_WARTOSC + '=' + sZLEWART_WARTOSC + '_TEMP');
        SQLManager.Commit;

        try
          SQLManager.ExecuteQuery('ALTER TABLE %s DROP COLUMN ' + sZLEWART_WARTOSC + '_TEMP',
                                  [sZLEWART]);
        except
        end;
     except
        SQLManager.Rollback;
        Raise;
     end;

     {Dopisanie pola ZLESKLADWART_FORMAT do tabeli ZLESKLADWART}
     ZLEDM.UpdateTable(sZLESKLADWART, sZLESKLADWART_FORMAT, True, True);
  end else if nr = '37.50' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
  end else if nr = '37.51' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
  end else if nr = '37.52' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);

    if DataManagers.Available(sUNIINTModulID) then
       ZLEDM.UtworzSP(sZLEXML_PACKAGE);
  end else if nr = '37.53' then begin
      // dodanie pl operacji
    ZLEDM.UpdateTable(sZLEZLECENIEMAT, sLWPRECEPPOZOPER_ID, True, True);
    ZLEDM.UpdateTable(sZLEZLECENIEMAT, sLWPRECEPPOZOPERZAM_ID, True, True);
  end else if nr = '37.54' then begin
    SQLManager.FixDomain( sZLECONST_ZLEWYCENAST, cslZLEConstZleWycenaStatus);
    ZLEDM.UpdateTable(sZLEZLECENIEWYC, sZLEZLECENIEWYC_STATUS, true);
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.55' then begin
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEZASOBYPRACAMAGP, sZLEZASOBYPRACAMAGP);
    SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEZASOBYPRACAMAGP);
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.56' then begin
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLEWSPNARZUTY, sZLEWSPNARZUTY);
    SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEWSPNARZUTY);
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.57' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
  end else if nr = '37.58' then begin
     {Zmiana definicji regu w kryteriach}
     if SQLManager.InTransaction then
        Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

     SQLManager.StartTransaction;
     oQuery := SQLManager.CreateQuery('SELECT ' + sZLEKRYTERIA_ID + ', ' + sZLEKRYTERIA_REGULA + ' ' +
                                      'FROM %s ' +
                                      'ORDER BY ' + sZLEKRYTERIA_ID,
                                      [sZLEKRYTERIA]);
     try
        oQuery.Open;
        if oQuery <> nil then begin
           while not oQuery.Eof do begin
              sRegula := oQuery.FieldByName(sZLEKRYTERIA_REGULA).AsString ;
              sTmp := sRegula;

              {1. KRYT_WARTPRACY => KRYT_WARTPRACY('NARZUT=TAK/NIE')}
              i := Pos('KRYT_WARTPRACY', sTmp);
              if i > 0 then begin
                 bNarzut := False;
                 j := Pos('KRYT_WSPPRACY', sTmp);
                 //UNIStringReplace(sRegula, 'KRYT_WSPPRACY');
                 if (j > 0) and ZLEDM.vZLENarzuty then
                       bNarzut := True;

                 if bNarzut then
                      sRegula := 'Result := KRYT_WARTPRACY(''NARZUT=TAK'')'
                 else sRegula := 'Result := KRYT_WARTPRACY(''NARZUT=NIE'')';
              end else begin
                 {2. KRYT_WARTMAT => KRYT_WARTMAT('NARZUT=TAK/NIE')}
                 bNarzut := False;
                 i := Pos('KRYT_WARTMAT', sTmp);
                 if i > 0 then begin
                    j := Pos('KRYT_WSPMAT', sTmp);
                    if (j > 0) and ZLEDM.vZLENarzuty then
                       bNarzut := True;

                    if bNarzut then
                         sRegula := 'Result := KRYT_WARTMAT(''NARZUT=TAK'')'
                    else sRegula := 'Result := KRYT_WARTMAT(''NARZUT=NIE'')';
                 end;
              end;

              try
                  oUpdateQuery := SQLManager.UpdateQueryStep1(sZLEKRYTERIA,
                                    sZLEKRYTERIA_REGULA + ', ' +
                                    sZLEKRYTERIA_UZ_ZM_ID + ', ' +
                                    sZLEKRYTERIA_DATA_ZM,
                                    sZLEKRYTERIA_ID + '=' + IntToStr(oQuery.FieldByName(sZLEKRYTERIA_ID).AsInteger));

                  oUpdateQuery.ParamByName(sZLEKRYTERIA_REGULA).DataType    := ftString;
                  oUpdateQuery.ParamByName(sZLEKRYTERIA_UZ_ZM_ID).DataType  := ftInteger;
                  oUpdateQuery.ParamByName(sZLEKRYTERIA_DATA_ZM).DataType   := ftDateTime;
                  oUpdateQuery.ParamByName(sZLEKRYTERIA_REGULA).AsString    := sRegula;
                  oUpdateQuery.ParamByName(sZLEKRYTERIA_UZ_ZM_ID).AsInteger := SecurityManager.UserId;
                  oUpdateQuery.ParamByName(sZLEKRYTERIA_DATA_ZM).AsDateTime := UNINow;
                  SQLManager.UpdateQueryStep2(oUpdateQuery);
              finally
                  if oUpdateQuery <> nil then FreeAndNil(oUpdateQuery);
              end;
              oQuery.Next;
           end;
        end;
        SQLManager.Commit;
     finally
        if oQuery <> nil then FreeAndNil(oQuery);
     end;
  end else if nr = '37.59' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.60' then begin
    ZLEDM.UpdateTable(sZLEKRYTERIA, sZLEKRYTERIA_OGRANICZ, True, True);
  end else if nr = '37.61' then begin
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLESKLADNIKIECPDEF, sZLESKLADNIKIECPDEF);
    SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLESKLADNIKIECPDEF);
    UniqueKey[sZLESKLADNIKIECPDEF] := 1;
  end else if nr = '37.62' then begin
    ZLEDM.DropIndexes(sZLEZLECENIEZASOB, sZLEZLECENIEZASOB + c_UNK+'1');
    ZLEDM.CreateIndexes(sZLEZLECENIEZASOB, true);
  end else if nr = '37.63' then begin
     ZLEDM.UpdateTable(sZLETYPSKLADW,  sZLETYPSKLADW_KOLEJNOSC,  True, True);
     ZLEDM.UpdateTable(sZLETYPSKLADIL, sZLETYPSKLADIL_KOLEJNOSC, True, True);
  end else if nr = '37.64' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
  end else if nr = '37.65' then begin
    ZLEDM.UtworzSP(sZLE_ZAKLADKI);
  end else if nr = '37.66' then begin
    {Zmiana definicji regu w kryteriach}
    iRes := 0;
     if SQLManager.InTransaction then
        Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

    SQLManager.StartTransaction;
    try
      //Usunicie pol nie powizanych z zadnym typem zlecenia
      SQLManager.ExecuteQuery('DELETE FROM %s ZM2 ' +
                              'WHERE ZM2.' + sZLEPOLAZM_ID + ' IN ( ' +
                                  'SELECT ZM.'+ sZLEPOLAZM_ID + ' ' +
                                  'FROM %s ZM, %s ZL, %s DEF ' +
                                  'WHERE ' +
                                    'ZL.' + sZLEZLECENIE_ID + ' = ZM.' + sZLEZLECENIE_ID + ' AND ' +
                                    'DEF.' + sZLEPOLAZMDEF_ID + ' = ZM.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                    'ZM.' + sZLEZLECENIEPOZ_ID + ' IS NULL AND ' +
                                    'NOT EXISTS (SELECT ZLEWSK.' + sZLEPOLAZMDEF_ID + ' ' +
                                                'FROM %s ZLEWSK ' +
                                                'WHERE ' +
                                                  'ZLEWSK.' + sZLETYPZLEC_ID   + ' = ZL.' + sZLETYPZLEC_ID + ' AND ' +
                                                  'ZLEWSK.' + sZLEPOLAZMDEF_ID + ' = ZM.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                                  'ZLEWSK.' + sZLEPOLAZMWSK_POZYCJA + ' = ' + QuotedStr(sNie) + '))',
                               [sZLEPOLAZM, sZLEPOLAZM, sZLEZLECENIE,
                                sZLEPOLAZMDEF, sZLEPOLAZMWSK]);

      SQLManager.ExecuteQuery('DELETE FROM %s ZM2 ' +
                              'WHERE ZM2.' + sZLEPOLAZM_ID + ' IN ( ' +
                                  'SELECT ZM.'+ sZLEPOLAZM_ID + ' ' +
                                  'FROM %s ZM, %s ZL, %s DEF ' +
                                  'WHERE ' +
                                    'ZL.' + sZLEZLECENIE_ID + ' = ZM.' + sZLEZLECENIE_ID + ' AND ' +
                                    'DEF.' + sZLEPOLAZMDEF_ID + ' = ZM.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                    'ZM.' + sZLEZLECENIEPOZ_ID + ' IS NOT NULL AND ' +
                                    'NOT EXISTS (SELECT ZLEWSK.' + sZLEPOLAZMDEF_ID + ' ' +
                                                'FROM %s ZLEWSK ' +
                                                'WHERE ' +
                                                  'ZLEWSK.' + sZLETYPZLEC_ID   + ' = ZL.' + sZLETYPZLEC_ID + ' AND ' +
                                                  'ZLEWSK.' + sZLEPOLAZMDEF_ID + ' = ZM.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                                  'ZLEWSK.' + sZLEPOLAZMWSK_POZYCJA + ' = ' + QuotedStr(sTak) + '))',
                               [sZLEPOLAZM, sZLEPOLAZM, sZLEZLECENIE,
                                sZLEPOLAZMDEF, sZLEPOLAZMWSK]);


    except
      if SQLManager.InTransaction then
         SQLManager.Rollback;
      Raise Exception.Create('Bd podczas usuwania zbdnych pol uytkownika.'#13+
                             'Problem zgo programicie');
    end;
    {Przeniesienie pl uytkownika do UNISYS}
    ZLEDM.UtworzSP(sZLEPRZEPISZPOLAUZ);
    oSP := TUniStoredProc.Create(nil);
    try
      try
        with oSP do begin
            StoredProcName := SQLManager.GetSPName(sZLEPRZEPISZPOLAUZ);
            Params.CreateParam(ftInteger, 'RESULT', ptResult);
            Prepare;
            ExecProc;
            iRes := Params.ParamByName('RESULT').AsInteger;
            UnPrepare;
        end;
      except
         if SQLManager.InTransaction then
            SQLManager.Rollback;
      end;
    finally
      oSP.Free;
    end;
    if iRes <> 0 then begin
       if SQLManager.InTransaction then
          SQLManager.Rollback;
       result := false;
       Komunikat(cWarning, 'Procedura przepisujca pola uytkownika zwrcia niezerow warto.'#13+
                           'Problem zgo programicie');
    end;
    if SQLManager.InTransaction then
       SQLManager.Commit;

  {end else if nr = '37.67' then begin}
    //ZLEDM.UtworzSP(sZLE_ZAKLADKI); To juz w wersji
  end else if nr = '37.67' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
  end else if nr = '37.68' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.69' then begin
    ZLEDM.UpdateTable(sZLEZLECENIEOBCY, sLWPPLANPRODEL_ID,  True, True);
    if(SQLManager.SprawdzIstnieniePola(sZLEZLECENIEOBCY, sLWPRECEPPOZ_ID)) then
      SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sLWPRECEPPOZ_ID + ' NULL', [sZLEZLECENIEOBCY]);
  end else if nr = '37.70' then begin
    ZLEDM.UtworzSP(sZLEXML_PACKAGE);
  end else if nr = '37.71' then begin
    ZLEDM.UpdateTable(sZLEZLECENIEPOZ, sZLEZLECENIEPOZ_WARTOSC,  True, True);

  end else if nr = '37.72' then begin

    UniqueKey[sZLEZASOBYPRACA];
    {nowa domena ZLECONST_RODZAJECP}
    SQLManager.FixDomain( sZLECONST_RODZAJECP, cslZLERodzajECP);
    {Nowe pola w tabeli ZLEZASOBYPRACA}
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLECONST_RODZAJECP_ID, true,true);  {Domyslny rodzaj = Produkcja}
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sASOASORT_ID, true,true);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sKDOSOBA_ID, true,true);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLEZLECENIEPOZ_ID, true,true);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLEZASOBYPRACA_ZUZ_PALIWA, true,true);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sUNIOKRES_ID, true,true);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLEZASOBYPRACA_STAWKA, true,true);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sSPCENNIK_ID, true,true);

    try
      ConstraintDefs := TUNIConstraintDefs.Create();
      ZLEDM.DajDefinicjeConstraints(sZLEZASOBYPRACA, ConstraintDefs );

      if not SQLManager.SprawdzIstnienieConstrainta(sZLEZASOBYPRACA + c_FRK+'5') then begin
         if ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '5') <> -1 then
            SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa( sZLEZASOBYPRACA,
                        ConstraintDefs.Items[ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '5')]);
      end;

      if not SQLManager.SprawdzIstnienieConstrainta(sZLEZASOBYPRACA + c_FRK+'6') then begin
         if ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '6') <> -1 then
            SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa( sZLEZASOBYPRACA,
                        ConstraintDefs.Items[ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '6')]);
      end;
      if not SQLManager.SprawdzIstnienieConstrainta(sZLEZASOBYPRACA + c_FRK+'7') then begin
         if ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '7') <> -1 then
            SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa( sZLEZASOBYPRACA,
                        ConstraintDefs.Items[ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '7')]);
      end;
      if not SQLManager.SprawdzIstnienieConstrainta(sZLEZASOBYPRACA + c_FRK+'8') then begin
         if ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '8') <> -1 then
            SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa( sZLEZASOBYPRACA,
                        ConstraintDefs.Items[ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '8')]);
      end;
      if not SQLManager.SprawdzIstnienieConstrainta(sZLEZASOBYPRACA + c_FRK+'9') then begin
         if ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '9') <> -1 then
            SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa( sZLEZASOBYPRACA,
                        ConstraintDefs.Items[ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '9')]);
      end;
      if not SQLManager.SprawdzIstnienieConstrainta(sZLEZASOBYPRACA + c_FRK+'10') then begin
         if ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '10') <> -1 then
            SQLManager.ZalozNaTabliceConstraintPrzyUzyciuSQLa( sZLEZASOBYPRACA,
                        ConstraintDefs.Items[ConstraintDefs.IndexOf(sZLEZASOBYPRACA + c_FRK + '10')]);
      end;
    finally
      if ConstraintDefs <> nil then ConstraintDefs.Free;
    end;

    {Modyfikacja definicji istniejcych kolumn}

    try
      if(SQLManager.SprawdzIstnieniePola(sZLEZASOBYPRACA, sZLEZASOB_ID)) then
        SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sZLEZASOB_ID + ' NULL', [sZLEZASOBYPRACA]);
    except
      // pomijam bd
    end;

    try
      if(SQLManager.SprawdzIstnieniePola(sZLEZASOBYPRACA, sKDZMIANYDEF_ID)) then
        SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sKDZMIANYDEF_ID + ' NULL', [sZLEZASOBYPRACA]);
    except
      // pomijam bd
    end;

    try
      if(SQLManager.SprawdzIstnieniePola(sZLEZASOBYPRACA, sZLEZASOBYPRACA_IL_PRACY)) then
        SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sZLEZASOBYPRACA_IL_PRACY + ' DEFAULT 0.0', [sZLEZASOBYPRACA]);
    except
      // pomijam bd
    end;

    try
      if(SQLManager.SprawdzIstnieniePola(sZLEZASOBYPRACA, sZLEZASOBYPRACA_CZAS_PRACY)) then
        SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sZLEZASOBYPRACA_CZAS_PRACY + ' DEFAULT 0.0', [sZLEZASOBYPRACA]);
    except
      // pomijam bd
    end;

    {Przepisanie danych z tabeli ZLEOSOBYGODZ do tabeli ZLEZASOBYPRACA}
    sSQL := 'INSERT INTO %s (' +
              sZLEZASOBYPRACA_ID + ', ' +
              sZLEZLECENIE_ID + ', ' +
              sZLEZLECENIEPOZ_ID + ', ' +
              sASOASORT_ID + ', ' +
              sSPCENNIK_ID + ', ' +
              sUNIOKRES_ID + ', ' +
              sKDOSOBA_ID + ', ' +
              sZLEZASOB_ID + ', ' +
              sZLEZASOBYPRACA_DATA + ', ' +
              sZLEZASOBYPRACA_IL_PRACY + ', ' +
              sZLEZASOBYPRACA_STAWKA + ', ' +
              sZLEZASOBYPRACA_CZAS_PRACY + ', ' +
              sKDZMIANYDEF_ID + ', ' +
              sLWPPLANPRODEL_ID + ', ' +
              sLWPRECEPPOZ_ID + ', ' +
              sZLEZASOBYPRACA_STATUS + ', ' +
              sZLECONST_RODZAJECP_ID + ', ' +
              sZLEZASOBYPRACA_ZUZ_PALIWA + ', ' +
              sZLEZASOBYPRACA_UZ_AU_ID + ', ' +
              sZLEZASOBYPRACA_DATA_AU + ', ' +
              sZLEZASOBYPRACA_UZ_ZM_ID + ', ' +
              sZLEZASOBYPRACA_DATA_ZM + ') ' +
            'SELECT ' +
              '%s , ' +
              sZLEZLECENIE_ID + ', ' +
              sZLEZLECENIEPOZ_ID + ', ' +
              sASOASORT_ID + ', ' +
              sSPCENNIK_ID + ', ' +
              sUNIOKRES_ID + ', ' +
              sKDOSOBA_ID + ', ' +
              sZLEZASOB_ID + ', ' +
              sZLEOSOBYGODZ_DATA + ', ' +
              'NVL(' + sZLEOSOBYGODZ_IL_PRACY + ', 0), ' +
              sZLEOSOBYGODZ_CENA + ', ' +
              {Uwzgldnienie parametru  ZLEDM.vZLEFormatGodzinLiczba}
              sZLEOSOBYGODZ_ILOSC + ', ' +
              'NULL, ' +
              'NULL, ' +
              'NULL, ' +
              QuotedStr(cZLEConstZasobPracaStatus_WprowadzonyID) + ', ' +
              'CASE WHEN ' + sZLEZASOB_ID + ' IS NULL THEN ' + QuotedStr(cZLERodzajECP_OsobaID) + ' ' +
                   'ELSE ' + QuotedStr(cZLERodzajECP_ZasobID) + ' ' +
              'END, ' +
              '0.00, ' +
              sZLEOSOBYGODZ + '_UZ_AU_ID' + ', ' +
              sZLEOSOBYGODZ + '_DATA_AU' + ', ' +
              sZLEOSOBYGODZ + '_UZ_ZM_ID' + ', ' +
              sZLEOSOBYGODZ + '_DATA_ZM' + ' ' +
            'FROM %s';
    SQLManager.ExecuteQuery(sSQL, [sZLEZASOBYPRACA,
                                   'SEQ_' + sZLEZASOBYPRACA +'.NEXTVAL',
                                   sZLEOSOBYGODZ]);

    {Przepisanie danych z tabeli ZLEZLECENIEROZL do tabeli ZLEZASOBYPRACA}
    {cZLERodzajECP_RozliczID}
    sSQL := 'INSERT INTO %s (' +
              sZLEZASOBYPRACA_ID + ', ' +
              sZLEZLECENIE_ID + ', ' +
              sZLEZLECENIEPOZ_ID + ', ' +
              sASOASORT_ID + ', ' +
              sSPCENNIK_ID + ', ' +
              sUNIOKRES_ID + ', ' +
              sKDOSOBA_ID + ', ' +
              sZLEZASOB_ID + ', ' +
              sZLEZASOBYPRACA_DATA + ', ' +
              sZLEZASOBYPRACA_IL_PRACY + ', ' +
              sZLEZASOBYPRACA_STAWKA + ', ' +
              sZLEZASOBYPRACA_CZAS_PRACY + ', ' +
              sKDZMIANYDEF_ID + ', ' +
              sLWPPLANPRODEL_ID + ', ' +
              sLWPRECEPPOZ_ID + ', ' +
              sZLEZASOBYPRACA_STATUS + ', ' +
              sZLECONST_RODZAJECP_ID + ', ' +
              sZLEZASOBYPRACA_ZUZ_PALIWA + ', ' +
              sZLEZASOBYPRACA_UZ_AU_ID + ', ' +
              sZLEZASOBYPRACA_DATA_AU + ', ' +
              sZLEZASOBYPRACA_UZ_ZM_ID + ', ' +
              sZLEZASOBYPRACA_DATA_ZM + ') ' +
            'SELECT ' +
              '%s , ' +
              'ZP.' + sZLEZLECENIE_ID + ', ' +
              'ZR.' + sZLEZLECENIEPOZ_ID + ', ' +
              'NULL, ' +
              'NULL, ' +
            '(SELECT UK.' + sUNIOKRES_ID + ' ' +
             'FROM %s UK ' +
             'WHERE ((UK.' + sUNIOKRES_DATA_POCZ  + ' <= ZR.' + sZLEZLECENIEROZL_DATA + ') AND ' +
                    '(UK.' + sUNIOKRES_DATA_KONCA + ' >= ZR.' + sZLEZLECENIEROZL_DATA + ')) ' +
            ') AS ' + sUNIOKRES_ID + ', ' +
            'NULL, ' +
            'ZR.' + sZLEZASOB_ID + ', ' +
            'ZR.' + sZLEZLECENIEROZL_DATA + ', ' +
            '0.00, ' +
            'ZR.' + sZLEZLECENIEROZL_STAWKA + ', ' +
            'ZR.' + sZLEZLECENIEROZL_GODZINY + ', ' +
            'NULL, ' +
            'NULL, ' +
            'NULL, ' +
            QuotedStr(cZLEConstZasobPracaStatus_WprowadzonyID) + ', ' +
            QuotedStr(cZLERodzajECP_RozliczID) + ', ' +
            'ZR.' + sZLEZLECENIEROZL_ZUZ_PALIWA + ', ' +
            'ZR.' + sZLEZLECENIEROZL + '_UZ_AU_ID' + ', ' +
            'ZR.' + sZLEZLECENIEROZL + '_DATA_AU' + ', ' +
            'ZR.' + sZLEZLECENIEROZL + '_UZ_ZM_ID' + ', ' +
            'ZR.' + sZLEZLECENIEROZL + '_DATA_ZM' + ' ' +
          'FROM %s ZR, %s ZP ' +
          'WHERE ZR.' + sZLEZLECENIEPOZ_ID + ' = ZP.' + sZLEZLECENIEPOZ_ID;
    SQLManager.ExecuteQuery(sSQL, [sZLEZASOBYPRACA,
                                   'SEQ_' + sZLEZASOBYPRACA +'.NEXTVAL',
                                   sUNIOKRES,
                                   sZLEZLECENIEROZL,
                                   sZLEZLECENIEPOZ]);

    if ZLEDM.vZLEFormatGodzinLiczba then begin
       {1. Dla cZLERodzajECP_ProdukcjaID rwnie uwzgldniamy obsug tego parametru}
       SQLManager.ExecuteQuery('UPDATE %s ' +
                               'SET ' + sZLEZASOBYPRACA_CZAS_PRACY + ' = ' + sZLEZASOBYPRACA_CZAS_PRACY + '/60.0 ' +
                               'WHERE ' + sZLECONST_RODZAJECP_ID + '= ' + QuotedStr(cZLERodzajECP_ProdukcjaID),
                               [sZLEZASOBYPRACA]);
    end;

    {Zmiana nazwy tabeli ZLEOSOBYGODZ na ZLEOSOBYGODZ_ARCH i zastpienie jej widokiem}
    SQLManager.ExecuteQuery('CREATE TABLE %s_ARCH AS (SELECT * FROM %s)',[sZLEOSOBYGODZ, sZLEOSOBYGODZ]);
    SQLManager.ExecuteQuery('DROP TABLE %s',[sZLEOSOBYGODZ]);
    ZLEDM.ZLEOSOBYGODZViewDef.CreateView;

    {Zmiana nazwy tabeli ZLEZLECENIEROZL na ZLEZLECENIEROZL_ARCH i zastpienie jej widokiem}
    SQLManager.ExecuteQuery('CREATE TABLE %s_ARCH AS (SELECT * FROM %s)',[sZLEZLECENIEROZL, sZLEZLECENIEROZL]);
    SQLManager.ExecuteQuery('DROP TABLE %s',[sZLEZLECENIEROZL]);
    ZLEDM.ZLEZLECENIEROZLViewDef.CreateView;

  end else if nr = '37.73' then begin
    if DataManagers.Available(sUNIINTModulID) then
       ZLEDM.UtworzSP(sZLEXML_PACKAGE);
  end else if nr = '37.74' then begin
    ZLEDM.UtworzSP(sZLEXML_PACKAGE);
  end else if nr = '37.75' then begin
    ZLEDM.UtworzSP(sZLEXML_PACKAGE);
  end else if nr = '37.76' then begin
      // usunicie constrainta do sZLEZLECENIE_ID
    if(SQLManager.SprawdzIstnienieConstrainta(sZLEZLECENIEOBCY + c_FRK + '1')) then
      SQLManager.ExecuteQuery('ALTER TABLE %s DROP CONSTRAINT ' + sZLEZLECENIEOBCY + c_FRK + '1', [sZLEZLECENIEOBCY]);
      // usunicie constrainta do sLWPRECEPPOZ_ID
    if(SQLManager.SprawdzIstnienieConstrainta(sZLEZLECENIEOBCY + c_FRK + '2')) then
      SQLManager.ExecuteQuery('ALTER TABLE %s DROP CONSTRAINT ' + sZLEZLECENIEOBCY + c_FRK + '2', [sZLEZLECENIEOBCY]);
      // usunicie constrainta do sLWPPLANPRODEL_ID
    if(SQLManager.SprawdzIstnienieConstrainta(sZLEZLECENIEOBCY + c_FRK + '3')) then
      SQLManager.ExecuteQuery('ALTER TABLE %s DROP CONSTRAINT ' + sZLEZLECENIEOBCY + c_FRK + '3', [sZLEZLECENIEOBCY]);
      // ponowne zaoenie constraintw
    SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLEZLECENIEOBCY);
  end else if nr = '37.77' then begin
    ZLEDM.UpdateTable(sZLEZLECENIEOBCY, sZLEZLECENIEOBCY_BLAD, true);
  end else if nr = '37.78' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.79' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.80' then begin
     {Zmiana definicji regu kosztow}
     if SQLManager.InTransaction then
        Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

     SQLManager.StartTransaction;
     oQuery := SQLManager.CreateQuery('SELECT ' + sZLESKLADWART_ID + ', ' + sZLESKLADWART_REGULA + ' ' +
                                      'FROM %s ' +
                                      'ORDER BY ' + sZLESKLADWART_ID,
                                      [sZLESKLADWART]);
     try
        oQuery.Open;
        if oQuery <> nil then begin
           while not oQuery.Eof do begin
              sRegula := oQuery.FieldByName(sZLESKLADWART_REGULA).AsString ;
              sTmp := sRegula;

              {1. WART_PRACY => WART_PRACY('')}
              if Pos('WART_PRACY', sTmp) > 0 then
                 sTmp := StringReplace(sTmp, 'WART_PRACY', 'WART_PRACY('''')', [rfReplaceAll]);

              {2. ILOSC_PRACY => ILOSC_PRACY('')}
              if Pos('ILOSC_PRACY', sTmp) > 0 then
                 sTmp := StringReplace(sTmp, 'ILOSC_PRACY', 'ILOSC_PRACY('''')', [rfReplaceAll]);


              {3. ILOSC_GODZ => ILOSC_GODZ('')}
              if Pos('ILOSC_GODZ', sTmp) > 0 then
                 sTmp := StringReplace(sTmp, 'ILOSC_GODZ', 'ILOSC_GODZ('''')', [rfReplaceAll]);

              if sTmp <> sRegula then begin
                sRegula := sTmp;
                try
                    oUpdateQuery := SQLManager.UpdateQueryStep1(sZLESKLADWART,
                                      sZLESKLADWART_REGULA + ', ' +
                                      sZLESKLADWART + '_UZ_ZM_ID' + ', ' +
                                      sZLESKLADWART + '_DATA_ZM',
                                      sZLESKLADWART_ID + '=' + IntToStr(oQuery.FieldByName(sZLESKLADWART_ID).AsInteger));

                    oUpdateQuery.ParamByName(sZLESKLADWART_REGULA).DataType    := ftString;
                    oUpdateQuery.ParamByName(sZLESKLADWART + '_UZ_ZM_ID').DataType  := ftInteger;
                    oUpdateQuery.ParamByName(sZLESKLADWART + '_DATA_ZM').DataType   := ftDateTime;
                    oUpdateQuery.ParamByName(sZLESKLADWART_REGULA).AsString    := sRegula;
                    oUpdateQuery.ParamByName(sZLESKLADWART + '_UZ_ZM_ID').AsInteger := SecurityManager.UserId;
                    oUpdateQuery.ParamByName(sZLESKLADWART + '_DATA_ZM').AsDateTime := UNINow;
                    SQLManager.UpdateQueryStep2(oUpdateQuery);
                finally
                    if oUpdateQuery <> nil then FreeAndNil(oUpdateQuery);
                end;
              end;
              oQuery.Next;
           end;
        end;
        SQLManager.Commit;
     finally
        if oQuery <> nil then FreeAndNil(oQuery);
        if SQLManager.InTransaction then begin
           SQLManager.Rollback; //Cos poszlo nie tak, przerywam transakcje?
           Raise Exception.Create('Wykryto niezakoczon transakcj - bd podczas wykonywania update''u');
        end;
     end;


     SQLManager.StartTransaction;
     oQuery := SQLManager.CreateQuery('SELECT ' + sZLESKLADIL_ID + ', ' + sZLESKLADIL_REGULA + ' ' +
                                      'FROM %s ' +
                                      'ORDER BY ' + sZLESKLADIL_ID,
                                      [sZLESKLADIL]);
     try
        oQuery.Open;
        if oQuery <> nil then begin
           while not oQuery.Eof do begin
              sRegula := oQuery.FieldByName(sZLESKLADIL_REGULA).AsString ;
              sTmp := sRegula;

              {1. WART_PRACY => WART_PRACY('')}
              if Pos('WART_PRACY', sTmp) > 0 then
                 sTmp := StringReplace(sTmp, 'WART_PRACY', 'WART_PRACY('''')', [rfReplaceAll]);

              {2. ILOSC_PRACY => ILOSC_PRACY('')}
              if Pos('ILOSC_PRACY', sTmp) > 0 then
                 sTmp := StringReplace(sTmp, 'ILOSC_PRACY', 'ILOSC_PRACY('''')', [rfReplaceAll]);


              {3. ILOSC_GODZ => ILOSC_GODZ('')}
              if Pos('ILOSC_GODZ', sTmp) > 0 then
                 sTmp := StringReplace(sTmp, 'ILOSC_GODZ', 'ILOSC_GODZ('''')', [rfReplaceAll]);

              if sTmp <> sRegula then begin
                sRegula := sTmp;
                try
                    oUpdateQuery := SQLManager.UpdateQueryStep1(sZLESKLADIL,
                                      sZLESKLADIL_REGULA + ', ' +
                                      sZLESKLADIL + '_UZ_ZM_ID' + ', ' +
                                      sZLESKLADIL + '_DATA_ZM',
                                      sZLESKLADIL_ID + '=' + IntToStr(oQuery.FieldByName(sZLESKLADIL_ID).AsInteger));

                    oUpdateQuery.ParamByName(sZLESKLADIL_REGULA).DataType    := ftString;
                    oUpdateQuery.ParamByName(sZLESKLADIL + '_UZ_ZM_ID').DataType  := ftInteger;
                    oUpdateQuery.ParamByName(sZLESKLADIL + '_DATA_ZM').DataType   := ftDateTime;
                    oUpdateQuery.ParamByName(sZLESKLADIL_REGULA).AsString    := sRegula;
                    oUpdateQuery.ParamByName(sZLESKLADIL + '_UZ_ZM_ID').AsInteger := SecurityManager.UserId;
                    oUpdateQuery.ParamByName(sZLESKLADIL + '_DATA_ZM').AsDateTime := UNINow;
                    SQLManager.UpdateQueryStep2(oUpdateQuery);
                finally
                    if oUpdateQuery <> nil then FreeAndNil(oUpdateQuery);
                end;
              end;
              oQuery.Next;
           end;
        end;
        SQLManager.Commit;
     finally
        if oQuery <> nil then FreeAndNil(oQuery);
        if SQLManager.InTransaction then begin
           SQLManager.Rollback; //Cos poszlo nie tak, przerywam transakcje?
           Raise Exception.Create('Wykryto niezakoczon transakcj - bd podczas wykonywania update''u');
        end;
     end;
  end else if nr = '37.81' then begin
    ZLEDM.UtworzSP(sZLEXML_PACKAGE);
  end else if nr = '37.82' then begin
    if (0 < StrToInt(SQLManager.OpenQueryWithResult('SELECT COUNT(*) FROM  %s DEF, %s FM ' +
                                                    'WHERE DEF.' + sFKMNEMONIKI_ID + ' = FM.' + sFKMNEMONIKI_ID + ' AND ' +
                                                          'FM.' + sFKMNEMONIKI_INDEKS + ' = 0 AND ' +
                                                          'FM.' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr('XPJ'{sMnemonikPojazd}),
                                                    [sZLEPOLAZMDEF, sFKMNEMONIKI]))) then begin
       Raise Exception.Create('W instalacji zosta wykorzystany mnemonik XPJ'#13+
                              'Prosz skontaktowa si z central UNISOFT');
    end;
  end else if nr = '37.83' then begin
      ZLEDM.UpdateTable(sZLEZLECENIEPOZ, sZLEZLECENIEPOZ_DATA, true, true);
  end else if nr = '37.84' then begin
      // zmiana nazwy dotychczasowego pola
    if(not SQLManager.SprawdzIstnieniePola(sZLEZLECENIEOBCY, sZLEZLECENIE_OBCY_ID + '_old')) then begin
      SQLManager.ExecuteQuery(
        'alter table %s rename column ' + sZLEZLECENIE_OBCY_ID + ' to ' + sZLEZLECENIE_OBCY_ID + '_old',
        [sZLEZLECENIEOBCY]
      );
    end;
    ZLEDM.UpdateTable(sZLEZLECENIEOBCY, sZLEZLECENIE_OBCY_ID, True, True, true);
      // przepisanie wartoci z tymczasowego pola
    SQLManager.ExecuteQuery(
      'update %s set ' + sZLEZLECENIE_OBCY_ID + ' = ' + sZLEZLECENIE_OBCY_ID + '_old',
      [sZLEZLECENIEOBCY]
    );
      // usunicie pola tymczasowego
    SQLManager.ExecuteQuery(
      'alter table %s drop column ' + sZLEZLECENIE_OBCY_ID + '_old',
      [sZLEZLECENIEOBCY]
    );
    SQLManager.ExecuteQuery(
      'alter table %s modify ' + sZLEZLECENIE_OBCY_ID + ' not null',
      [sZLEZLECENIEOBCY]
    );
    ZLEDM.UtworzSP(sZLEXML_PACKAGE);
  end else if nr = '37.85' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.86' then begin
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sLWPRAPORTPRODTYP_ID, true, true);
    ZLEDM.UtworzSP(sZLEXML_PACKAGE);
  end else if nr = '37.87' then begin
    //Dopisanie nowej domeny
    {nowa domena sZLECONST_ZASOBYPRACARAPST}
    SQLManager.FixDomain( sZLECONST_ZASOBYPRACARAPST, cslZLEConstZasobyPracaRapStatus);

    //Utworzenie tabeli ZLEZASOBYPRACARAP
    if not SQLManager.SprawdzIstnienieTabeli(sZLEZASOBYPRACARAP) then begin
      SQLManager.ZalozTabliceZDataManagera( sZLEModulID, sZLEZASOBYPRACARAP, sZLEZASOBYPRACARAP);
      SQLManager.ZalozNaTabliceConstaintsZDataManagera( sZLEModulID, sZLEZASOBYPRACARAP);
    end;
  end else if nr = '37.88' then begin
    if SQLManager.InTransaction then
       Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

    SQLManager.StartTransaction;
    try
      SQLManager.ExecuteQuery('UPDATE %s ZP ' +
                              'SET ZP.' + sUNIOKRES_ID + ' = (SELECT OKR.' + sUNIOKRES_ID + ' ' +
                                                             'FROM %s OKR ' +
                                                             'WHERE (ZP.' + sZLEZASOBYPRACA_DATA + ' >= OKR.' + sUNIOKRES_DATA_POCZ + ') ' +
                                                             '  AND (ZP.' + sZLEZASOBYPRACA_DATA + ' <= OKR.' + sUNIOKRES_DATA_KONCA + ')) ' +
                              'WHERE ZP.' + sUNIOKRES_ID + ' IS NULL',
                              [sZLEZASOBYPRACA, sUNIOKRES]
                             );
      SQLManager.Commit;
    Except
      if SQLManager.InTransaction then
           SQLManager.Rollback; //Cos poszlo nie tak, przerywam transakcje?
    end;
  end else if nr = '37.89' then begin
    ZLEDM.UtworzSP(sZLEXML_PACKAGE);
      // naprawa istniejcych rekordw
    if(ZLEDM.vZLEFormatGodzinLiczba) then begin
        // czas pracy ma by wyraony w godzinach z przecinkiem
      SQLManager.ExecuteQuery(
        'UPDATE %s PR' +
        ' set PR.' + sZLEZASOBYPRACA_CZAS_PRACY + ' = PR.' + sZLEZASOBYPRACA_CZAS_PRACY + ' / 60' +
        ' where ' +
          'PR.' + sZLEZASOBYPRACA_CZAS_PRACY + ' is not null and ' +
          'PR.' + sZLEZASOBYPRACA_CZAS_PRACY + ' > 100 and ' +
          '(' +
            'PR.' + sLWPRECEPPOZ_ID + ' is not null or ' +
            'PR.' + sLWPPLANPRODEL_ID + ' is not null' +
          ')',
        [sZLEZASOBYPRACA]
      );
    end;  // if(ZLEDM.vZLEFormatGodzinLiczba)
  end else if nr = '37.90' then begin
    if SQLManager.InTransaction then
       Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

    SQLManager.StartTransaction;
    // Uzupenienie osoby w tabeli ZLEZASOBYPRACA dla rozliczen
    try
      SQLManager.ExecuteQuery(
          'UPDATE %s ZP1 ' +
          'SET ' +
            'ZP1.' + sKDOSOBA_ID + ' = (SELECT ZB.' + sKDOSOBA_ID + ' ' +
                                       'FROM %s ZP, %s ZB ' +
                                       'WHERE ZP.' + sZLECONST_RODZAJECP_ID + ' = ' + QuotedStr('R') +
                                        ' AND ZB.' + sZLEZASOB_ID + ' = ZP.' + sZLEZASOB_ID +
                                        ' AND ZB.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('P') +
                                        ' AND ZP.' + sZLEZASOBYPRACA_ID + ' = ZP1.' + sZLEZASOBYPRACA_ID +
                                        ' AND ZB.' + sKDOSOBA_ID + ' IS NOT NULL ' +
                                        ' AND ZP.' + sKDOSOBA_ID + ' IS NULL ' +
                                       ') ' +
          'WHERE ' +
            'ZP1.' + sZLEZASOBYPRACA_ID + ' IN (SELECT ZP.' + sZLEZASOBYPRACA_ID + ' ' +
                                               'FROM %s ZP, %s ZB ' +
                                               'WHERE ZP.' + sZLECONST_RODZAJECP_ID + ' = ' + QuotedStr('R') +
                                                ' AND ZB.' + sZLEZASOB_ID + ' = ZP.' + sZLEZASOB_ID +
                                                ' AND ZB.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('P') +
                                                ' AND ZB.' + sKDOSOBA_ID + ' IS NOT NULL ' +
                                                ' AND ZP.' + sKDOSOBA_ID + ' IS NULL)',
        [sZLEZASOBYPRACA, sZLEZASOBYPRACA, sZLEZASOB, sZLEZASOBYPRACA, sZLEZASOB]
      );
      SQLManager.Commit;
    Except
      if SQLManager.InTransaction then
           SQLManager.Rollback; //Cos poszlo nie tak, przerywam transakcje?
      Raise Exception.Create('Bd podczas uzupeniania osoby w rozliczeniach'#13+
                              'Prosz skontaktowa si z central UNISOFT');
    end;
  end else if nr = '37.91' then begin
    {Zmiana nazwy tabeli ZLEPOLAZM na ZLEPOLAZM_ARCH i zastpienie jej widokiem}
    SQLManager.ExecuteQuery('CREATE TABLE %s_ARCH AS (SELECT * FROM %s)',[sZLEPOLAZM, sZLEPOLAZM]);
    SQLManager.ExecuteQuery('DROP TABLE %s',[sZLEPOLAZM]);
    ZLEDM.ZLEPolazmViewDef.CreateView;

    {Zmiana nazwy tabeli ZLEPOLAZMWSK na ZLEPOLAZMWSK_ARCH i zastpienie jej widokiem}
    SQLManager.ExecuteQuery('CREATE TABLE %s_ARCH AS (SELECT * FROM %s)',[sZLEPOLAZMWSK, sZLEPOLAZMWSK]);
    SQLManager.ExecuteQuery('DROP TABLE %s',[sZLEPOLAZMWSK]);
    ZLEDM.ZLEPolazmwskViewDef.CreateView;

    {Zmiana nazwy tabeli ZLEPOLAZMDEF na ZLEPOLAZMDEF_ARCH i zastpienie jej widokiem}
    SQLManager.ExecuteQuery('CREATE TABLE %s_ARCH AS (SELECT * FROM %s)',[sZLEPOLAZMDEF, sZLEPOLAZMDEF]);
    SQLManager.ExecuteQuery('DROP TABLE %s',[sZLEPOLAZMDEF]);
    ZLEDM.ZLEPolazmdefViewDef.CreateView;
  end else if nr = '37.92' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
  end else if nr = '37.93' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.94' then begin
    SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLERAPORTEDIT, sZLERAPORTEDIT);
    SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLERAPORTEDIT);
  end else if nr = '37.95' then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.96' then begin
    if(SQLManager.SprawdzIstnienieConstrainta(sZLERAPORTEDIT + c_FRK + '1')) then
      SQLManager.ExecuteQuery('ALTER TABLE %s DROP CONSTRAINT ' + sZLERAPORTEDIT + c_FRK + '1', [sZLERAPORTEDIT]);
  end else if nr = '37.97' then begin
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sKDSKLADNIKCZASU_ID, true, true);
    if (ZLEDM.vZLEWysylanieECPWlaczone or ZLEDM.vZLEWysylanieRozliczECPWlaczone) and
       (ZLEDM.vZLESkladnikECPDomyslnyID > 0) then begin
       if SQLManager.InTransaction then
          Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

       try
          SQLManager.StartTransaction;
          SQLManager.ExecuteQuery('UPDATE %s ' +
                                  'SET ' + sKDSKLADNIKCZASU_ID + '=' + IntToStr(ZLEDM.vZLESkladnikECPDomyslnyID),
                                  [sZLEZASOBYPRACA]);
          SQLManager.Commit;
       except
          if SQLManager.InTransaction then SQLmanager.RollBack();
       end;
    end;
  end else if (nr = '37.98')  or (nr ='37.99')   or (nr = '37.100') or
              (nr = '37.101') or (nr = '37.104') or (nr = '37.105') then begin
    FC := TFunkCollection.Create(TFunkItem);
    try
      ZLEDM.GetFunctionality(FC);
      SecurityManager.ProcessFunctionalities(FC);
    finally
      FC.Free;
    end;
  end else if nr = '37.102' then begin
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLEZASOBYPRACA_UWAGI, true, true);
  end else if nr = '37.103' then begin
    ZLEDM.UtworzSP(sZLE_PACKAGE);
    //37.104
    //37.105
  end else if nr = '37.106' then begin
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLEZASOBYPRACA_DATA_DO, true, true);
    SQLManager.ExecuteQuery('ALTER TABLE %s MODIFY ' + sZLEZASOBYPRACARAP_KOMUNIKAT + ' VARCHAR2(4000)', [sZLEZASOBYPRACARAP]);
  end else if nr = '37.107' then begin
    ZLEDM.UpdateTable(sZLEZLECENIEPOZ, sZLEZLECENIEPOZ_CENA, true, true);

  end else if nr = '37.108' then begin
     SQLManager.ZalozTabliceZDataManagera(sZLEModulID, sZLETYPZLECUSERS, sZLETYPZLECUSERS);
     SQLManager.ZalozNaTabliceConstaintsZDataManagera(sZLEModulID, sZLETYPZLECUSERS);
     FC := TFunkCollection.Create(TFunkItem);
     try
       ZLEDM.GetFunctionality(FC);
       SecurityManager.ProcessFunctionalities(FC);
     finally
       FC.Free;
     end;
  end else if nr = '37.109' then begin
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLEZASOBYPRACA_CZAS_PRACY_NOM, true, true);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sUNIJEDNOSTKAORG_ID, true, true);
    if SQLManager.InTransaction then
        Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

     try
        SQLManager.StartTransaction;
        SQLManager.ExecuteQuery('UPDATE %s ' +
                                'SET ' + sZLEZASOBYPRACA_CZAS_PRACY_NOM + '=' + sZLEZASOBYPRACA_CZAS_PRACY,
                                [sZLEZASOBYPRACA]);

        SQLManager.ExecuteQuery('UPDATE %s ZZP ' +
                                'SET ZZP.' + sUNIJEDNOSTKAORG_ID + '= (SELECT ' + sUNIJEDNOSTKAORG_ID + ' ' +
                                                                      'FROM %s ZS ' +
                                                                      'WHERE ZS.' + sZLEZASOB_ID + '=ZZP.' + sZLEZASOB_ID + ')',
                                [sZLEZASOBYPRACA, sZLEZASOB]);


        if ZLEDM.vZLEWysylanieECPWlaczone then begin
          SQLManager.ExecuteQuery('UPDATE %s ZP ' +
                                  'SET ZP.' + sZLEZASOBYPRACA_CZAS_PRACY + '=(SELECT NVL(SUM(NVL(KC.' + sKDCZAS_GODZINY + ',0)),0) ' +
                                                                             'FROM %s KC ' +
                                                                             'WHERE KC.' + sKDCZAS_ZRODLO + ' = ' + QuotedStr('Z') +
                                                                              ' AND KC.' + sZLEZASOBYPRACA_ID + ' = ZP.' + sZLEZASOBYPRACA_ID + ') ' +
                                  'WHERE ZP.' + sZLEZASOBYPRACA_DATA_DO + ' IS NOT NULL AND ' +
                                        'ZP.' + sZLECONST_RODZAJECP_ID + ' IN (' + QuotedStr(cZLERodzajECP_ZasobID) + ', ' +
                                                                                   QuotedStr(cZLERodzajECP_OsobaID) + ')',
                                  [sZLEZASOBYPRACA, sKDCZAS]);
        end;
        SQLManager.Commit;
     except
        if SQLManager.InTransaction then SQLManager.RollBack();
     end;
  end else if nr = '37.110' then begin
     if SQLManager.InTransaction then
        Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');

     try
        SQLManager.StartTransaction;
        if ZLEDM.vZLEWysylanieECPWlaczone then begin
          SQLManager.ExecuteQuery('UPDATE %s ZP ' +
                                  'SET ZP.' + sZLEZASOBYPRACA_CZAS_PRACY + '=(SELECT NVL(SUM(NVL(KC.' + sKDCZAS_GODZINY + ',0)),0) ' +
                                                                             'FROM %s KC ' +
                                                                             'WHERE KC.' + sKDCZAS_ZRODLO + ' = ' + QuotedStr('Z') +
                                                                              ' AND KC.' + sZLEZASOBYPRACA_ID + ' = ZP.' + sZLEZASOBYPRACA_ID + ') ' +
                                  'WHERE ZP.' + sZLEZASOBYPRACA_DATA_DO + ' IS NOT NULL AND ' +
                                        'ZP.' + sZLECONST_RODZAJECP_ID + ' IN (' + QuotedStr(cZLERodzajECP_ZasobID) + ', ' +
                                                                                   QuotedStr(cZLERodzajECP_OsobaID) + ')',
                                  [sZLEZASOBYPRACA, sKDCZAS]);
        end;
        SQLManager.Commit;
     except
        if SQLManager.InTransaction then SQLManager.RollBack();
     end;
  end else if nr = '37.111' then begin
    ZLEDM.UpdateTable(sZLESKLADIL, sZLESKLADIL_NIEOKRESOWY, true, true);
  end else if nr = '37.112' then begin
    if SQLManager.InTransaction then
      Raise Exception.Create('Wykryto niezakoczon transakcj - uruchomienie update''u niemoliwe');


    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLEZASOBYPRACA_EL_NAD_ID, true, true);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLEZASOBYPRACA_STANOWISKO_ID, true, true);
    ZLEDM.UpdateTable(sZLEZASOBYPRACA, sZLEZASOBYPRACA_FORMECP_ID, true, true);
    ZLEDM.UpdateTable(sZLEZASOBYBRAKI, sKDOSOBA_ID, true, true);
    ZLEDM.UpdateTable(sZLEBRAKI, sKDSKLADNIKCZASU_ID, true, true);

    DopiszMnemonik( sMnemonikZLEBraki, 'Braki', sZLEBRAKI, sZLEModulID);

    try
      try
        {Dugosc mnemonik = 20 - dugo symbolu zgodna z dugoci pola symbol}
        SQLManager.StartTransaction();
        SQLManager.ExecuteQuery('UPDATE ' + SQLManager.GetTableName(sFKMNEMONIKI) + ' ' +
                                'SET ' + sFKMNEMONIKI_DLUGOSC + ' = 20 ' +
                                'WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(sMnemonikZLEBraki) + ' AND ' +
                                         sFKMNEMONIKI_INDEKS + ' = 0');

       {Uzupenienie pola sZLEZASOBYPRACA_FORMECP_ID}
        ProgressStart(Nil, 100, 'Uzupenianie pl ECP zlece', True, 0);
        ProgressForm.L1.Caption := 'Trwa uzupenianie. Prosz czeka...';
        ProgressForm.L2.Caption := '';
        ProgressForm.L3.Caption := '';
        ProgressForm.Position := poScreenCenter;
        ProgressForm.l1.Font.Size := 9;
        ProgressForm.l1.Font.Style := [];
        ProgressForm.l2.Font.Size := 9;
        ProgressForm.l2.Font.Style := [];
        ProgressForm.l3.Font.Size := 9;
        ProgressForm.l3.Font.Style := [];
        ProgressForm.Height := ProgressForm.l3.Top + (2 * ProgressForm.l3.Height);
        ProgressForm.PB.Visible := True;

        ProgressForm.ProgressUpdate(
              'Uzupenianie pl ECP zlece',
              'Trwa uzupenianie. Prosz czeka...',
              '',
              10
            );
        SQLManager.ExecuteQuery('UPDATE %s zp ' +
                              'SET ZP.' + sZLEZASOBYPRACA_FORMECP_ID + ' = ' +
                                '(CASE WHEN EXISTS (SELECT ZO.' + sZLEZASOBYPRACA_ID + ' ' +
                                                   'FROM %s ZO ' +
                                                   'WHERE ZO.' + sZLEZASOBYPRACA_ID + ' = ZP.' + sZLEZASOBYPRACA_ID + ') THEN 1 ' +
                                      'WHEN EXISTS (SELECT KC.' + sZLEZASOBYPRACA_ID + ' ' +
                                                   'FROM %s KC ' +
                                                   'WHERE KC.' + sZLEZASOBYPRACA_ID + ' = ZP.' + sZLEZASOBYPRACA_ID + ') THEN 2 ' +
                                'ELSE 0 ' +
                                'END) ' +
                              'WHERE ZP.' + sZLECONST_RODZAJECP_ID + ' = ' + QuotedStr('P'),
                              [sZLEZASOBYPRACA, sZLEOSOBY, sKDCZAS]);
        ProgressForm.Update;
        SQLManager.Commit;
        ProgressEnd;
      except
        SQLManager.Rollback();
        Raise Exception.Create('Bd podczas uzupeniania danych w ECP Zlece'#13+
                               'Prosz skontaktowa si z central UNISOFT');
      end;
    finally
      if ProgressForm <> Nil then ProgressEnd;
    end;
  end else if nr = '37.113' then begin
    ZLEDM.UtworzSP(sZLE_POBIERZ_ID_OBCY);
    ZLEDM.UtworzWyzwalacz(sZLEZLECENIE_INS_AFTER);
  end else if nr = '37.114' then begin
    ZLEDM.UtworzSP(sZLE_POBIERZ_ID_OBCY);
  end;
end;

procedure DopiszMnemonik( const ac_sMnemonik, ac_sNazwa, ac_sTabela,
                                ac_sLokalizacja: String;
                                a_bFirmowy: Boolean = False;
                                a_sOpis: String = '' );
var
  sWskaznik: Char;
  iDlugosc: Integer;
  oQuery: TUNIQuery;
begin
  if DataManagers.Available(ac_sLokalizacja) then begin
    sWskaznik := 'P';
    iDlugosc  := SQLManager.DajDlugoscPola(ac_sTabela, ac_sTabela+'_SYMBOL');
  end else begin
    sWskaznik := 'B';
    iDlugosc  := 3;
  end;
  oQuery := SQLManager.InsertQueryStep1( sFKMNEMONIKI,
                                         sFKMNEMONIKI_ID+','+
                                         sFKMNEMONIKI_MNEMONIK+','+
                                         sFKMNEMONIKI_INDEKS+','+
                                         sFKMNEMONIKI_NAZWA+','+
                                         sFKMNEMONIKI_WSKAZNIK+','+
                                         sFKMNEMONIKI_TABELA+','+
                                         sFKMNEMONIKI_LOKALIZACJA+','+
                                         sFKMNEMONIKI_DLUGOSC+','+
                                         sFKMNEMONIKI_OPIS+','+
                                         sFKMNEMONIKI_CZY_FIRM+','+
                                         sFKMNEMONIKI_UZ_AU_ID+','+
                                         sFKMNEMONIKI_DATA_AU );
  try
    if oQuery <> nil then with oQuery do begin
      ParamByName(sFKMNEMONIKI_MNEMONIK).AsString := ac_sMnemonik;
      ParamByName(sFKMNEMONIKI_INDEKS).AsInteger := 0;
      ParamByName(sFKMNEMONIKI_NAZWA).AsString := ac_sNazwa;
      ParamByName(sFKMNEMONIKI_WSKAZNIK).AsString := sWskaznik;
      ParamByName(sFKMNEMONIKI_TABELA).AsString := ac_sTabela;
      ParamByName(sFKMNEMONIKI_LOKALIZACJA).AsString := ac_sLokalizacja;
      ParamByName(sFKMNEMONIKI_DLUGOSC).AsInteger := iDlugosc;
      ParamByName(sFKMNEMONIKI_OPIS).AsString := a_sOpis;
      if a_bFirmowy then
        ParamByName(sFKMNEMONIKI_CZY_FIRM).AsString := sUNICONST_ALTERNATYWA_TAK
      else
        ParamByName(sFKMNEMONIKI_CZY_FIRM).AsString := sUNICONST_ALTERNATYWA_NIE;

      ParamByName(sFKMNEMONIKI_UZ_AU_ID).AsInteger := SecurityManager.UserId;
      ParamByName(sFKMNEMONIKI_DATA_AU).AsDateTime := UNINow;
      SQLManager.InsertQueryStep2( oQuery, sFKMNEMONIKI_ID );
      //<mnemonik>1
      ParamByName(sFKMNEMONIKI_INDEKS).AsInteger := 1;
      ParamByName(sFKMNEMONIKI_NAZWA).AsString := ac_sNazwa+'-1';
      ParamByName(sFKMNEMONIKI_DLUGOSC).AsInteger := 0;
      SQLManager.InsertQueryStep2( oQuery, sFKMNEMONIKI_ID );
      //<mnemonik>2
      ParamByName(sFKMNEMONIKI_INDEKS).AsInteger := 2;
      ParamByName(sFKMNEMONIKI_NAZWA).AsString := ac_sNazwa+'-2';
      ParamByName(sFKMNEMONIKI_DLUGOSC).AsInteger := 0;
      SQLManager.InsertQueryStep2( oQuery, sFKMNEMONIKI_ID );
      //<mnemonik>3
      ParamByName(sFKMNEMONIKI_INDEKS).AsInteger := 3;
      ParamByName(sFKMNEMONIKI_NAZWA).AsString := ac_sNazwa+'-3';
      ParamByName(sFKMNEMONIKI_DLUGOSC).AsInteger := 0;
      SQLManager.InsertQueryStep2( oQuery, sFKMNEMONIKI_ID );
    end;
  finally
    oQuery.Free;
  end;
end;

end.
