unit ZLEZakresSelectFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-05-13 gdeyk    Utworzone
2005-07-20 MB       przebudowane do RangeFormUnit
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIRangeFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  ExtCtrls, Mask, UNIDateEditUnit, DB, CheckLst, Math, UNISelectFormUnit,
  Buttons;

type
  TZLEZakresSelectForm = class(TUNIRangeForm)
    MainPageControl: TPageControl;
    PodstawoweTabSheet: TTabSheet;
    DefTabSheet: TTabSheet;
    SymbolPanel: TUNIPanel;
    SymbolLabel: TUNILabel;
    SymbolDoLabel: TUNILabel;
    NazwaLabel: TUNILabel;
    NazwaDoLabel: TUNILabel;
    SymbolOdLookupAliasEdit: TUNILookupAliasEdit;
    SymbolDoLookupAliasEdit: TUNILookupAliasEdit;
    NazwaOdEdit: TUNIEdit;
    NazwaDoEdit: TUNIEdit;
    DataOtwarciaPanel: TUNIPanel;
    DataOtwarciaLabel: TUNILabel;
    DataOtwarciaDoLabel: TUNILabel;
    DataOtwarciaOdDateEdit: TUNIDateEdit;
    DataOtwarciaDoDateEdit: TUNIDateEdit;
    StatusZleceniaPanel: TUNIPanel;
    StatusZleceniaLabel: TUNILabel;
    Status4CheckBox: TUNICheckBox;
    Status3CheckBox: TUNICheckBox;
    Status2CheckBox: TUNICheckBox;
    Status1CheckBox: TUNICheckBox;
    InnePanel: TUNIPanel;
    OsobaOdpLabel: TUNILabel;
    ZasobLabel: TUNILabel;
    OperatorWprowadzLabel: TUNILabel;
    OsobaOdpLookupAliasEdit: TUNIRangeLookupAliasEdit;
    ZasobLookupAliasEdit: TUNIRangeLookupAliasEdit;
    OperatorWprowadzRangeLookupAliasEdit: TUNIRangeLookupAliasEdit;
    TypZleceniaRCheckListBox: TUNIRangeCheckListBox;
    ModulZsiRCheckListBox: TUNIRangeCheckListBox;
    DefUNIPanel: TUNIPanel;
    OddzialPanel: TUNIPanel;
    OddzialLabel: TUNILabel;
    OddzialRangeLookupAliasEdit: TUNIRangeLookupAliasEdit;
    DataZakonczeniaPanel: TUNIPanel;
    DataZakLabel: TUNILabel;
    DataZakDoLabel: TUNILabel;
    DataZakonczeniaOdDateEdit: TUNIDateEdit;
    DataZakonczeniaDoDateEdit: TUNIDateEdit;
    WykonawcaLabel: TUNILabel;
    KontrahentRangeLookupAliasEdit: TUNIRangeLookupAliasEdit;
    NiezakonczoneCheckBox: TUNICheckBox;
    PrefixPanel: TUNIPanel;
    PrefixLabel: TUNILabel;
    PrefixRangeLookupAliasEdit: TUNIRangeLookupAliasEdit;
    JednOrgLabel: TUNILabel;
    JednostkaRangeLookupAliasEdit: TUNIRangeLookupAliasEdit;
    Status5CheckBox: TUNICheckBox;
    tsUzytkownicyTabSheet: TTabSheet;
    unpnlUzytkownicyPanel: TUNIPanel;
    lbl1: TUNILabel;
    lbl2: TUNILabel;
    lbl4: TUNILabel;
    lbl5: TUNILabel;
    edtAkceptujacyOsobaAliasEdit: TUNIRangeLookupAliasEdit;
    edtRealizujacyOsobaAliasEdit: TUNIRangeLookupAliasEdit;
    edtPotwRealizacjeAliasEdit: TUNIRangeLookupAliasEdit;
    edtAkceptujacyUzytkAliasEdit: TUNIRangeLookupAliasEdit;
    edtOdpowiedzialnyUzytkAliasEdit: TUNIRangeLookupAliasEdit;
    edtRealizujacyUzytkAliasEdit: TUNIRangeLookupAliasEdit;
    edtPotwRealizacjeUzytkAliasEdit: TUNIRangeLookupAliasEdit;
    PojazdLabel: TUNILabel;
    PojazdRangeLookupAliasEdit: TUNIRangeLookupAliasEdit;
    PrzeliczCheckBox: TUNICheckBox;
    NadrzedneLabel: TUNILabel;
    ZlecenieNadrzedneRangeLookupAliasEdit: TUNIRangeLookupAliasEdit;
    PokazNadrzedneCheckBox: TUNICheckBox;
    procedure SymbolOdLookupAliasEditButtonClick(Sender: TObject);
    function SymbolOdLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure SymbolDoLookupAliasEditButtonClick(Sender: TObject);
    function SymbolDoLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure SymbolOdLookupAliasEditDelKey(Sender: TObject);
    procedure SymbolDoLookupAliasEditDelKey(Sender: TObject);
    function TypZleceniaRCheckListBoxGetQuery: TUNIQuery;
    function ModulZsiRCheckListBoxGetQuery: TUNIQuery;
    procedure NazwaOdEditChange(Sender: TObject);
    procedure NazwaDoEditChange(Sender: TObject);
    procedure DataOtwarciaOdDateEditDateChange(Sender: TObject);
    procedure DataOtwarciaDoDateEditDateChange(Sender: TObject);
    function OsobaOdpLookupAliasEditGetQuery: TUNIQuery;
    function OperatorWprowadzLookupAliasEditGetQuery: TUNIQuery;
    procedure OsobaOdpLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure OperatorWprowadzLookupAliasEditInitAliasInfo(Sender: TObject);
    function ZasobLookupAliasEditGetQuery: TUNIQuery;
    procedure ZasobLookupAliasEditInitAliasInfo(Sender: TObject);
    {function OperatorWprowadzRangeLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;}
    procedure OperatorWprowadzRangeLookupAliasEditDelKey(Sender: TObject);
    procedure SelectButtonClick(Sender: TObject);
    function OddzialRangeLookupAliasEditGetQuery: TUNIQuery;
    procedure OddzialRangeLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure DataZakonczeniaDoDateEditDateChange(Sender: TObject);
    procedure DataZakonczeniaOdDateEditDateChange(Sender: TObject);
    function KontrahentRangeLookupAliasEditGetQuery: TUNIQuery;
    procedure KontrahentRangeLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure KontrahentRangeLookupAliasEditDelKey(Sender: TObject);
    procedure SymbolOdLookupAliasEditExit(Sender: TObject);
    procedure SymbolDoLookupAliasEditExit(Sender: TObject);
    function PrefixRangeLookupAliasEditGetQuery: TUNIQuery;
    procedure PrefixRangeLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure PrefixRangeLookupAliasEditDelKey(Sender: TObject);
    procedure JednostkaRangeLookupAliasEditInitAliasInfo(Sender: TObject);
    function JednostkaRangeLookupAliasEditGetQuery: TUNIQuery;
    procedure JednostkaRangeLookupAliasEditDelKey(Sender: TObject);
    function edtAkceptujacyOsobaAliasEditGetQuery: TUNIQuery;
    procedure edtAkceptujacyOsobaAliasEditInitAliasInfo(Sender: TObject);
    function edtRealizujacyOsobaAliasEditGetQuery: TUNIQuery;
    procedure edtRealizujacyOsobaAliasEditInitAliasInfo(Sender: TObject);
    procedure edtRealizujacyOsobaAliasEditDelKey(Sender: TObject);
    procedure edtAkceptujacyOsobaAliasEditDelKey(Sender: TObject);
    function edtPotwRealizacjeAliasEditGetQuery: TUNIQuery;
    procedure edtPotwRealizacjeAliasEditInitAliasInfo(Sender: TObject);
    procedure edtPotwRealizacjeAliasEditDelKey(Sender: TObject);
    function edtAkceptujacyUzytkAliasEditGetQuery: TUNIQuery;
    procedure edtAkceptujacyUzytkAliasEditInitAliasInfo(Sender: TObject);
    procedure edtAkceptujacyUzytkAliasEditDelKey(Sender: TObject);
    function edtOdpowiedzialnyUzytkAliasEditGetQuery: TUNIQuery;
    procedure edtOdpowiedzialnyUzytkAliasEditInitAliasInfo(
      Sender: TObject);
    procedure edtOdpowiedzialnyUzytkAliasEditDelKey(Sender: TObject);
    function edtRealizujacyUzytkAliasEditGetQuery: TUNIQuery;
    procedure edtRealizujacyUzytkAliasEditInitAliasInfo(Sender: TObject);
    procedure edtRealizujacyUzytkAliasEditDelKey(Sender: TObject);
    function edtPotwRealizacjeUzytkAliasEditGetQuery: TUNIQuery;
    procedure edtPotwRealizacjeUzytkAliasEditInitAliasInfo(
      Sender: TObject);
    procedure edtPotwRealizacjeUzytkAliasEditDelKey(Sender: TObject);
    procedure PojazdRangeLookupAliasEditDelKey(Sender: TObject);
    function PojazdRangeLookupAliasEditGetQuery: TUNIQuery;
    procedure PojazdRangeLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure ZlecenieNadrzedneRangeLookupAliasEditDelKey(Sender: TObject);
    function ZlecenieNadrzedneRangeLookupAliasEditGetQuery: TUNIQuery;
    procedure ZlecenieNadrzedneRangeLookupAliasEditInitAliasInfo(
      Sender: TObject);
//    function OperatorWprowadzRangeLookupAliasEditSetData(
//      AliasSrc: TDataSet): Boolean;
  private
    bProcessData: Boolean;

    iOsobaOdpID: Integer;
    iOperatorWprowadzID: Integer;
    iZasobID: Integer;

    procedure InitializeControls();
    procedure InitializeObjectFields();
//    function  InternalSetData( AliasSrc: TDataSet) : boolean; override;
    procedure UstawAliasy();
    procedure GetParamZasForGrid();

  protected
    procedure BeforeShow; override;
    procedure InternalOpen; override;
    procedure RestoreDefaults; override;
    procedure AssignProperties; override;
    procedure SelectButtonPressed; override;
    procedure GetPositionAndParentForContainedForm( const nr:integer ; var APosition: TRect ; var AParent: TWinControl ; var AAlign:TAlign); override;
    procedure ProcessData; override;
    procedure ProcessRangeParamsToParameters; override;
    procedure PrepareParamsStep1; override;
    procedure PrepareParamsStep2; override;
    procedure PackData; override;
  public
    destructor Destroy(); override;
    function Validate: Boolean; override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  UNIDataManagerUnit,
  FormManagerUnit,
  KeyManagerUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  SystemDefUnit,
  BKDefUnit,
  KDDefUnit,
  KDDataManagerExtUnit,
  BKDataManagerUnit,
  UNISysDefUnit,
  UNIStaleUnit,
  UNISysDataManagerUnit,
  UNICreatorRangeSelectFormUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;
  //UNIDBGridFormUnit;

{ TZakresSelectForm }

procedure TZLEZakresSelectForm.GetPositionAndParentForContainedForm(
  const nr: integer; var APosition: TRect; var AParent: TWinControl;
  var AAlign: TAlign);
begin
  inherited;
  case nr of
    0: begin
         AParent := DefUniPanel;
         APosition :=DefUniPanel.ClientRect;
         AAlign := alClient;
       end;
  end;
end;


procedure TZLEZakresSelectForm.InitializeControls;
    procedure UstawZakresyListoweItem( kvParameters: TKeyValues;
                                       sKeyName: string;
                                       oSlownikDoListy: TStringList;
                                       oCheckListBox: TUNICheckListBox;
                                       iItemCheckedCount: integer );
    begin
    end;

var iIndex: Integer;
begin
  //wczytanie moliwych statusw zlecenia
  for iIndex := 0 to StatusZleceniaPanel.ControlCount-1 do begin
    if StatusZleceniaPanel.Controls[iIndex] is TUNICheckBox then
      (StatusZleceniaPanel.Controls[iIndex] as TUNICheckBox).Caption :=
      cslZLEStatusZlecenia[StatusZleceniaPanel.Controls[iIndex].Tag];
  end;

  OddzialPanel.Visible := (vWieloodzialowosc or (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia));
  if OddzialPanel.Visible and vWielofirmowosc then OddzialLabel.Caption := 'Firma';

  PrefixPanel.Visible := ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0);
  //wczytanie typw zlece do CheckListBox'a
{  try
    oListaDlaComboListBoxa := TStringList.Create;
    ZaladujListeTypowZlecen(oListaDlaComboListBoxa);
    //w powyszej funkcji wypeniana jest rwnie zmienna slSlownikDoListyPodklas
    if oListaDlaComboListBoxa <> nil then begin
      TypZleceniaCheckListBox.Items.Assign(oListaDlaComboListBoxa);
    end;
    ZmienStanCheckListBox( cPrefixTypZlecenia, iItemCheckedCount > 0 );

    oListaDlaComboListBoxa.Clear;
    ZaladujListeModulowZSI(oListaDlaComboListBoxa);
    //w powyszej funkcji wypeniana jest rwnie zmienna slSlownikDoListyPodklas
    if oListaDlaComboListBoxa <> nil then begin
      ModulZSICheckListBox.Items.Assign(oListaDlaComboListBoxa);
    end;
    ZmienStanCheckListBox( cPrefixModulZSI, iItemCheckedCount > 0 );
  finally
    if oListaDlaComboListBoxa <> nil then oListaDlaComboListBoxa.Free;
  end;}

  UstawAliasy();
end;

procedure TZLEZakresSelectForm.InitializeObjectFields;
begin
  bProcessData := False;

  iOsobaOdpID := 0;
  iOperatorWprowadzID := 0;
  iZasobID := 0;
end;

procedure TZLEZakresSelectForm.InternalOpen;
var
  oParams    : TKeyValues;
  omOpenMode : TOpenMode;
  oParams2   : TKeyValues;
begin
  //inicjalizacja pl obiektu
  InitializeObjectFields();
  //inicjalizacja kontrolek
  InitializeControls();

  if Parameters = nil then begin
    Parameters := TKeyValues.CreateEmpty;
  end;
  oParams := TKeyValues.CreateEmpty;
  try
    oParams.Assign(Parameters);
    if oParams.IndexOfName(sParam_ZLEPrzeliczanie) > 0 then
      RangeBehavior := rbProcessOnly
    else
      RangeBehavior := rbProcessAndShow;
  finally
    oParams.Free;
  end;

  inherited;

  with FContainedForms do begin
    omOpenMode := (omList or omContained or omVirtual);

    oParams2 := TKeyValues.CreateEmpty();
    with oParams2 do begin
      Add(cFORM_CAPTION + '=' + 'Zakres danych');

      if Parameters.Values['KLASA'] <> '' then begin
         Add('KLASA' + '=' + Parameters.Values['KLASA']);
      end;
    end;
    AddObject( '', FormManager.OpenForm(self, 'TUNICreatorRangeSelectForm', omOpenMode, oParams2));
  end;
  MainPageControl.ActivePage := PodstawoweTabSheet;
end;

procedure TZLEZakresSelectForm.SelectButtonPressed;
begin
  if not Validate then begin
    ModalResult:= mrnone;
    exit;
  end;
  inherited;
end;

procedure TZLEZakresSelectForm.SymbolOdLookupAliasEditButtonClick(
  Sender: TObject);
var oQuery: TUNIQuery;
    sWhere: String;
    iFirmaID: Integer;
    oSelectedId: TStringList;
begin
  oQuery := nil;
  sWhere := '';
  iFirmaId := 0;
  if (UNISysDM.vWieloodzialowosc)and(Parameters.Values[sUNIODDZIAL_ID] <> '') then
    try
      iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID]);
    except
      iFirmaID := 0;
    end
  else if UNISysDM.vWielofirmowosc then
    iFirmaID := UNISysDM.vAktywnaFirma;

    if RangeParam(sParam_ZLESymbolOd+'ID').Count > 1 then
     oSelectedId := RangeParam(sParam_ZLESymbolOd+'ID')
  else
     oSelectedId := nil;

  try
    oQuery := ZLEDM.ZLEPokazIObsluzZlecenia( sZLEALIAS_ZLECENIE_ID+';'+
                                             sZLEALIAS_ZLECENIE_SYMBOL,
                                             sWhere, false, false,
                                             cZLEModulZSI_ID,
                                             StrToIntDef(RangeParam(sParam_ZLESymbolOd+'ID').Value, 0),
                                             iFirmaID, oSelectedId );
    if oQuery <> nil then SymbolOdLookupAliasEditSetData(oQuery);
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLEZakresSelectForm.SymbolOdLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result:= True;
  if AliasSrc <> nil then begin
      with AliasSrc do begin
        SymbolOdLookupAliasEdit.Text := AliasSrc.FieldByName(sZLEZLECENIE_SYMBOL).AsString;
        RangeParam(sParam_ZLESymbolOd).Value := FieldByName(sZLEZLECENIE_SYMBOL).AsString;
        RangeParam(sParam_ZLESymbolOd+'ID').Value := FieldByName(sZLEZLECENIE_ID).AsString;
      end;
  end;
end;

procedure TZLEZakresSelectForm.SymbolDoLookupAliasEditButtonClick(
  Sender: TObject);
var oQuery: TUNIQuery;
    sWhere: String;
    iFirmaID: Integer;
    oSelectedId: TStringList;
begin
  oQuery := nil;
  sWhere := '';
  iFirmaId := 0;
  if (UNISysDM.vWieloodzialowosc)and(Parameters.Values[sUNIODDZIAL_ID] <> '') then
    try
      iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID]);
    except
      iFirmaID := 0;
    end
  else if UNISysDM.vWielofirmowosc then
    iFirmaID := UNISysDM.vAktywnaFirma;

  if RangeParam(sParam_ZLESymbolDo+'ID').Count > 1 then
     oSelectedId := RangeParam(sParam_ZLESymbolDo+'ID')
  else
     oSelectedId := nil;

  try
    oQuery := ZLEDM.ZLEPokazIObsluzZlecenia( sZLEALIAS_ZLECENIE_ID+';'+
                                             sZLEALIAS_ZLECENIE_SYMBOL,
                                             sWhere, false, false,
                                             cZLEModulZSI_ID,
                                             StrToIntDef(RangeParam(sParam_ZLESymbolDo+'ID').Value, 0),
                                             iFirmaID, oSelectedId );
    if oQuery <> nil then SymbolDoLookupAliasEditSetData(oQuery);
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLEZakresSelectForm.SymbolDoLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result:= True;
  if AliasSrc <> nil then begin
      with AliasSrc do begin
        SymbolDoLookupAliasEdit.Text := AliasSrc.FieldByName(sZLEZLECENIE_SYMBOL).AsString;
        RangeParam(sParam_ZLESymbolDo).Value := FieldByName(sZLEZLECENIE_SYMBOL).AsString;
        RangeParam(sParam_ZLESymbolDo+'ID').Value := FieldByName(sZLEZLECENIE_ID).AsString;
      end;
  end;
end;

destructor TZLEZakresSelectForm.Destroy;
begin
  inherited;
end;

procedure TZLEZakresSelectForm.AssignProperties;
begin
  inherited;
end;


function TZLEZakresSelectForm.Validate: Boolean;
begin
  result := inherited Validate;
  if not result then Exit;

end;

procedure TZLEZakresSelectForm.SymbolOdLookupAliasEditDelKey(
  Sender: TObject);
begin
  RangeParam(sParam_ZLESymbolOd).Clear();
  RangeParam(sParam_ZLESymbolOd+'ID').Clear();
  SymbolOdLookupAliasEdit.Clear;
end;

procedure TZLEZakresSelectForm.SymbolDoLookupAliasEditDelKey(
  Sender: TObject);
begin
  RangeParam(sParam_ZLESymbolDo).Clear();
  RangeParam(sParam_ZLESymbolDo+'ID').Clear();
  SymbolDoLookupAliasEdit.Clear;
end;

function TZLEZakresSelectForm.TypZleceniaRCheckListBoxGetQuery: TUNIQuery;
var
   sWhere: string;
begin
  sWhere := '';
  if vWielofirmowosc and
     (not (ZLEDM.vZLEWspolneZlecenia or UNISYSDM.vWielofirmowoscWieleFirm)) then
     sWhere := ' (@'+sZLEALIAS_TYPZLECENIA_Oddzial_ID+'='+IntToStr(vAktywnaFirma)+')';
  result := ZLEDM.ZLEOdpytajODane( sZLETYPZLEC,
                                   sZLEALIAS_TYPZLECENIA_ID+';'+
                                   sZLEALIAS_TYPZLECENIA_NAZWA+';'+
                                   sZLEALIAS_TYPZLECENIA_SYMBOL,
                                   sWhere,
                                   false);
end;

function TZLEZakresSelectForm.ModulZsiRCheckListBoxGetQuery: TUNIQuery;
var
    iFirmaID: Integer;
begin
  iFirmaId := 0;
  if (UNISysDM.vWieloodzialowosc)and(Parameters.Values[sUNIODDZIAL_ID] <> '') then
    try
      iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID]);
    except
      iFirmaID := 0;
    end
  else if UNISysDM.vWielofirmowosc then
    iFirmaID := UNISysDM.vAktywnaFirma;

  result := UNISysDM.UNIOdpytajODane( sUNIMODULZSI,
                                       sUNISYSALIAS_ModulZSI_ID+';'+
                                       sUNISYSALIAS_ModulZSI_Nazwa+';'+
                                       sUNISYSALIAS_ModulZSI_Kod,
                                       '@'+sUNISYSALIAS_ModulZSI_Czy_Aktywny+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK),
                                       false, iFirmaID );
end;

procedure TZLEZakresSelectForm.PackData;
var
    iIndex: integer;
    iStatusKod: integer;
begin
    iStatusKod := 0;
    for iIndex := 0 to StatusZleceniaPanel.ControlCount-1 do begin
      if (StatusZleceniaPanel.Controls[iIndex] is TCheckBox) then
        if (StatusZleceniaPanel.Controls[iIndex] as TCheckBox).Checked then
          iStatusKod := iStatusKod + Round(Power( 2, StatusZleceniaPanel.Controls[iIndex].Tag));
    end;
    RangeParam(sParam_ZLEStatusZlec).Value := IntToStr(iStatusKod);

    if NiezakonczoneCheckBox.Checked then
       RangeParam('NIEZAKONCZONE').Value:= sTak
    else
       RangeParam('NIEZAKONCZONE').Value:= sNie;

    if PrzeliczCheckBox.Checked then
       RangeParam(sParam_ZLEPrzelicz).Value:= sTak
    else
       RangeParam(sParam_ZLEPrzelicz).Value:= sNie;

    if PokazNadrzedneCheckBox.Checked then
       RangeParam(sParam_ZlecNadrzednePokaz).Value:= sTak
    else
       RangeParam(sParam_ZlecNadrzednePokaz).Value:= sNie;

   inherited;
end;

procedure TZLEZakresSelectForm.PrepareParamsStep1;
begin
  with RangeParams do begin
    OsobaOdpLookupAliasEdit.RangeParam := AddLarge(sParam_ZLEOsobaOdp, '', cADMIDFuncZLEOsoba);
    ZasobLookupAliasEdit.RangeParam    := AddLarge(sParam_ZLEZasZleZLEID, '', cADMIDFuncZLEZasZle);
//    OperatorWprowadzRangeLookupAliasEdit.RangeParam := AddLarge(sParam_ZLEOperatorWprowadz, '', cADMIDFuncZLEOperWpr);

    edtAkceptujacyUzytkAliasEdit.RangeParam := AddLarge(sParam_ZLEOperAkcept, '', cADMIDFuncZLEOperAkcept);
    edtOdpowiedzialnyUzytkAliasEdit.RangeParam := AddLarge(sParam_ZLEOperOdp, '', cADMIDFuncZLEOperOdp);
    edtRealizujacyUzytkAliasEdit.RangeParam := AddLarge(sParam_ZLEOperReal, '', cADMIDFuncZLEOperReal);
    edtPotwRealizacjeUzytkAliasEdit.RangeParam := AddLarge(sParam_ZLEOperPotwReal, '', cADMIDFuncZLEOperPotwReal);
    edtAkceptujacyOsobaAliasEdit.RangeParam := AddLarge(sParam_ZLEOsobaAkcept, '', cADMIDFuncZLEOsobaAkcept);
    edtRealizujacyOsobaAliasEdit.RangeParam := AddLarge(sParam_ZLEOsobaReal, '', cADMIDFuncZLEOsobaReal);
    edtPotwRealizacjeAliasEdit.RangeParam := AddLarge(sParam_ZLEOsobaPotwReal, '', cADMIDFuncZLEOsobaPotwReal);

    AddLarge(sParam_ZLEZasobZLEID, '', cADMIDFuncZLEZasob);
    JednostkaRangeLookupAliasEdit.RangeParam := RangeParam(sUNIJEDNOSTKAORG_ID);
  end;

  if OddzialPanel.Visible then
     OddzialRangeLookupAliasEdit.RangeParam := RangeParam(sUNIODDZIAL_ID);

  PojazdRangeLookupAliasEdit.RangeParam := RangeParam(sParam_ZLEPOjazdID);
  KontrahentRangeLookupAliasEdit.RangeParam := RangeParam(sParam_ZLEKlientId);
  ZlecenieNadrzedneRangeLookupAliasEdit.RangeParam := RangeParam(sParam_ZlecNadrzedneID);
  if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then
     PrefixRangeLookupAliasEdit.RangeParam := RangeParam(sParam_ZLEPrefixId);
  OperatorWprowadzRangeLookupAliasEdit.RangeParam := RangeParam(sParam_ZLEOperatorWprowadz);
  TypZleceniaRCheckListBox.RangeParam := RangeParam(sParam_ZLETypZlec);
  ModulZsiRCheckListBox.RangeParam := RangeParam(sParam_ZLEModulZSI);
end;

procedure TZLEZakresSelectForm.PrepareParamsStep2;
begin
  inherited;

end;

procedure TZLEZakresSelectForm.ProcessData;
var
    iStatusKod: integer;
    iIndex: integer;
begin
  inherited;
  bProcessData := True;
  try
    if RangeParam(sParam_ZLESymbolOd+'ID').IsSet then begin
       if RangeParam(sParam_ZLESymbolOd+'ID').Value <> '' then
          SymbolOdLookupAliasEdit.Text := SQLManager.OpenQueryWithResult(
             ZLEDM.ZLEOdpytajODaneSQL(sZLEZLECENIE,
                                        sZLEAlias_Zlecenie_Symbol,
                                        '@'+sZLEAlias_Zlecenie_ID + '=' + RangeParam(sParam_ZLESymbolOd+'ID').Value,false));
      //SymbolOdLookupAliasEdit.InitiateData( StrToIntDef(RangeParam(sParam_ZLESymbolOd+'ID').Value,0) )
    end else begin
      if RangeParam(sParam_ZLESymbolOd).IsSet then
         SymbolOdLookupAliasEdit.Text := RangeParam(sParam_ZLESymbolOd).Value;
    end;

    if RangeParam(sParam_ZLESymbolDo+'ID').IsSet then begin
       if RangeParam(sParam_ZLESymbolDo+'ID').Value <> '' then
          SymbolDoLookupAliasEdit.Text := SQLManager.OpenQueryWithResult(
             ZLEDM.ZLEOdpytajODaneSQL(sZLEZLECENIE,
                                        sZLEAlias_Zlecenie_Symbol,
                                        '@'+sZLEAlias_Zlecenie_ID + '=' + RangeParam(sParam_ZLESymbolDo+'ID').Value,false));
    end else begin
      if RangeParam(sParam_ZLESymbolDo).IsSet then
         SymbolDoLookupAliasEdit.Text := RangeParam(sParam_ZLESymbolDo).Value;
    end;

    NazwaOdEdit.Text := RangeParam(sParam_ZLENazwaOd).Value;
    NazwaDoEdit.Text := RangeParam(sParam_ZLENazwaDo).Value;

    if RangeParam(sParam_ZLEDataOtwOd).IsSet then
      DataOtwarciaOdDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataOtwOd).Value, 0)
    else
      DataOtwarciaOdDateEdit.Date := 0;

    if RangeParam(sParam_ZLEDataOtwDo).IsSet then
      DataOtwarciaDoDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataOtwDo).Value, 0)
    else
      DataOtwarciaDoDateEdit.Date := 0;

    if RangeParam(sParam_ZLEDataZakOd).IsSet then
      DataZakonczeniaOdDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataZakOd).Value, 0)
    else
      DataZakonczeniaOdDateEdit.Date := 0;

    if RangeParam(sParam_ZLEDataZakDo).IsSet then
      DataZakonczeniaDoDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataZakDo).Value, 0)
    else
      DataZakonczeniaDoDateEdit.Date := 0;


    if RangeParam(sParam_ZLEOperatorWprowadz).IsSet then
      OperatorWprowadzRangeLookupAliasEdit.InitiateData( )
    else
      OperatorWprowadzRangeLookupAliasEdit.OnDelKey(self);


    iStatusKod := StrToIntDef(RangeParam(sParam_ZLEStatusZlec).Value, 0);
    for iIndex := 0 to StatusZleceniaPanel.ControlCount-1 do begin
        if StatusZleceniaPanel.Controls[iIndex] is TCheckBox then
          (StatusZleceniaPanel.Controls[iIndex] as TCheckBox).Checked :=
          (iStatusKod and Round(Power( 2, StatusZleceniaPanel.Controls[iIndex].Tag ))) <> 0;
    end;

    NieZakonczoneCheckBox.Checked := (RangeParam('NIEZAKONCZONE').Value = 'T');
    PrzeliczCheckBox.Checked := (RangeParam(sParam_ZLEPrzelicz).Value = 'T');
    PokazNadrzedneCheckBox.Checked := (RangeParam(sParam_ZlecNadrzednePokaz).Value = 'T');

  finally
    bProcessData := False;
  end;

end;

procedure TZLEZakresSelectForm.ProcessRangeParamsToParameters;
begin
  inherited;

  with Parameters do begin
    Values[sParam_ZLESymbolOd] := RangeParam(sParam_ZLESymbolOd).Value;
    Values[sParam_ZLESymbolDo] := RangeParam(sParam_ZLESymbolDo).Value;

    Values[sParam_ZLENazwaOd]:= RangeParam(sParam_ZLENazwaOd).Value;
    Values[sParam_ZLENazwaDo]:= RangeParam(sParam_ZLENazwaDo).Value;

    Values[sParam_ZLEDataOtwOd]:= RangeParam(sParam_ZLEDataOtwOd).Value;
    Values[sParam_ZLEDataOtwDo]:= RangeParam(sParam_ZLEDataOtwDo).Value;

    Values[sParam_ZLEDataZakOd]:= RangeParam(sParam_ZLEDataZakOd).Value;
    Values[sParam_ZLEDataZakDo]:= RangeParam(sParam_ZLEDataZakDo).Value;

    Values[sParam_ZLEStatusZlec] := RangeParam(sParam_ZLEStatusZlec).Value;

    Values[sParam_ZLEOperatorWprowadz] := RangeParam(sParam_ZLEOperatorWprowadz).CommaText;
    Values[sParam_ZLEOperAkcept]    := RangeParam(sParam_ZLEOperAkcept).CommaText;
    Values[sParam_ZLEOperOdp]       := RangeParam(sParam_ZLEOperOdp).CommaText;
    Values[sParam_ZLEOperReal]      := RangeParam(sParam_ZLEOperReal).CommaText;
    Values[sParam_ZLEOperPotwReal]  := RangeParam(sParam_ZLEOperPotwReal).CommaText;
    Values[sParam_ZLEOsobaAkcept]   := RangeParam(sParam_ZLEOsobaAkcept).CommaText;
    Values[sParam_ZLEOsobaReal]     := RangeParam(sParam_ZLEOsobaReal).CommaText;
    Values[sParam_ZLEOsobaPotwReal] := RangeParam(sParam_ZLEOsobaPotwReal).CommaText;

    Values[sParam_ZLETypZlec]:= TypZleceniaRCheckListBox.ActCommaText();
    Values[sParam_ZLEModulZSI]:= ModulZsiRCheckListBox.ActCommaText();

    Values[sParam_ZLEKlientId]:= RangeParam(sParam_ZLEKlientId).CommaText;
    if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then
       Values[sParam_ZLEPrefixId]:= RangeParam(sParam_ZLEPrefixId).CommaText;

    Values[sParam_ZLEPOjazdID]:= RangeParam(sParam_ZLEPOjazdID).CommaText;
    Values['NIEZAKONCZONE'] := RangeParam('NIEZAKONCZONE').Value;
    Values[sParam_ZLEPrzelicz] := RangeParam(sParam_ZLEPrzelicz).Value;

    Values[sParam_ZlecNadrzedneID]:= RangeParam(sParam_ZlecNadrzedneID).CommaText;
    Values[sParam_ZlecNadrzednePokaz] := RangeParam(sParam_ZlecNadrzednePokaz).Value;

    if (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia) or (vWieloodzialowosc) then
       Values[sUNIODDZIAL_ID] := RangeParam(sUNIODDZIAL_ID).CommaText; {Lista ID}

    //if RangeParam(sUNIJEDNOSTKAORG_ID).IsSet then
    Values[sUNIJEDNOSTKAORG_ID] := RangeParam(sUNIJEDNOSTKAORG_ID).CommaText;
  end;

  FromRangeToParams();
  GetParamZasForGrid();

end;

procedure TZLEZakresSelectForm.BeforeShow;
begin
  if Parameters=nil then Parameters := TKeyValues.CreateEmpty;

  inherited;

//  OperatorWprowadzRangeLookupAliasEdit.ReadOnly := True;
end;

procedure TZLEZakresSelectForm.RestoreDefaults;
begin
  ClearRangeParams();
  PrepareParamsStep1();
  ProcessData();
end;

procedure TZLEZakresSelectForm.UstawAliasy;
begin
  //przypisanie aliasw do kontrolek symboli zlece
  {with SymbolOdLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_Id := sZLEALIAS_ZLECENIE_ID;
    Alias_Name := sZLEALIAS_ZLECENIE_SYMBOL;
  end;

  with SymbolDoLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_Id := sZLEALIAS_ZLECENIE_ID;
    Alias_Name := sZLEALIAS_ZLECENIE_SYMBOL;
  end;}
end;

procedure TZLEZakresSelectForm.NazwaOdEditChange(Sender: TObject);
begin
  if ZZBEmptyString(NazwaOdEdit.Text) then
    RangeParam(sParam_ZLENazwaOd).Clear()
  else
    RangeParam(sParam_ZLENazwaOd).Value := NazwaOdEdit.Text;
end;

procedure TZLEZakresSelectForm.NazwaDoEditChange(Sender: TObject);
begin
  if ZZBEmptyString(NazwaDoEdit.Text) then
    RangeParam(sParam_ZLENazwaDo).Clear()
  else
    RangeParam(sParam_ZLENazwaDo).Value := NazwaDoEdit.Text;
end;

procedure TZLEZakresSelectForm.DataOtwarciaOdDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataOtwarciaOdDateEdit.Date) <> 0 then
    RangeParam(sParam_ZLEDataOtwOd).Value := IntToStr(Trunc(DataOtwarciaOdDateEdit.Date))
  else
    RangeParam(sParam_ZLEDataOtwOd).Clear();
end;

procedure TZLEZakresSelectForm.DataOtwarciaDoDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataOtwarciaDoDateEdit.Date) <> 0 then
    RangeParam(sParam_ZLEDataOtwDo).Value := IntToStr(Trunc(DataOtwarciaDoDateEdit.Date))
  else
    RangeParam(sParam_ZLEDataOtwDo).Clear();
end;

function TZLEZakresSelectForm.OsobaOdpLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  if RangeParam(sParam_ZLEOsobaOdp).Count > 0 then
     oSelectedId := RangeParam(sParam_ZLEOsobaOdp)
  else
     oSelectedId := nil;

  Result := UNISysDM.KDPokazIObsluzPracownika(self, '', sKDAlias_OsobaID+';'+
                                                   sKDAlias_OsobaNazwa+';'+
                                                 sKDAlias_OsobaSymbol,
                                                 True, True,
                                                 0, vAktywnaFirma, '', '', oSelectedId );
end;

function TZLEZakresSelectForm.OperatorWprowadzLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  if RangeParam(sParam_ZLEOperatorWprowadz).Count > 0 then
     oSelectedId := RangeParam(sParam_ZLEOperatorWprowadz)
  else
     oSelectedId := nil;

  Result := UNISysDM.UNIPokazIObsluzDane( sSMUSER, '', false, true,
                                        sADMAlias_UserID + ';' +
                                        sADMAlias_UserNazwisko + ';' +
                                        sADMAlias_UserImie,
                                        vAktywnaFirma,
                                        '',
                                        oSelectedId);

end;

procedure TZLEZakresSelectForm.OsobaOdpLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  //przypisanie aliasw do kontrolki - osoba odpowiedzialna
  with OsobaOdpLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaNazwa; //sKDAlias_OsobaSymbol;
    AdditionalAliases := sKDAlias_OsobaSymbol; //sKDAlias_OsobaNazwa;
  end;
end;

procedure TZLEZakresSelectForm.OperatorWprowadzLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  //przypisanie aliasw do kontrolki - osoba odpowiedzialna
  with OperatorWprowadzRangeLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sADMAlias_UserID; //sKDAlias_OsobaID;
    Alias_Name := sADMAlias_UserNazwisko; //sSMUSER_IMIE+ '||'+''''+' '+''''+'||'+sSMUSER_NAZWISKO; //sADMAlias_UserImie; //sKDAlias_OsobaSymbol;
    AdditionalAliases := sADMAlias_UserImie;

  end;
end;

function TZLEZakresSelectForm.ZasobLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  if RangeParam(sParam_ZLEZasZleZLEID).Count > 0 then
     oSelectedId := RangeParam(sParam_ZLEZasZleZLEID)
  else
     oSelectedId := nil;

  Result := ZLEDM.ZLEPokazIObsluzDane( sZLEZASOB,
                                       sZLEALIAS_ZLEZASOB_ID+';'+
                                       sZLEALIAS_ZLEZASOB_NAZWA, '',
                                       True, True, cZLEModulZSI_ID, 0, 0,
                                       '', oSelectedId );
{  Result := ZLEDM.ZLEPokazIObsluzDane( sZLEZASOB,
                            sZLEALIAS_ZLECENIEZASOB_ZLECENIE_ID+';'+// sZLEALIAS_ZLEZASOB_ID+';'+
                            sZLEALIAS_ZLEZASOB_NAZWA,
                            '@'+sZLEALIAS_ZLEZASOB_ID+'=@'+sZLEALIAS_ZLECENIEZASOB_ZASOB_ID,
                            True, True, cZLEModulZSI_ID, 0, 0,
                            '', oSelectedId );}
end;

procedure TZLEZakresSelectForm.ZasobLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ZasobLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_ZLEZASOB_ID;
    Alias_Name := sZLEALIAS_ZLEZASOB_NAZWA;
  end;
end;

procedure TZLEZakresSelectForm.ZlecenieNadrzedneRangeLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZlecNadrzedneID).Clear();
  ZlecenieNadrzedneRangeLookupAliasEdit.Text := '';
end;

function TZLEZakresSelectForm.ZlecenieNadrzedneRangeLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  oSelectedId := nil;
  if RangeParam(sParam_ZlecNadrzedneID).Count > 0 then
     oSelectedId := RangeParam(sParam_ZlecNadrzedneID);

  Result := ZLEDM.ZLEPokazIObsluzZlecenia( sZLEAlias_Zlecenie_ID+';'+
                                           sZLEAlias_Zlecenie_Symbol,
                                           '',
                                           True, False,
                                           cZLEModulZSI_ID,
                                           StrToIntDef(RangeParam(sParam_ZlecNadrzedneID).Value, 0),
                                           vAktywnaFirma,
                                           oSelectedId );
end;

procedure TZLEZakresSelectForm.ZlecenieNadrzedneRangeLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ZlecenieNadrzedneRangeLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEAlias_Zlecenie_ID;
    Alias_Name := sZLEAlias_Zlecenie_Symbol;
    //AdditionalAliases := sZLEAlias_Zlecenie_Symbol;
  end;
end;

procedure TZLEZakresSelectForm.GetParamZasForGrid();//Pobranie parametrow dla Zasb
const cADMID = sADMID+'%d';
var
  sCondition: String;
  oIDs_List: TStringList;
  sCorrel2: String;
  iPFun: Integer;
  sRangeClassName: String;
  sSql: String;
  oQuery: TUNIQuery;
  iFun: Integer;
  sFieldName: String;
begin
  iFun := cADMIDFuncZLEZasZle;
  sFieldName  := {sZLEALIAS_ZLECENIEZASOB+'.'+}sZLEZASOB_ID;

  iPFun := RangeComboBox.ItemIndex;
  sRangeClassName := ClassName + FSuffix;
  oIDs_List := ADMID_CreateAndLoad( iFun, iPFun, SecurityManager.UserId,
                                    sRangeClassName );
  RangeParam(sParam_ZLEZasobZLEID).Clear();
  try
    if oIDs_List.Count > 0 then
    begin
      sCorrel2 := Format(cADMID, [iFun]);

        //dodanie warunku
      sCondition := '('+sCorrel2+'.'+sADMID_FUNK+'='+IntToStr(iFun)+')and'+
                  '('+sCorrel2+'.'+sADMID_PFUNK+'='+IntToStr(iPFun)+')and'+
                  '('+sCorrel2+'.'+sSMUSER_ID+'='+IntToStr(SecurityManager.UserId)+')and'+
                  '('+sCorrel2+'.'+sADMID_KONTEKST+'='+QuotedStr(sRangeClassName)+')';
        //dodajemy tabele
//        sTables := sTables+','+SQLManager.GetTableName(sADMID)+' '+sCorrel2+' ';
//          GridTabDefs.Add(sCorrel2, sADMID)

        //dodajemy warunki zlaczenia
//        GridJoinDefs.AddExpres(sFieldName+'='+sCorrel2+'.'+sADMID_V, qjkInner, true)
//        sConditions := sConditions + ' and '+sFieldName+'='+sCorrel2+'.'+sADMID_V+' and '+sCondition+' ';

//        DopiszDoWhere(sCondition, sConditions);

        sSql := 'Select ' + sZLEZLECENIE_ID + ' From ' +
                SQLManager.GetTableName(sZLEZLECENIEZASOB) + ',' + SQLManager.GetTableName(sADMID) + ' ' + sCorrel2 +
                ' Where ' + sFieldName + '=' + sCorrel2 + '.' + sADMID_V +
                ' and ' + sCondition;

        oQuery := SQLManager.CreateQuery( sSql );
        oQuery.Open;
        if oQuery.IsEmpty then
            oQuery := nil
        else while not oQuery.Eof do
        begin
            RangeParam(sParam_ZLEZasobZLEID).Add( oQuery.FieldByName(sZLEZLECENIE_ID).AsString);
            oQuery.Next;
        end

    end;
  finally
    if oQuery <> nil then
        FreeAndNil(oQuery);
    oIDs_List.Free;

    ADMID_Save( cADMIDFuncZLEZasob, iPFun, SecurityManager.UserId, sRangeClassName,
                nil, RangeParam(sParam_ZLEZasobZLEID) );

  end;
end;

(*
function TZLEZakresSelectForm.OperatorWprowadzRangeLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
const
   cTekstWiele = 'Wybrano %d pozycji';
begin
  if AliasSrc <> nil then begin
    //obsuga przypadku, gdy wpisana warto generuje wicej ni jeden rekord
    if AliasSrc.RecordCount > 1 then
         OperatorWprowadzRangeLookupAliasEdit.Text := Format( cTekstWiele, [AliasSrc.RecordCount] )
    else OperatorWprowadzRangeLookupAliasEdit.Text := AliasSrc.Fields[2].AsString + ' ' +AliasSrc.Fields[1].AsString;
  end;

  inherited;
  result  := true;
end;
*)
procedure TZLEZakresSelectForm.OperatorWprowadzRangeLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
//  OperatorWprowadzRangeLookupAliasEdit.ReadOnly := false;
  RangeParam(sParam_ZLEOperatorWprowadz).Clear();
  OperatorWprowadzRangeLookupAliasEdit.Text := '';
end;

procedure TZLEZakresSelectForm.SelectButtonClick(Sender: TObject);
begin
  {Przepisanie parametrw z osadzonego grida}
  if (FContainedForms <> nil) and Assigned(FContainedForms.Objects[0]) then
     if TUNICreatorRangeSelectForm(FContainedForms.Objects[0]).MyRangeParams <> nil then
        UzupelnijRangeParams(TUNICreatorRangeSelectForm(FContainedForms.Objects[0]).MyRangeParams);

  inherited;
end;

function TZLEZakresSelectForm.OddzialRangeLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  result := nil;
  if OddzialPanel.Visible then begin
    oSelectedId := nil;
    if RangeParam(sUNIODDZIAL_ID).Count > 1 then
       oSelectedId := RangeParam(sUNIODDZIAL_ID);
    result := UNISysDataManager.UNIPokazIObsluzDane(
      sUNIODDZIAL,
      '',
      False,
      True,
      sUNISYSALIAS_Oddzial_ID + ';' + sUNISYSALIAS_Oddzial_Symbol,
      0,
      sUNIODDZIAL_ID + '=' + iifs(RangeParam(sUNIODDZIAL_ID).Value = '', '0', RangeParam(sUNIODDZIAL_ID).Value),
      oSelectedId
    );
  end;
end;

procedure TZLEZakresSelectForm.OddzialRangeLookupAliasEditInitAliasInfo(Sender: TObject);
begin
  if OddzialPanel.Visible then
    with OddzialRangeLookupAliasEdit do begin
      AliasManager := UNISysDM.AliasManager;
      Alias_ID := sUNISYSALIAS_Oddzial_ID;
      Alias_Name := sUNISYSALIAS_Oddzial_Symbol;
    end;
end;

procedure TZLEZakresSelectForm.DataZakonczeniaOdDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataZakonczeniaOdDateEdit.Date) <> 0 then
    RangeParam(sParam_ZLEDataZakOd).Value := IntToStr(Trunc(DataZakonczeniaOdDateEdit.Date))
  else
    RangeParam(sParam_ZLEDataZakOd).Clear();
end;

procedure TZLEZakresSelectForm.DataZakonczeniaDoDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataZakonczeniaDoDateEdit.Date) <> 0 then
    RangeParam(sParam_ZLEDataZakDo).Value := IntToStr(Trunc(DataZakonczeniaDoDateEdit.Date))
  else
    RangeParam(sParam_ZLEDataZakDo).Clear();
end;

function TZLEZakresSelectForm.KontrahentRangeLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  oSelectedId := nil;
  if RangeParam(sParam_ZLEKlientId).Count > 0 then
     oSelectedId := RangeParam(sParam_ZLEKlientId);

  result := BKDM.PokazIObsluzDaneKlienta( sBKAlias_KlientID+';'+
                                          sBKAlias_KlientSymbol+';'+
                                          sBKAlias_KlientNazwa, '',
                                          false, True,
                                          cZLEModulZSI_ID,
                                          UniDate(),
                                          '',
                                          0,
                                          oSelectedId);
end;

procedure TZLEZakresSelectForm.KontrahentRangeLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with KontrahentRangeLookupAliasEdit do begin
    AliasManager := BKDM.AliasManager;
    Alias_ID := sBKAlias_KlientID;
    Alias_Name := sBKAlias_KlientSymbol;
    AdditionalAliases := sBKAlias_KlientNazwa;
    AdditionalCondition := '(@'+sBKAlias_Klient_Aktywny+'=1)';
  end;
end;

procedure TZLEZakresSelectForm.KontrahentRangeLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZLEKlientId).Clear();
  KontrahentRangeLookupAliasEdit.Text := ''
end;

procedure TZLEZakresSelectForm.SymbolOdLookupAliasEditExit(
  Sender: TObject);
begin
  inherited;
  if SymbolOdLookupAliasEdit.Text <> '' then begin
     if SymbolOdLookupAliasEdit.Text <> RangeParam(sParam_ZLESymbolOd).Value then begin
        RangeParam(sParam_ZLESymbolOd+'ID').Value := SQLManager.OpenQueryWithResult(
             ZLEDM.ZLEOdpytajODaneSQL(sZLEZLECENIE,
                                        sZLEAlias_Zlecenie_ID,
                                        '@'+sZLEAlias_Zlecenie_Symbol + '=' + QuotedStr(AnsiUpperCase(SymbolOdLookupAliasEdit.Text)),false));
        RangeParam(sParam_ZLESymbolOd).Value := SymbolOdLookupAliasEdit.Text;
     end;
  end else begin
     SymbolOdLookupAliasEdit.OnDelKey(self);
  end;

end;

procedure TZLEZakresSelectForm.SymbolDoLookupAliasEditExit(
  Sender: TObject);
begin
  inherited;
  if SymbolDoLookupAliasEdit.Text <> '' then begin
     if SymbolDoLookupAliasEdit.Text <> RangeParam(sParam_ZLESymbolDo).Value then begin
        RangeParam(sParam_ZLESymbolDo+'ID').Value := SQLManager.OpenQueryWithResult(
             ZLEDM.ZLEOdpytajODaneSQL(sZLEZLECENIE,
                                        sZLEAlias_Zlecenie_ID,
                                        '@'+sZLEAlias_Zlecenie_Symbol + '=' + QuotedStr(AnsiUpperCase(SymbolDoLookupAliasEdit.Text)),false));
        RangeParam(sParam_ZLESymbolDo).Value := SymbolDoLookupAliasEdit.Text;
     end;
  end else begin
     SymbolDoLookupAliasEdit.OnDelKey(self);
  end;
end;

function TZLEZakresSelectForm.PrefixRangeLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  oSelectedId := nil;
  if RangeParam(sParam_ZLEPrefixId).Count > 0 then
     oSelectedId := RangeParam(sParam_ZLEPrefixId);

  result := ZLEDM.ZLEPokazIObsluzDane( sZLEPREFIX,
                                       sZLEAlias_PrefixID+';'+
                                       sZLEAlias_PrefixSymbol,
                                       '',
                                       false,
                                       True,
                                       cZLEModulZSI_ID,
                                       0,
                                       vAktywnaFirma,
                                       '',
                                       oSelectedId,
                                       nil,
                                       nil);
end;

procedure TZLEZakresSelectForm.PrefixRangeLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with PrefixRangeLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEAlias_PrefixID;
    Alias_Name := sZLEAlias_PrefixSymbol;
    //AdditionalAliases := sZLEAlias_PrefixNazwa;
  end;
end;

procedure TZLEZakresSelectForm.PrefixRangeLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZLEPrefixId).Clear();
  PrefixRangeLookupAliasEdit.Text := ''
end;

procedure TZLEZakresSelectForm.JednostkaRangeLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with JednostkaRangeLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sUNISysAlias_JednostkaOrg_ID;
    Alias_Name := sUNISysAlias_JednostkaOrg_Symbol;
   // AdditionalCondition := MultiFirmCond('', sMultiFirmCondEMPTY);
  end;
end;

function TZLEZakresSelectForm.JednostkaRangeLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  oSelectedId := nil;
  if RangeParam(sUNIJEDNOSTKAORG_ID).Count > 1 then
     oSelectedId := RangeParam(sUNIJEDNOSTKAORG_ID);
  Result := UniSysDM.UNIPokazIObsluzDane(
    sUNIJEDNOSTKAORG,
    '',
    False,
    True,
    sUNISysAlias_JednostkaOrg_ID + ';' + sUNISysAlias_JednostkaOrg_Symbol,
    0,
    sUNIJEDNOSTKAORG_ID + '=' + iifs(RangeParam(sUNIJEDNOSTKAORG_ID).Value = '', '0', RangeParam(sUNIJEDNOSTKAORG_ID).Value),
    oSelectedId
  );
end;

procedure TZLEZakresSelectForm.JednostkaRangeLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sUNIJEDNOSTKAORG_ID).Clear();
  JednostkaRangeLookupAliasEdit.Text := ''
end;



(**********************
function TZLEZakresSelectForm.OsobaOdpLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  if RangeParam(sParam_ZLEOsobaOdp).Count > 1 then
     oSelectedId := RangeParam(sParam_ZLEOsobaOdp)
  else
     oSelectedId := nil;

  Result := UNISysDM.KDPokazIObsluzPracownika( '', sKDAlias_OsobaID+';'+
                                                   sKDAlias_OsobaNazwa+';'+
                                                 sKDAlias_OsobaSymbol,
                                                 True, True,
                                                 0, vAktywnaFirma, '', oSelectedId );
end;

function TZLEZakresSelectForm.OperatorWprowadzLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  if RangeParam(sParam_ZLEOperatorWprowadz).Count > 1 then
     oSelectedId := RangeParam(sParam_ZLEOperatorWprowadz)
  else
     oSelectedId := nil;

     Result := UNISysDM.UNIPokazIObsluzDane( sSMUSER, '', false, true,
                                        sADMAlias_UserID + ';' +
                                        sADMAlias_UserNazwisko + ';' +
                                        sADMAlias_UserImie,
                                        vAktywnaFirma, '');

end;

procedure TZLEZakresSelectForm.OsobaOdpLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  //przypisanie aliasw do kontrolki - osoba odpowiedzialna
  with OsobaOdpLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaNazwa; //sKDAlias_OsobaSymbol;
    AdditionalAliases := sKDAlias_OsobaSymbol; //sKDAlias_OsobaNazwa;
  end;
end;

procedure TZLEZakresSelectForm.OperatorWprowadzLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  //przypisanie aliasw do kontrolki - osoba odpowiedzialna
  with OperatorWprowadzRangeLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sADMAlias_UserID; //sKDAlias_OsobaID;
    Alias_Name := sADMAlias_UserNazwisko; //sSMUSER_IMIE+ '||'+''''+' '+''''+'||'+sSMUSER_NAZWISKO; //sADMAlias_UserImie; //sKDAlias_OsobaSymbol;
    AdditionalAliases := sADMAlias_UserImie;

  end;
end;

  {Uytkownicy zaangaowani}
  sParam_ZLEOsobaAkcept    = 'ZLEOsobaAkcept';
  sParam_ZLEOsobaReal      = 'ZLEOsobaReal';
  sParam_ZLEOsobaPotwReal  = 'ZLEOsobaPotwReal';
  sParam_ZLEOperAkcept     = 'ZLEOperAkcept';
  sParam_ZLEOperOdp        = 'ZLEOperOdp';
  sParam_ZLEOperReal       = 'ZLEOperReal';
  sParam_ZLEOperPotwReal   = 'ZLEOperPotwReal';
************************)
function TZLEZakresSelectForm.edtAkceptujacyOsobaAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  oSelectedId := nil;
  if RangeParam(sParam_ZLEOsobaAkcept).Count > 0 then
     oSelectedId := RangeParam(sParam_ZLEOsobaAkcept);

  Result := UNISysDM.KDPokazIObsluzPracownika( self, '',
                                               sKDAlias_OsobaID+';'+
                                               sKDAlias_OsobaNazwa+';'+
                                               sKDAlias_OsobaSymbol,
                                               True, False,
                                               0,
                                               vAktywnaFirma,
                                               '', '',
                                               oSelectedId );
end;

procedure TZLEZakresSelectForm.edtAkceptujacyOsobaAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with edtAkceptujacyOsobaAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaNazwa; //sKDAlias_OsobaSymbol;
    AdditionalAliases := sKDAlias_OsobaSymbol; //sKDAlias_OsobaNazwa;
  end;
end;

procedure TZLEZakresSelectForm.edtAkceptujacyOsobaAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZLEOsobaAkcept).Clear();
end;

function TZLEZakresSelectForm.edtRealizujacyOsobaAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  if RangeParam(sParam_ZLEOsobaReal).Count > 0 then
     oSelectedId := RangeParam(sParam_ZLEOsobaReal)
  else
     oSelectedId := nil;

  Result := UNISysDM.KDPokazIObsluzPracownika(self, '', sKDAlias_OsobaID+';'+
                                                   sKDAlias_OsobaNazwa+';'+
                                                   sKDAlias_OsobaSymbol,
                                                   True, True,
                                                   0, vAktywnaFirma, '', '', oSelectedId );
end;

procedure TZLEZakresSelectForm.edtRealizujacyOsobaAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with edtRealizujacyOsobaAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaNazwa; //sKDAlias_OsobaSymbol;
    AdditionalAliases := sKDAlias_OsobaSymbol; //sKDAlias_OsobaNazwa;
  end;
end;

procedure TZLEZakresSelectForm.edtRealizujacyOsobaAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZLEOsobaReal).Clear();
end;

function TZLEZakresSelectForm.edtPotwRealizacjeAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  if RangeParam(sParam_ZLEOsobaPotwReal).Count > 0 then
     oSelectedId := RangeParam(sParam_ZLEOsobaPotwReal)
  else
     oSelectedId := nil;

  Result := UNISysDM.KDPokazIObsluzPracownika( self, '', sKDAlias_OsobaID+';'+
                                                   sKDAlias_OsobaNazwa+';'+
                                                   sKDAlias_OsobaSymbol,
                                                   True, True,
                                                   0, vAktywnaFirma, '', '', oSelectedId );
end;

procedure TZLEZakresSelectForm.edtPotwRealizacjeAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with edtPotwRealizacjeAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaNazwa; //sKDAlias_OsobaSymbol;
    AdditionalAliases := sKDAlias_OsobaSymbol; //sKDAlias_OsobaNazwa;
  end;
end;

procedure TZLEZakresSelectForm.edtPotwRealizacjeAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZLEOsobaPotwReal).Clear();
end;

function TZLEZakresSelectForm.edtAkceptujacyUzytkAliasEditGetQuery: TUNIQuery;
begin
     Result := UNISysDM.UNIPokazIObsluzDane( sSMUSER, '', false, true,
                                             sUniSysAlias_User_ID + ';' +
                                             sUniSysAlias_User_Nazwa,
                                             vAktywnaFirma, '');
end;

procedure TZLEZakresSelectForm.edtAkceptujacyUzytkAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with edtAkceptujacyUzytkAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sUniSysAlias_User_ID;
    Alias_Name := sUniSysAlias_User_Nazwa;
  end;
end;

procedure TZLEZakresSelectForm.edtAkceptujacyUzytkAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZLEOperAkcept).Clear();
end;

function TZLEZakresSelectForm.edtOdpowiedzialnyUzytkAliasEditGetQuery: TUNIQuery;
begin
     Result := UNISysDM.UNIPokazIObsluzDane( sSMUSER, '', false, true,
                                             sUniSysAlias_User_ID + ';' +
                                             sUniSysAlias_User_Nazwa,
                                             vAktywnaFirma, '');
end;

procedure TZLEZakresSelectForm.edtOdpowiedzialnyUzytkAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with edtOdpowiedzialnyUzytkAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sUniSysAlias_User_ID;
    Alias_Name := sUniSysAlias_User_Nazwa;
  end;
end;

procedure TZLEZakresSelectForm.edtOdpowiedzialnyUzytkAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZLEOperOdp).Clear();
end;

function TZLEZakresSelectForm.edtRealizujacyUzytkAliasEditGetQuery: TUNIQuery;
begin
     Result := UNISysDM.UNIPokazIObsluzDane( sSMUSER, '', false, true,
                                             sUniSysAlias_User_ID + ';' +
                                             sUniSysAlias_User_Nazwa,
                                             vAktywnaFirma, '');
end;

procedure TZLEZakresSelectForm.edtRealizujacyUzytkAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with edtRealizujacyUzytkAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sUniSysAlias_User_ID;
    Alias_Name := sUniSysAlias_User_Nazwa;
  end;
end;

procedure TZLEZakresSelectForm.edtRealizujacyUzytkAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZLEOperReal).Clear();
end;

function TZLEZakresSelectForm.edtPotwRealizacjeUzytkAliasEditGetQuery: TUNIQuery;
begin
     Result := UNISysDM.UNIPokazIObsluzDane( sSMUSER, '', false, true,
                                             sUniSysAlias_User_ID + ';' +
                                             sUniSysAlias_User_Nazwa,
                                             vAktywnaFirma, '');
end;

procedure TZLEZakresSelectForm.edtPotwRealizacjeUzytkAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with edtPotwRealizacjeUzytkAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sUniSysAlias_User_ID;
    Alias_Name := sUniSysAlias_User_Nazwa;
  end;
end;

procedure TZLEZakresSelectForm.edtPotwRealizacjeUzytkAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZLEOperPotwReal).Clear();
end;

procedure TZLEZakresSelectForm.PojazdRangeLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  RangeParam(sParam_ZLEPOjazdID).Clear();
end;

function TZLEZakresSelectForm.PojazdRangeLookupAliasEditGetQuery: TUNIQuery;
var
  oSelId:TStringList;
begin
  oSelId := nil;
  if RangeParam(sParam_ZLEPOjazdID).Count > 0 then
     oSelId := RangeParam(sParam_ZLEPOjazdID);

  result := UNISYSDM.UNIPokazIObsluzDane( sUNIPOJSP,
                                       '',
                                       False,
                                       False,
                                       sUNISysAlias_PojSp_ID+';'+
                                       sUNISysAlias_PojSp_Symbol+';'+
                                       sUNISysAlias_PojSp_Nazwa,
                                       vAktywnaFirma,
                                       ''{DMAQFbN(sUNIPOJSP_ID).AsString}, //WarunekPoz
                                       oSelId
                                       );
end;

procedure TZLEZakresSelectForm.PojazdRangeLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with PojazdRangeLookupAliasEdit do begin
    AliasManager := UNISYSDM.AliasManager;
    Alias_ID     := sUNISysAlias_PojSp_ID;
    Alias_Name   := sUNISysAlias_PojSp_Symbol;
    //AdditionalAliases := sUNISysAlias_PojSp_Nazwa;
  end;

end;

initialization
  FormManager.RegisterForm( TZLEZakresSelectForm, 'Zakres zlece', sZLEModulID );

end.


