unit ZLEZasobyPracaRapDBGridFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, ExtCtrls, UNIComponentsUnit, Db, DBTables, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  UNIStaleUnit, UNIDataModuleUnit;

type
  TZLEZasobyPracaRapDBGridForm = class(TUNIDBGridForm)
  protected
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
    procedure BeforeShow; override;
  public
    procedure InternalOpen(); override;
  end;

var
  ZLEZasobyPracaRapDBGridForm: TZLEZasobyPracaRapDBGridForm;

implementation

{$R *.DFM}
uses
  Dodatki,
  FormManagerUnit,
  SecurityManagerUnit,
  UNIDBDetailFormUnit,
  KeyManagerUnit,
  ZLEDefUnit,
  ZleZasobyPracaRapUnit,
  ZLEDataManagerUnit,
  UNISysDefUnit;

function TZleZasobyPracaRapDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZleZasobyPracaRapDataModule.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZleZasobyPracaRapDBGridForm.InternalOpen;
begin
  inherited;
end;

procedure TZleZasobyPracaRapDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(False);
    Switch_Open_HotKey(False);
    Switch_New_HotKey(False);
    Switch_Delete_HotKey(False);
  end;
end;

procedure TZleZasobyPracaRapDBGridForm.BeforeShow;
begin
  inherited;
  //UstawPrzyciski;
end;

initialization
  FormManager.RegisterForm( TZleZasobyPracaRapDBGridForm, 'Raport komunikacji z ECP', sZLEModulID );
end.
