unit ZLEZlecenieDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-24 gdeyk    Utworzone
2007-07-25 Adam     Przystosowanie do wsppracy z zapotrzebowaniami
2007-08-20 Adam     Dodane przyciski tworzenia zapotrzebowania i rezerwacji
2008-01-18 Adam     Dodana funkcja 'Kopiuj zlecenie' w menu funkcji
2008-02-27 Adam     Dodana obsuga parametru vZLEWycenaPracyZasobowWlaczona
2008-07-25 Adam     Dodane wysyanie zasobw na ktrych ma by realizowana dana pozycja receptury
2008-10-07 Adam     Dodanie trybu multiselect do grida wyceny
2009-05-12 Adam     Dodana funkcja zmiany statusu zlecenia
2009-10-02 Adam     Blokowanie usuwania zlece wysanych do systemu partnerskiego
2009-10-09 Adam     Dodane wycofywanie zlece z systemu partnerskiego
2010-05-21 Adam     Moliwo wysyania do partnera wybranych elementw planu produkcji
2011-04-20 Tomjen   Modyfikacja funkcji i umoliwienie grupowej zmiany statusu zlecenia
2011-08-25 Adam     Parametr ukrywania przycisku tworzenia zapotrzebowania
2012-03-26 Adam     Moliwo tworzenia zapotrzebowa ze zlece nieprodukcyjnych
2012-06-12 Adam     Automatyczne tworzenie zapotrzebowania
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, UNIFormUnit, KeyManagerUnit,
  ActnList;

type
  TZLEZlecenieDBGridForm = class(TUNIDBGridForm)
    InformacjeZleceniaPanel: TUNIPanel;
    ZleceniaSplitter: TUNISplitter;
    ToolButton1: TToolButton;
    ZakresButton: TUNIButton;
    FunkcjePopupMenu: TUNIPopupMenu;
    PozycjeMenuItem: TMenuItem;
    KontrolaKosztowMenuItem: TMenuItem;
    KontrolaIlosciMenuItem: TMenuItem;
    SzczegoloweKosztyMaterialoweMenuItem: TMenuItem;
    SzczegoloweKosztyRobociznyMenuItem: TMenuItem;
    WystawioneFakturyMenuItem: TMenuItem;
    PozycjeZleceniaPanel: TUNIPanel;
    KontrolaKosztowPanel: TUNIPanel;
    KontrolaIlosciPanel: TUNIPanel;
    SzczegoloweKosztyMaterialowePanel: TUNIPanel;
    SzczegoloweKosztyRobociznyPanel: TUNIPanel;
    WystawioneFakturyPanel: TUNIPanel;
    FunkcjePanel: TUNIPanel;
    ButtonPozycjePanel: TUNIPanel;
    PozycjeButton: TUNIButton;
    ButtonsTopPanel: TUNIPanel;
    ButtonKontrolaKosztowPanel: TUNIPanel;
    ButtonKontrolaIlosciPanel: TUNIPanel;
    ButtonKosztyMaterialowePanel: TUNIPanel;
    ButtonKosztyRobociznyPanel: TUNIPanel;
    KontrolaKosztowButton: TUNIButton;
    KontrolaIlosciButton: TUNIButton;
    KosztyMaterialoweButton: TUNIButton;
    ButtonWystawioneFakturyPanel: TUNIPanel;
    ButtonPowiekszPanel: TUNIPanel;
    KosztyRobociznyButton: TUNIButton;
    WystawioneFakturyButton: TUNIButton;
    PowiekszButton: TUNIButton;
    ButtonRozliczeniePanel: TUNIPanel;
    RozliczenieButton: TUNIButton;
    RozliczenieMenuItem: TMenuItem;
    RozliczeniePanel: TUNIPanel;
    ZasobyMenuItem: TMenuItem;
    ButtonZasobyPanel: TUNIPanel;
    ZasobyButton: TUNIButton;
    ZasobyPanel: TUNIPanel;
    PokazWszystkieSprawyButton: TUNIButton;
    RazemPanel: TUNIPanel;
    PodsumowanieEdit: TUNIEdit;
    SumaLabel: TUNILabel;
    PrzeliczWszystkieButton: TUNIButton;
    PrzeliczaniePanel: TUNIPanel;
    PrzeliczanieLabel: TUNILabel;
    GodzinaLabel: TUNILabel;
    ButtonZapotrzebowaniePanel: TUNIPanel;
    ZapotrzebowanieButton: TUNIButton;
    ButtonWycenaPanel: TUNIPanel;
    WystawioneFakturyZakupuPanel: TUNIPanel;
    ButtonWystawioneFakturyZakupuPanel: TUNIPanel;
    WystawioneFakturyZakupuButton: TUNIButton;
    WystawioneFakturyZakupuMenuItem: TMenuItem;
    WycenaButton: TUNIButton;
    WycenaPanel: TUNIPanel;
    WycenaMenuItem: TMenuItem;
    KopiujMenuItem: TMenuItem;
    ButtonKopiujPanel: TUNIPanel;
    KopiujButton: TUNIButton;
    tbtPrzeslij: TToolButton;
    miPrzeslij: TMenuItem;
    FunkcjeToolButton: TToolButton;
    FunkcjeToolBarPopupMenu: TUNIPopupMenu;
    UNIINTWyslijZaznaczoneMenuItem: TMenuItem;
    ZamknijkontaMenuItem: TMenuItem;
    KosztyZakupuPanel: TUNIPanel;
    KosztyZakupuButtonPanel: TUNIPanel;
    KosztyZakupuButton: TUNIButton;
    KosztyZakupuMenuItem: TMenuItem;
    KosztyECPPanel: TUNIPanel;
    KosztyECPButtonPanel: TUNIPanel;
    KosztyECPButton: TUNIButton;
    KosztyECPMenuItem: TMenuItem;
    ZmienStatusMenuItem: TMenuItem;
    UNIINTWyslijPlanProdukcjiMenuItem: TMenuItem;
    DopiszKosztyZakupuPanel: TUNIPanel;
    DopiszKosztyZakupuButton: TUNIButton;
    UNIINTWycofajZlecenieMenuItem: TMenuItem;
    UNIINTWycofajPlanProdukcjiMenuItem: TMenuItem;
    mniUzytkownicyZaangazowaniMenuItem: TMenuItem;
    mniUstawPrzeliczZlecMenuItem: TMenuItem;
    mniWylaczPrzeliczZlecenMenuItem: TMenuItem;
    SrodkiTrwalePanel: TUNIPanel;
    SrodkiTrwaleButtonPanel: TUNIPanel;
    SrodkiTrwaleButton: TUNIButton;
    SrodkiTrwaleMenuItem: TMenuItem;
    TransportPanel: TUNIPanel;
    TransportButtonPanel: TUNIPanel;
    TransportButton: TUNIButton;
    TransportMenuItem: TMenuItem;
    ButtonsToolBar: TUNIToolBar;
    PokazButton: TToolButton;
    DodajToolButton: TToolButton;
    ZmienToolButton: TToolButton;
    UsunToolButton: TToolButton;
    ZleceniaPodrzednePanel: TUNIPanel;
    ZleceniaPodrzedneButtonPanel: TUNIPanel;
    ZleceniaPodrzedneButton: TUNIButton;
    ZleceniapodrzedneMenuItem: TMenuItem;
    ImportStatusowzlecenMenuItem: TMenuItem;
    RaportyBledowMenuItem: TMenuItem;
    Rpt_ImportStatusowZleceniaMenuItem: TMenuItem;
    procedure ZakresButtonClick(Sender: TObject);
    procedure RealizacjaButtonClick(Sender: TObject);
    procedure PozycjeMenuItemClick(Sender: TObject);
    procedure KontrolaKosztowMenuItemClick(Sender: TObject);
    procedure KontrolaIlosciMenuItemClick(Sender: TObject);
    procedure SzczegoloweKosztyMaterialoweMenuItemClick(Sender: TObject);
    procedure SzczegoloweKosztyRobociznyMenuItemClick(Sender: TObject);
    procedure WystawioneFakturyMenuItemClick(Sender: TObject);
    procedure PozycjeButtonClick(Sender: TObject);
    procedure KontrolaKosztowButtonClick(Sender: TObject);
    procedure KontrolaIlosciButtonClick(Sender: TObject);
    procedure KosztyMaterialoweButtonClick(Sender: TObject);
    procedure KosztyRobociznyButtonClick(Sender: TObject);
    procedure WystawioneFakturyButtonClick(Sender: TObject);
    procedure PowiekszButtonClick(Sender: TObject);
    procedure RozliczenieButtonClick(Sender: TObject);
    procedure RozliczenieMenuItemClick(Sender: TObject);
    procedure ZasobyMenuItemClick(Sender: TObject);
    procedure ZasobyButtonClick(Sender: TObject);
    procedure PokazWszystkieSprawyButtonClick(Sender: TObject);
    procedure DataSourceDataChange(Sender: TObject; Field: TField);
    procedure PrzeliczWszystkieButtonClick(Sender: TObject);
    procedure ZapotrzebowanieButtonClick(Sender: TObject);
    procedure WystawioneFakturyZakupuMenuItemClick(Sender: TObject);
    procedure WystawioneFakturyZakupuButtonClick(Sender: TObject);
    procedure WycenaMenuItemClick(Sender: TObject);
    procedure WycenaButtonClick(Sender: TObject);
    procedure KopiujMenuItemClick(Sender: TObject);
    procedure KopiujButtonClick(Sender: TObject);
    procedure tbtPrzeslijClick(Sender: TObject);
    procedure UNIINTWyslijZaznaczoneMenuItemClick(Sender: TObject);
    procedure ZamknijkontaMenuItemClick(Sender: TObject);
    procedure KosztyZakupuMenuItemClick(Sender: TObject);
    procedure KosztyZakupuButtonClick(Sender: TObject);
    procedure KosztyECPButtonClick(Sender: TObject);
    procedure KosztyECPMenuItemClick(Sender: TObject);
    procedure ZmienStatusMenuItemClick(Sender: TObject);
    procedure UNIINTWyslijPlanProdukcjiMenuItemClick(Sender: TObject);
    procedure DopiszKosztyZakupuButtonClick(Sender: TObject);
    procedure UNIINTWycofajZlecenieMenuItemClick(Sender: TObject);
    procedure UNIINTWycofajPlanProdukcjiMenuItemClick(Sender: TObject);
    procedure ZaangazowaniMenuItemClick(Sender: TObject);
    procedure mniUstawPrzeliczZlecMenuItemClick(Sender: TObject);
    procedure mniWylaczPrzeliczZlecenMenuItemClick(Sender: TObject);
    procedure SrodkiTrwaleMenuItemClick(Sender: TObject);
    procedure TransportMenuItemClick(Sender: TObject);
    procedure PokazButtonClick(Sender: TObject);
    procedure DodajToolButtonClick(Sender: TObject);
    procedure ZmienToolButtonClick(Sender: TObject);
    procedure UsunToolButtonClick(Sender: TObject);
    procedure ZleceniapodrzedneMenuItemClick(Sender: TObject);
    procedure ZleceniaPodrzedneButtonClick(Sender: TObject);
    procedure ImportStatusowzlecenMenuItemClick(Sender: TObject);
    procedure Rpt_ImportStatusowZleceniaMenuItemClick(Sender: TObject);

  private
    iZlecenieID: Integer;
    bUtworzoneFormatkiOsadzone: Boolean;
    bInternalOpen: Boolean;
    iPozycjeZleceniaFormIndex: Integer;
    iKontrolaKosztowFormIndex: Integer;
    iKontrolaIlosciFormIndex: Integer;
    iSzczegoloweKosztyMaterialowFormIndex: Integer;
    iSzczegoloweKosztyRobociznyFormIndex: Integer;
    iWystawioneFakturyFormIndex: Integer;
    iWystawioneFakturyZakupuFormIndex: integer;
    iZasobyFormIndex: Integer;
    iRozliczenieFormIndex: Integer;
    m_iWycenaFormIndex: integer;
    iKosztyZakupuFormIndex: Integer;
    iKosztyECPFormIndex: Integer;
    iSrodkiTrwaleFormIndex: Integer;
    iTransportFormIndex: Integer;
    iZleceniaPodrzedneFormIndex: Integer;
    bInformacjeWidoczne: Boolean;
    bWszystkieSprawy: Boolean;
    bPrzeliczanie : Boolean;
    {bPrzyciskiWlaczone: Boolean;
    bPrzyciskPozycjiWlaczony: Boolean;
    bPolaUzWlaczone: Boolean;}

    procedure OpenDetail( AOpenMode: TOpenMode; const ac_bKopiowanie: boolean = false );
    procedure PrzelaczInformacje();
    procedure UstawMenuFunkcji();
    procedure PokazWszystkieSprawy( bPokaz: Boolean );

  protected
    bPrzyciskiWlaczone: Boolean;
    bPrzyciskPozycjiWlaczony: Boolean;
    bPolaUzWlaczone: Boolean;
    bPanelWlaczony: Boolean;

    procedure InitializeObjectFields(); virtual;
    procedure InitializeControls(); virtual;
    procedure AddContainedForms(); virtual;
    procedure AktywujFunkcje( oButton: TUNIButton; oPanel: TUNIPanel;
                              oMenuItem: TMenuItem; oAction: TAction = nil );

    procedure WylaczPaneleInformacji(); virtual;

    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    procedure BeforeShow(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure GetPositionAndParentForContainedForm( const nr:integer ; var APosition: TRect ; var AParent: TWinControl ; var AAlign:TAlign); override;
    procedure AssignProperties; override;
    function GetPropertyValue( APropertyName: String ): String; override;
    procedure SetFormProperties(); override;
    procedure SetUserRights; override;
    procedure DisableButtons;
    function OpenRangeForm( bWymusWyswietlenie: boolean = True): boolean; override;
  public
    procedure ZmienStatus();
    destructor  Destroy();  override;
    procedure RefreshDetail( bWymus: Boolean = False; iFormIndex: Integer = -2); virtual;
    procedure InternalOpen(); override;
    procedure GetParametersForForm( AForm: TUNIForm; Parameters: TKeyValues ); override;
    procedure GetRangeForReport(KeyRange: TKeyValues); override;
    procedure PrzeliczWszystkie(Sender: TObject);
    property WszystkieSprawy: Boolean read bWszystkieSprawy;
    property ZasobyFormIndex: Integer read iZasobyFormIndex;
    property RozliczenieFormIndex: Integer read iRozliczenieFormIndex;
    property SzczegoloweKosztyRobociznyFormIndex: Integer read iSzczegoloweKosztyRobociznyFormIndex;
    property PrzyciskiWlaczone: Boolean read bPrzyciskiWlaczone;
    property PrzyciskPozycjiWlaczony: Boolean read bPrzyciskPozycjiWlaczony;
    property PolaUzWlaczone: Boolean read bPolaUzWlaczone;
    property PanelWlaczony: Boolean read bPanelWlaczony;
    property ZlecenieID: Integer read iZlecenieID;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  Math,
  FormManagerUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  UNISysDefUnit,
  SystemDefUnit,
  UNIDBDetailFormUnit,
  UNIDataManagerUnit,
  BOKDefUnit,
  REMDefUnit,
  MFSDefUnit,
  MFZDefUnit,
  ZLEDefUnit,
  STDefUnit,
  TSDefUnit,
  KDPRADefUnit,
  KDPRADataManagerExtUnit,
  ZLEDataManagerUnit,
  MFZDataManagerUnit,
  UNISysDataManagerUnit,
  ZAODataManagerExtUnit,
  MAGDataManagerExtUnit,
  BKDataManagerUnit,
  STDataManagerUnit,
  ZLEKontrolaRealizacjiDBGridFormUnit,
  ZLEKontrolaRealizacjiDBDetailFormUnit,
  ZLEZlecenieDBDetailFormUnit,
  ZLEZlecenieUnit,
  ProgressFormUnit,
  LWPDefUnit,
  OIDefUnit,
  OIDataManagerExtUnit,
  UNIRepTypes,
  UNIINTDefUnit,
  UNIIntDataManagerExtUnit,
  MAGDefUnit,
  BKDefUnit,
  FKDefUnit,
  FKDataManagerUnit,
  ZAODefUnit,
  ZAMDefUnit,
  SPDefUnit,
  KDECPDefUnit,
  KDECPDataManagerExtUnit,
  MSXML2_TLB,
  UNIXMLParserUnit,
  TSDataManagerExtUnit,
  ZLEZlecenieZmianaStatusuSelectFormUnit;

{ TZLEZlecenieDBGridForm }

const
  csZlecenieWUzyciu = 'Nie mona %s zlecenia. Przyczyna:' + Chr(13) + '%s';

procedure TZLEZlecenieDBGridForm.AddContainedForms;
var
  oParamsPozycje, oParamsKontrolaKosztow,
  oParamsKontrolaIlosci, oParamsSzczegolyMaterialow,
  oParamsSzczegolyRobocizny, oParamsFaktury,
  oParamsFakturyZakupu, oParamsZasoby,
  oParamsRozliczenie, oParamsKosztyZakupu,
  oParamsKosztyECP, oParamsSrodkiTrwale,
  oParamsTransport, oParamsZleceniaPodrzedne: TKeyValues;
  AOpenMode: TOpenMode;
  //oPojazdList: TStringList;
//  iIndex: Integer;
  q: TUNIQuery;
  sSymb: String;
begin
  //Nie tworzymy osadzonych siatek gdy nie ma zlece
  //if DataModule.ActiveQuery.IsEmpty then Exit;
   if bUtworzoneFormatkiOsadzone then Exit;

   bUtworzoneFormatkiOsadzone := True;
  AOpenMode := omList or omContained or omReadOnly;

  with FContainedForms do begin
    if ZLEDM.vZLEPozycjeWlaczone and (PrzyciskiWlaczone or PrzyciskPozycjiWlaczony) then begin
      //pozycje zlecenia
      oParamsPozycje := TKeyValues.CreateEmpty();
      with oParamsPozycje do begin
        Add(cFORM_CAPTION+'='+'Pozycje zlecenia');
        Add(sZLEZLECENIE_ID+'=0'{+IntToStr(DMAQFbN(sZLEZLECENIE_ID).AsInteger)});
        if Parameters.Values[sZLEZLECENIEPOZ] <> '' then
          Add( cConditionPosForGrid+'='+Parameters.Values[sZLEZLECENIEPOZ] );
      end;
      iPozycjeZleceniaFormIndex := Count;
      AddObject( 'Pozycje zlecenia', FormManager.OpenDBGrid( Self,
                                                             cKlasaPozycje+cSuffixKlasyDBGrid,
                                                             AOpenMode,
                                                             oParamsPozycje ) );
      if Parameters.Values[sZLEZLECENIEPOZ] <> '' then
        AktywujFunkcje( PozycjeButton, PozycjeZleceniaPanel, PozycjeMenuItem );
    end;
    if (DataModule <> nil) and  ZLEDM.vZLEKontrolaKosztowWlaczona and PrzyciskiWlaczone then begin
      //kontrola kosztw realizacji
      oParamsKontrolaKosztow := TKeyValues.CreateEmpty();
      with oParamsKontrolaKosztow do begin
        Add( cFORM_CAPTION+'='+'Kontrola kosztw i budetu realizacji zlecenia');
        Add( sUNIODDZIAL_ID+'='+Parameters.Values[sUNIODDZIAL_ID]);
        Add( sUNIMODULZSI_ID+'='+Parameters.Values[sUNIMODULZSI_ID]);
        Add( cZLEFuncRodzaj+'='+Parameters.Values[cZLEFuncRodzaj]);
        Add( sZLEZLECENIE_ID+'=0'{+DMAQFbN(sZLEZLECENIE_ID).AsString});
        Add( sZLETYPZLEC_ID+'=0'{+DMAQFbN(sZLETYPZLEC_ID).AsString});
        Add( 'PRZELICZANIE='+sNie);
        Add( sZLETYPZLEC_KOSZTY+'='+sUNICONST_ALTERNATYWA_TAK);
        Add('ZLEGRUPOWANIEDANYCH=' + sNie);
      end;

      AOpenMode := omEdit or omContained;
      iKontrolaKosztowFormIndex := Count;
      AddObject( 'Kontrola kosztw realizacji zlecenia',
                 FormManager.OpenDBDetail( Self,
                                           cKlasaKontrolaRealizacji+cSuffixKlasyDBDetail,
                                           AOpenMode, oParamsKontrolaKosztow ) );
    end;
    if ZLEDM.vZLEKontrolaIlosciWlaczona  and PrzyciskiWlaczone then begin
      //kontrola iloci
      oParamsKontrolaIlosci := TKeyValues.CreateEmpty();
      with oParamsKontrolaIlosci do begin
        Add( cFORM_CAPTION+'='+'Kontrola iloci realizacji zlecenia');
        Add( sUNIODDZIAL_ID+'='+Parameters.Values[sUNIODDZIAL_ID]);
        Add( sUNIMODULZSI_ID+'='+Parameters.Values[sUNIMODULZSI_ID]);
        Add( cZLEFuncRodzaj+'='+Parameters.Values[cZLEFuncRodzaj]);
        Add( sZLEZLECENIE_ID+'=0'{+DMAQFbN(sZLEZLECENIE_ID).AsString});
        Add( sZLETYPZLEC_ID+'=0'{+DMAQFbN(sZLETYPZLEC_ID).AsString});
        Add( 'PRZELICZANIE='+sNie);
        Add( sZLETYPZLEC_ILOSCI+'='+sUNICONST_ALTERNATYWA_TAK);

        if ZLEDM.vZLEGrupowanieDanych then
             Add('ZLEGRUPOWANIEDANYCH=' + sTak)
        else Add('ZLEGRUPOWANIEDANYCH=' + sNie);
      end;

      AOpenMode := omEdit or omContained;
      iKontrolaIlosciFormIndex := Count;
      AddObject( 'Kontrola iloci realizacji zlecenia',
                 FormManager.OpenDBDetail( Self,
                                           cKlasaKontrolaRealizacji+cSuffixKlasyDBDetail,
                                           AOpenMode, oParamsKontrolaIlosci ) );
    end;
    if ZLEDM.vZLEKosztyMaterialoweWlaczone and PrzyciskiWlaczone then begin
      //szczegowe koszty materiaowe
      iSzczegoloweKosztyMaterialowFormIndex := Count;
      oParamsSzczegolyMaterialow := TKeyValues.CreateEmpty();
      with oParamsSzczegolyMaterialow do begin
        Add( sZLEZLECENIE_ID+'=0'{+DMAQFbN(sZLEZLECENIE_ID).AsString });
        //Add( sUNIOKRES_ID+'='+DMAQFbN(sUNIOKRES_ID).AsString );
        Add( sZLESZCZEGOLY_RODZAJ+'='+sZLESZCZEGOLY_RODZAJ_M);
      end;
      AOpenMode := omList or omContained or omReadOnly or omMultiSelect;
      AddObject( 'Szczegoly_materialy',
                 FormManager.OpenDBGrid( Self,
                                         'TZLESzczegoloweKosztyDBGridForm',
                                         AOpenMode, oParamsSzczegolyMaterialow ) );
    end;
    if ZLEDM.vZLEKosztyRobociznyWlaczone and PrzyciskiWlaczone then begin
      //szczegowe koszty robocizny
      iSzczegoloweKosztyRobociznyFormIndex := Count;
      oParamsSzczegolyRobocizny := TKeyValues.CreateEmpty();
      with oParamsSzczegolyRobocizny do begin
        Add( sZLEZLECENIE_ID+'=0'{+DMAQFbN(sZLEZLECENIE_ID).AsString });
        //Add( sUNIOKRES_ID+'='+DMAQFbN(sUNIOKRES_ID).AsString );
        Add( sZLESZCZEGOLY_RODZAJ+'='+sZLESZCZEGOLY_RODZAJ_R);
      end;
      AOpenMode := omList or omContained {or omVirtual} {or omReadOnly} or omMultiSelect;
      AddObject( 'Szczegoly_robocizna',
                 FormManager.OpenDBGrid( Self,
                                         'TZLESzczegoloweKosztyDBGridForm',
                                         AOpenMode, oParamsSzczegolyRobocizny ) );
    end;
    if ZLEDM.vZLEWystawioneFakturyWlaczone and PrzyciskiWlaczone then begin
      //wystawione fatury
      {Tomjen 2006-04-27 - sprawdzanie dostepnosci modulu MFS}

      if DataManagers.Load(sMFSModulID) then begin
         oParamsFaktury := TKeyValues.CreateEmpty();
         with oParamsFaktury do begin
           Add( sParam_MFSTryb+'='+sMFSFakturyTryb_Dokumenty);
           Add( sZLEZLECENIE_ID+'=0'{+DMAQFbN(sZLEZLECENIE_ID).AsString});
           if vWielofirmowosc then
              Add(sParam_MFSOddzialID+'='+IntToStr(DMAQFbN(sUNIODDZIAL_ID).AsInteger))
           else
           if vWieloodzialowosc then
              Add(sParam_MFSOddzialID+'=0');

           Add( sZLEModulID+sBKKLIENT_ID + '=0');
           //Add( sParam_MFSRokID+'='+IntToStr(vAktywnyRokObrachunkowyID) );

           {Tomjen - 2007-07-11 - odkomentowane - Przekazanie moduu
                                  do formatki ze wzgldu na ustawienie LFK}
           Add( sSRCMODULZSI+'='+IntToStr(cSPModulZSI_ID) );
         end;
         AOpenMode := omList or omContained {or omReadOnly};
         iWystawioneFakturyFormIndex := Count;
         AddObject( 'Wystawione faktury',
                     FormManager.OpenDBGrid( Self,
                                         'TMFSFakturaDBGridForm',
                                         AOpenMode, oParamsFaktury ) );
      end;
    end;
    if ZLEDM.vZLEWystawioneFakturyZakupuWlaczone and PrzyciskiWlaczone then begin
      if DataManagers.Load(sMFZModulID) then begin
         oParamsFakturyZakupu := TKeyValues.CreateEmpty();
         with oParamsFakturyZakupu do begin
           Add( sParam_MFZTryb+'='+sMFZZakupTryb_Dokumenty);
           Add( sZLEZLECENIE_ID+'=0'{+DMAQFbN(sZLEZLECENIE_ID).AsString});
           {Add( sParam_MFSOddzialID+'='+IntToStr(DMAQFbN(sUNIODDZIAL_ID).AsInteger) );
           Add( sParam_MFSRokID+'='+IntToStr(vAktywnyRokObrachunkowyID) );}
           if vWielofirmowosc then
              Add(sParam_MFZOddzialID+'='+IntToStr(DMAQFbN(sUNIODDZIAL_ID).AsInteger))
           else
           if vWieloodzialowosc then
              Add(sParam_MFZOddzialID+'=0');

           Add(sParam_MFZRokID+'=0');
           Add(sParam_MFZKlientID+'=0');
           Add(sParam_MFZListaProsta+'='+sUNICONST_ALTERNATYWA_TAK);
           Add(sUNIOKRES_ID+'=0');
           Add(sUNIROK_ID+'=0');
           Add(sUNIWALUTA_ID+'=0');
           Add( sSRCMODULZSI+'='+IntToStr(cZLEModulZSI_ID) );
         end;
         AOpenMode := omList or omContained or omReadOnly;
         iWystawioneFakturyZakupuFormIndex := Count;
         AddObject( 'Wystawione faktury zakupu',
                     FormManager.OpenDBGrid( Self,
                                         'TMFZZakupDBGridForm',
                                         AOpenMode, oParamsFakturyZakupu ) );
      end;
    end;
    if ZLEDM.vZLEZasobyWlaczone and PrzyciskiWlaczone then begin
      //zasoby
      oParamsZasoby := TKeyValues.CreateEmpty();
      with oParamsZasoby do begin
        Add(sZLEZLECENIE_ID+'=0'{+DMAQFbN(sZLEZLECENIE_ID).AsString});
        if Parameters.Values[sZLEZLECENIEZASOB] <> '' then
          Add( cConditionPosForGrid+'='+Parameters.Values[sZLEZLECENIEZASOB] );
      end;
      AOpenMode := omList or omContained or omReadOnly {or omVirtual} or omMultiSelect;
      iZasobyFormIndex := Count;
      AddObject( 'Zasoby przydzielone do zlecenia',
                 FormManager.OpenDBGrid( Self,
                                         cKlasaZlecenieZasob+cSuffixKlasyDBGrid,
                                         AOpenMode, oParamsZasoby ) );
      if Parameters.Values[sZLEZLECENIEZASOB] <> '' then
        AktywujFunkcje( ZasobyButton, ZasobyPanel, ZasobyMenuItem );
    end;
    if ZLEDM.vZLERozliczenieWlaczone and PrzyciskiWlaczone then begin
      //rozliczenie zasobw
      oParamsRozliczenie := TKeyValues.CreateEmpty();
      with oParamsRozliczenie do begin
        Add(sZLEZLECENIE_ID+'=0'{+DMAQFbN(sZLEZLECENIE_ID).AsString});
        if Parameters.Values[sZLEZLECENIEROZL] <> '' then
          Add( cConditionPosForGrid+'='+Parameters.Values[sZLEZLECENIEROZL] );
      end;
      AOpenMode := omList or omContained or omVirtual or omMultiSelect;
      iRozliczenieFormIndex := Count;
      AddObject( 'Rozliczenie zasobw',
                 FormManager.OpenDBGrid( Self,
                                         cKlasaZlecenieRozl+cSuffixKlasyDBGrid,
                                         AOpenMode, oParamsRozliczenie ) );
      if Parameters.Values[sZLEZLECENIEROZL] <> '' then
       AktywujFunkcje( RozliczenieButton, RozliczeniePanel, RozliczenieMenuItem );
    end;
    if(DataManagers.Available(sLWPModulID) and ZLEDM.vZLEWycenaPracyZasobowWlaczona and PrzyciskiWlaczone) then begin
      m_iWycenaFormIndex  := Count;
      AOpenMode := omList or omContained or omMultiSelect;
      AddObject(
        'Wycena pracy zasobw',
        FormManager.OpenDBGrid(
          Self,
          'TZLEZlecenieWycenaDBGridForm',
          AOpenMode
        )
      );
    end else
      ButtonWycenaPanel.Visible := false;

    if ZLEDM.vZLEKosztyZakupuWlaczone and PrzyciskiWlaczone then begin
      if DataManagers.Load(sMFZModulID) then begin
         oParamsKosztyZakupu := TKeyValues.CreateEmpty();
         with oParamsKosztyZakupu do begin
           //Add( sParam_MFZTryb+'='+sMFZZakupTryb_Dokumenty);
           Add(sFKMNEMONIKI_ID + '=' + (SQLManager.OpenQueryWithResult('SELECT ' + sFKMNEMONIKI_ID + ' FROM %s WHERE ' + sFKMNEMONIKI_MNEMONIK + '=' + QuotedStr(sMnemonikZlecenie) + ' AND ' + sFKMNEMONIKI_INDEKS + ' = 0',[sFKMNEMONIKI])));
           Add( sMFZKOSZT + '_ELS_ID' + '=0'{+DMAQFbN(sZLEZLECENIE_ID).AsString});
           {Add( sParam_MFSOddzialID+'='+IntToStr(DMAQFbN(sUNIODDZIAL_ID).AsInteger) );
           Add( sParam_MFSRokID+'='+IntToStr(vAktywnyRokObrachunkowyID) );}

           //Add(sParam_MFZOddzialID+'='+IntToStr(DMAQFbN(sUNIODDZIAL_ID).AsInteger));
           //Add(sParam_MFZRokID+'=0');
           //Add(sParam_MFZKlientID+'=0');
           //Add(sParam_MFZListaProsta+'='+sUNICONST_ALTERNATYWA_TAK);
           //Add(sUNIOKRES_ID+'=0');
           //Add(sUNIROK_ID+'=0');
           //Add(sUNIWALUTA_ID+'=0');
           //Add( sSRCMODULZSI+'='+IntToStr(cZLEModulZSI_ID) );
         end;
         iKosztyZakupuFormIndex := Count;
         AddObject( 'Koszty zakupu',
                     MFZDM.MFZStworzGridaKosztowZakupu(Self, True, False, False,
                                                       True, False,
                                                       oParamsKosztyZakupu));
      end;
    end;


    if ZLEDM.vZLESrodkiTrwaleWlaczone and PrzyciskiWlaczone then begin
      if DataManagers.Load(sSTModulID) then begin
         oParamsSrodkiTrwale := TKeyValues.CreateEmpty();
         with oParamsSrodkiTrwale do begin
           Add(sZLEZLECENIE_ID + '=0'{ + DMAQFbN(sZLEZLECENIE_ID).AsString});
         end;
         iSrodkiTrwaleFormIndex := Count;
         AddObject('rodki trwae', STDM.STZlecenieWRej(Self, oParamsSrodkiTrwale));
      end;
    end;

    if ZLEDM.vZLEZleceniaPodrzedneWlaczone and PrzyciskiWlaczone then begin
       oParamsZleceniaPodrzedne := TKeyValues.CreateEmpty();
       with oParamsZleceniaPodrzedne do begin
         //Add(sZLEZLECENIE_ID + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString);
         //Add(sParam_ZlecNadrzednePokaz + '='+sTak);
         //Add(sParam_ZleceniaPodrzedne + '='+sTak);
         Add(sParam_ZlecNadrzedneID +'=0'{ + IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)});
       end;
       AOpenMode := omList or omContained or omMultiSelect;
       iZleceniaPodrzedneFormIndex := Count;
       AddObject(
        'Zlecenia podrzdne',
        FormManager.OpenDBGrid(
          Self,
          'TZLEZlecenieUprDBGridForm',
          AOpenMode,
          oParamsZleceniaPodrzedne
        )
      );

    end;

    if ZLEDM.vZLETransportWlaczony and PrzyciskiWlaczone then begin
      if DataManagers.Load(sTSModulID) then begin
          oParamsTransport := TKeyValues.CreateEmpty();
          //oPojazdList := TStringList.Create;
          //try
            //Przekazanie pojazdu i domyslnych parametrw - na razie rezygnuj z przekazywania pojazdu
            {if not DMAQFbN(sUNIPOJSP_ID).IsNull then
              oPojazdList.Add(DMAQFbN(sUNIPOJSP_ID).AsString)
            else}
            //oPojazdList.Add('0');

            oParamsTransport.Add(sParam_TSRozlPrzek + '=' + sTSRozliczeniePojSpDBGridForm_PrzekZleGrPojDz_ID);
            oParamsTransport.Add(sParam_TSRozlOkr + '=' + sUNICONST_ALTERNATYWA_TAK);
            oParamsTransport.Add(sParam_TSKontekst +'=' + Self.ClassName + TransportPanel.Name);
            oParamsTransport.Add(sZLEZLECENIE_ID + '=0'{ + DMAQFbN(sZLEZLECENIE_ID).AsString});

            //Ustalenie indeksu formy osadzonej
            iTransportFormIndex := Count;
            AddObject('Transport',
                        TSDM.TSStworzGridaRozliczen(
                        Self, false, false, true, false,
                        TTSRozliczeniaRangeForm_Pojazdu,
                        oParamsTransport,
                        nil));
          //finally
            //oPojazdList.Free;
          //end;
      end;
    end;

    if ZLEDM.vZLEKosztyKDECPWlaczone and PrzyciskiWlaczone then begin
      if DataManagers.Load(sKDECPModulID) then begin
         oParamsKosztyECP := TKeyValues.CreateEmpty();

         {Lista symbol skadnikw}
         sSymb := '';
         q := SQLManager.CreateQuery('SELECT def.' + sKDSKLADNIKCZASU_ID + ' FROM %s def ',
                                     [sZLESKLADNIKIECPDEF]);

         try
           q.Open;
           if not q.IsEmpty then begin
              while not q.Eof do begin
                if q.FieldByName(sKDSKLADNIKCZASU_ID).AsString <> '' then begin
                   if sSymb <> '' then sSymb := sSymb + ',';
                   sSymb := sSymb + q.FieldByName(sKDSKLADNIKCZASU_ID).AsString;
                end;
                q.Next;
              end;
           end;
         finally
           if q <> nil then FreeAndNil(q);
         end;

         with oParamsKosztyECP do begin
           Add(sZLEZLECENIE_ID + '=0'{ + IntToStr(DMAQFbN(sZLEZLECENIE_ID).AsInteger)});
           if sSymb <> '' then
              Add(sKDSKLADNIKCZASU_ID + '=(' + sSymb + ')');
           //Add('AGREGACJA=' + sTak); //Dane s zgrupowane dla pracownikw w okresie
         end;
         iKosztyECPFormIndex := Count;
         AddObject( 'Koszty ECP', KDECPDM.KDECPCzasPracyNaZleceniu(Self, oParamsKosztyECP));
      end;
    end;

  end;
end;

function TZLEZlecenieDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  m_iWycenaFormIndex  := -1;
  iZlecenieID := 0;
  result := TZLEZlecenieDataModule.CreateOpen( Self, DefaultMasterKeyValues, AOpenMode );
end;

procedure TZLEZlecenieDBGridForm.Delete;
begin
  if(DataModule.ActiveQuery.IsEmpty()) then
    exit;
  if(UNIINTDM.Available and ZLEDM.ZlecenieWyslaneDoPartnera(DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then
    Komunikat(cWarning, 'Zlecenie zostao wysane do systemu partnerskiego.' + Chr(13) + 'Usunicie niemoliwe')
  else
    OpenDetail( omDelete );
end;

procedure TZLEZlecenieDBGridForm.BeforeShow;
begin
  inherited;
end;

procedure TZLEZlecenieDBGridForm.GetPositionAndParentForContainedForm(
  const nr: integer; var APosition: TRect; var AParent: TWinControl;
  var AAlign: TAlign);
begin
  if nr = iPozycjeZleceniaFormIndex then begin  //pozycje zlecenia
    PozycjeZleceniaPanel.Align := alClient;
    AParent := PozycjeZleceniaPanel;
    APosition := PozycjeZleceniaPanel.ClientRect;
    AAlign := alClient;
  end else if nr = iKontrolaKosztowFormIndex then begin
    KontrolaKosztowPanel.Align := alClient;
    AParent := KontrolaKosztowPanel;
    APosition := KontrolaKosztowPanel.ClientRect;
    AAlign := alClient;
  end else if nr = iKontrolaIlosciFormIndex then begin
    KontrolaIlosciPanel.Align := alClient;
    AParent := KontrolaIlosciPanel;
    APosition := KontrolaIlosciPanel.ClientRect;
    AAlign := alClient;
  end else if nr = iSzczegoloweKosztyMaterialowFormIndex then begin
    SzczegoloweKosztyMaterialowePanel.Align := alClient;
    AParent := SzczegoloweKosztyMaterialowePanel;
    APosition := SzczegoloweKosztyMaterialowePanel.ClientRect;
    AAlign := alClient;
  end else if nr = iSzczegoloweKosztyRobociznyFormIndex then begin
    SzczegoloweKosztyRobociznyPanel.Align := alClient;
    AParent := SzczegoloweKosztyRobociznyPanel;
    APosition := SzczegoloweKosztyRobociznyPanel.ClientRect;
    AAlign := alClient;
  end else if nr = iWystawioneFakturyFormIndex then begin
    WystawioneFakturyPanel.Align := alClient;
    AParent := WystawioneFakturyPanel;
    APosition := WystawioneFakturyPanel.ClientRect;
    AAlign := alClient;
  end else if nr = iWystawioneFakturyZakupuFormIndex then begin
    WystawioneFakturyZakupuPanel.Align := alClient;
    AParent := WystawioneFakturyZakupuPanel;
    APosition := WystawioneFakturyZakupuPanel.ClientRect;
    AAlign := alClient;
  end else if nr = iZasobyFormIndex then begin
    ZasobyPanel.Align := alClient;
    AParent := ZasobyPanel;
    APosition := ZasobyPanel.ClientRect;
    AAlign := alClient;
  end else if nr = iRozliczenieFormIndex then begin
    RozliczeniePanel.Align := alClient;
    AParent := RozliczeniePanel;
    APosition := RozliczeniePanel.ClientRect;
    AAlign := alClient;
  end else if(Nr = m_iWycenaFormIndex) then begin
    WycenaPanel.Align := alClient;
    AParent   := WycenaPanel;
    APosition := WycenaPanel.ClientRect;
    AAlign    := alClient;
  end else if(Nr = iKosztyZakupuFormIndex) then begin
    KosztyZakupuPanel.Align := alClient;
    AParent   := KosztyZakupuPanel;
    APosition := KosztyZakupuPanel.ClientRect;
    AAlign    := alClient;
  end else if(Nr = iKosztyECPFormIndex) then begin
    KosztyECPPanel.Align := alClient;
    AParent   := KosztyECPPanel;
    APosition := KosztyECPPanel.ClientRect;
    AAlign    := alClient;
  end else if(Nr = iSrodkiTrwaleFormIndex) then begin
    SrodkiTrwalePanel.Align := alClient;
    AParent   := SrodkiTrwalePanel;
    APosition := SrodkiTrwalePanel.ClientRect;
    AAlign    := alClient;
  end else if(Nr = iZleceniaPodrzedneFormIndex) then begin
    ZleceniaPodrzednePanel.Align := alClient;
    AParent   := ZleceniaPodrzednePanel;
    APosition := ZleceniaPodrzednePanel.ClientRect;
    AAlign    := alClient;
  end else if(Nr = iTransportFormIndex) then begin
    TransportPanel.Align := alClient;
    AParent   := TransportPanel;
    APosition := TransportPanel.ClientRect;
    AAlign    := alClient;
  end;
end;

procedure TZLEZlecenieDBGridForm.ImportStatusowzlecenMenuItemClick(
  Sender: TObject);
var
  iResult : integer;
  oForm   : TUNIForm;
  oParams : TKeyValues;
begin
  //tu bedzie import

  if vWielofirmowosc then
    oParams := TKeyValues.CreateAs([sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma)])
  else
    oParams := nil;
  oForm := FormManager.OpenForm(self,
                           'TZLEStatusZleceniaImportSelectForm',
                           omNew+omHidden,
                           oParams
                           );
  try
    iResult:=oForm.ShowModal;
    if (iResult = mrOK) then
    begin
      //warunki sie nie zmieniy, ale dopisano pozycje,
      //wic trzeba odwiey okno
      DataModule.ReOpenDataSets;
    end;
  finally
    oForm.Free
  end;
end;

procedure TZLEZlecenieDBGridForm.InitializeControls;
begin
  //inicjalizacja kontrolek formy
  UstawMenuFunkcji();

  PrzelaczInformacje();

  WylaczPaneleInformacji();
  if FormIsContained then
    ButtonsToolBar.Visible := true
  else
    ButtonsToolBar.Visible := false;

  //ustalenie dostpnoci funkcji na podstawie ustawie parametrw ZLE
  with ZLEDM do begin
    ButtonPozycjePanel.Visible := vZLEPozycjeWlaczone;
    ButtonKontrolaKosztowPanel.Visible := vZLEKontrolaKosztowWlaczona;
    ButtonKontrolaIlosciPanel.Visible := vZLEKontrolaIlosciWlaczona;
    ButtonKosztyMaterialowePanel.Visible := vZLEKosztyMaterialoweWlaczone;
    ButtonKosztyRobociznyPanel.Visible := vZLEKosztyRobociznyWlaczone;
    ButtonWystawioneFakturyPanel.Visible := vZLEWystawioneFakturyWlaczone;
    ButtonWystawioneFakturyZakupuPanel.Visible := vZLEWystawioneFakturyZakupuWlaczone;
    KosztyZakupuButtonPanel.Visible := vZLEKosztyZakupuWlaczone;
    DopiszKosztyZakupuPanel.Visible := vZLEDopiszKosztyZakupuWlaczone;
    KosztyECPButtonPanel.Visible := vZLEKosztyKDECPWlaczone;
    SrodkiTrwaleButtonPanel.Visible := vZLESrodkiTrwaleWlaczone;
    TransportButtonPanel.Visible := vZLETransportWlaczony;
    ButtonWycenaPanel.Visible := ZLEDM.vZLEWycenaPracyZasobowWlaczona;
    ZleceniaPodrzedneButtonPanel.Visible := vZLEZleceniaPodrzedneWlaczone;
    ButtonZasobyPanel.Visible := vZLEZasobyWlaczone;
    ButtonRozliczeniePanel.Visible := vZLERozliczenieWlaczone;
    ButtonZapotrzebowaniePanel.Visible:= (UNISysDM.UNICzyAktywnyModul(sZAOModulID) and vZLETworzZapotrzWlaczone);
    FunkcjePanel.Visible := ButtonPozycjePanel.Visible or ButtonKontrolaKosztowPanel.Visible or
                            ButtonKontrolaIlosciPanel.Visible or ButtonKosztyMaterialowePanel.Visible or
                            ButtonKosztyRobociznyPanel.Visible or ButtonWystawioneFakturyPanel.Visible or
                            ButtonWystawioneFakturyZakupuPanel.Visible or KosztyZakupuButtonPanel.Visible or
                            ButtonZasobyPanel.Visible or ButtonRozliczeniePanel.Visible or
                            KosztyECPButtonPanel.Visible or SrodkiTrwaleButtonPanel.Visible or
                            ZleceniaPodrzedneButtonPanel.Visible or TransportButtonPanel.Visible or
                            ButtonZapotrzebowaniePanel.Visible or ButtonWycenaPanel.Visible;

    FunkcjePanel.Visible := FunkcjePanel.Visible and bPanelWlaczony;
  end;

  PrzeliczWszystkieButton.Height := ZakresButton.Height;
  PrzeliczWszystkieButton.Visible := False;
  PokazWszystkieSprawyButton.Visible := (Parameters.Values[sUNIMODULZSI_ID] = IntToStr(cBOKModulZSI_ID)) or (Parameters.Values[sParam_ZLEKontekst] = sParam_ZLEKontekst_KlientInfo);
  {if WszystkieSprawy then begin}
  if Parameters <> nil then begin
     if Parameters.Values[sParam_ZLEKontekst] = sParam_ZLEKontekst_KlientInfo then
        PokazWszystkieSprawyButton.Caption := 'Klienci-dla spraw'
     else
     if Parameters.Values[sBOKUMOWA_ID] <> '' then
        PokazWszystkieSprawyButton.Caption := 'Wszystkie umowy'
     else
        PokazWszystkieSprawyButton.Caption := 'Wszystkie sprawy';
  end;
  {end else begin
     if Parameters.Values[sBOKUMOWA_ID] <> '' then
          PokazWszystkieSprawyButton.Caption := 'Wszystkie umowy'
     else PokazWszystkieSprawyButton.Caption := 'Wszystkie sprawy';
  end;}
end;

procedure TZLEZlecenieDBGridForm.InitializeObjectFields;
var
  iParam: Integer;
begin
  iPozycjeZleceniaFormIndex := -1;
  iKontrolaKosztowFormIndex := -1;
  iKontrolaIlosciFormIndex := -1;
  iSzczegoloweKosztyMaterialowFormIndex := -1;
  iSzczegoloweKosztyRobociznyFormIndex := -1;
  iWystawioneFakturyFormIndex := -1;
  iWystawioneFakturyZakupuFormIndex := -1;
  iKosztyZakupuFormIndex := -1;
  iKosztyECPFormIndex := -1;
  iZasobyFormIndex := -1;
  iRozliczenieFormIndex := -1;
  m_iWycenaFormIndex    := -1;
  iSrodkiTrwaleFormIndex := -1;
  iTransportFormIndex := -1;
  iZleceniaPodrzedneFormIndex := -1;
  bInformacjeWidoczne := False;
  bPrzeliczanie := False;

  bPrzyciskiWlaczone := True;
  bPrzyciskPozycjiWlaczony := True;
  bPolaUzWlaczone := True;
  bPanelWlaczony := True;


  if Parameters <> nil then begin
     if Parameters.IndexOfName(cZLELista_Optymalizacja) <> -1 then begin
        try
           iParam := StrToInt(Parameters.Values[cZLELista_Optymalizacja]);
        except
           iParam := 0;
        end;

        bPrzyciskiWlaczone       := not ((iParam and cZLELista_WylaczPrzyciski)  = cZLELista_WylaczPrzyciski);
        bPolaUzWlaczone          := not ((iParam and cZLELista_WylaczPolaUzytk)  = cZLELista_WylaczPolaUzytk);
        bPanelWlaczony           := not ((iParam and cZLELista_WylaczPanel)      = cZLELista_WylaczPanel);
        bPrzyciskPozycjiWlaczony :=     ((iParam and cZLELista_WlaczPrzyciskPoz) = cZLELista_WlaczPrzyciskPoz);
     end;
  end;
end;

procedure TZLEZlecenieDBGridForm.InternalOpen;
begin
  iZlecenieID := 0;
  bUtworzoneFormatkiOsadzone := False;
  //inicjalizacja kontrolek
  InitializeControls();
  //inicjalizacja pl obiektu
  InitializeObjectFields();

  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;
  if Parameters.Values[cZLEFuncRodzaj] = '' then
    Parameters.Values[cZLEFuncRodzaj] := cZLEFuncZlecenie;

  try
    bInternalOpen:=True;
    inherited;
  finally
    bInternalOpen:=False;
  end;
  PrzeliczWszystkieButton.Height := ZakresButton.Height;

  //Formatki nie s tworzone automatycznie, dopiero gdy s potrzebne
  //if not DataModule.ActiveQuery.IsEmpty then begin
    //dodanie form osadzonych
  //  AddContainedForms();
  //end;

  PrzeliczaniePanel.Visible := ZLEDM.vZLEPrzeliczanieWlaczone;
  if ZLEDM.vZLEPrzeliczanieWlaczone then begin
     GodzinaLabel.Caption := ZLEDM.vZLEPrzeliczanieGodzina;
  end;

{
  if(m_bOsadzonaNaZapotrz) then begin
      // jeeli grid jest osadzony na zapotrzebowaniach to wyczamy panele
    InfromacjeZleceniaPanel.Visible := false;
    FunkcjePanel.Visible  := false;
  end;  // if(m_bOsadzonaNaZapotrz)
}
end;

procedure TZLEZlecenieDBGridForm.New;
begin
  OpenDetail( omNew );
end;

procedure TZLEZlecenieDBGridForm.Open;
var
  sResult:  string;
begin
  sResult := ZLEDM.MoznaEdytowacZlecenieProdukcyjne(DMAQFbN(sZLEZLECENIE_ID).AsInteger);
  if(Length(sResult) > 0) then begin
    Komunikat(
      cWarning,
      Format(csZlecenieWUzyciu, ['modyfikowa', sResult]),
      MB_OK + MB_ICONWARNING
    );
  end else begin
    OpenDetail( omEdit );
  end;
end;

procedure TZLEZlecenieDBGridForm.OpenDetail(AOpenMode: TOpenMode; const ac_bKopiowanie: boolean = false);
var oParams: TKeyValues;
    sKlasa: String;
    sValue: string;
    oDetal: TZLEZlecenieDBDetailForm;
    iZapotrzId: integer;
    oQuery: TUNIQuery;
begin
  oParams := TKeyValues.CreateEmpty();
  if Parameters.Values[cZLEFuncRodzaj] = cZLEFuncZlecenie then begin
    with oParams do begin
      Add( cFORM_CAPTION+'='+'Zlecenie');
      Add( sUNIODDZIAL_ID+'='+Parameters.Values[sUNIODDZIAL_ID]);
      if vWielofirmowosc and (Parameters.Values['FIRMA_ID'] <> '') then
         Add('FIRMA_ID='+Parameters.Values['FIRMA_ID']);
      Add( sUNIMODULZSI_ID+'='+Parameters.Values[sUNIMODULZSI_ID]);
    end;
    sKlasa := cKlasaZlecenie+cSuffixKlasyDBDetail;
  end else if Parameters.Values[cZLEFuncRodzaj] = cZLEFuncKontrolaRealizacji then begin
    with oParams do begin
      Add( cFORM_CAPTION+'='+'Kontrola realizacji zlecenia');
      Add( sUNIODDZIAL_ID+'='+Parameters.Values[sUNIODDZIAL_ID]);
      if vWielofirmowosc and (Parameters.Values['FIRMA_ID'] <> '') then
         Add('FIRMA_ID='+Parameters.Values['FIRMA_ID']);
      Add( sUNIMODULZSI_ID+'='+Parameters.Values[sUNIMODULZSI_ID]);
    end;
    sKlasa := cKlasaKontrolaRealizacji+cSuffixKlasyDBDetail;
  end;
  oParams.Add(cZLEFuncRodzaj+'='+Parameters.Values[cZLEFuncRodzaj]);
  oParams.Add(sZLEZLECENIE_ID+'='+DMAQFbN(sZLEZLECENIE_ID).AsString);
  oParams.Add(sZLETYPZLEC_ID+'='+DMAQFbN(sZLETYPZLEC_ID).AsString);
  oParams.Add(sBOKSPRAWA_ID+'='+Parameters.Values[sBOKSPRAWA_ID]);
//  oParams.Add(sZLEZLECENIE_WYKONAWCA_ID+'='+Parameters.Values[sZLEZLECENIE_WYKONAWCA_ID]);

  if((AOpenMode = omNew) and (Parameters <> nil)) then begin
    if(ParamIsNotEmpty(Parameters, sZAOZAPOTRZPOZ_ID, sValue)) then
      oParams.Values[sZAOZAPOTRZPOZ_ID] := sValue;
    if(ParamIsNotEmpty(Parameters, sZAMZAMOWIENIEPOZ_ID, sValue)) then
      oParams.Values[sZAMZAMOWIENIEPOZ_ID] := sValue;
  end;  // if((AOpenMode = omNew) and (Parameters <> nil))

  //na razie formatki detail modalne
  if(ac_bKopiowanie) then begin
    AOpenMode := AOpenMode + omHidden;
    if((OpenModeFlags and omVirtual) = omVirtual) then
      AOpenMode := AOpenMode + omOverVirtual;
    oDetal  := (
      FormManager.OpenDBDetail(
        Self,
        sKlasa,
        AOpenMode,
        oParams
      ) as TZLEZlecenieDBDetailForm
    );
    try
      oDetal.SkopiujDaneZeZlecenia(DMAQFbN(sZLEZLECENIE_ID).AsInteger);
      oDetal.ShowModal();
    finally
      oDetal.Free();
    end;
  end else begin  // if(ac_bKopiowanie)
    AOpenMode := AOpenMode + omHidden;
    if((OpenModeFlags and omVirtual) = omVirtual) then
      AOpenMode := AOpenMode + omOverVirtual;
    oQuery  := nil;
    oDetal  := (
      FormManager.OpenDBDetail(
        Self,
        sKlasa,
        AOpenMode,
        oParams
      ) as TZLEZlecenieDBDetailForm
    );
    try
      if(oDetal.ShowModal() = mrOk) then begin
        if(ZAODM.Available and ((AOpenMode and $0F) = omNew) and (oDetal.ZAOZapotrzTypId <> 0)) then begin
            // generowanie automatycznego zapotrzebowania jeeli zlecenie ma wprowadzone materiay
          oQuery  := SQLManager.CreateQuery(
            'select ZM.' + sZLEZLECENIEMAT_ID + ' from %s ZM where ZM.' + sZLEZLECENIE_ID + ' = :' + sZLEZLECENIE_ID,
            [sZLEZLECENIEMAT]
          );
          oQuery.Params[0].AsInteger  := oDetal.DMAQFbN(sZLEZLECENIE_ID).AsInteger;
          oQuery.Open();
          if(not oQuery.IsEmpty()) then begin
            FreeAndNil(oQuery);
            iZapotrzId  := ZAODM.ZAODopiszZapotrzebowanieZeZlecen(oDetal.DMAQFbN(sZLEZLECENIE_ID).AsString, oDetal.ZAOZapotrzTypId);
            if(iZapotrzId <> 0) then
              ZAODM.ZAOPokazIObsluzDane(sZAOZAPOTRZ, '', '', false, false, false, IntToStr(iZapotrzId));
          end;  // if(not oQuery.IsEmpty())
        end;  // if omNew
      end;  // if(oDetal.ShowModal() = mrOk)
    finally
      FreeAndNil(oDetal);
      FreeAndNil(oQuery);
    end;
    if (AOpenMode and omNew) <> 0 then begin
       {Nie ma jeszcze adnych CointainedForm i not ActiveQuery.IsEmpty}
       if ((FContainedForms.Count = 0) and (not DataModule.ActiveQuery.IsEmpty)) then begin
          //dodanie form osadzonych
          AddContainedForms();
       end;
    end;
  end;  // else - if(ac_bKopiowanie)
  RefreshDetail(True);
end;

function TZLEZlecenieDBGridForm.OpenRangeForm(bWymusWyswietlenie: boolean): boolean;
begin
  if FormIsContained then
    result := True
  else
    result := inherited OpenRangeForm(bWymusWyswietlenie);
end;

destructor  TZLEZlecenieDBGridForm.Destroy();
begin
  inherited;
end;

procedure TZLEZlecenieDBGridForm.RefreshDetail;
begin
  //pozycje
  if  (PrzyciskiWlaczone or PrzyciskPozycjiWlaczony) and (PozycjeZleceniaPanel.Visible or (iFormIndex = iPozycjeZleceniaFormIndex)) then begin
    if PozycjeZleceniaPanel.Visible then begin
       (ContainedForms[iPozycjeZleceniaFormIndex] as TUNIDBGridForm).Visible := True;
       RazemPanel.Visible := False;
    end;

    with (ContainedForms[iPozycjeZleceniaFormIndex] as TUNIDBGridForm) do
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        Self.DataModule.ContainedDataModules[iPozycjeZleceniaFormIndex].ReOpenDataSets();
      end;
  end;
  //kontrola kosztw
  if  PrzyciskiWlaczone and (KontrolaKosztowPanel.Visible or (iFormIndex = iKontrolaKosztowFormIndex)) then begin
    if KontrolaKosztowPanel.Visible then begin
      (ContainedForms[iKontrolaKosztowFormIndex] as TUNIDBDetailForm).Visible := True;
      RazemPanel.Visible := False;
      PrzeliczWszystkieButton.Visible := True;
      PrzeliczWszystkieButton.Height := ZakresButton.Height;
    end;

    with (ContainedForms[iKontrolaKosztowFormIndex] as TUNIDBDetailForm) do begin
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        Parameters.Values[sZLETYPZLEC_ID] := intToStr(Self.DMAQFbN(sZLETYPZLEC_ID).AsInteger);
        if bPrzeliczanie then
           Parameters.Values['PRZELICZANIE'] := sTak
        else Parameters.Values['PRZELICZANIE'] := sNie;

        ReOpen();
      end
    end;
  end;
  //kontrola iloci
  if (KontrolaIlosciPanel.Visible or (iFormIndex = iKontrolaIlosciFormIndex)) and  PrzyciskiWlaczone then begin
    if KontrolaIlosciPanel.Visible then begin
       (ContainedForms[iKontrolaIlosciFormIndex] as TUNIDBDetailForm).Visible := True;
       RazemPanel.Visible := False;
      PrzeliczWszystkieButton.Visible := True;
      PrzeliczWszystkieButton.Height := ZakresButton.Height;
    end;

    with (ContainedForms[iKontrolaIlosciFormIndex] as TUNIDBDetailForm) do begin
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        Parameters.Values[sZLETYPZLEC_ID] := IntToStr(Self.DMAQFbN(sZLETYPZLEC_ID).AsInteger);
        if bPrzeliczanie then
           Parameters.Values['PRZELICZANIE'] := sTak
        else Parameters.Values['PRZELICZANIE'] := sNie;
        ReOpen();
      end;
    end;
  end;
  //szczeglowe koszty materiaowe
  if (SzczegoloweKosztyMaterialowePanel.Visible or (iFormIndex = iSzczegoloweKosztyMaterialowFormIndex)) and PrzyciskiWlaczone then begin
    if SzczegoloweKosztyMaterialowePanel.Visible then begin
      (ContainedForms[iSzczegoloweKosztyMaterialowFormIndex] as TUNIDBGridForm).Visible := True;
      RazemPanel.Visible := True;
    end;

    with (ContainedForms[iSzczegoloweKosztyMaterialowFormIndex] as TUNIDBGridForm) do begin
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        Parameters.Values[sZLESZCZEGOLY_RODZAJ] := sZLESZCZEGOLY_RODZAJ_M;

        //Komunikat(cInformation, 'Odswiezam podsumowanie');
        ReOpenDataSets();
      end;
    end;
  end;
  //szczeglowe koszty robocizny
  if (SzczegoloweKosztyRobociznyPanel.Visible or (iFormIndex = iSzczegoloweKosztyRobociznyFormIndex)) and PrzyciskiWlaczone then begin
    if SzczegoloweKosztyRobociznyPanel.Visible then begin
       (ContainedForms[iSzczegoloweKosztyRobociznyFormIndex] as TUNIDBGridForm).Visible := True;
       RazemPanel.Visible := True;
    end;

    with (ContainedForms[iSzczegoloweKosztyRobociznyFormIndex] as TUNIDBGridForm) do begin
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        Parameters.Values[sZLESZCZEGOLY_RODZAJ] := sZLESZCZEGOLY_RODZAJ_R;
        ReOpenDataSets();
      end;
    end;
  end;
  //wystawione faktury sprzeday
  if (WystawioneFakturyPanel.Visible or (iFormIndex = iWystawioneFakturyFormIndex)) and PrzyciskiWlaczone then begin
    if WystawioneFakturyPanel.Visible then begin
      (ContainedForms[iWystawioneFakturyFormIndex] as TUNIDBGridForm).Visible := True;
      RazemPanel.Visible := False;
    end;

    with (ContainedForms[iWystawioneFakturyFormIndex] as TUNIDBGridForm) do begin
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        //Przekazanie klienta do wystawiania faktur sprzedazy
        if Self.DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger > 0 then begin
          Parameters.Values[sZLEModulID+sBKKLIENT_ID] :=  IntToStr(BKDM.GetKlientArchID(Self.DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger));
        end else begin
          Parameters.Values[sZLEModulID+sBKKLIENT_ID] :=  '0';
        end;

        if vWielofirmowosc or vWieloodzialowosc then

(**
if vWieloodzialowosc or
       (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia) or
       (vWielofirmowosc and UNISYSDM.vWielofirmowoscWieleFirm) then
      AddSimple( 'M', 'O', 'M.'+sUNIODDZIAL_ID+'=O.'+sUNIODDZIAL_ID, qjkLeftOuter, True )
    else if vWielofirmowosc and
            (not (ZLEDM.vZLEWspolneZlecenia or UNISYSDM.vWielofirmowoscWieleFirm)) then begin
      AddCondition( 'M.'+sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma), True );
*)



           Parameters.Values[sParam_MFSOddzialID] := IntToStr(Self.DMAQFbN(sUNIODDZIAL_ID).AsInteger);
        ReOpenDataSets();
      end;
    end;
  end;
  // Wystawione faktury zakupu
  if (WystawioneFakturyZakupuPanel.Visible or (iFormIndex = iWystawioneFakturyZakupuFormIndex)) and PrzyciskiWlaczone then begin
    if WystawioneFakturyZakupuPanel.Visible then begin
      (ContainedForms[iWystawioneFakturyZakupuFormIndex] as TUNIDBGridForm).Visible := True;
      RazemPanel.Visible := False;
    end;

    with (ContainedForms[iWystawioneFakturyZakupuFormIndex] as TUNIDBGridForm) do begin
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        {Parameters.Values[sParam_MFZOddzialID] := IntToStr(Self.DMAQFbN(sUNIODDZIAL_ID).AsInteger);}
        ReOpenDataSets();
      end;
    end;
  end;

  //zasoby powizane ze zleceniem
  if (ZasobyPanel.Visible or (iFormIndex = iZasobyFormIndex)) and PrzyciskiWlaczone then begin
    if ZasobyPanel.Visible then begin
      (ContainedForms[iZasobyFormIndex] as TUNIDBGridForm).Visible := True;
      RazemPanel.Visible := False;
    end;

    with (ContainedForms[iZasobyFormIndex] as TUNIDBGridForm) do begin
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        ReOpenDataSets();
      end;
    end;
  end;
  //rozliczenie zasobw
  if (RozliczeniePanel.Visible or (iFormIndex = iRozliczenieFormIndex)) and PrzyciskiWlaczone then begin
    if RozliczeniePanel.Visible then begin
      (ContainedForms[iRozliczenieFormIndex] as TUNIDBGridForm).Visible := True;
      RazemPanel.Visible := True;
    end;

    with (ContainedForms[iRozliczenieFormIndex] as TUNIDBGridForm) do begin
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
       // Komunikat(cInformation, 'Odswiezam podsumowanie - Rozliczanie');
        ReOpenDataSets();
      end;
    end;
  end;
  //Koszty zakupu
  if (KosztyZakupuPanel.Visible or (iFormIndex = iKosztyZakupuFormIndex)) and PrzyciskiWlaczone then begin
    if KosztyZakupuPanel.Visible then begin
      (ContainedForms[iKosztyZakupuFormIndex] as TUNIDBGridForm).Visible := True;
      //DopiszKosztyZakupuPanel.Visible := True;
      RazemPanel.Visible := False;
    end;

    with (ContainedForms[iKosztyZakupuFormIndex] as TUNIDBGridForm) do begin
      if bWymus or (Parameters.Values[sMFZKOSZT + '_ELS_ID'] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sMFZKOSZT + '_ELS_ID'] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        ReOpenDataSets();
      end;
    end;
  end;

  //Czas pracy z ECP
  if (KosztyECPPanel.Visible or (iFormIndex = iKosztyECPFormIndex)) and PrzyciskiWlaczone then begin
    if KosztyECPPanel.Visible then begin
      ContainedForms[iKosztyECPFormIndex].Visible := True;
      RazemPanel.Visible := True;
    end;

    with (ContainedForms[iKosztyECPFormIndex]) do begin
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        KDECPDM.KDECPOdswiezCzasPracyNaZleceniu(Self.ContainedForms[iKosztyECPFormIndex]);
        if Parameters.Values['RAZEM'] <> PodsumowanieEdit.Text then
           PodsumowanieEdit.Text := Parameters.Values['RAZEM'];
      end;
    end;
  end;

  //rodki trwae
  if (SrodkiTrwalePanel.Visible or (iFormIndex = iSrodkiTrwaleFormIndex)) and PrzyciskiWlaczone then begin
    if SrodkiTrwalePanel.Visible then begin
      (ContainedForms[iSrodkiTrwaleFormIndex] as TUNIDBGridForm).Visible := True;
      RazemPanel.Visible := True;
    end;

    with (ContainedForms[iSrodkiTrwaleFormIndex] as TUNIDBGridForm) do begin
      if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        ReOpenDataSets();
        if Parameters.Values['RAZEM'] <> PodsumowanieEdit.Text then
           PodsumowanieEdit.Text := Parameters.Values['RAZEM'];
      end;
    end;
  end;

  //zlecenia podrzedne
  if (ZleceniaPodrzednePanel.Visible or (iFormIndex = iZleceniaPodrzedneFormIndex)) and PrzyciskiWlaczone then begin
    if ZleceniaPodrzednePanel.Visible then begin
      (ContainedForms[iZleceniaPodrzedneFormIndex] as TUNIDBGridForm).Visible := True;
      RazemPanel.Visible := False;
    end;

    with (ContainedForms[iZleceniaPodrzedneFormIndex] as TUNIDBGridForm) do begin
      if bWymus or (Parameters.Values[sParam_ZlecNadrzedneID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
        Parameters.Values[sParam_ZlecNadrzedneID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
        ReOpenDataSets();
      end;
    end;
  end;

  //Transport i sprzt
  if (TransportPanel.Visible or (iFormIndex = iTransportFormIndex)) and PrzyciskiWlaczone then begin
    if TransportPanel.Visible then begin
      (ContainedForms[iTransportFormIndex] as TUNIDBGridForm).Visible := True;
      RazemPanel.Visible := False;
    end;

   //with (ContainedForms[iTransportFormIndex] as TUNIDBGridForm) do begin
    if bWymus or ((ContainedForms[iTransportFormIndex] as TUNIDBGridForm).Parameters.Values[sZLEZLECENIE_ID] <> IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger)) then begin
      (ContainedForms[iTransportFormIndex] as TUNIDBGridForm).Parameters.Values[sZLEZLECENIE_ID] := IntToStr(Self.DMAQFbN(sZLEZLECENIE_ID).AsInteger);
      TSDM.TSOdswiezGridaRozliczen((ContainedForms[iTransportFormIndex] as TUNIDBGridForm),
                                             Self.ClassName + TransportPanel.Name,
                                             nil);
      //ReOpenDataSets();
    end;
    //end;
  end;

  {Odswieenie infromacji na Panelu PrzeliczaniePanel}
  PrzeliczaniePanel.Visible := ZLEDM.vZLEPrzeliczanieWlaczone;
  if ZLEDM.vZLEPrzeliczanieWlaczone then begin
     GodzinaLabel.Caption := ZLEDM.vZLEPrzeliczanieGodzina;
  end;

  if((m_iWycenaFormIndex > -1) and (WycenaPanel.Visible or (iFormIndex = m_iWycenaFormIndex))) and PrzyciskiWlaczone then begin
    (ContainedForms[m_iWycenaFormIndex] as TUNIDBGridForm).Visible := True;
    (ContainedForms[m_iWycenaFormIndex] as TUNIDBGridForm).ReOpenDataSets();
  end;
end;

procedure TZLEZlecenieDBGridForm.View;
begin
  OpenDetail( omView );
end;

procedure TZLEZlecenieDBGridForm.PrzelaczInformacje;
begin
  //ZleceniaSplitter.Visible := InfromacjeZleceniaPanel.Visible;
  ZleceniaSplitter.Visible := False;//InfromacjeZleceniaPanel.Visible;
  InformacjeZleceniaPanel.Visible := not InformacjeZleceniaPanel.Visible;
  if InformacjeZleceniaPanel.Height > Self.Height-80 then
    InformacjeZleceniaPanel.Height := Self.Height-80;
  ZleceniaSplitter.Visible := InformacjeZleceniaPanel.Visible;
//  ZleceniaSplitter.Visible := not ZleceniaSplitter.Visible;
  bInformacjeWidoczne := InformacjeZleceniaPanel.Visible;
end;

procedure TZLEZlecenieDBGridForm.ZakresButtonClick(Sender: TObject);
begin
  if OpenRangeForm() then
    DataModule.ReOpenDataSets();
  DBGrid.SetFocus;
end;

procedure TZLEZlecenieDBGridForm.GetParametersForForm(AForm: TUNIForm;
  Parameters: TKeyValues);
begin
  Parameters.Assign(Self.Parameters);
  if(DataModule <> nil) and (not DataModule.ActiveQuery.IsEmpty) then
    Parameters.Values[sZLEZLECENIE_ID]  := DMAQFbN(sZLEZLECENIE_ID).AsString
  else
    Parameters.Values[sZLEZLECENIE_ID]  := '-1';
end;

procedure TZLEZlecenieDBGridForm.AssignProperties;
var
  iParam: Integer;
begin
  if Parameters = nil then
    Parameters := TKeyValues.CreateEmpty;
  if Parameters.IndexOf(cRangeClassName) < 0 then
    Parameters.Add(cRangeClassName+'='+cKlasaZakresZlecen+cSuffixKlasySelect);
{
  if(((OpenModeFlags and omContained) = omContained) and
  (LowerCase(Copy(Owner.ClassName, 1, 8)) = 'tzaozapo')) then begin
    m_bOsadzonaNaZapotrz  := true;
      // wyczamy zakres dla grida osadzonego
    if(Parameters <> nil) then
      Parameters.Values[cRangeClassName]  := '';
  end else
    m_bOsadzonaNaZapotrz  := false;
}
  bPrzyciskiWlaczone := True;
  bPrzyciskPozycjiWlaczony := True;
  bPolaUzWlaczone := True;
  bPanelWlaczony := True;

  if Parameters <> nil then begin
     if Parameters.IndexOfName(cZLELista_Optymalizacja) <> -1 then begin
        try
           iParam := StrToInt(Parameters.Values[cZLELista_Optymalizacja]);
        except
           iParam := 0;
        end;

        bPrzyciskiWlaczone       := not ((iParam and cZLELista_WylaczPrzyciski)  = cZLELista_WylaczPrzyciski);
        bPolaUzWlaczone          := not ((iParam and cZLELista_WylaczPolaUzytk)  = cZLELista_WylaczPolaUzytk);
        bPanelWlaczony           := not ((iParam and cZLELista_WylaczPanel)      = cZLELista_WylaczPanel);
        bPrzyciskPozycjiWlaczony :=     ((iParam and cZLELista_WlaczPrzyciskPoz) = cZLELista_WlaczPrzyciskPoz);
     end;
  end;

  inherited;
  Properties.AddProperty( 'PH', GetPropertyValue );
  Properties.AddProperty( 'PV', GetPropertyValue );
end;

function TZLEZlecenieDBGridForm.GetPropertyValue(
  APropertyName: String): String;
begin
  if APropertyName = 'PH' then result := IntToStr(InformacjeZleceniaPanel.Height)
  else if APropertyName = 'PV' then result := IntToStr(Integer(InformacjeZleceniaPanel.Visible))
  else result := inherited GetPropertyValue( APropertyName );
end;

procedure TZLEZlecenieDBGridForm.SetFormProperties;
var s: String;
begin
  inherited;
  {s := Properties['PV'];
  if s <> '' then begin
    if (StrToInt(s)<>Integer(InfromacjeZleceniaPanel.Visible)) then begin
      PrzelaczInformacje();
      s := Properties['PH'];
      if s <> '' then InfromacjeZleceniaPanel.Height := StrToInt(s);
    end;
  end;}
  s := Properties['PH'];
  if s <> '' then InformacjeZleceniaPanel.Height := StrToInt(s);
end;

procedure TZLEZlecenieDBGridForm.RealizacjaButtonClick(Sender: TObject);
var sFunkcja: String;
begin
  try
    sFunkcja := Parameters.Values[cZLEFuncRodzaj];
    Parameters.Values[cZLEFuncRodzaj] := cZLEFuncKontrolaRealizacji;
    OpenDetail(omEdit);
  finally
    Parameters.Values[cZLEFuncRodzaj] := sFunkcja;
  end;
end;

procedure TZLEZlecenieDBGridForm.PozycjeMenuItemClick(Sender: TObject);
begin
  AktywujFunkcje( PozycjeButton, PozycjeZleceniaPanel, PozycjeMenuItem );
end;

procedure TZLEZlecenieDBGridForm.KontrolaKosztowMenuItemClick(
  Sender: TObject);
begin
  AktywujFunkcje( KontrolaKosztowButton, KontrolaKosztowPanel, KontrolaKosztowMenuItem );
end;

procedure TZLEZlecenieDBGridForm.KontrolaIlosciMenuItemClick(
  Sender: TObject);
begin
  AktywujFunkcje( KontrolaIlosciButton, KontrolaIlosciPanel, KontrolaIlosciMenuItem );
end;

procedure TZLEZlecenieDBGridForm.UstawMenuFunkcji;
begin
  //ustawienia menu funkcji w zalenoci od danych zlecenie i moduw woajcych
  if Parameters.Values[sUNIMODULZSI_ID] = sREMModulID then
    PozycjeMenuItem.Visible := False;
end;

procedure TZLEZlecenieDBGridForm.UsunToolButtonClick(Sender: TObject);
begin
  inherited;
  DeleteMenuItemClick(self);
end;

procedure TZLEZlecenieDBGridForm.WylaczPaneleInformacji;
begin
  RazemPanel.Visible := False;
  PozycjeZleceniaPanel.Visible := False;
  PozycjeMenuItem.Checked := False;
  KontrolaKosztowPanel.Visible := False;
  PrzeliczWszystkieButton.Visible := False;
  KontrolaKosztowMenuItem.Checked := False;
  KontrolaIlosciPanel.Visible := False;
  KontrolaIlosciMenuItem.Checked := False;
  SzczegoloweKosztyMaterialowePanel.Visible := False;
  SzczegoloweKosztyMaterialoweMenuItem.Checked := False;
  SzczegoloweKosztyRobociznyPanel.Visible := False;
  SzczegoloweKosztyRobociznyMenuItem.Checked := False;
  KosztyECPPanel.Visible := False;
  KosztyECPMenuItem.Checked := False;
  WystawioneFakturyPanel.Visible := False;
  WystawioneFakturyMenuItem.Checked := False;
  WystawioneFakturyZakupuPanel.Visible := False;
  WystawioneFakturyZakupuMenuItem.Checked := False;
  ZasobyPanel.Visible := False;
  ZasobyMenuItem.Checked := False;
  RozliczeniePanel.Visible := False;
  RozliczenieMenuItem.Checked := False;
  WycenaPanel.Visible     := false;
  WycenaMenuItem.Checked  := false;
  KosztyZakupuPanel.Visible := False;
  KosztyZakupuMenuItem.Checked := False;
  DopiszKosztyZakupuPanel.Visible := False;
  //DopiszKosztyZakupuMenuItem.Checked := False;
  SrodkiTrwalePanel.Visible := False;
  SrodkiTrwaleMenuItem.Checked := False;
  TransportPanel.Visible := False;
  TransportMenuItem.Checked := False;
  ZleceniaPodrzednePanel.Visible := False;
  ZleceniaPodrzedneMenuItem.Checked := False;

  WycenaButton.Font.Style := [];
  PozycjeButton.Font.Style := [];
  KontrolaKosztowButton.Font.Style := [];
  KontrolaIlosciButton.Font.Style := [];
  KosztyMaterialoweButton.Font.Style := [];
  KosztyRobociznyButton.Font.Style := [];
  WystawioneFakturyButton.Font.Style := [];
  WystawioneFakturyZakupuButton.Font.Style := [];
  ZasobyButton.Font.Style := [];
  RozliczenieButton.Font.Style := [];
  KosztyECPButton.Font.Style := [];
  KosztyZakupuButton.Font.Style := [];
  SrodkiTrwaleButton.Font.Style := [];
  TransportButton.Font.Style := [];
  ZleceniaPodrzedneButton.Font.Style := [];
  DopiszKosztyZakupuButton.Font.Style := [];
end;

procedure TZLEZlecenieDBGridForm.SzczegoloweKosztyMaterialoweMenuItemClick(
  Sender: TObject);
begin
  AktywujFunkcje( KosztyMaterialoweButton, SzczegoloweKosztyMaterialowePanel,
                  SzczegoloweKosztyMaterialoweMenuItem );
end;

procedure TZLEZlecenieDBGridForm.SzczegoloweKosztyRobociznyMenuItemClick(
  Sender: TObject);
begin
  AktywujFunkcje( KosztyRobociznyButton, SzczegoloweKosztyRobociznyPanel,
                  SzczegoloweKosztyRobociznyMenuItem );
end;

procedure TZLEZlecenieDBGridForm.WystawioneFakturyMenuItemClick(
  Sender: TObject);
begin
  AktywujFunkcje( WystawioneFakturyButton, WystawioneFakturyPanel,
                  WystawioneFakturyMenuItem );
end;

procedure TZLEZlecenieDBGridForm.KosztyZakupuMenuItemClick(
  Sender: TObject);
begin
  AktywujFunkcje( KosztyZakupuButton, KosztyZakupuPanel,
                  KosztyZakupuMenuItem );
end;

procedure TZLEZlecenieDBGridForm.PozycjeButtonClick(Sender: TObject);
begin
  PozycjeMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.KontrolaKosztowButtonClick(
  Sender: TObject);
begin
  KontrolaKosztowMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.KontrolaIlosciButtonClick(
  Sender: TObject);
begin
  KontrolaIlosciMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.KosztyMaterialoweButtonClick(
  Sender: TObject);
begin
  SzczegoloweKosztyMaterialoweMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.KosztyRobociznyButtonClick(
  Sender: TObject);
begin
  SzczegoloweKosztyRobociznyMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.WystawioneFakturyButtonClick(
  Sender: TObject);
begin
  WystawioneFakturyMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.WystawioneFakturyZakupuButtonClick(
  Sender: TObject);
begin
  WystawioneFakturyZakupuMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.KosztyZakupuButtonClick(Sender: TObject);
begin
  KosztyZakupuMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.PowiekszButtonClick(Sender: TObject);
begin
  inherited;
  if not InformacjeZleceniaPanel.Visible then begin
    DBGrid.SetFocus;
    Exit;
  end;
  DBGrid.Visible := not DBGrid.Visible;
  if DBGrid.Visible then begin
    PowiekszButton.Caption := 'Powiksz';
    InformacjeZleceniaPanel.Align := alBottom;
    InformacjeZleceniaPanel.Height := InformacjeZleceniaPanel.Tag;
    ZleceniaSplitter.Align := alTop;
    ZleceniaSplitter.Align := alBottom;
    DBGrid.SetFocus;
  end else begin
    PowiekszButton.Caption := 'Pomniejsz';
    InformacjeZleceniaPanel.Tag := InformacjeZleceniaPanel.Height;
    InformacjeZleceniaPanel.Align := alClient;
    InformacjeZleceniaPanel.SetFocus;
  end;
end;

procedure TZLEZlecenieDBGridForm.AktywujFunkcje( oButton: TUNIButton;
                                                 oPanel: TUNIPanel;
                                                 oMenuItem: TMenuItem;
                                                 oAction: TAction );
  function IfChecked(): Boolean;
  begin
    if oMenuItem <> nil then
      result := oMenuItem.Checked
    else if oAction <> nil then
      result := oAction.Checked
    else
      result := false;
  end;

  procedure EnableCheck();
  begin
    if oMenuItem <> nil then
      oMenuItem.Checked := True
    else if oAction <> nil then
      oAction.Checked := True;
  end;
begin
  if not IfChecked() then begin
    WylaczPaneleInformacji();
    //Jesli nie utworzone jeszcze formatek to je tworzymy teraz
    if not bUtworzoneFormatkiOsadzone then
       AddContainedForms();

    oPanel.Visible := True;
    //oMenuItem.Checked := True;
    EnableCheck();
    oButton.Font.Style := [fsBold];
    if not bInformacjeWidoczne then PrzelaczInformacje();
  end else begin
    WylaczPaneleInformacji();
    if not DBGrid.Visible then PowiekszButton.Click();
    if bInformacjeWidoczne then PrzelaczInformacje();
  end;
  if oPanel.Visible then
       RefreshDetail(True)
  else RefreshDetail();

  //{$ifndef ver210}
  if not self.FormIsContained then begin
    if  DBGrid.Visible then ActiveControl := DBGrid
    else ActiveControl := InformacjeZleceniaPanel;
  end;
  //{$endif}
end;

procedure TZLEZlecenieDBGridForm.RozliczenieButtonClick(Sender: TObject);
begin
  RozliczenieMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.RozliczenieMenuItemClick(Sender: TObject);
begin
  AktywujFunkcje( RozliczenieButton, RozliczeniePanel, RozliczenieMenuItem );
end;

procedure TZLEZlecenieDBGridForm.Rpt_ImportStatusowZleceniaMenuItemClick(
  Sender: TObject);
begin
  //import jak dopisywanie - tylko do aktywnej
  UNISysDataManager.UNIPokazIObsluzRaportyBl( vAktywnaFirma,
                                              SecurityManager.UserId,
                                              cZLEMODULZSI_ID,
                                              sUNISysRaportBledow_ZLE_ImportStatZlec,
                                              '','',false,false);
end;

procedure TZLEZlecenieDBGridForm.ZasobyMenuItemClick(Sender: TObject);
begin
  AktywujFunkcje( ZasobyButton, ZasobyPanel, ZasobyMenuItem );
end;

procedure TZLEZlecenieDBGridForm.ZleceniapodrzedneMenuItemClick(
  Sender: TObject);
begin
  AktywujFunkcje( ZleceniaPodrzedneButton, ZleceniaPodrzednePanel, ZleceniaPodrzedneMenuItem );
end;

procedure TZLEZlecenieDBGridForm.ZasobyButtonClick(Sender: TObject);
begin
  ZasobyMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.ZleceniaPodrzedneButtonClick(Sender: TObject);
begin
  ZleceniapodrzedneMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.PokazButtonClick(Sender: TObject);
begin
  inherited;
  ViewMenuItemClick(self);
end;

procedure TZLEZlecenieDBGridForm.PokazWszystkieSprawy;
begin
  bWszystkieSprawy := bPokaz;
  ReOpenDataSets();
end;

procedure TZLEZlecenieDBGridForm.SrodkiTrwaleMenuItemClick(
  Sender: TObject);
begin
  AktywujFunkcje(SrodkiTrwaleButton, SrodkiTrwalePanel, SrodkiTrwaleMenuItem);
end;

procedure TZLEZlecenieDBGridForm.PokazWszystkieSprawyButtonClick(
  Sender: TObject);
begin
  inherited;
  PokazWszystkieSprawy( not WszystkieSprawy );
  if WszystkieSprawy then begin
     if Parameters.Values[sParam_ZLEKontekst] = sParam_ZLEKontekst_KlientInfo then
        PokazWszystkieSprawyButton.Caption := 'Klient-kontrahent'
     else
     if Parameters.Values[sBOKUMOWA_ID] <> '' then
        PokazWszystkieSprawyButton.Caption := 'Wybrane umowy'
     else
        PokazWszystkieSprawyButton.Caption := 'Wybrane sprawy';
  end else begin
     if Parameters.Values[sParam_ZLEKontekst] = sParam_ZLEKontekst_KlientInfo then
        PokazWszystkieSprawyButton.Caption := 'Klient-dla sprawy'
     else
     if Parameters.Values[sBOKUMOWA_ID] <> '' then
        PokazWszystkieSprawyButton.Caption := 'Wszystkie umowy'
     else
        PokazWszystkieSprawyButton.Caption := 'Wszystkie sprawy';
  end;
end;

procedure TZLEZlecenieDBGridForm.SetUserRights;
var
  i:  integer;
  bMoznaEdytowac: Boolean;
begin
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_KART_ZLECEN_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_KART_ZLECEN_DOPISZ));

    bMoznaEdytowac := SM_UserCanDo(sZLE_KART_ZLECEN_ZMIEN);
    if ZLEDM.vZLEBlokadaEdycjiZakoncz then begin
       if (DataModule <> nil) and
          (DataModule.ActiveQuery <> nil) and
          (not DataModule.ActiveQuery.IsEmpty) then
          if DMAQFbN(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID then
             bMoznaEdytowac := SM_UserCanDo(sZLE_KART_ZLECEN_ZMIEN_ZAKONCZ);
    end;
    Switch_Open_HotKey(bMoznaEdytowac);
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_KART_ZLECEN_USUN));

    //pozycje
    PozycjeButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_POZYCJE) and (PrzyciskiWlaczone or PrzyciskPozycjiWlaczony);
    //kontrola kosztw
    KontrolaKosztowButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_KONTR_KOSZTOW) and PrzyciskiWlaczone;
    //kontrola iloci
    KontrolaIlosciButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_KONTR_ILOSCI) and PrzyciskiWlaczone;
    //koszty materiaowe
    KosztyMaterialoweButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_KOSZTY_MAT) and PrzyciskiWlaczone;
    //koszty robocizny
    KosztyRobociznyButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_KOSZTY_ROB) and PrzyciskiWlaczone;
    //wystawione faktury sprzeday
    WystawioneFakturyButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_FAKTURY) and PrzyciskiWlaczone;
    // wystawione faktury zakupu
    WystawioneFakturyZakupuButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_FAKTURY) and PrzyciskiWlaczone;
    // wystawione faktury zakupu
    KosztyZakupuButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_KOSZTZAKUPU) and PrzyciskiWlaczone;
    // Dopisywanie kosztw zakupu
    DopiszKosztyZakupuButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_KOSZTZAKUPU) and PrzyciskiWlaczone;
    //zasoby
    ZasobyButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_ZASOBY) and PrzyciskiWlaczone;
    //rozliczenie
    RozliczenieButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_ROZL_ZASOBOW) and PrzyciskiWlaczone;
    //Koszty ECP
    KosztyECPButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_CZASPRACYECP) and PrzyciskiWlaczone;
    //Srodki Trwale
    SrodkiTrwaleButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_SRODKITRWALE) and PrzyciskiWlaczone;
    // tworzenie zapotrzebowa
    ZapotrzebowanieButton.Enabled := ZAODM.Available and SM_UserCanDo(sZLE_KART_ZLECEN_UTWORZ_ZAPOTRZ) and PrzyciskiWlaczone;
      // wycena kosztw pracy zasobw
    WycenaButton.Enabled  := SM_UserCanDo(sZLE_KART_ZLECEN_WYCENA) and PrzyciskiWlaczone;
      // kopiowanie zlece
    KopiujButton.Enabled  := SM_UserCanDo(sZLE_KART_ZLECEN_DOPISZ);
    //Transport
    TransportButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_Transport) and PrzyciskiWlaczone;
    //Zlecenia podrzedne
    ZleceniaPodrzedneButton.Enabled := PrzyciskiWlaczone;

    ZamknijkontaMenuItem.Enabled := ZLEDM.vZLEZamkniecieKont and DataManagers.Available(sFKModulID);
    mniUzytkownicyZaangazowaniMenuItem.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_ZMIEN);
    mniWylaczPrzeliczZlecenMenuItem.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_ZMIEN);
    mniUstawPrzeliczZlecMenuItem.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_ZMIEN);
    
      // wysyanie zaznacznych zlece
    UNIINTWyslijZaznaczoneMenuItem.Enabled  := DataManagers.Available(sUNIINTModulID) and
      SM_UserCanDo(sZLE_KART_ZLECEN_WYSLIJ) and
      UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_ZlecenieProdWyslij_Id);
    ZmienStatusMenuItem.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_ZMIEN_STATUS);
    UNIINTWyslijPlanProdukcjiMenuItem.Enabled  := DataManagers.Available(sUNIINTModulID) and
      SM_UserCanDo(sZLE_KART_ZLECEN_WYSLIJ_PLAN) and
      UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_PlanProdWyslij_Id);
    UNIINTWycofajZlecenieMenuItem.Enabled  := DataManagers.Available(sUNIINTModulID) and
      SM_UserCanDo(sZLE_KART_ZLECEN_WYCOFAJ) and
      UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_ZlecenieProdUsun_Id);
    UNIINTWycofajPlanProdukcjiMenuItem.Enabled  := DataManagers.Available(sUNIINTModulID) and
      SM_UserCanDo(sZLE_KART_ZLECEN_PLAN_WYCOFAJ) and
      UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_PlanProdUsun_Id);
  end;
    // wyczamy przycisk z funkcjami jeeli uytkownik nie ma prawa do adnej funkcji
  if(FunkcjeToolButton.Visible) then begin
    FunkcjeToolButton.Visible := false;
    for i := 0 to FunkcjeToolBarPopupMenu.Items.Count-1 do begin
      if(FunkcjeToolBarPopupMenu.Items[i].Enabled and FunkcjeToolBarPopupMenu.Items[i].Visible) then begin
        FunkcjeToolButton.Visible := true;
        break;
      end;
    end;  // for i := 0 to FunkcjeToolBarPopupMenu.Items.Count-1
  end;  // if(FunkcjeToolButton.Visible)

  OIDM.OIUstawPrzeslijObiekt(Self, tbtPrzeslij, miPrzeslij);
end;

procedure TZLEZlecenieDBGridForm.DataSourceDataChange(Sender: TObject;
  Field: TField);
begin
  inherited;
  if DataModule.ActiveQuery.IsEmpty then
    DisableButtons()
  else
    SetUserRights();

  if (not bInternalOpen) and InformacjeZleceniaPanel.Visible then begin
    if not bUtworzoneFormatkiOsadzone  then
      AddContainedForms();
    RefreshDetail();
  end;

  PokazButton.Enabled := ViewToolButton.Enabled;
  DodajToolButton.Enabled := NewToolButton.Enabled;
  ZmienToolButton.Enabled := EditToolButton.Enabled;
  UsunToolButton.Enabled := DeleteToolButton.Enabled;
end;

procedure TZLEZlecenieDBGridForm.DisableButtons;
begin
  with SecurityManager do begin
    //pozycje
    PozycjeButton.Enabled := False;
    //kontrola kosztw
    KontrolaKosztowButton.Enabled := False;
    //kontrola iloci
    KontrolaIlosciButton.Enabled := False;
    //koszty materiaowe
    KosztyMaterialoweButton.Enabled := False;
    //koszty robocizny
    KosztyRobociznyButton.Enabled := False;
    //wystawione faktury sprzeday
    WystawioneFakturyButton.Enabled := False;
    //wystawione faktury zakupu
    WystawioneFakturyZakupuButton.Enabled := False;
    //Koszty zakupu
    KosztyZakupuButton.Enabled := False;
    // Dopisywanie kosztw zakupu
    //DopiszKosztyZakupuButton.Enabled := False;
    //zasoby
    ZasobyButton.Enabled := False;
    //rozliczenie
    RozliczenieButton.Enabled := False;
      // wycena kosztw pracy zasobw
    WycenaButton.Enabled  := false;
    //koszty robocizny ECP
    KosztyECPButton.Enabled := False;
    //rodki trwae
    SrodkiTrwaleButton.Enabled := False;
    //Transport
    TransportButton.Enabled := False;
    //zlecenia podrzedne
    ZleceniaPodrzedneButton.Enabled := False;

    KopiujMenuItem.Enabled := not DataModule.ActiveQuery.IsEmpty;
  end;
end;

procedure TZLEZlecenieDBGridForm.PrzeliczWszystkie(Sender: TObject);
begin
  if DBGrid = nil then Exit;
  if not (ZLEDM.vZLEKontrolaKosztowWlaczona or ZLEDM.vZLEKontrolaIlosciWlaczona) then Exit;

  if ZLEDM.vZLEKontrolaIlosciWlaczona then begin
     KontrolaIlosciButtonClick(Sender);
     DBGrid.MarkAll;
     PrzeliczWszystkieButtonClick(Sender);
     DBGrid.UnMarkAll;
  end;

  if ZLEDM.vZLEKontrolaKosztowWlaczona then begin
     KontrolaKosztowButtonClick(Sender);
     DBGrid.MarkAll;
     PrzeliczWszystkieButtonClick(Sender);
     DBGrid.UnMarkAll;
  end;

  Komunikat(cInformation, 'Przeliczanie zakoczyo si powodzeniem');

end;

procedure TZLEZlecenieDBGridForm.PrzeliczWszystkieButtonClick(
  Sender: TObject);
var
//  oForm: TUNIForm;
  sListaZlecen: String;
//  oParams: TKeyValues;
  i: Integer;
//  p: integer;
  KosztyGrid: TZLEKontrolaRealizacjiDBGridForm;
  vPrzeliczoneItem: TZLEPrzeliczone;
begin
  {Przeliczenie dla kontroli Wartociowej}
  KosztyGrid  := nil;
//  if not (OpenMode = omList) then Exit;
  try
    ZLEDM.FPrzeliczoneKoszty.Clear(); {Wyczyszczenie listy}
    ZLEDM.FPrzeliczoneIlosci.Clear();

    if KontrolaKosztowPanel.Visible then begin
       KosztyGrid := (TZLEKontrolaRealizacjiDBDetailForm(ContainedForms[iKontrolaKosztowFormIndex])).GetGrid;
       if KosztyGrid <> nil then
          KosztyGrid.DataSource.DataSet.DisableControls;
    end else if KontrolaIlosciPanel.Visible then begin
       KosztyGrid := (TZLEKontrolaRealizacjiDBDetailForm(ContainedForms[iKontrolaIlosciFormIndex])).GetGrid;
       if KosztyGrid <> nil then
          KosztyGrid.DataSource.DataSet.DisableControls;
    end;

    if DBGrid.DataSource.DataSet <> nil then DBGrid.DataSource.DataSet.DisableControls;
//    if DataModule.ActiveQuery <> nil then DataModule.ActiveQuery.DisableControls;
    bPrzeliczanie := True;
    try
      if Length(DBGrid.MarkedRows) > 0 then
      begin
        ProgressStart( nil, Length(DBGrid.MarkedRows), 'Trwa przeliczanie kosztw. Prosz czeka.', false, 0 );
        // odczytanie ID zaznaczonych Zlece
        for i := 0 to Length(DBGrid.MarkedRows)-1 do
        if DBGrid.MarkedRows[i] > -1 then begin
          if sListaZlecen <> '' then
            sListaZlecen := sListaZlecen + ',' + IntToStr(DBGrid.MarkedRows[i])
          else
            sListaZlecen := IntToStr(DBGrid.MarkedRows[i]);

          if KontrolaKosztowPanel.Visible then
               vPrzeliczoneItem := ZLEDM.FPrzeliczoneKoszty.GetItemByValue(DBGrid.MarkedRows[i])
          else vPrzeliczoneItem := ZLEDM.FPrzeliczoneIlosci.GetItemByValue(DBGrid.MarkedRows[i]);

          if vPrzeliczoneItem <> nil then begin
             if vPrzeliczoneItem.Przeliczone then begin
                ProgressForm.Progress(1);
                {Pomijamy przeliczanie, poniewa zostao przeliczone
                 przy przeliczaniu wczesniejszego zlecenia}
                Continue;
             end;
          end else begin
             if KontrolaKosztowPanel.Visible then
                   vPrzeliczoneItem := ZLEDM.FPrzeliczoneKoszty.Add
             else  vPrzeliczoneItem := ZLEDM.FPrzeliczoneIlosci.Add;

             vPrzeliczoneItem.ZleZlecenieID := DBGrid.MarkedRows[i];
             vPrzeliczoneItem.Przeliczone := False;
          end;


          DataModule.ActiveQuery.Locate(sZLEZLECENIE_ID, DBGrid.MarkedRows[i], []);

          if DMAQFbN(sZLEZLECENIE_PRZELICZ).AsString = sNie then begin
             {Zaznaczamy zlecenie jako przeliczone i kontunuujemy
              UWAGA! mog by problemy przy zleceniach grupujcych}
             vPrzeliczoneItem.Przeliczone := True;
             Continue;
          end;

          RefreshDetail(True);
          ProgressForm.Progress(1);
        end;
      end
      else if (not DMAQFbN(sZLEZLECENIE_ID).IsNull) and (DMAQFbN(sZLEZLECENIE_PRZELICZ).AsString = sTak) then begin
          sListaZlecen := DMAQFBN(sZLEZLECENIE_ID).AsString;
          RefreshDetail(True);
      end;
    except
      raise;
    end;
  finally
    ZLEDM.FPrzeliczoneKoszty.Clear(); {Wyczyszczenie listy}
    ZLEDM.FPrzeliczoneIlosci.Clear();  
    ProgressEnd();
    if KosztyGrid <> nil then KosztyGrid.DataSource.DataSet.EnableControls;
    //if DataModule.ActiveQuery <> nil then DataModule.ActiveQuery.EnableControls;
    if DBGrid.DataSource.DataSet <> nil then DBGrid.DataSource.DataSet.EnableControls;
    bPrzeliczanie := False;
  end;

end;

procedure TZLEZlecenieDBGridForm.ZapotrzebowanieButtonClick(
  Sender: TObject);
var
  sOldId,
  sIds:   string;
  i:      integer;
begin
  if(DataModule.ActiveQuery.IsEmpty()) then
    exit;
  if(Length(DBGrid.MarkedRows) > 0) then begin
    sOldId  := DMAQFbN(sZLEZLECENIE_ID).AsString;
    DataModule.ActiveQuery.DisableControls();
    try
      for i := Low(DBGrid.MarkedRows) to High(DBGrid.MarkedRows) do begin
        if(i > 0) then
          sIds  := sIds + ', ' + IntToStr(DBGrid.MarkedRows[i])
        else
          sIds  := IntToStr(DBGrid.MarkedRows[i]);
      end;  // for i := Low(DBGrid.MarkedRows) to High(DBGrid.MarkedRows)
    finally
      UNILocate(
        DataModule.ActiveQuery,
        sZLEZLECENIE_ID,
        sOldId
      );
      DataModule.ActiveQuery.EnableControls();
    end;
  end else  // if(DMAQFbN(sZLETYPZLEC_PRODUKCYJNE).AsString = sTak) then
    sIds  := DMAQFbN(sZLEZLECENIE_ID).AsString;

  if(Length(sIds) > 0) then begin
    ZAODM.ZAODopiszZapotrzebowanieZeZlecen(sIds);
  end else begin  // if(Length(sIds) > 0)
    Komunikat(
      cWarning,
      'Wybrane zlecenia nie s zleceniami produkcyjnymi',
      MB_OK + MB_ICONEXCLAMATION
    );
  end;  // else - if(Length(sIds) > 0)
end;

procedure TZLEZlecenieDBGridForm.WystawioneFakturyZakupuMenuItemClick(
  Sender: TObject);
begin
  AktywujFunkcje( WystawioneFakturyZakupuButton, WystawioneFakturyZakupuPanel,
                  WystawioneFakturyZakupuMenuItem );
end;

procedure TZLEZlecenieDBGridForm.WycenaMenuItemClick(Sender: TObject);
begin
  AktywujFunkcje(
    WycenaButton,
    WycenaPanel,
    WycenaMenuItem
  );
end;

procedure TZLEZlecenieDBGridForm.WycenaButtonClick(Sender: TObject);
begin
  WycenaMenuItem.Click();
end;

procedure TZLEZlecenieDBGridForm.KopiujMenuItemClick(Sender: TObject);
begin
  OpenDetail(omNew, true);
end;

procedure TZLEZlecenieDBGridForm.KopiujButtonClick(Sender: TObject);
begin
  KopiujMenuItemClick(self);
end;


procedure TZLEZlecenieDBGridForm.tbtPrzeslijClick(Sender: TObject);
begin
 {$ifndef build_all}
 OIDM.OIPrzeslijObiekt2(nil, iOIZALACZNIKTYP_ZLEZLECENIE_ID, Self);
 {$endif}
end;

procedure TZLEZlecenieDBGridForm.GetRangeForReport;
var
  sSQL     : string;
  //iPos,
  iStatusKod, iIndex : Integer;
  oQuery   : TUNIQuery;
  sOpis1   : string;
  sOpis2   : string;
  d1, d2   : String;
//  iLicznik1, iLicz2      : Integer;
//  bWartOd, bWartDo       : Boolean;

begin
  with Parameters, UniDesigner.RangeParams do begin
     UniDesigner.RangeParams.Clear;

    AddParam('Symbol od', Values[sParam_ZLESymbolOd], Values[sParam_ZLESymbolOd], false);
    AddParam('Symbol do', Values[sParam_ZLESymbolDo], Values[sParam_ZLESymbolDo], false);
    AddParam('Nazwa od' , Values[sParam_ZLENazwaOd] , Values[sParam_ZLENazwaOd] , false);
    AddParam('Nazwa do' , Values[sParam_ZLENazwaDo] , Values[sParam_ZLENazwaDo] , false);

    try
       d1 := DateToStr(StrToInt(Values[sParam_ZLEDataOtwOd]));
    except
       d1 := '';
    end;

    try
       d2 := DateToStr(StrToInt(Values[sParam_ZLEDataOtwDo]));
    except
       d2 := '';
    end;
    AddParam('Data otw. od',  d1, d1, false);
    AddParam('Data otw. do',  d2, d2, false);

    try
       d1 := DateToStr(StrToInt(Values[sParam_ZLEDataZakOd]));
    except
       d1 := '';
    end;

    try
       d2 := DateToStr(StrToInt(Values[sParam_ZLEDataZakDo]));
    except
       d2 := '';
    end;
    AddParam('Data zak. od',  d1, d1, false);
    AddParam('Data zak. do',  d2, d2, false);

    Addparam('Niezamknite', Values['NIEZAKONCZONE'], Values['NIEZAKONCZONE'], false);

    //status zlecenia
    sOpis1 := '';
    sOpis2 := '';
    if Values[sParam_ZLEStatusZlec] <> '' then begin
       iStatusKod := StrToInt(Values[sParam_ZLEStatusZlec]);
       for iIndex := 0 to cslZLEStatusZlecenia.Count-1 do begin
          if iStatusKod and Round(Power( 2, iIndex )) <> 0 then begin
             if sOpis1 <> '' then sOpis1 := sOpis1 + ',';
             sOpis1 := sOpis1 + QuotedStr(cslZLEStatusZlecenia.ZwrocSkrot(iIndex));

             if sOpis2 <> '' then sOpis2 := sOpis2 + ', ';
             sOpis2 := sOpis2 + cslZLEStatusZlecenia[iIndex];
          end;
       end;
    end else begin
       sOpis1 := QuotedStr('O') + ',' + QuotedStr('R') + ',' +QuotedStr('W') + ',' + QuotedStr('Z');
       sOpis2 := '';
    end;
    if sOpis1 = '' then
       sOpis1 := QuotedStr('O') + ',' + QuotedStr('R') + ',' +QuotedStr('W') + ',' + QuotedStr('Z');

    AddParam('Status' , sOpis2, sOpis1 {, Values[sParam_ZLEStatusZlec]}, false);


    sOpis1 := '';
    if Values[sParam_ZLEOperatorWprowadz] <> '' then begin

        sSQL := DataManagers[sUNISYSModulID].AliasManager.ComposeQuery(
                         sUNISYSALIAS_USER_NAZWA,
                         '@' + sADMAlias_UserID + ' IN (' + Values[sParam_ZLEOperatorWprowadz] + ')',
                         false);

       sSQL := sSQL + ' ORDER BY ' + sSMUSER_NAZWA;
       oQuery := SQLManager.CreateQuery(sSQL);
       try
          oQuery.Open;
          if (oQuery <> nil) and (not oQuery.IsEmpty) then begin
             while not oQuery.Eof do begin
                if sOpis1 <> '' then sOpis1 := sOpis1 + ', ';
                sOpis1 := sOpis1 + oQuery.FieldByName(sSMUSER_NAZWA).AsString;
                oQuery.Next;
             end;

          end;
       finally
         if oQuery <> nil then FreeAndNil(oQuery);
       end;
    end;
    AddParam('Operator wprowadz.' , sOpis1, Values[sParam_ZLEOperatorWprowadz], false);


    sOpis1:='';
    if (Values[sParam_ZLETypZlec] <> '') then
    begin
      //a tu wyzbiera list symboli typw dokumentw
      sSQL := 'select ' +sZLETYPZLEC_SYMBOL+
              ' from %s'+
              ' where ' +sZLETYPZLEC_ID+' in ('+Values[sParam_ZLETypZlec]+')'+
              ' order by '+sZLETYPZLEC_SYMBOL;

      oQuery:=TUNIQuery.create(nil);
      if oQuery <> NIL then
      try
        SQLManager.OpenQuery(oQuery,sSQL,[sZLETYPZLEC]);
        while not oQuery.Eof do
        begin
          if sOpis1 <> '' then sOpis1:=sOpis1+', ';
          sOpis1 := sOpis1 + oQuery.FieldByName(sZLETYPZLEC_SYMBOL).AsString;
          oQuery.next;
        end;
      finally
        oQuery.free;
      end;
    end;
    AddParam('Typ zlecenia' , sOpis1, Values[sParam_ZLETypZlec], false);

    //AddParam('Modu' , Values[sParam_ZLEModulZSI], Values[sParam_ZLEModulZSI], false);

    sOpis1 := '';
    if Values[sParam_ZLEKlientId] <> '' then begin
       sSQL := DataManagers[sBKModulID].AliasManager.ComposeQuery(
                         sBKAlias_KlientSymbol,
                         '@' + sBKAlias_KlientID + ' IN (' + Values[sParam_ZLEKlientId] + ')',
                         false);

       sSQL := sSQL + ' ORDER BY ' + sBKKLIENT_Symbol;

       oQuery := SQLManager.CreateQuery(sSQL);
       try
          oQuery.Open;
          if (oQuery <> nil) and (not oQuery.IsEmpty) then begin
             while not oQuery.Eof do begin
                if sOpis1 <> '' then sOpis1 := sOpis1 + ', ';
                sOpis1 := sOpis1 + oQuery.FieldByName(sBKKLIENT_Symbol).AsString;
                oQuery.Next;
             end;

          end;
       finally
         if oQuery <> nil then FreeAndNil(oQuery);
       end;
    end;
    AddParam('Kontrahent' , sOpis1, Values[sParam_ZLEKlientId], false);

    sOpis1 := '';
    if Values[sUNIJEDNOSTKAORG_ID] <> '' then begin
       sSQL := DataManagers[sUNISYSModulID].AliasManager.ComposeQuery(
                         sUNISYSAlias_JednostkaOrg_Symbol,
                         '@' + sUNISYSAlias_JednostkaOrg_ID + ' IN (' + Values[sUNIJEDNOSTKAORG_ID] + ')',
                         false);
       sSQL := sSQL + ' ORDER BY ' + sUNIJEDNOSTKAORG_Symbol;
       oQuery := SQLManager.CreateQuery(sSQL);
       try
          oQuery.Open;
          if (oQuery <> nil) and (not oQuery.IsEmpty) then begin
             while not oQuery.Eof do begin
                if sOpis1 <> '' then sOpis1 := sOpis1 + ', ';
                sOpis1 := sOpis1 + oQuery.FieldByName(sUNIJEDNOSTKAORG_Symbol).AsString;
                oQuery.Next;
             end;

          end;
       finally
         if oQuery <> nil then FreeAndNil(oQuery);
       end;
    end;
    AddParam('Jednostka org.' , sOpis1, Values[sUNIJEDNOSTKAORG_ID], false);

    if (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia) or (vWieloodzialowosc) then begin
      sOpis1 := '';
      if Values[sUNIODDZIAL_ID] <> '' then begin
         sSQL := DataManagers[sUNISYSModulID].AliasManager.ComposeQuery(
                           sUNISYSAlias_Oddzial_Symbol,
                           '@' + sUNISYSAlias_Oddzial_ID + ' IN (' + Values[sUNIODDZIAL_ID] + ')',
                           false);
         sSQL := sSQL + ' ORDER BY ' + sUNIODDZIAL_Symbol;
         oQuery := SQLManager.CreateQuery(sSQL);
         try
            oQuery.Open;
            if (oQuery <> nil) and (not oQuery.IsEmpty) then begin
               while not oQuery.Eof do begin
                  if sOpis1 <> '' then sOpis1 := sOpis1 + ', ';
                  sOpis1 := sOpis1 + oQuery.FieldByName(sUNIODDZIAL_Symbol).AsString;
                  oQuery.Next;
               end;

            end;
         finally
           if oQuery <> nil then FreeAndNil(oQuery);
         end;
      end;

      if vWielofirmowosc then
           AddParam('Firma' , sOpis1, Values[sUNIODDZIAL_ID], false)
      else AddParam('Oddzia' , sOpis1, Values[sUNIODDZIAL_ID], false);
    end;

    if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
      sOpis1 := '';
      if Values[sParam_ZLEPrefixId] <> '' then begin
         sSQL := DataManagers[sZLEModulID].AliasManager.ComposeQuery(
                           sZLEAlias_PrefixSymbol,
                           '@' + sZLEAlias_PrefixID + ' IN (' + Values[sParam_ZLEPrefixId] + ')',
                           false);
         sSQL := sSQL + ' ORDER BY ' + sZLEPREFIX_Symbol;
         oQuery := SQLManager.CreateQuery(sSQL);
         try
            oQuery.Open;
            if (oQuery <> nil) and (not oQuery.IsEmpty) then begin
               while not oQuery.Eof do begin
                  if sOpis1 <> '' then sOpis1 := sOpis1 + ', ';
                  sOpis1 := sOpis1 + oQuery.FieldByName(sZLEPREFIX_Symbol).AsString;
                  oQuery.Next;
               end;

            end;
         finally
           if oQuery <> nil then FreeAndNil(oQuery);
         end;
      end;
      AddParam('Prefiks' , sOpis1, Values[sParam_ZLEPrefixId], false);
    end;
  end;
end;

procedure TZLEZlecenieDBGridForm.UNIINTWyslijZaznaczoneMenuItemClick(
  Sender: TObject);
{$ifndef build_all}
var
  oXMLDoc:    TUNIXMLParser;
  oElem:      IXMLDOMElement;
  oQueryZlec: TUNIQuery;
  oQueryRecep:TUNIQuery;
  oQueryZasob:TUNIQuery;
  oZlecId:    TStringList;
  sXML:       string;
  i:          integer;
  OutProgForm: TProgressForm;
{$endif}
begin
{$ifndef build_all}
  if(DataModule.ActiveQuery.IsEmpty() or (not UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_ZlecenieProdWyslij_Id))) then
    exit;
  oQueryZlec  := nil;
  oQueryRecep := nil;
  oQueryZasob := nil;
  oXMLDoc     := nil;
  oZlecId     := TStringList.Create();
  try
    if(Length(DBGrid.MarkedRows) > 0) then begin
      for i := 0 to Length(DBGrid.MarkedRows)-1 do
        oZlecId.Add(IntToStr(DBGrid.MarkedRows[i]));
    end else
      oZlecId.Add(DMAQFbN(DataModule.Keys.GetPrimaryKey()).AsString);
    ZLEDM.ZapiszIdZlecDoWyslaniaWADMId(oZlecId, SecurityManager.UserId, self.ClassName + self.Suffix, false);
    oQueryZlec  := ZLEDM.DajQueryZlecDoWyslania(
      SecurityManager.UserId,
      self.ClassName + self.Suffix
    );
    oQueryRecep := ZLEDM.DajQueryReceppozZlecDoWyslania(
      SecurityManager.UserId,
      self.ClassName + self.Suffix
    );
    oQueryZasob := ZLEDM.DajQueryZasobowReceppozZlecDoWyslania(
      SecurityManager.UserId,
      self.ClassName + self.Suffix
    );
    if(oQueryZlec <> nil) then begin
      oQueryZlec.FetchAll();
      ProgressStart(self, oQueryZlec.RecordCount, 'Wysyanie zaznaczonych zlece', True);
      OutProgForm := ProgressForm;
      try
        while(not oQueryZlec.Eof) do begin
          oXMLDoc := TUNIXMLParser.Create();
          oElem := oXMLDoc.DodajElementGlowny(sZLEZLECENIE);
          ZLEDM.PrzepiszDaneZlecDoXML(
            oXMLDoc,
            oElem,
            oQueryZlec,
            oQueryRecep,
            oQueryZasob
          );
          sXML  := oXMLDoc.ZapiszDokumentDoStringa();
          FreeAndNil(oXMLDoc);
          ProgressForm := OutProgForm;
          ProgressForm.ProgressInc();
          Application.ProcessMessages();
          if(ProgressForm.aborted) then
            break;
          ZLEDM.WyslijDaneZlec(sXML, cUNIINTOperacja_ZlecenieProdWyslij_Id, SecurityManager.UserId, self.ClassName + self.Suffix);
          oQueryZlec.Next();
        end;  // while(not oQueryZlec.Eof)
      finally
        ProgressForm := OutProgForm;
        ProgressEnd();
        DataModule.RefreshDataSets();
      end;
    end;  // if(oQueryZlec <> nil)
  finally
    oXMLDoc.Free();
    oQueryZlec.Free();
    oQueryRecep.Free();
    oQueryZasob.Free();
    oZlecId.Free();
    ZLEDM.UsunIdZlecDoWyslaniaWADMId(SecurityManager.UserId, self.ClassName + self.Suffix);
  end;
{$endif}
end;

procedure TZLEZlecenieDBGridForm.ZamknijkontaMenuItemClick(
  Sender: TObject);
var
  i, iMnemonikZLEID: Integer;
  oQuery: TUNIQuery;
begin
  if DataModule.ActiveQuery.IsEmpty() then Exit;

  if ZLEDM.vZLEZamkniecieKont and DataManagers.Available(sFKModulID) then begin
     iMnemonikZLEID := -1;
     oQuery := SQLManager.CreateQuery('SELECT ' + sFKMNEMONIKI_ID +
                                     ' FROM %s ' +
                                     ' WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(sMnemonikZlecenie) + ' AND ' +
                                      sFKMNEMONIKI_INDEKS + ' = 0',
                                      [sFKMNEMONIKI]);

     try
        if oQuery <> nil then begin
          oQuery.Open;
          if not oQuery.IsEmpty then
            iMnemonikZLEID := oQuery.FieldByName(sFKMNEMONIKI_ID).AsInteger;
        end;
     finally
         if oQuery <> nil then FreeAndNil(oQuery);
     end;

     if (Length(DBGrid.MarkedRows) > 0) then begin
        //sOldId  := DMAQFbN(sZLEZLECENIE_ID).AsString;

        if DBGrid.DataSource.DataSet <> nil then DBGrid.DataSource.DataSet.DisableControls;
        try
           ProgressStart(self, Length(DBGrid.MarkedRows) + 1, 'Zamykanie kont powizanych ze zleceniami. Prosz czeka ...', True);
           for i := Low(DBGrid.MarkedRows) to High(DBGrid.MarkedRows) do begin
              Application.ProcessMessages;
              if ProgressForm.aborted then begin
                 Komunikat(cError,'Operacja usuwania przerwana przez uytkownika!');
                 break;
              end;

              if ( UNILocate(DataModule.ActiveQuery, sZLEZLECENIE_ID, IntToStr(DBGrid.MarkedRows[i])) and
                   (DMAQFbN(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID) and
                   (DMAQFbN(sZLEZLECENIE_DATA_ZAMK).AsDateTime > 0)) then begin
                 FKDM.FKKontaNieaktywne(vAktywnaFirma,
                                 vAktywnyRokObrachunkowyID,
                                 DMAQFbN(sZLEZLECENIE_DATA_ZAMK).AsDateTime,
                                 iMnemonikZLEID,
                                 DMAQFbN(sZLEZLECENIE_SYMBOL).AsString,
                                 nil);

              end;  // if
              ProgressForm.ProgressInc();
           end;  // for i := Low(DBGrid.MarkedRows) to High(DBGrid.MarkedRows)

           if not ProgressForm.aborted then
              Komunikat(cInformation,'Operacja zamykania kont zakoczona');

        finally
           ProgressEnd();
           if DBGrid.DataSource.DataSet <> nil then DBGrid.DataSource.DataSet.EnableControls();
           //UNILocate(DataModule.ActiveQuery, sZLEZLECENIE_ID, sOldId);
        end;
     end else begin
        if (DMAQFbN(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID) and
           (DMAQFbN(sZLEZLECENIE_DATA_ZAMK).AsDateTime > 0) then
           FKDM.FKKontaNieaktywne(vAktywnaFirma,
                                 vAktywnyRokObrachunkowyID,
                                 DMAQFbN(sZLEZLECENIE_DATA_ZAMK).AsDateTime,
                                 iMnemonikZLEID,
                                 DMAQFbN(sZLEZLECENIE_SYMBOL).AsString,
                                 nil);
     end;
  end;
end;

procedure TZLEZlecenieDBGridForm.KosztyECPButtonClick(Sender: TObject);
begin
  KosztyECPMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm.KosztyECPMenuItemClick(Sender: TObject);
begin
  AktywujFunkcje( KosztyECPButton, KosztyECPPanel, KosztyECPMenuItem );
end;

procedure TZLEZlecenieDBGridForm.ZmienStatus();
begin
  ZmienStatusMenuItemClick(nil);
end;

procedure TZLEZlecenieDBGridForm.ZmienStatusMenuItemClick(Sender: TObject);
var
  oStatusForm:  TZLEZlecenieZmianaStatusuSelectForm;
  oZlecId:      TStringList;
  i:            Integer;
begin
  {Tomjen - 2011-04-20 - Modyfikacja funkcji i umoliwienie grupowej
                         zmiany statusu zlecenia}
  if (not DataModule.ActiveQuery.IsEmpty()) then begin
    oZlecId     := TStringList.Create();

    try
      if (Length(DBGrid.MarkedRows) > 0) then begin
        for i := 0 to Length(DBGrid.MarkedRows)-1 do
          oZlecId.Add(IntToStr(DBGrid.MarkedRows[i]));
      end else
        oZlecId.Add(DMAQFbN(sZLEZLECENIE_ID).AsString);

      ADMID_Save(cADMIDFunZLEZmianaStatusu,
                 0,
                 SecurityManager.UserID,
                 self.ClassName + self.Suffix{sKontekst},
                 nil,
                 oZlecId,
                 vAktywnaFirma);

      oStatusForm := (FormManager.OpenForm(
                          self,
                          'TZLEZlecenieZmianaStatusuSelectForm',
                          omDefault + omHidden,
                          TKeyValues.CreateAs(
                            [sZLEZLECENIE_STATUS + '=' + DMAQFbN(sZLEZLECENIE_STATUS).AsString]
                          )) as TZLEZlecenieZmianaStatusuSelectForm);
      try
        if(oStatusForm.ShowModal() = mrOk) then begin
          SQLManager.ExecuteQuery(
            'update %s Z' +
            ' set Z.' + sZLEZLECENIE_STATUS + ' = ''' + oStatusForm.StatusNowy + '''' +
            ' where Z.' + sZLEZLECENIE_STATUS + ' <> ''' + oStatusForm.StatusNowy + ''' and ' +
                   'Z.' + sZLEZLECENIE_ID + ' in(' +
                       ADMID_SelectSQL(cADMIDFunZLEZmianaStatusu,
                                       0,
                                       SecurityManager.UserId,
                                       self.ClassName + self.Suffix{sKontekst},
                                       vAktywnaFirma)  +
                       ')',
            //' where Z.' + sZLEZLECENIE_ID + ' = ' + DMAQFbN(sZLEZLECENIE_ID).AsString,
            [sZLEZLECENIE]
          );
          DataModule.RefreshDataSets();
        end;  // if(oStatusForm.ShowModal() = mrOk)
      finally
        oStatusForm.Free();
      end;
    finally
      oZlecId.Free();
      ADMID_DelAll(cADMIDFunZLEZmianaStatusu,
                 0,
                 SecurityManager.UserId,
                 self.ClassName + self.Suffix{sKontekst},
                 vAktywnaFirma);
    end;
  end;  // if(not DataModule.ActiveQuery.IsEmpty())
end;

procedure TZLEZlecenieDBGridForm.ZmienToolButtonClick(Sender: TObject);
begin
  inherited;
  EditMenuItemClick(self);
end;

procedure TZLEZlecenieDBGridForm.UNIINTWyslijPlanProdukcjiMenuItemClick(
  Sender: TObject);
{$ifndef build_all}
var
  oZlecId:    TStringList;
  i:          integer;
{$endif}
begin
{$ifndef build_all}
  if(DataModule.ActiveQuery.IsEmpty() or (not UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_PlanProdWyslij_Id))) then
    exit;
  oZlecId     := TStringList.Create();
  try
    if(Length(DBGrid.MarkedRows) > 0) then begin
      for i := 0 to Length(DBGrid.MarkedRows)-1 do
        oZlecId.Add(IntToStr(DBGrid.MarkedRows[i]));
    end else
      oZlecId.Add(DMAQFbN(DataModule.Keys.GetPrimaryKey()).AsString);
    ZLEDM.WyslijPlanProdukcjiZlec(oZlecId, self.ClassName + self.Suffix);
    DataModule.RefreshDataSets();
  finally
    oZlecId.Free();
  end;
{$endif}
end;

procedure TZLEZlecenieDBGridForm.DodajToolButtonClick(Sender: TObject);
begin
  inherited;
  NewMenuItemClick(self);
end;

procedure TZLEZlecenieDBGridForm.DopiszKosztyZakupuButtonClick(
  Sender: TObject);
var
  sOldId: string;
  slListaZlecen: TStringList;
  i:      integer;
  iFirmaID: Integer;
  bBlednaFirma: Boolean;
begin
  if(DataModule.ActiveQuery.IsEmpty()) then
    exit;

  iFirmaID := 0;
  bBlednaFirma := False;
  slListaZlecen := TStringList.Create();

  if(Length(DBGrid.MarkedRows) > 0) then begin
    sOldId  := DMAQFbN(sZLEZLECENIE_ID).AsString;
    DataModule.ActiveQuery.DisableControls();
    try
      for i := Low(DBGrid.MarkedRows) to High(DBGrid.MarkedRows) do begin
        if UNILocate(DataModule.ActiveQuery, sZLEZLECENIE_ID, IntToStr(DBGrid.MarkedRows[i])) then begin
          if vWielofirmowosc and (iFirmaID <> 0) and (iFirmaID <> DMAQFbN(sUNIODDZIAL_ID).AsInteger) then begin
             bBlednaFirma := True;
             Break;
          end else begin
             if vWielofirmowosc and (iFirmaID = 0) then
                iFirmaID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;

          end;
          slListaZlecen.Add(IntToStr(DBGrid.MarkedRows[i]));
        end;
      end;
    finally
      UNILocate(DataModule.ActiveQuery, sZLEZLECENIE_ID, sOldId);
      DataModule.ActiveQuery.EnableControls();
    end;
  end else begin
    if vWielofirmowosc then
       iFirmaID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
    slListaZlecen.Add(DMAQFbN(sZLEZLECENIE_ID).AsString);
  end;

  if (not bBlednaFirma) and (slListaZlecen.Count > 0) then begin
    //iMfzZakupId: integer; slListaZlecen: TStringList; iUniOddzialId: integer = 0
    MFZDM.MFZKosztyZeZlecen(0, slListaZlecen, iFirmaID);
  end else begin
    Komunikat(cWarning, 'Wybrano zlecenia z rnych firm', MB_OK + MB_ICONEXCLAMATION);
  end;
end;

procedure TZLEZlecenieDBGridForm.UNIINTWycofajZlecenieMenuItemClick(
  Sender: TObject);
{$ifndef build_all}
var
  oXMLDoc:    TUNIXMLParser;
  oElem:      IXMLDOMElement;
  oQueryZlec: TUNIQuery;
  oQueryRecep:TUNIQuery;
  oQueryZasob:TUNIQuery;
  oZlecId:    TStringList;
  sXML:       string;
  i:          integer;
  OutProgForm: TProgressForm;
{$endif}
begin
{$ifndef build_all}
  if(DataModule.ActiveQuery.IsEmpty() or (not UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_ZlecenieProdUsun_Id))) then
    exit;
  oQueryZlec  := nil;
  oQueryRecep := nil;
  oQueryZasob := nil;
  oXMLDoc     := nil;
  oZlecId     := TStringList.Create();
  try
    if(Length(DBGrid.MarkedRows) > 0) then begin
      for i := 0 to Length(DBGrid.MarkedRows)-1 do
        oZlecId.Add(IntToStr(DBGrid.MarkedRows[i]));
    end else
      oZlecId.Add(DMAQFbN(DataModule.Keys.GetPrimaryKey()).AsString);
    ZLEDM.ZapiszIdZlecDoWyslaniaWADMId(oZlecId, SecurityManager.UserId, self.ClassName + self.Suffix, true);
    oQueryZlec  := ZLEDM.DajQueryZlecDoWyslania(
      SecurityManager.UserId,
      self.ClassName + self.Suffix
    );
    oQueryRecep := ZLEDM.DajQueryReceppozZlecDoWyslania(
      SecurityManager.UserId,
      self.ClassName + self.Suffix
    );
    oQueryZasob := ZLEDM.DajQueryZasobowReceppozZlecDoWyslania(
      SecurityManager.UserId,
      self.ClassName + self.Suffix
    );
    if(oQueryZlec <> nil) then begin
      oQueryZlec.FetchAll();
      ProgressStart(self, oQueryZlec.RecordCount, 'Wycofywanie zaznaczonych zlece', True);
      OutProgForm := ProgressForm;
      try
        while(not oQueryZlec.Eof) do begin
          oXMLDoc := TUNIXMLParser.Create();
          oElem := oXMLDoc.DodajElementGlowny(sZLEZLECENIE);
          ZLEDM.PrzepiszDaneZlecDoXML(
            oXMLDoc,
            oElem,
            oQueryZlec,
            oQueryRecep,
            oQueryZasob
          );
          sXML  := oXMLDoc.ZapiszDokumentDoStringa();
          FreeAndNil(oXMLDoc);
          ProgressForm := OutProgForm;
          ProgressForm.ProgressInc();
          Application.ProcessMessages();
          if(ProgressForm.aborted) then
            break;
          ZLEDM.WyslijDaneZlec(sXML, cUNIINTOperacja_ZlecenieProdUsun_Id, SecurityManager.UserId, self.ClassName + self.Suffix);
          oQueryZlec.Next();
        end;  // while(not oQueryZlec.Eof)
      finally
        ProgressForm := OutProgForm;
        ProgressEnd();
        DataModule.RefreshDataSets();
      end;
    end;  // if(oQueryZlec <> nil)
  finally
    oXMLDoc.Free();
    oQueryZlec.Free();
    oQueryRecep.Free();
    oQueryZasob.Free();
    oZlecId.Free();
    ZLEDM.UsunIdZlecDoWyslaniaWADMId(SecurityManager.UserId, self.ClassName + self.Suffix);
  end;
{$endif}
end;

procedure TZLEZlecenieDBGridForm.UNIINTWycofajPlanProdukcjiMenuItemClick(
  Sender: TObject);
{$ifndef build_all}
var
  oZlecId:    TStringList;
  i:          integer;
{$endif}
begin
{$ifndef build_all}
  if(DataModule.ActiveQuery.IsEmpty() or (not UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_PlanProdUsun_Id))) then
    exit;
  oZlecId     := TStringList.Create();
  try
    if(Length(DBGrid.MarkedRows) > 0) then begin
      for i := 0 to Length(DBGrid.MarkedRows)-1 do
        oZlecId.Add(IntToStr(DBGrid.MarkedRows[i]));
    end else
      oZlecId.Add(DMAQFbN(DataModule.Keys.GetPrimaryKey()).AsString);
    ZLEDM.WycofajPlanProdukcjiZlec(oZlecId, self.ClassName + self.Suffix);
    DataModule.RefreshDataSets();
  finally
    oZlecId.Free();
  end;
{$endif}
end;

procedure TZLEZlecenieDBGridForm.ZaangazowaniMenuItemClick(
  Sender: TObject);
var
  AOpenMode: TOpenMode;
begin
  //btnUzytkownicyZaangazowaniButton.SetFocus;
  inherited;
  //if OpenMode in [omNew,omEdit] then
    AOpenMode := {OpenMode} omEdit; //or omHidden or omOverVirtual;
  //else if OpenMode in [omView,omDelete] then
//    AOpenMode := omView or omReadOnly or omHidden or omVirtual; { omShowModal or omVirtual;}
  {f :=} FormManager.OpenDBDetail( Self, 'TZLEZaangazowaniDBDetailForm', AOpenMode );
  {if f <> nil then begin
     if f.ShowModal = mrOK then begin
        if OpenMode in [omNew,omEdit] then
           DataModule.ActiveQuery.Edit;  //Czy to jest potrzebne?
     end;
     if f <> nil then FreeAndNil(f);
  end;}
end;

procedure TZLEZlecenieDBGridForm.mniUstawPrzeliczZlecMenuItemClick(
  Sender: TObject);
var
  i: Integer;
  sListaZlecID: String;
begin
   if DataModule.ActiveQuery.IsEmpty() then Exit;

   if not SecurityManager.SM_UserCanDo(sZLE_KART_ZLECEN_ZMIEN) then begin
      Komunikat(cWarning, 'Brak wystarczajcych uprawnien do zmiany znacznika Przelicz');
      Exit;
   end;

   sListaZlecID := '';
   if (Length(DBGrid.MarkedRows) > 0) then begin
      for i := Low(DBGrid.MarkedRows) to High(DBGrid.MarkedRows) do begin
         if sListaZlecID <> '' then sListaZlecID := sListaZlecID + ',';
         sListaZlecID := sListaZlecID + IntToStr(DBGrid.MarkedRows[i]);
      end;
   end else begin
     sListaZlecID := DMAQFbN(sZLEZLECENIE_ID).AsString;
   end;

   if sListaZlecID <> '' then begin
     try
        SQLManager.ExecuteQuery('UPDATE %s ' +
                                'SET ' + sZLEZLECENIE_PRZELICZ + ' = ' + QuotedStr(sTak) + ' ' +
                                'WHERE ' + sZLEZLECENIE_ID + ' IN (' + sListaZlecID + ')',
                                [sZLEZLECENIE]);
     except
        Komunikat(cError, 'Bd podczas ustawiania znacznika Przelicz');
     end;
   end;
   DBGrid.UnMarkAll();
   ReOpenDataSets;
end;

procedure TZLEZlecenieDBGridForm.mniWylaczPrzeliczZlecenMenuItemClick(
  Sender: TObject);
var
  i: Integer;
  sListaZlecID: String;
begin
   if DataModule.ActiveQuery.IsEmpty() then Exit;

   if not SecurityManager.SM_UserCanDo(sZLE_KART_ZLECEN_ZMIEN) then begin
      Komunikat(cWarning, 'Brak wystarczajcych uprawnien do zmiany znacznika Przelicz');
      Exit;
   end;

   sListaZlecID := '';
   if (Length(DBGrid.MarkedRows) > 0) then begin
      for i := Low(DBGrid.MarkedRows) to High(DBGrid.MarkedRows) do begin
         if sListaZlecID <> '' then sListaZlecID := sListaZlecID + ',';
         sListaZlecID := sListaZlecID + IntToStr(DBGrid.MarkedRows[i]);
      end;
   end else begin
     sListaZlecID := DMAQFbN(sZLEZLECENIE_ID).AsString;
   end;

   if sListaZlecID <> '' then begin
     try
        SQLManager.ExecuteQuery('UPDATE %s ' +
                                'SET ' + sZLEZLECENIE_PRZELICZ + ' = ' + QuotedStr(sNie) + ' ' +
                                'WHERE ' + sZLEZLECENIE_ID + ' IN (' + sListaZlecID + ')',
                                [sZLEZLECENIE]);
     except
        Komunikat(cError, 'Bd podczas ustawiania znacznika Przelicz');
     end;
   end;
   DBGrid.UnMarkAll();
   ReOpenDataSets;
end;

procedure TZLEZlecenieDBGridForm.TransportMenuItemClick(Sender: TObject);
begin
  AktywujFunkcje( TransportButton, TransportPanel, TransportMenuItem );
end;

initialization
  FormManager.RegisterForm( TZLEZlecenieDBGridForm, 'Lista zlece', sZLEModulID );
end.
