CREATE OR REPLACE FUNCTION zle_pobierz_id_obcy(iZlezlecenieID INTEGER)
RETURN INTEGER
AS
 iZlecenieObcyID INTEGER;
 P_ORDER_ID_UNISOFT INTEGER;
 sSQL VARCHAR2(1024);
 v_blad VARCHAR2(1024);

  iIDObcyID INTEGER;
  vZLEWysylanie VARCHAR2(1);
  vPartnerID INTEGER;

BEGIN
 iZlecenieObcyID := NULL;
 vZLEWysylanie := 'N';
 vPartnerID := -1;

 IF UNIZSI_PACKAGE.ifUNIINT = TRUE THEN
   BEGIN
    SELECT zt.ZLETYPZLEC_WYSYLANIE_UNIINT
    INTO  vZLEWysylanie
    FROM  zletypzlec zt, zlezlecenie zl
    WHERE zt.zletypzlec_id = zl.Zletypzlec_ID
      AND zl.zlezlecenie_id = iZlezlecenieID;
    EXCEPTION
      WHEN No_Data_Found THEN
        vZLEWysylanie := 'N';
      WHEN OTHERS THEN
          RAISE;
   END;

   SELECT UNISYSTEMPARAM_VALUE
   INTO  vPartnerID
   FROM  unisystemparam
   WHERE unisystemparam_system='UNIINT'
     AND UNISYSTEMPARAM_ITEM='UNIINT_PARTNER';

   IF (vPartnerID = 2) AND (vZLEWysylanie = 'T') THEN
     sSQL := 'BEGIN mb_app.unisoft_get_order@link_ejb(' || To_Char(iZlezlecenieID) || ', :1, :2); END;';
     EXECute IMMEDIATE sSQL USING IN OUT iZlecenieObcyID, OUT v_blad;
   END IF;
 END IF;
 RETURN iZlecenieObcyID;
END;

