library ZLE;

{$R 'zleresource.res' 'zleresource.rc'}

uses
  ShareMem,
  SysUtils,
  Controls,
  AliasManagerUnit in 'R:\UNIFramework\AliasManagerUnit.pas',
  Dodatki in 'R:\UNIFramework\Dodatki.pas',
  EnvironmentManagerUnit in 'R:\UNIFramework\EnvironmentManagerUnit.pas',
  FormManagerUnit in 'R:\UNIFramework\FormManagerUnit.pas',
  InitUnit in 'R:\UNIFramework\InitUnit.pas',
  KeyManagerUnit in 'R:\UNIFramework\KeyManagerUnit.pas',
  ProgressFormUnit in 'R:\UNIFramework\ProgressFormUnit.pas' {ProgressForm},
  QueryBuilderUnit in 'R:\UNIFramework\QueryBuilderUnit.pas',
  SecurityManagerUnit in 'R:\UNIFramework\SecurityManagerUnit.pas',
  SQLManagerUnit in 'R:\UNIFramework\SQLManagerUnit.pas',
  SystemDataManagerUnit in 'R:\UNIFramework\SystemDataManagerUnit.pas',
  SystemDefUnit in 'R:\UNIFramework\SystemDefUnit.pas',
  UNIDataManagerUnit in 'R:\UNIFramework\UNIDataManagerUnit.pas' {UNIDataManager: TDataModule},
  UNIDataModuleUnit in 'R:\UNIFramework\UNIDataModuleUnit.pas' {UNIDataModule: TDataModule},
  UNIImageManagerUnit in 'R:\UNIFramework\UNIImageManagerUnit.pas' {UNIImageManager: TDataModule},
  UNIMainFormUnit in 'R:\UNIFramework\UNIMainFormUnit.pas' {UNIMainForm},
  UniqueKeyUnit in 'R:\UNIFramework\UniqueKeyUnit.pas',
  UNIStaleUnit in 'R:\UNIFramework\UNIStaleUnit.pas',
  UNIFormUnit in 'R:\UNIFramework\UNIFormUnit.pas' {UNIForm},
  UNIDBFormUnit in 'R:\UNIFramework\UNIDBFormUnit.pas' {UNIDBForm},
  UNIDBSelectFormUnit in 'R:\UNIFramework\UNIDBSelectFormUnit.pas' {UNIDBSelectForm},
  UNIDBDetailFormUnit in 'R:\UNIFramework\UNIDBDetailFormUnit.pas' {UNIDBDetailForm},
  UNIDBGridFormUnit in 'R:\UNIFramework\UNIDBGridFormUnit.pas' {UNIDBGridForm},
  UNISelectFormUnit in 'R:\UNIFramework\UNISelectFormUnit.pas' {UNISelectForm},
  UNIComponentsUnit in 'R:\UNIComponents\UNIComponentsUnit.pas',
  UNISysDataManagerUnit in 'R:\UniSys\UNISysDataManagerUnit.pas' {UniSysDataManager: TDataModule},
  UNISysDefUnit in 'R:\UniSys\UNISysDefUnit.pas',
  RRDefUnit in 'R:\RR\RRDefUnit.pas',
  RRDataManagerUnit in 'R:\RR\RRDataManagerUnit.pas' {RRDataManager: TDataModule},
  FKDefUnit in 'R:\Fk\FKDefUnit.pas',
  FKDataManagerUnit in 'R:\Fk\FKDataManagerUnit.pas' {FKDataManager: TDataModule},
  ASODefUnit in 'R:\Aso\ASODefUnit.pas',
  KDDefUnit in 'R:\Kd\KDDefUnit.pas',
  BKDefUnit in 'R:\BK\BKDefUnit.pas',
  ZLEDefUnit in 'ZLEDefUnit.pas',
  ZLEDataManagerUnit in 'ZLEDataManagerUnit.pas' {ZLEDataManager: TDataModule},
  ZLETypZleceniaUnit in 'ZLETypZleceniaUnit.pas' {ZLETypZleceniaDataModule: TDataModule},
  ZLETypZleceniaDBDetailFormUnit in 'ZLETypZleceniaDBDetailFormUnit.pas' {ZLETypZleceniaDBDetailForm},
  ZLESkladnikKontroliWartosciowejUnit in 'ZLESkladnikKontroliWartosciowejUnit.pas' {ZLESkladnikKontroliWartosciowejDataModule: TDataModule},
  ZLESkladnikKontroliIlosciowejUnit in 'ZLESkladnikKontroliIlosciowejUnit.pas' {ZLESkladnikKontroliIlosciowejDataModule: TDataModule},
  ZLESkladnikKontroliDBGridFormUnit in 'ZLESkladnikKontroliDBGridFormUnit.pas' {ZLESkladnikKontroliDBGridForm},
  ZLESkladnikKontroliDBDetailFormUnit in 'ZLESkladnikKontroliDBDetailFormUnit.pas' {ZLESkladnikKontroliDBDetailForm},
  ZLESkladnikKontroliUnit in 'ZLESkladnikKontroliUnit.pas' {ZLESkladnikKontroliDataModule: TDataModule},
  ZLESkladnikKontroliWartosciowejDBDetailFormUnit in 'ZLESkladnikKontroliWartosciowejDBDetailFormUnit.pas' {ZLESkladnikKontroliWartosciowejDBDetailForm},
  ZLESkladnikKontroliIlosciowejDBDetailFormUnit in 'ZLESkladnikKontroliIlosciowejDBDetailFormUnit.pas' {ZLESkladnikKontroliIlosciowejDBDetailForm},
  ZLESkladnikKontroliWartosciowejDBGridFormUnit in 'ZLESkladnikKontroliWartosciowejDBGridFormUnit.pas' {ZLESkladnikKontroliWartosciowejDBGridForm},
  ZLESkladnikKontroliIlosciowejDBGridFormUnit in 'ZLESkladnikKontroliIlosciowejDBGridFormUnit.pas' {ZLESkladnikKontroliIlosciowejDBGridForm},
  ZLETypZleceniaDBGridFormUnit in 'ZLETypZleceniaDBGridFormUnit.pas' {ZLETypZleceniaDBGridForm},
  ZLEZlecenieUnit in 'ZLEZlecenieUnit.pas' {ZLEZlecenieDataModule: TDataModule},
  ZLEZlecenieDBGridFormUnit in 'ZLEZlecenieDBGridFormUnit.pas' {ZLEZlecenieDBGridForm},
  ZLEZlecenieDBDetailFormUnit in 'ZLEZlecenieDBDetailFormUnit.pas' {ZLEZlecenieDBDetailForm},
  ZLEParametrySelectFormUnit in 'ZLEParametrySelectFormUnit.pas' {ZLEParametrySelectForm},
  ZLEPozycjeUnit in 'ZLEPozycjeUnit.pas' {ZLEPozycjeDataModule: TDataModule},
  ZLEPozycjeDBGridFormUnit in 'ZLEPozycjeDBGridFormUnit.pas' {ZLEPozycjeDBGridForm},
  ZLEPozycjeDBDetailFormUnit in 'ZLEPozycjeDBDetailFormUnit.pas' {ZLEPozycjeDBDetailForm},
  ZLEKontrolaRealizacjiDBDetailFormUnit in 'ZLEKontrolaRealizacjiDBDetailFormUnit.pas' {ZLEKontrolaRealizacjiDBDetailForm},
  ZLEKontrolaRealizacjiWartosciowejUnit in 'ZLEKontrolaRealizacjiWartosciowejUnit.pas' {ZLEKontrolaRealizacjiWartosciowejDataModule: TDataModule},
  ZLEKontrolaRealizacjiDBGridFormUnit in 'ZLEKontrolaRealizacjiDBGridFormUnit.pas' {ZLEKontrolaRealizacjiDBGridForm},
  ZLEKontrolaRealizacjiWartosciowejDBGridFormUnit in 'ZLEKontrolaRealizacjiWartosciowejDBGridFormUnit.pas' {ZLEKontrolaRealizacjiWartosciowejDBGridForm},
  ZLEKontrolaRealizacjiIlosciowejDBGridFormUnit in 'ZLEKontrolaRealizacjiIlosciowejDBGridFormUnit.pas' {ZLEKontrolaRealizacjiIlosciowejDBGridForm},
  ZLEKontrolaRealizacjiIlosciowejUnit in 'ZLEKontrolaRealizacjiIlosciowejUnit.pas' {ZLEKontrolaRealizacjiIlosciowejDataModule: TDataModule},
  ZLEKontrolaRealizacjiUnit in 'ZLEKontrolaRealizacjiUnit.pas' {ZLEKontrolaRealizacjiDataModule: TDataModule},
  ASODataManagerExtUnit in 'R:\Aso\ASODataManagerExtUnit.pas',
  BKDataManagerUnit in 'R:\BK\BKDataManagerUnit.pas' {BKDataManager: TDataModule},
  MFSDataManagerUnit in 'R:\MFS\MFSDataManagerUnit.pas' {MFSDataManager: TDataModule},
  VatDefUnit in 'R:\Vat\VatDefUnit.pas',
  MFSDefUnit in 'R:\MFS\MFSDefUnit.pas',
  VatDataManagerUnit in 'R:\Vat\VatDataManagerUnit.pas' {VATDataManager: TDataModule},
  MAGDataManagerExtUnit in 'R:\Mag\MAGDataManagerExtUnit.pas',
  MAGDefUnit in 'R:\Mag\MAGDefUnit.pas',
  MFZDataManagerUnit in 'R:\Mfz\MFZDataManagerUnit.pas' {MFZDataManager: TDataModule},
  MFZDefUnit in 'R:\Mfz\MFZDefUnit.pas',
  LFKDefUnit in 'R:\LFK\LFKDefUnit.pas',
  LFKDataManagerUnit in 'R:\LFK\LFKDataManagerUnit.pas' {LFKDataManager: TDataModule},
  ZADataManagerExtUnit in 'R:\Za\ZADataManagerExtUnit.pas',
  ZADefUnit in 'R:\Za\ZADefUnit.pas',
  RGDataManagerUnit in 'R:\Rg\RGDataManagerUnit.pas' {RGDataManager: TDataModule},
  RGDefUnit in 'R:\Rg\RGDefUnit.pas',
  ZLEParserUnit in 'ZLEParserUnit.pas',
  ZLEKontrolaRealizacjiRecznaUnit in 'ZLEKontrolaRealizacjiRecznaUnit.pas' {ZLEKontrolaRealizacjiRecznaDataModule: TDataModule},
  ZLEKontrolaRealizacjiRecznaWartosciowaUnit in 'ZLEKontrolaRealizacjiRecznaWartosciowaUnit.pas' {ZLEKontrolaRealizacjiRecznaWartosciowaDataModule: TDataModule},
  ZLEKontrolaRealizacjiRecznaDBGridFormUnit in 'ZLEKontrolaRealizacjiRecznaDBGridFormUnit.pas' {ZLEKontrolaRealizacjiRecznaDBGridForm},
  ZLEKontrolaRealizacjiRecznaWartosciowaDBGridFormUnit in 'ZLEKontrolaRealizacjiRecznaWartosciowaDBGridFormUnit.pas' {ZLEKontrolaRealizacjiRecznaWartosciowaDBGridForm},
  ZLEKontrolaRealizacjiRecznaIlosciowaDBGridFormUnit in 'ZLEKontrolaRealizacjiRecznaIlosciowaDBGridFormUnit.pas' {ZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm},
  ZLEKontrolaRealizacjiRecznaIlosciowaUnit in 'ZLEKontrolaRealizacjiRecznaIlosciowaUnit.pas' {ZLEKontrolaRealizacjiRecznaIlosciowaDataModule: TDataModule},
  INFDefUnit in 'R:\INF\INFDefUnit.pas',
  INFDataManagerExtUnit in 'R:\INF\INFDataManagerExtUnit.pas',
  ZLEZakresSelectFormUnit in 'ZLEZakresSelectFormUnit.pas' {ZLEZakresSelectForm},
  REMDefUnit in 'R:\REM\REMDefUnit.pas',
  REMDataManagerExtUnit in 'R:\REM\REMDataManagerExtUnit.pas' {REMDataManagerExt: TDataModule},
  Classes,
  BOKDefUnit in 'R:\BOK\BOKDefUnit.pas',
  PLREGDefUnit in 'R:\PLREG\PLREGDefUnit.pas',
  PLREGDataManagerExtUnit in 'R:\PLREG\PLREGDataManagerExtUnit.pas' {PLREGDataManagerExt: TDataModule},
  PLPRADataManagerExtUnit in 'R:\PLPRA\PLPRADataManagerExtUnit.pas' {PLPRADataManagerExt: TDataModule},
  PLPRADefUnit in 'R:\PLPRA\PLPRADefUnit.pas',
  KDDataManagerExtUnit in 'R:\Kd\KDDataManagerExtUnit.pas' {KDDataManagerExt: TDataModule},
  ZLEUpdateUnit in 'ZLEUpdateUnit.pas',
  ZleOsobyGodzDBDetailFormUnit in 'ZleOsobyGodzDBDetailFormUnit.pas' {ZleOsobyGodzDBDetailForm},
  ZleOsobyGodzDBGridFormUnit in 'ZleOsobyGodzDBGridFormUnit.pas' {ZleOsobyGodzDBGridForm},
  ZleOsobyGodzUnit in 'ZleOsobyGodzUnit.pas' {ZleOsobyGodz: TDataModule},
  SPDefUnit in 'R:\Sp\SPDefUnit.pas',
  SPDataManagerExtUnit in 'R:\Sp\SPDataManagerExtUnit.pas',
  ZLESzczegoloweKosztyUnit in 'ZLESzczegoloweKosztyUnit.pas' {ZLESzczegoloweKosztyDataModule: TDataModule},
  ZLESzczegoloweKosztyDBGridUnit in 'ZLESzczegoloweKosztyDBGridUnit.pas' {ZLESzczegoloweKosztyDBGridForm},
  ZLEZasobUnit in 'ZLEZasobUnit.pas' {ZLEZasobDataModule: TDataModule},
  ZLEZasobDBGridFormUnit in 'ZLEZasobDBGridFormUnit.pas' {ZLEZasobDBGridForm},
  ZLEZasobDBDetailFormUnit in 'ZLEZasobDBDetailFormUnit.pas' {ZLEZasobDBDetailForm},
  BOKDataManagerExtUnit in 'R:\BOK\BOKDataManagerExtUnit.pas',
  ZLEZlecenieZasobUnit in 'ZLEZlecenieZasobUnit.pas' {ZLEZlecenieZasobDataModule: TDataModule},
  ZLEZlecenieZasobDBGridFormUnit in 'ZLEZlecenieZasobDBGridFormUnit.pas' {ZLEZlecenieZasobDBGridForm},
  ZLEZlecenieRozlUnit in 'ZLEZlecenieRozlUnit.pas' {ZLEZlecenieRozlDataModule: TDataModule},
  ZLEZlecenieRozlDBGridFormUnit in 'ZLEZlecenieRozlDBGridFormUnit.pas' {ZLEZlecenieRozlDBGridForm},
  ZLEZlecenieRozlDBDetailFormUnit in 'ZLEZlecenieRozlDBDetailFormUnit.pas' {ZLEZlecenieRozlDBDetailForm},
  UNIRangeFormUnit in 'R:\UNIFramework\UNIRangeFormUnit.pas' {UNIRangeForm},
  ZLEZlecenieRozlRangeFormUnit in 'ZLEZlecenieRozlRangeFormUnit.pas' {ZLEZlecenieRozlRangeForm},
  ZLEZasobZakresFormUnit in 'ZLEZasobZakresFormUnit.pas' {ZLEZasobyZakresForm},
  ZLEPoleZmDefUnit in 'ZLEPoleZmDefUnit.pas' {ZLEPoleZmDef: TDataModule},
  ZLEPoleZmDefDBGridFormUnit in 'ZLEPoleZmDefDBGridFormUnit.pas' {ZLEPoleZmDefDBGridForm},
  ZLEPoleZmDefDBDetailFormUnit in 'ZLEPoleZmDefDBDetailFormUnit.pas' {ZLEPoleZmDefDBDetailForm},
  ZLEPoleZmUnit in 'ZLEPoleZmUnit.pas' {ZLEPoleZmDataModule: TDataModule},
  ZLEPoleZmGridFormUnit in 'ZLEPoleZmGridFormUnit.pas' {ZLEPoleZmGridForm},
  ZLEPoleZmWskUnit in 'ZLEPoleZmWskUnit.pas' {ZLEPoleZmWsk: TDataModule},
  ZLEPoleZmWskDBGridFormUnit in 'ZLEPoleZmWskDBGridFormUnit.pas' {ZLEPoleZmWskDBGridForm},
  ZLEPoleZmWskDBDetailFormUnit in 'ZLEPoleZmWskDBDetailFormUnit.pas' {ZLEPoleZmWskDBDetailForm},
  PecDefUnit in 'R:\Pec\PecDefUnit.pas',
  PLLIDefUnit in 'R:\PLLI\PLLIDefUnit.pas',
  PLLIDataManagerExtUnit in 'R:\PLLI\PLLIDataManagerExtUnit.pas' {PLLIDataManagerExt: TDataModule},
  ZLEPlRozDefUnit in 'ZLEPlRozDefUnit.pas' {ZLEPlRozDefDataModule: TDataModule},
  ZLEPlRozDefGridFormUnit in 'ZLEPlRozDefGridFormUnit.pas' {ZLEPlRozDefGridForm},
  ZLEPobierzTekstFormUnit in 'ZLEPobierzTekstFormUnit.pas' {ZLEPobierzTekstForm},
  ZAODefUnit in 'R:\ZAO\ZAODefUnit.pas',
  ZAODataManagerExtUnit in 'R:\ZAO\ZAODataManagerExtUnit.pas' {ZAODataManagerExt: TDataModule},
  ZAMDefUnit in 'R:\ZAM\ZAMDefUnit.pas',
  ZAMDataManagerExtUnit in 'R:\ZAM\ZAMDataManagerExtUnit.pas' {ZAMDataManagerExt: TDataModule},
  LWPDefUnit in 'R:\LWP\LWPDefUnit.pas',
  LWPDataManagerExtUnit in 'R:\LWP\LWPDataManagerExtUnit.pas' {LWPDataManagerExt: TDataModule},
  ZLEZlecenieMaterialUnit in 'ZLEZlecenieMaterialUnit.pas' {ZLEZlecenieMaterialDataModule: TDataModule},
  ZLEZlecenieMaterialDBGridFormUnit in 'ZLEZlecenieMaterialDBGridFormUnit.pas' {ZLEZlecenieMaterialDBGridForm},
  ZLEZlecenieMaterialDBDetailFormUnit in 'ZLEZlecenieMaterialDBDetailFormUnit.pas' {ZLEZlecenieMaterialDBDetailForm},
  ZLEZasobyPracaUnit in 'ZLEZasobyPracaUnit.pas' {ZleZasobyPracaDataModule: TDataModule},
  ZleZasobyPracaDBGridFormUnit in 'ZleZasobyPracaDBGridFormUnit.pas' {ZleZasobyPracaDBGridForm},
  ZleZasobyPracaDBDetailFormUnit in 'ZleZasobyPracaDBDetailFormUnit.pas' {ZLEZasobyPracaDBDetailForm},
  ZLEBrakiUnit in 'ZLEBrakiUnit.pas' {ZLEBrakiDataModule: TDataModule},
  ZLEBrakiDBGridFormUnit in 'ZLEBrakiDBGridFormUnit.pas' {ZLEBrakiDBGridForm},
  ZLEBrakiDBDetailFormUnit in 'ZLEBrakiDBDetailFormUnit.pas' {ZLEBrakiDBDetailForm},
  ZLEOsobyUnit in 'ZLEOsobyUnit.pas' {ZLEOsobyDataModule: TDataModule},
  ZLEOsobyDBGridFormUnit in 'ZLEOsobyDBGridFormUnit.pas' {ZLEOsobyDBGridForm},
  ZLEOsobyDBDetailFormUnit in 'ZLEOsobyDBDetailFormUnit.pas' {ZLEOsobyDBDetailForm},
  ZLEZasobyBrakiUnit in 'ZLEZasobyBrakiUnit.pas' {ZLEZasobyBrakiDataModule: TDataModule},
  ZLEZasobyBrakiDBGridFormUnit in 'ZLEZasobyBrakiDBGridFormUnit.pas' {ZLEZasobyBrakiDBGridForm},
  ZLEZasobyBrakiDBDetailFormUnit in 'ZLEZasobyBrakiDBDetailFormUnit.pas' {ZLEZasobyBrakiDBDetailForm},
  ZLEZlecenieWycenaUnit in 'ZLEZlecenieWycenaUnit.pas' {ZLEZlecenieWycenaDataModule: TDataModule},
  ZLEZlecenieWycenaDBGridFormUnit in 'ZLEZlecenieWycenaDBGridFormUnit.pas' {ZLEZlecenieWycenaDBGridForm},
  ZLEZlecenieWycenaDBDetailFormUnit in 'ZLEZlecenieWycenaDBDetailFormUnit.pas' {ZLEZlecenieWycenaDBDetailForm},
  ZLEKryteriaUnit in 'ZLEKryteriaUnit.pas' {ZLEKryteriaDataModule: TDataModule},
  ZLEKryteriaDBGridFormUnit in 'ZLEKryteriaDBGridFormUnit.pas' {ZLEKryteriaDBGridForm},
  ZLEKryteriaDBDetailFormUnit in 'ZLEKryteriaDBDetailFormUnit.pas' {ZLEKryteriaDBDetailForm},
  ZLEKRYTPOZUnit in 'ZLEKRYTPOZUnit.pas' {ZLEKRYTPOZDataModule: TDataModule},
  ZLEKRYTPOZDBGridFormUnit in 'ZLEKRYTPOZDBGridFormUnit.pas' {ZLEKRYTPOZDBGridForm},
  SANDefUnit in 'R:\SAN\SANDefUnit.pas',
  ZLEKryteriaOkresoweSelectFormUnit in 'ZLEKryteriaOkresoweSelectFormUnit.pas' {ZLEKryteriaOkresoweSelectForm},
  PRZDefUnit in 'R:\PRZ\PRZDefUnit.pas',
  WODDefUnit in 'R:\WOD\WODDefUnit.pas',
  ZleOsobyGodzSelectFormUnit in 'ZleOsobyGodzSelectFormUnit.pas' {ZleOsobyGodzSelectForm},
  ZLEOsobyGodzPrzeliczSelectFormUnit in 'ZLEOsobyGodzPrzeliczSelectFormUnit.pas' {ZLEOsobyGodzPrzeliczSelectForm},
  OIDataManagerExtUnit in 'R:\OI\OIDataManagerExtUnit.pas' {OIDataManagerExt: TDataModule},
  OIDefUnit in 'R:\OI\OIDefUnit.pas',
  UNIINTDefUnit in 'R:\UNIINT\UNIINTDefUnit.pas',
  UNIINTKomunikatyUnit in 'R:\UNIINT\UNIINTKomunikatyUnit.pas',
  UNIINTDataManagerExtUnit in 'R:\UNIINT\UNIINTDataManagerExtUnit.pas' {UNIINTDataManagerExt: TDataModule},
  ZLEPrefixUnit in 'ZLEPrefixUnit.pas' {ZLEPrefixDataModule: TDataModule},
  ZLEPrefixDBGridFormUnit in 'ZLEPrefixDBGridFormUnit.pas' {ZLEPrefixDBGridForm},
  ZLEPrefixDBDetailFormUnit in 'ZLEPrefixDBDetailFormUnit.pas' {ZLEPrefixDBDetailForm},
  ZLEZasobyPracaZMagazynuSelectFormUnit in 'ZLEZasobyPracaZMagazynuSelectFormUnit.pas' {ZLEZasobyPracaZMagazynuSelectForm},
  ZLEWSPNarzutyUnit in 'ZLEWSPNarzutyUnit.pas' {ZLEWSPNarzutyDataModule: TDataModule},
  ZLEWSPNarzutyDBGridFormUnit in 'ZLEWSPNarzutyDBGridFormUnit.pas' {ZLEWSPNarzutyDBGridForm},
  ZLEWSPNarzutyDBDetailFormUnit in 'ZLEWSPNarzutyDBDetailFormUnit.pas' {ZLEWSPNarzutyDBDetailForm},
  ZLEKrytPozRangeFormUnit in 'ZLEKrytPozRangeFormUnit.pas' {ZLEKrytPozRangeForm},
  KDECPDefUnit in 'R:\KDECP\KDECPDefUnit.pas',
  KDECPDataManagerExtUnit in 'R:\KDECP\KDECPDataManagerExtUnit.pas' {KDECPDataManagerExt: TDataModule},
  ZLESkladnikiECPDefUnit in 'ZLESkladnikiECPDefUnit.pas' {ZLESkladnikiECPDefDataModule: TDataModule},
  ZLESkladnikiECPDefDBGridFormUnit in 'ZLESkladnikiECPDefDBGridFormUnit.pas' {ZLESkladnikiECPDefDBGridForm},
  KDPRADefUnit in 'R:\KDPRA\KDPRADefUnit.pas',
  KDPRADataManagerExtUnit in 'R:\KDPRA\KDPRADataManagerExtUnit.pas' {KDPRADataManagerExt: TDataModule},
  ZLEZlecenieZmianaStatusuSelectFormUnit in 'ZLEZlecenieZmianaStatusuSelectFormUnit.pas' {ZLEZlecenieZmianaStatusuSelectForm},
  ZLEZasobyPrzeliczSelectFormUnit in 'ZLEZasobyPrzeliczSelectFormUnit.pas' {ZLEZasobyPrzeliczSelectForm},
  ZLEFunkcjeAnalizyUnit in 'ZLEFunkcjeAnalizyUnit.pas',
  GZKDefUnit in 'R:\Gzk\GZKDefUnit.pas',
  CENDefUnit in 'R:\Cen\CENDefUnit.pas',
  GZKDataManagerExtUnit in 'R:\Gzk\GZKDataManagerExtUnit.pas' {GZKDataManagerExt: TDataModule},
  MEDDefUnit in 'R:\Med\MEDDefUnit.pas',
  ZleZasobyPracaRangeFormUnit in 'ZleZasobyPracaRangeFormUnit.pas' {ZleZasobyPracaRangeForm},
  CENDataManagerExtUnit in 'R:\Cen\CENDataManagerExtUnit.pas',
  ZLEParametryTreeFormUnit in 'ZLEParametryTreeFormUnit.pas' {ZLEParametryTreeForm},
  ZLEZaangazowaniDBDetailFormUnit in 'ZLEZaangazowaniDBDetailFormUnit.pas' {ZLEZaangazowaniDBDetailForm},
  MEDDataManagerExtUnit in 'R:\Med\MEDDataManagerExtUnit.pas',
  STDefUnit in 'R:\St\STDefUnit.pas',
  STDataManagerUnit in 'R:\St\STDataManagerUnit.pas' {STDataManager: TDataModule},
  ZLEZasobyPracaRapUnit in 'ZLEZasobyPracaRapUnit.pas' {ZLEZasobyPracaRapDataModule: TDataModule},
  ZLEZasobyPracaRapDBGridFormUnit in 'ZLEZasobyPracaRapDBGridFormUnit.pas' {ZLEZasobyPracaRapDBGridForm},
  ZLEZlecenieSANDBGridFormUnit in 'ZLEZlecenieSANDBGridFormUnit.pas' {ZLEZlecenieDBGridForm_SAN},
  SANDataManagerExtUnit in 'R:\SAN\SANDataManagerExtUnit.pas' {SANDataManagerExt: TDataModule},
  ZAMToolsUnit in 'R:\ZAM\ZAMToolsUnit.pas',
  ZLERaportEditUnit in 'ZLERaportEditUnit.pas' {ZLERaportEditDataModule: TDataModule},
  ZLERaportEditDBGridFormUnit in 'ZLERaportEditDBGridFormUnit.pas' {ZLERaportEditDBGridForm},
  ZLEZlecenieUprUnit in 'ZLEZlecenieUprUnit.pas' {ZLEZlecenieUprDataModule: TDataModule},
  ZLEZlecenieUprDBGridFormUnit in 'ZLEZlecenieUprDBGridFormUnit.pas' {ZLEZlecenieUprDBGridForm},
  TSDefUnit in 'R:\TS\TSDefUnit.pas',
  TSDataManagerExtUnit in 'R:\TS\TSDataManagerExtUnit.pas' {TSDataManagerExt: TDataModule},
  ZLEZlecenieUprZakresSelectFormUnit in 'ZLEZlecenieUprZakresSelectFormUnit.pas' {ZLEZlecenieUprZakresSelectForm},
  KOMDefUnit in 'R:\KOM\KOMDefUnit.pas',
  KOMDataManagerExtUnit in 'R:\KOM\KOMDataManagerExtUnit.pas',
  WDSDefUnit in 'R:\WDS\WDSDefUnit.pas',
  WDSDataManagerExtUnit in 'R:\WDS\WDSDataManagerExtUnit.pas',
  ZLETypZleceniaUsersUnit in 'ZLETypZleceniaUsersUnit.pas' {ZLETypZleceniaUsers: TDataModule},
  ZLETypZleceniaUsersDBGridFormUnit in 'ZLETypZleceniaUsersDBGridFormUnit.pas' {ZLETypZleceniaUsersDBGridForm},
  ZLEStatusZleceniaImportSelectFormUnit in 'ZLEStatusZleceniaImportSelectFormUnit.pas' {ZLEStatusZleceniaImportSelectForm};

{$R *.RES}

function DLL_ZLEOdpytajODaneSQL( sTabela, sAtrybuty, sWarunek: string;
                                 bUnikalne: boolean) : string; export;
begin
  result := ZLEDM.ZLEOdpytajODaneSQL( sTabela, sAtrybuty, sWarunek, bUnikalne );
end;

function DLL_ZLEOdpytajODane( sTabela, sAtrybuty, sWarunek: string;
                              bUnikalne: boolean) : TUNIQuery; export;
begin
  result := ZLEDM.ZLEOdpytajODane( sTabela, sAtrybuty, sWarunek, bUnikalne );
end;

function DLL_ZLEZlecenieOtwarte( sSymbol: String; dData: TDate ): Boolean; export;
begin
  result := ZLEDM.ZLEZlecenieOtwarte( sSymbol, dData );
end;

function DLL_ZLEPokazIObsluzDane( sTabela, sAtrybuty, sWarunek: string;
                                  bBlok, bWyborWielu: Boolean;
                                  iModulZSIID: Integer = 0;
                                  iLocateID: integer = 0;
                                  iFirmaID: integer = 0;
                                  sPola: String = '';
                                  oSelected: TStrings = nil;
                                  oLocateContained: TStrings = nil;
                                  oParams: TKeyValues = nil ): TUNIQuery; export;
begin
  result := ZLEDM.ZLEPokazIObsluzDane( sTabela, sAtrybuty, sWarunek, bBlok,
                                       bWyborWielu, iModulZSIID, iLocateID,
                                       iFirmaID, sPola, oSelected,
                                       oLocateContained, oParams );
end;

function DLL_ZLEPokazIObsluzDaneGrid(const oOwner:TComponent; sTabela, sAtrybuty, sWarunek: string;
                                      bBlok, bWyborWielu: Boolean;
                                      iOpenMode: TOpenMode;
                                      iModulZSIID: Integer = 0;
                                      iLocateID: integer = 0;
                                      iFirmaID: integer = 0;
                                      oLocateContained: TStrings = nil;
                                      oParams: TKeyValues = nil;
                                      sSufiksKlasy: String = '' ): TUNIDBGridForm; export;
begin
  result := ZLEDM.ZLEPokazIObsluzDaneGrid(oOwner, sTabela, sAtrybuty, sWarunek, bBlok,
                                           bWyborWielu, iOpenMode, iModulZSIID,
                                           iLocateID, iFirmaID,
                                           oLocateContained, oParams, sSufiksKlasy );
end;

function DLL_ZLEPokazIObsluzTypZlecenia( sAtrybuty, sWarunek: string;
                                         bBlok, bWyborWielu: Boolean;
                                         iModulZSIID: integer = 0;
                                         iLocateID: integer = 0;
                                         iFirmaID: integer = 0): TUNIQuery; export;
begin
  result := ZLEDM.ZLEPokazIObsluzTypZlecenia( sAtrybuty, sWarunek, bBlok,
                                              bWyborWielu, iModulZSIID,
                                              iLocateID, iFirmaID );
end;

function DLL_ZLEPokazIObsluzTypZleceniaGrid(const oOwner:TComponent; sAtrybuty, sWarunek: string;
                                             bBlok, bWyborWielu: Boolean;
                                             iOpenMode: TOpenMode;
                                             iModulZSIID: integer = 0;
                                             iLocateID: integer = 0;
                                             iFirmaID: integer = 0): TUNIDBGridForm; export;
begin
  result := ZLEDM.ZLEPokazIObsluzTypZleceniaGrid(oOwner, sAtrybuty, sWarunek, bBlok,
                                                  bWyborWielu, iOpenMode, iModulZSIID,
                                                  iLocateID, iFirmaID );
end;

function DLL_ZLEPokazIObsluzZlecenia( sAtrybuty, sWarunek: string;
                                      bBlok, bWyborWielu: Boolean;
                                      iModulZSIID: Integer;
                                      iLocateID: integer = 0;
                                      iFirmaID: integer = 0;
                                      oSelected: TStrings = nil;
                                      oLocateContained: TStrings = nil;
                                      oParams: TKeyValues = nil ): TUNIQuery; export;
begin
  result := ZLEDM.ZLEPokazIObsluzZlecenia( sAtrybuty, sWarunek, bBlok, bWyborWielu,
                                           iModulZSIID, iLocateID, iFirmaID,
                                           oSelected, oLocateContained, oParams );
end;

(****************** Ta funkcja jest override
function DLL_UNIPokazIObsluzSlownik(sAtrybuty, sTabela, sPole, sWarunek: string;
                                    iMnemonikID:integer=0): TUNIQuery; export;
begin
  result := ZLEDM.UNIPokazIObsluzSlownik(sAtrybuty, sTabela, sPole, sWarunek,iMnemonikID);
end;
**************************************)

function DLL_ZLEPokazIObsluzZleceniaGrid(const oOwner:TComponent; sAtrybuty, sWarunek: string;
                                          bBlok, bWyborWielu: Boolean;
                                          iOpenMode: TOpenMode;
                                          iModulZSIID: Integer;
                                          iLocateID: integer = 0;
                                          iFirmaID: integer = 0;
                                          oLocateContained: TStrings = nil;
                                          oParams: TKeyValues = nil;
                                          sSufiksKlasy: String = '' ): TUNIDBGridForm; export;
begin
  result := ZLEDM.ZLEPokazIObsluzZleceniaGrid( oOwner, sAtrybuty, sWarunek, bBlok,
                                               bWyborWielu, iOpenMode, iModulZSIID,
                                               iLocateID, iFirmaID,
                                               oLocateContained, oParams,
                                               sSufiksKlasy );
end;

function DLL_ZLEKontrolaZlecenia( iZlecenieID: Integer;
                                  sAtrybuty: string;
                                  bBlok: Boolean;
                                  iModulZSIID: Integer;
                                  iFirmaID: integer = 0): TUNIQuery; export;
begin
  result := ZLEDM.ZLEKontrolaZlecenia( iZlecenieID, sAtrybuty, bBlok,
                                       iModulZSIID, iFirmaID );
end;

function DLL_ZLEKontrolaZleceniaGrid(const oOwner:TComponent; iZlecenieID: Integer;
                                      sAtrybuty: string;
                                      bBlok: Boolean;
                                      iOpenMode: TOpenMode;
                                      iModulZSIID: Integer;
                                      iFirmaID: integer = 0): TUNIDBDetailForm; export;
begin
  result := ZLEDM.ZLEKontrolaZleceniaGrid(oOwner, iZlecenieID, sAtrybuty, bBlok, iOpenMode,
                                           iModulZSIID, iFirmaID );
end;

function DLL_ZLEDopiszZlecenie( const cTypOperacji: TSposobNadaniaGrupy;
                                var iGrupaID: Integer;
                                iTypZleceniaID: Integer;
                                iModulZSIID: Integer;
                                iFirmaID: Integer = 0 ): Integer; export;
begin
  result := ZLEDM.ZLEDopiszZlecenie( cTypOperacji, iGrupaID, iTypZleceniaID,
                                     iModulZSIID, iFirmaID );
end;

function DLL_ZLEKontrolaUnikalnosciElemInf( iTypZleceniaID: Integer;
                                            iInfElementID: Integer;
                                            sPoziomInf: String;
                                            iZlecenieID: Integer): Boolean; export;
begin
  result := ZLEDM.ZLEKontrolaUnikalnosciElemInf(iTypZleceniaID, iInfElementID,
                                                sPoziomInf, iZlecenieID);
end;

function DLL_ZLEDopiszZlecenieGrupujace( iTypZleceniaID, iModulZSIID: Integer;
                                         sSymbol, sNazwa, sOpis: String;
                                         dDataOtwarcia: TDate;
                                         iFirmaID: Integer = 0 ): Integer; export;
begin
  result := ZLEDM.ZLEDopiszZlecenieGrupujace( iTypZleceniaID, iModulZSIID,
                                              sSymbol, sNazwa, sOpis,
                                              dDataOtwarcia, iFirmaID );
end;

function DLL_ZLEDajIdTypElemGrup( iTypZleceniaID: Integer;
                                  iFirmaID: Integer = 0 ): Integer; export;
begin
  result := ZLEDM.ZLEDajIdTypElemGrup( iTypZleceniaID, iFirmaID );
end;

function DLL_ZLEDajIdElemGrup( iZlecenieID: Integer;
                               iFirmaID: Integer = 0 ): Integer; export;
begin
  result := ZLEDM.ZLEDajIdElemGrup( iZlecenieID, iFirmaID );
end;

function DLL_ZLEDajListeSkladTypu( iGrupaID, iTypZleceniaID: Integer;
                                   iFirmaID: Integer = 0 ): TUNIQuery; export;
begin
  result := ZLEDM.ZLEDajListeSkladTypu( iGrupaID, iTypZleceniaID, iFirmaID );
end;

function DLL_ZLEDajListeWartSklad( iGrupaID, iZlecenieID: Integer;
                                   iFirmaID: Integer = 0 ): TUNIQuery; export;
begin
  result := ZLEDM.ZLEDajListeWartSklad( iGrupaID, iZlecenieID, iFirmaID );
end;

function DLL_ZLEZapiszWartSklad(  iGrupaID, iZlecenieID, iZleceniePozID: Integer;
                                  oSkladniki: TZLEListaSkladnikow;
                                  iFirmaID: Integer = 0 ): Boolean; export;
begin
  result := ZLEDM.ZLEZapiszWartSklad( iGrupaID, iZlecenieID, iZleceniePozID,
                                      oSkladniki, iFirmaID );
end;

procedure DLL_ZLEPokazIObsluzDetail(
  const ac_sTabela:     string;
  const ac_iId:         integer;
  const ac_iOpenMode:   TOpenMode;
  const ac_iModulID:    integer;
        a_oParams:      TKeyValues
);  export;
begin
  ZLEDM.ZLEPokazIObsluzDetail(
    ac_sTabela,
    ac_iId,
    ac_iOpenMode,
    ac_iModulID,
    a_oParams
  );
end;

function  DLL_ZLEDopiszZlecenieZPozycjiZapotrzebowan(
  const ac_sZapotrzPozId: string;
  const ac_iTypZlecId:    integer
):  TIntegerArray;
begin
  result  := ZLEDM.ZLEDopiszZlecenieZPozycjiZapotrzebowan(ac_sZapotrzPozId, ac_iTypZlecId);
end;

function  DLL_ZLEDopiszZlecenieZPozycjiZamowien(
  const ac_sZamowieniePozId:string;
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  TIntegerArray;
begin
  result  := ZLEDM.ZLEDopiszZlecenieZPozycjiZamowien(ac_sZamowieniePozId, ac_iTypZlecId);
end;

function  DLL_ZLEDopiszZlecenieNieProdZPozycjiZamowien(
  const ac_iAdmIdFunkId:    integer;
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  integer;  export;
begin
  result  := ZLEDM.ZLEDopiszZlecenieNieProdZPozycjiZamowien(ac_iAdmIdFunkId, ac_iTypZlecId);
end;

function  DLL_ZLEDopiszZlecenieNieProdZPozycjiZapotrzebowan(
  const ac_iAdmIdFunkId:    integer;
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  integer;  export;
begin
  result  := ZLEDM.ZLEDopiszZlecenieNieProdZPozycjiZapotrzebowan(ac_iAdmIdFunkId, ac_iTypZlecId);
end;

function  DLL_ZLEDopiszZlecenieZPozycjiZapytan(
  const ac_sZapytaniePozId: string;
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  TIntegerArray;  export;
begin
  result  := ZLEDM.ZLEDopiszZlecenieZPozycjiZapytan(ac_sZapytaniePozId, ac_iTypZlecId);
end;

function  DLL_ZLEDopiszZlecenieNieProdZPozycjiZapytan(
  const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapyta wejciowych z ktrych ma by utworzone zlecenie
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  integer;  export;
begin
  result  := ZLEDM.ZLEDopiszZlecenieNieProdZPozycjiZapytan(ac_iAdmIdFunkId, ac_iTypZlecId);
end;

//Funkcja dla analiz zwracajca Wartosc pozycji dla okreslonego opisu parametrw
function DLL_ZLEFunAnalizy_ZLEDanePozycji(
                       iFirmaID: integer;
                       sRok, sOpisParametrow: string;
                       var iLiczbaSlownikow:integer;
                       bSymulacja:boolean=false;
                       iAktywnyOkresNr:integer=0;
                       bTylkoNiezerowe:boolean=false;
                       bZestawienieZDokumentami:boolean=false): TUNIQuery; export;
begin
  result := ZLEDM.ZLEFunAnalizy_ZLEDanePozycji(
                       iFirmaID,
                       sRok,
                       sOpisParametrow,
                       iLiczbaSlownikow,
                       bSymulacja,
                       iAktywnyOkresNr,
                       bTylkoNiezerowe,
                       bZestawienieZDokumentami);

end;

function DLL_ZLEDajWartoscPracy(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                RODZAJECP: string = '';
                                RODZAJZASOBU: String = ''): Extended; export;
begin
  result := ZLEDM.ZLEDajWartoscPracy( iZLECENIE_ID, iUNIOKRES_ID, RODZAJECP, RODZAJZASOBU);
end;

function DLL_ZLEDajKosztyZleceniaSzczegolowo(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                             aRodzajKosztow: TZleRodzajKosztow;
                                             a_oParams: TKeyValues  = nil): TUNIQuery; export
begin
  result := ZLEDM.ZLEDajKosztyZleceniaSzczegolowo(iZLECENIE_ID, iUNIOKRES_ID, aRodzajKosztow, a_oParams);
end;

function DLL_ZLEDajKosztyZleceniaSzczegolowoSuma(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                                 a_oParams: TKeyValues  = nil): Extended; Export;
begin
   result := ZLEDM.ZLEDajKosztyZleceniaSzczegolowoSuma(iZLECENIE_ID, iUNIOKRES_ID, a_oParams);
end;

procedure DLL_ZLEPokazZasob(
  const ac_iZasobId:  integer
);  export;
begin
  ZLEDM.ZLEPokazZasob(ac_iZasobId);
end;

function DLL_vZLEDomyslnyStatusZlecenia: String; export;
begin
  result := ZLEDM.vZLEDomyslnyStatusZlecenia;
end;

function DLL_vZLEDomyslnyTypZlecenia: Integer; export;
begin
  result := ZLEDM.vZLEDomyslnyTypZlecenia;
end;

function DLL_vZLEInstalacjeTypZlec: Integer; export;
begin
  result := ZLEDM.vZLEInstalacjeTypZlec;
end;

function DLL_vZLEKosztyMatZakupWlaczone: Boolean; export;
begin
  result := ZLEDM.vZLEKosztyMatZakupWlaczone;
end;

function DLL_vZLEWymaganaOsobaZamykajacaZlecenie: Boolean; export;
begin
  result := ZLEDM.vZLEWymaganaOsobaZamykajacaZlecenie;
end;


function DLL_vZLEPrefixSlownikID: Integer; export;
begin
  result := ZLEDM.vZLEPrefixSlownikID;
end;

function DLL_vZLENumeratorExt: Boolean; export;
begin
  result := ZLEDM.vZLENumeratorExt;
end;

function DLL_vZLEOsobnaNum: Boolean; export;
begin
  result := ZLEDM.vZLEOsobnaNum;
end;

function DLL_vZLESprawyPodpowiadanie: Boolean; export;
begin
  result := ZLEDM.vZLESprawyPodpowiadanie;
end;

function DLL_vZLESprawyKontrahent: String; export;
begin
  result := ZLEDM.vZLESprawyKontrahent;
end;

function DLL_vZLESprawyWydzial: String; export;
begin
  result := ZLEDM.vZLESprawyWydzial;
end;

function DLL_vZLESprawyPrefix: String; export;
begin
  result := ZLEDM.vZLESprawyPrefix;
end;

function DLL_vZLENarzuty: Boolean; export;
begin
  result := ZLEDM.vZLENarzuty;
end;

function DLL_vZLEPoziomNarzutowJednOrg: Boolean; export;
begin
  result := ZLEDM.vZLEPoziomNarzutowJednOrg;
end;

function DLL_vZLEPoziomNarzutowOddzial: Boolean; export;
begin
  result := ZLEDM.vZLEPoziomNarzutowOddzial;
end;

function DLL_vZLEPoziomNarzutowTypZlec: Boolean; export;
begin
  result := ZLEDM.vZLEPoziomNarzutowTypZlec;
end;

function DLL_vZLEZleceniaNadrzedne: Boolean; export;
begin
  result := ZLEDM.vZLEZleceniaNadrzedne;
end;

function DLL_vZLEStawkaRegula: String; export;
begin
  result := ZLEDM.vZLEStawkaRegula;
end;

function DLL_vZLEUnikalnoscElemInf: Boolean; export;
begin
  result := ZLEDM.vZLEUnikalnoscElemInf;
end;

function DLL_vZLEZleceniaBezPozycjiZeSpraw: Boolean; export;
begin
  result := ZLEDM.vZLEZleceniaBezPozycjiZeSpraw;
end;

function DLL_UNIDopiszZlecenie( iTypZleceniaID, iModulZSIID: Integer;
                            sSymbol, sNazwa, sOpis: String;
                            dDataOtwarcia: TDate;
                            dDataZamkniecia: TDate;
                            sStatus: String = cZLEStatusZlecenia_OczekujaceID;
                            iOsobaOdp: Integer = 0;
                            iOsobaStatus: Integer = 0;
                            iUniRok_ID: Integer = 0;
                            iUniJednostkaOrg_ID: Integer = 0;
                            iWykonawca_ID: Integer = 0; //Kontrahent
                            sPotwierdzenie: String = '';
                            iFirmaID: Integer = 0;
                            iInfSiecElementID: Integer = 0;
                            iZleZlecenieGrupaID: Integer = 0 ): Integer; export;
begin
  result:=ZLEDM.UNIDopiszZlecenie( iTypZleceniaID, iModulZSIID,
                            sSymbol, sNazwa, sOpis,
                            dDataOtwarcia,
                            dDataZamkniecia,
                            sStatus,
                            iOsobaOdp,
                            iOsobaStatus,
                            iUniRok_ID,
                            iUniJednostkaOrg_ID,
                            iWykonawca_ID,
                            sPotwierdzenie,
                            iFirmaID,
                            iInfSiecElementID,
                            iZleZlecenieGrupaID);
end;

function DLL_ZLEDajWartoscKryterium(iFirmaID: integer;
            sKryteriaSymbol: string; iFKMnemonikiID: integer; sZakres,
            sKrytPozWartoscTyp, sKryteriaRodzaj: string;
            iOkresID:integer; bAnalizy:boolean = false): TUNIQuery; export;
begin
   result := ZLEDM.ZLEDajWartoscKryterium(iFirmaID,
            sKryteriaSymbol, iFKMnemonikiID, sZakres,
            sKrytPozWartoscTyp, sKryteriaRodzaj,
            iOkresID, bAnalizy);
end;

function DLL_ZLEMnemonikiDlaZlecenia(iZlecenieID : Integer;
                                     var av_aMnem: TaMnemValue): Integer; export;
begin
   result := ZLEDM.ZLEMnemonikiDlaZlecenia(iZlecenieID, av_aMnem);
end;

procedure DLL_ZLEListaMnemonikow(slMnemZle: TStringList;
                                 iFirmaID: Integer = 0); export;
begin
   ZLEDM.ZLEListaMnemonikow(slMnemZle, iFirmaID);
end;

procedure DLL_ZmienStatusZlecenia(
  const ac_iZlecenieId:     integer;
  const ac_sNowyStatus:     string
);
begin
  ZLEDM.ZmienStatusZlecenia(ac_iZlecenieId, ac_sNowyStatus);
end;

function  DLL_ZlecenieWyslaneDoPartnera(
  const ac_iZlecenieId:     integer
):  boolean;  export;
begin
  result  := ZLEDM.ZlecenieWyslaneDoPartnera(ac_iZlecenieId);
end;

function  DLL_RecepturaWyslanaDoPartnera(
  const ac_iRecepturaId:    integer
):  boolean;  export;
begin
  result  := ZLEDM.RecepturaWyslanaDoPartnera(ac_iRecepturaId);
end;

function  DLL_RecepturaPozWyslanaDoPartnera(
  const ac_iRecepturaPozId: integer
):  boolean;  export;
begin
  result  := ZLEDM.RecepturaPozWyslanaDoPartnera(ac_iRecepturaPozId);
end;

function  DLL_PlanProdElWyslanyDoPartnera(
  const ac_iPlanProdElId:   integer
):  boolean;  export;
begin
  result  := ZLEDM.PlanProdElWyslanyDoPartnera(ac_iPlanProdElId);
end;

procedure DLL_WyslijPlanProdukcjiZlec(
  const ac_oZlecIds:            TStringList;
  const ac_sKontekst:           string;
  const ac_oPlanProdElId:       TStringList // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
);  export;
begin
  ZLEDM.WyslijPlanProdukcjiZlec(ac_oZlecIds, ac_sKontekst, ac_oPlanProdElId);
end;

procedure DLL_WycofajPlanProdukcjiZlec(
  const ac_oZlecIds:            TStringList;
  const ac_sKontekst:           string;
  const ac_oPlanProdElId:       TStringList // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
);  export;
begin
  ZLEDM.WycofajPlanProdukcjiZlec(ac_oZlecIds, ac_sKontekst, ac_oPlanProdElId);
end;

function  DLL_MoznaEdytowacZlecenieProdukcyjne(
  const ac_iZlecenieId:       integer
):  string; export;
begin
  result  := ZLEDM.MoznaEdytowacZlecenieProdukcyjne(ac_iZlecenieId);
end;

exports
  DLL_ZLEOdpytajODaneSQL,
  DLL_UNIDopiszZlecenie,
  DLL_ZLEOdpytajODane,
  DLL_ZLEZlecenieOtwarte,
  DLL_ZLEPokazIObsluzDane,
  (********* override
  DLL_UNIPokazIObsluzSlownik,
  ***********************)
  DLL_ZLEPokazIObsluzDaneGrid,
  DLL_ZLEPokazIObsluzTypZlecenia,
  DLL_ZLEPokazIObsluzTypZleceniaGrid,
  DLL_ZLEPokazIObsluzZlecenia,
  DLL_ZLEPokazIObsluzZleceniaGrid,
  DLL_ZLEKontrolaZlecenia,
  DLL_ZLEKontrolaZleceniaGrid,
  DLL_ZLEDopiszZlecenie,
  DLL_ZLEKontrolaUnikalnosciElemInf,
  DLL_ZLEDopiszZlecenieGrupujace,
  DLL_ZLEDajIdTypElemGrup,
  DLL_ZLEDajIdElemGrup,
  DLL_ZLEDajListeSkladTypu,
  DLL_ZLEDajListeWartSklad,
  DLL_ZLEZapiszWartSklad,
  DLL_ZLEDajWartoscPracy,
  DLL_ZLEDajKosztyZleceniaSzczegolowo,
  DLL_ZLEDajKosztyZleceniaSzczegolowoSuma,
  DLL_vZLEDomyslnyStatusZlecenia,
  DLL_vZLEDomyslnyTypZlecenia,
  DLL_vZLENumeratorExt,
  DLL_vZLEPrefixSlownikID,
  DLL_vZLEOsobnaNum,
  DLL_vZLEInstalacjeTypZlec,
  DLL_vZLEWymaganaOsobaZamykajacaZlecenie,
  DLL_vZLEKosztyMatZakupWlaczone,
  DLL_ZLEPokazZasob,
  DLL_ZLEPokazIObsluzDetail,
  DLL_ZLEDajWartoscKryterium,
  DLL_ZLEDopiszZlecenieZPozycjiZapotrzebowan,
  DLL_ZLEDopiszZlecenieZPozycjiZamowien,
  DLL_ZLEDopiszZlecenieNieProdZPozycjiZamowien,
  DLL_ZLEDopiszZlecenieNieProdZPozycjiZapotrzebowan,
  DLL_ZLEDopiszZlecenieZPozycjiZapytan,
  DLL_ZLEDopiszZlecenieNieProdZPozycjiZapytan,
  DLL_vZLESprawyPodpowiadanie,
  DLL_vZLESprawyKontrahent,
  DLL_vZLESprawyWydzial,
  DLL_vZLESprawyPrefix,
  DLL_vZLENarzuty,
  DLL_vZLEPoziomNarzutowJednOrg,
  DLL_vZLEPoziomNarzutowOddzial,
  DLL_vZLEPoziomNarzutowTypZlec,
  DLL_vZLEZleceniaNadrzedne,
  DLL_ZLEMnemonikiDlaZlecenia,
  DLL_ZLEListaMnemonikow,
  DLL_ZmienStatusZlecenia,
  DLL_ZLEFunAnalizy_ZLEDanePozycji,
  DLL_ZlecenieWyslaneDoPartnera,
  DLL_RecepturaWyslanaDoPartnera,
  DLL_RecepturaPozWyslanaDoPartnera,
  DLL_PlanProdElWyslanyDoPartnera,
  DLL_WyslijPlanProdukcjiZlec,
  DLL_WycofajPlanProdukcjiZlec,
  DLL_vZLEStawkaRegula,
  DLL_vZLEUnikalnoscElemInf,
  DLL_MoznaEdytowacZlecenieProdukcyjne,
  DLL_vZLEZleceniaBezPozycjiZeSpraw;

begin
end.
