unit ZLEKontrolaRealizacjiIlosciowejUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-29 gdeyk    Utworzone
}
{$I ..\!\defines.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables, ZLEKontrolaRealizacjiUnit,
  DBClient;

type
  TZLEKontrolaRealizacjiIlosciowejDataModule = class(TZLEKontrolaRealizacjiDataModule)
  protected
    procedure DefineColumns( oQuery: TUNIQuery); override;
    procedure AddRecordsToDataSet( oQueryFrom: TUNIQuery; oDataSetTo: TClientDataSet ); override;
    procedure CreateVirtualQuery(); override;
    function GetTableName: string; override;
    procedure GetKeys; override;
  public
    constructor Create( Owner: TComponent ); override;
    procedure ReOpenDataSets(); override;
  end;

implementation

{$R *.DFM}

uses
  variants,
  Dodatki,
  FormManagerUnit,
  QueryBuilderUnit,
  SQLManagerUnit,
  UNIFormUnit,
  UNIDBGridFormUnit,
  UNIStaleUnit,
  UNISysDefUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  ZLEKontrolaRealizacjiIlosciowejDBGridFormUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;

{ TKontrolaRealizacjiIlosciowejDataModule }

procedure TZLEKontrolaRealizacjiIlosciowejDataModule.AddRecordsToDataSet(
  oQueryFrom: TUNIQuery; oDataSetTo: TClientDataSet);
begin
  with oQueryFrom do begin
    First;
    while not Eof do begin
      try
        if TUniForm(Self.Owner).Parameters.Values['ZLEGRUPOWANIEDANYCH']=sTak then begin
          if oDataSetTo.Locate( sZLEZLECENIEPOZ_ID+';'+sASOASORT_ID,
                                VarArrayOf([ FieldByName(sZLEZLECENIEPOZ_ID).AsInteger,
                                             FieldByName(sASOASORT_ID).AsInteger]), []) then
            oDataSetTo.Edit
          else
            oDataSetTo.Append;

        end else begin
          if oDataSetTo.Locate( sZLEZLECENIEPOZ_ID+';'+sUNIOKRES_ID+';'+sASOASORT_ID,
                                VarArrayOf([ FieldByName(sZLEZLECENIEPOZ_ID).AsInteger,
                                             FieldByName(sUNIOKRES_ID).AsInteger,
                                             FieldByName(sASOASORT_ID).AsInteger]), [] ) then
            oDataSetTo.Edit
          else
            oDataSetTo.Append;
          end;

        if TUniForm(Self.Owner).Parameters.Values['ZLEGRUPOWANIEDANYCH']=sTak then begin
            oDataSetTo.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger := FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
            oDataSetTo.FieldByName(sASOASORT_ID).AsInteger := FieldByName(sASOASORT_ID).AsInteger;
            oDataSetTo.FieldByName(sASOASORT_INDEKS).AsString := FieldByName(sASOASORT_INDEKS).AsString;
            oDataSetTo.FieldByName(sASOASORT_NAZWA).AsString := FieldByName(sASOASORT_NAZWA).AsString;
            oDataSetTo.FieldByName(sZLEZLECENIEPOZ_OPIS).AsString := FieldByName(sZLEZLECENIEPOZ_OPIS).AsString;
            oDataSetTo.FieldByName(sZLEILOPIS_UWAGI).AsString := FieldByName(sZLEILOPIS_UWAGI).AsString;
        end else begin
            oDataSetTo.FieldByName(sUNIOKRES_ID).AsString := FieldByName(sUNIOKRES_ID).AsString;
            oDataSetTo.FieldByName(sUNIOKRES_OKRES_NR).AsString := FieldByName(sUNIOKRES_OKRES_NR).AsString;
            oDataSetTo.FieldByName(sUNIOKRES_NAZWA).AsString := FieldByName(sUNIOKRES_NAZWA).AsString;
            oDataSetTo.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger := FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
            oDataSetTo.FieldByName(sASOASORT_ID).AsInteger := FieldByName(sASOASORT_ID).AsInteger;
            oDataSetTo.FieldByName(sASOASORT_INDEKS).AsString := FieldByName(sASOASORT_INDEKS).AsString;
            oDataSetTo.FieldByName(sASOASORT_NAZWA).AsString := FieldByName(sASOASORT_NAZWA).AsString;
            oDataSetTo.FieldByName(sZLEZLECENIEPOZ_OPIS).AsString := FieldByName(sZLEZLECENIEPOZ_OPIS).AsString;
            oDataSetTo.FieldByName(sZLEILOPIS_UWAGI).AsString := FieldByName(sZLEILOPIS_UWAGI).AsString;
        end;

        if FieldByName(sZLEIL_BLAD).AsString <> cZLEParserBlad_BrakID then begin
//           oDataSetTo.FieldByName( sZLEIL_ILOSC+'_'+FieldByName(sZLESKLADIL_ID).AsString ).AsString := cslZLEParserBlad.Strings[FieldByName(sZLEIL_BLAD).AsInteger];
           oDataSetTo.FieldByName( sZLEIL_ILOSC+'_'+FieldByName(sZLESKLADIL_ID).AsString ).AsFloat := -1; //cslZLEParserBlad.Strings[FieldByName(sZLEIL_BLAD).AsInteger];
           oDataSetTo.FieldByName( sZLEIL_BLAD+'_'+FieldByName(sZLESKLADIL_ID).AsString ).AsString :=
                                FieldByName(sZLEIL_BLAD).AsString;
        end else begin
           oDataSetTo.FieldByName( sZLEIL_ILOSC+'_'+FieldByName(sZLESKLADIL_ID).AsString ).AsFloat :=
                                FieldByName(sZLEIL_ILOSC).AsFloat;
           oDataSetTo.FieldByName( sZLEIL_BLAD+'_'+FieldByName(sZLESKLADIL_ID).AsString ).AsString :=
                                FieldByName(sZLEIL_BLAD).AsString;
        end;
        if FieldByName(sZLESKLADIL_RODZAJ).AsString = cZLERodzajSklad_RecznyID then
          oDataSetTo.FieldByName( sZLEIL_ILOSC+'_'+FieldByName(sZLESKLADIL_ID).AsString ).Tag := clBlue
        else
          oDataSetTo.FieldByName( sZLEIL_ILOSC+'_'+FieldByName(sZLESKLADIL_ID).AsString ).Tag := clWindowText;
        oDataSetTo.Post;
      except
        oDataSetTo.Cancel;
        raise;
      end;
      Next;
    end;
  end;
end;

constructor TZLEKontrolaRealizacjiIlosciowejDataModule.Create(
  Owner: TComponent);
begin
  inherited;
  KontrolaWartosciowa := False;
end;

procedure TZLEKontrolaRealizacjiIlosciowejDataModule.CreateVirtualQuery;
var sWhere: String;
    sSQL, sTmp: String;
begin
  sTmp := '';

  try
    if TUniForm(Owner).Parameters.Values['ZLEGRUPOWANIEDANYCH']=sTak then begin
       sWhere := '('+ sZLEALIAS_ZLEZLECENIEPOZ + '.' + sZLEZLECENIE_ID + ' = ' + (Owner as TUNIForm).Parameters.Values[sZLEZLECENIE_ID]+')';
       if (Owner as TUNIForm).Parameters.Values[sASOASORT_ID] <> '-1' then
          sWhere := sWhere+
                ' and ('+ sZLEALIAS_ZLEZLECENIEPOZ + '.' + sASOASORT_ID + ' = ' + (Owner as TUNIForm).Parameters.Values[sASOASORT_ID]+')';
       if (Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID] <> '-1' then
          sWhere := sWhere+
                ' and (' + sZLEALIAS_IL + '.' + sUNIOKRES_ID + ' = ' + (Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID]+')'
       else if (Owner as TUNIForm).Parameters.Values[sZLETYPZLEC_ILOSCI_OKRES]=sUNICONST_ALTERNATYWA_TAK then begin
         {Zakomentowane - Tomjen - 2010-02-09 - wieloletnie dane w zleceniach}
          {sSubSQL := 'select ok.%s from %s ok where ok.%s=%d';
          sSubSQL := Format( sSubSQL, [ sUNIOKRES_ID, SQLManager.GetTableName(sUNIOKRES),
                                        sUNIROK_ID, vAktywnyRokObrachunkowyID] );
          sWhere := sWhere+
                ' and ('+sZLEALIAS_IL + '.' + sUNIOKRES_ID + ' IN ('+sSubSQL+'))'}
       end;

       sSQL := 'SELECT ' + {sZLEALIAS_IL             + '.' + sZLEIL_ID            + ', ' +}
                           sZLEALIAS_SKLADIL        + '.' + sZLESKLADIL_ID       + ', ' +
                           sZLEALIAS_SKLADIL        + '.' + sZLESKLADIL_NAZWA    + ', ' +
                           sZLEALIAS_SKLADIL        + '.' + sZLESKLADIL_RODZAJ   + ', ' +
                           sZLEALIAS_ZLEZLECENIEPOZ + '.' + sZLEZLECENIEPOZ_ID   + ', ' +
                           sZLEALIAS_ZLEZLECENIEPOZ + '.' + sASOASORT_ID         + ', ' +
                           sZLEALIAS_ZLEZLECENIEPOZ + '.' + sZLEZLECENIEPOZ_OPIS + ', ' +
                           sZLEALIAS_ASORT          + '.' + sASOASORT_INDEKS     + ', ' +
                           sZLEALIAS_ASORT          + '.' + sASOASORT_NAZWA      + ', ' +
                           '(SELECT Max(Nvl(' + sZLEALIAS_ILOPIS + '.' + sZLEILOPIS_UWAGI + ', ' + QuotedStr('') + ')) ' +
                            'FROM %s ILOPIS ' +
                            'WHERE ZLEPOZ.' + sZLEZLECENIEPOZ_ID + ' = ILOPIS.' + sZLEZLECENIEPOZ_ID + ') AS ' + sZLEILOPIS_UWAGI + ', ' +
                           'MAX(' + sZLEALIAS_IL + '.' + sZLEIL_BLAD + ') AS ' + sZLEIL_BLAD+', '+
                           {CASE WHEN SKLADIL.ZLESKLADIL_NIEOKRESOWY = 'T' THEN MAX(IL.ZLEIL_ILOSC) ELSE  SUM(IL.ZLEIL_ILOSC) END AS ZLEIL_ILOSC}
                           'CASE WHEN ' + sZLEALIAS_SKLADIL + '.' + sZLESKLADIL_NIEOKRESOWY  + ' = ' + QuotedStr(sTak) + ' ' +
                                'THEN MAX(' + sZLEALIAS_IL + '.' + sZLEIL_ILOSC + ') ' +
                                'ELSE SUM(' + sZLEALIAS_IL + '.' + sZLEIL_ILOSC + ') ' +
                           'END AS ' + sZLEIL_ILOSC;

       sSQL := sSQL + ' FROM %s IL , %s SKLADIL , %s ZLEPOZ, %s ASORT ' +
                      ' WHERE IL.' + sZLEZLECENIEPOZ_ID + ' = ZLEPOZ.' + sZLEZLECENIEPOZ_ID + ' and ' +
                             'IL.' + sZLESKLADIL_ID + ' = SKLADIL.' + sZLESKLADIL_ID + ' and ' +
                             'ZLEPOZ.' + sASOASORT_ID + ' = ASORT.' + sASOASORT_ID + ' AND ' + sWhere;

       sSQL := sSQL + ' GROUP BY ' + {sZLEALIAS_IL             + '.' + sZLEIL_ID            + ', ' +}
                                     sZLEALIAS_SKLADIL        + '.' + sZLESKLADIL_ID       + ', ' +
                                     sZLEALIAS_SKLADIL        + '.' + sZLESKLADIL_NIEOKRESOWY + ', ' +
                                     sZLEALIAS_SKLADIL        + '.' + sZLESKLADIL_NAZWA    + ', ' +
                                     sZLEALIAS_SKLADIL        + '.' + sZLESKLADIL_RODZAJ   + ', ' +
                                     sZLEALIAS_ZLEZLECENIEPOZ + '.' + sZLEZLECENIEPOZ_ID   + ', ' +
                                     sZLEALIAS_ZLEZLECENIEPOZ + '.' + sASOASORT_ID         + ', ' +
                                     sZLEALIAS_ZLEZLECENIEPOZ + '.' + sZLEZLECENIEPOZ_OPIS + ', ' +
                                     sZLEALIAS_ASORT          + '.' + sASOASORT_INDEKS     + ', ' +
                                     sZLEALIAS_ASORT          + '.' + sASOASORT_NAZWA;

       sSQL := sSQL + ' order by '+ sZLEALIAS_ASORT+'.'+sASOASORT_INDEKS;

       FQuery := SQLManager.CreateQuery( sSQL, [sZLEILOPIS, sZLEIL, sZLESKLADIL, sZLEZLECENIEPOZ, sASOASORT]);
    end else begin
      sWhere := '(@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+(Owner as TUNIForm).Parameters.Values[sZLEZLECENIE_ID]+')';
      if (Owner as TUNIForm).Parameters.Values[sASOASORT_ID] <> '-1' then
         sWhere := sWhere+
                'and(@'+sZLEALIAS_ZLECENIEPOZ_ASORT_ID+'='+(Owner as TUNIForm).Parameters.Values[sASOASORT_ID]+')';
      if (Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID] <> '-1' then
         sWhere := sWhere+
                'and(@'+sZLEALIAS_IL_OKRES_ID+'='+(Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID]+')'
      else if (Owner as TUNIForm).Parameters.Values[sZLETYPZLEC_ILOSCI_OKRES]=sUNICONST_ALTERNATYWA_TAK then begin
         {Zakomentowane - Tomjen - 2010-02-09 - wieloletnie dane w zleceniach}
         {sSubSQL := 'select ok.%s from %s ok where ok.%s=%d';
         sSubSQL := Format( sSubSQL, [ sUNIOKRES_ID, SQLManager.GetTableName(sUNIOKRES),
                                       sUNIROK_ID, vAktywnyRokObrachunkowyID] );
         sWhere := sWhere+
                'and(@'+sZLEALIAS_IL_OKRES_ID+' in ('+sSubSQL+'))'}
      end;

      (**************
      sTmp := sZLEALIAS_IL_ID+';'+
              sZLEALIAS_IL_OKRES_ID+';'+
              sZLEALIAS_OKRES_NR+';'+
              sZLEALIAS_ROK_ID+';'+
              sZLEALIAS_OKRES_NAZWA+';'+
              sZLEALIAS_IL_SKLADIL_ID+';'+
              sZLEALIAS_SKLADIL_NAZWA+';'+
              sZLEALIAS_SKLADIL_RODZAJ+';'+
              sZLEALIAS_ZLECENIEPOZ_ID+';'+
              sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
              sZLEALIAS_ZLECENIEPOZ_OPIS+';'+
              sZLEALIAS_ILOPIS_OKRES_ID+';'+
              sZLEALIAS_ILOPIS_UWAGI+';'+
              sZLEALIAS_ASORT_INDEKS+';'+
              sZLEALIAS_ASORT_NAZWA+';'+
              sZLEALIAS_IL_BLAD+';'+
              sZLEALIAS_IL_ILOSC;

      sSQL := ZLEDM.ZLEOdpytajODaneSQL( sZLEIL,
                                        sTmp,
                                        sWhere,
                                        true );
      ******************************************)

      sSQL := 'SELECT distinct ' +
                'IL.' + sZLEIL_ID + ', ' +
                'IL.' + sUNIOKRES_ID + ', ' +
                'OKRES.'  + sUNIOKRES_DATA_POCZ + ', ' +
                //'OKRES.' + sUNIOKRES_OKRES_NR + ', ' +
                'RK.' + sUNIROK_ROK_TEXT + '|| LPAD(' + 'OKRES.' + sUNIOKRES_OKRES_NR + ', 2, 0) AS ' + sUNIOKRES_OKRES_NR + ', ' +
                'OKRES.' + sUNIOKRES_NAZWA + '||' + QuotedStr(' ') + '|| RK.' + sUNIROK_ROK_TEXT + ' AS ' + sUNIOKRES_NAZWA + ', ' +
                'IL.' + sZLESKLADIL_ID + ', ' +
                'SKLADIL.'  + sZLESKLADIL_NAZWA + ', ' +
                'SKLADIL.' + sZLESKLADIL_RODZAJ + ', ' +
                'ZLEPOZ.' + sZLEZLECENIEPOZ_ID + ', ' +
                'ZLEPOZ.' + sASOASORT_ID + ', ' +
                'ZLEPOZ.' + sZLEZLECENIEPOZ_OPIS + ', ' +
                'ILOPIS.' + sUNIOKRES_ID + ', ' +
                'ILOPIS.' + sZLEILOPIS_UWAGI + ', ' +
                'ASORT.' + sASOASORT_INDEKS + ', ' +
                'ASORT.' + sASOASORT_NAZWA + ', ' +
                'IL.' + sZLEIL_BLAD + ', ' +
                'IL.' + sZLEIL_ILOSC + ' ' +
              'FROM ' +
                '%s IL, ' +
                '%s OKRES, ' +
                '%s RK, ' +
                '%s SKLADIL, ' +
                '%s ZLEPOZ, ' +
                '%s ILOPIS, ' +
                '%s ASORT ' +
              'WHERE IL.' + sZLEZLECENIEPOZ_ID + ' = ZLEPOZ.' + sZLEZLECENIEPOZ_ID +
                ' AND IL.' + sUNIOKRES_ID + ' = OKRES.' + sUNIOKRES_ID + '(+)' +
                ' AND OKRES.' + sUNIROK_ID + ' = RK.' + sUNIROK_ID +
                ' AND IL.' + sZLESKLADIL_ID + ' = SKLADIL.' + sZLESKLADIL_ID +
                ' AND IL.' + sZLEZLECENIEPOZ_ID + ' = ILOPIS.' + sZLEZLECENIEPOZ_ID + '(+)' +
                ' AND IL.' + sUNIOKRES_ID + ' = ILOPIS.' + sUNIOKRES_ID + '(+)' +
                ' AND ZLEPOZ.' + sASOASORT_ID + ' = ASORT.' + sASOASORT_ID +
                ' AND ZLEPOZ.' + sZLEZLECENIE_ID + ' = ' + (Owner as TUNIForm).Parameters.Values[sZLEZLECENIE_ID];

      if (Owner as TUNIForm).Parameters.Values[sASOASORT_ID] <> '-1' then
         sSQL := sSQL + ' AND ZLEPOZ.' + sASOASORT_ID + ' = ' + (Owner as TUNIForm).Parameters.Values[sASOASORT_ID];

      if (Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID] <> '-1' then
         sSQL := sSQL + ' AND IL.' + sUNIOKRES_ID + ' = ' + (Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID];

      sSQL := sSQL + ' order by '+sZLEALIAS_OKRES+'.'+sUNIOKRES_DATA_POCZ+','+
                   sZLEALIAS_ASORT+'.'+sASOASORT_INDEKS;

      FQuery := SQLManager.CreateQuery( sSQL,
                                        [sZLEIL, sUNIOKRES, sUNIROK, sZLESKLADIL,
                                         sZLEZLECENIEPOZ, sZLEILOPIS, sASOASORT] );
    end;

    if FQuery <> nil then
       FQuery.Open;
    inherited;
    if (ActiveQuery <> nil)and(ActiveQuery.FindField(sASOASORT_INDEKS) <> nil) then
      ActiveQuery.FieldByName(sASOASORT_INDEKS).EditMask := ASODM.vAsoMaskaIndeksu+';0;_';
  finally
    if FQuery <> nil then FreeAndNil(FQuery);
  end;
end;

procedure TZLEKontrolaRealizacjiIlosciowejDataModule.DefineColumns(
  oQuery: TUNIQuery);
var iIndex: Integer;
begin
  //ustawienie kolumn dla Grida
  with GridColDefs do begin
    //dorzucenie nie istniejcych kolumn

    {Czy okres_id mozna tez wyrzucic jak jest grupowanie?}
    if IndexOfFieldName(sUNIOKRES_ID) = -1 then
       AddRequired( sUNIOKRES_ID, 'M', 'OkresId', False, taLeftJustify, 0, uftInteger );

    if not (TUniForm(Owner).Parameters.Values['ZLEGRUPOWANIEDANYCH']=sTak) then begin
      if IndexOfFieldName(sUNIOKRES_OKRES_NR) = -1 then
        Add( sUNIOKRES_OKRES_NR, 'O', 'Nr Okresu',    False, True, taLeftJustify, 50, uftString);
      if IndexOfFieldName(sUNIOKRES_DATA_POCZ) = -1 then
        Add( sUNIOKRES_DATA_POCZ, 'O', 'Pocztek okresu', False, True, taLeftJustify, 60, uftDate);
      if IndexOfFieldName(sUNIOKRES_NAZWA) = -1 then
        Add( sUNIOKRES_NAZWA,    'O', 'Okres',        False, True, taLeftJustify, 50, uftString);
    end;
    if IndexOfFieldName(sZLEZLECENIEPOZ_ID) = -1 then
      AddRequired( sZLEZLECENIEPOZ_ID, 'M', 'ZleceniePozID', False, taLeftJustify, 0, uftInteger);
    if IndexOfFieldName(sASOASORT_ID) = -1 then
      AddRequired( sASOASORT_ID, 'M', 'AsortymentID', False, taLeftJustify, 0, uftInteger);


    {procedure Add( AFieldName,ACorrel,AName: string; AActive,AVisible: boolean;
                   AAlignment :TAlignment; AWidth: integer; ATyp : TUNIFieldType = uftUnknown;
                   AForceField: Boolean = False; AFieldFormat: string = '' );}

    if IndexOfFieldName(sASOASORT_INDEKS) = -1 then
      Add( sASOASORT_INDEKS,   'A', 'Asortyment',   False, True, taLeftJustify, 100, uftString);
    if IndexOfFieldName(sASOASORT_NAZWA) = -1 then
      Add( sASOASORT_NAZWA,    'A', 'Nazwa Asort.', False, True, taLeftJustify, 100, uftString);
    if IndexOfFieldName(sZLEZLECENIEPOZ_OPIS) = -1 then
      Add( sZLEZLECENIEPOZ_OPIS, 'M', 'Opis',       False, True, taLeftJustify, 150, uftString);
    if IndexOfFieldName(sZLEILOPIS_UWAGI) = -1 then
      Add( sZLEILOPIS_UWAGI,   'M', 'Uwagi',        False, True, taLeftJustify, 150, uftString);

{    if IndexOfFieldName(sUNIOKRES_OKRES_NR) = -1 then
      AddRequired( sUNIOKRES_OKRES_NR, 'O', 'Nr Okresu', True, taLeftJustify, 50, uftInteger);
    if IndexOfFieldName(sUNIOKRES_NAZWA) = -1 then
      AddRequired( sUNIOKRES_NAZWA, 'O', 'Okres', True, taLeftJustify, 50, uftString);

    if IndexOfFieldName(sASOASORT_INDEKS) = -1 then
      AddRequired( sASOASORT_INDEKS, 'A', 'Asortyment', True, taLeftJustify, 100, uftString);
    if IndexOfFieldName(sASOASORT_NAZWA) = -1 then
      AddRequired( sASOASORT_NAZWA, 'A', 'Nazwa Asort.', True, taLeftJustify, 100, uftString);
    if IndexOfFieldName(sZLEZLECENIEPOZ_OPIS) = -1 then
      AddRequired( sZLEZLECENIEPOZ_OPIS, 'M', 'Opis', True, taLeftJustify, 150, uftString);
    if IndexOfFieldName(sZLEILOPIS_UWAGI) = -1 then
      AddRequired( sZLEILOPIS_UWAGI, 'M', 'Uwagi', True, taLeftJustify, 150, uftString);}
    oQuery.First;
    while not oQuery.Eof do begin
      if IndexOfFieldName( sZLEIL_ILOSC+'_'+oQuery.FieldByName(sZLESKLADIL_ID).AsString ) = -1 then
        AddRequired( sZLEIL_ILOSC+'_'+
                     oQuery.FieldByName(sZLESKLADIL_ID).AsString, 'M',
                     oQuery.FieldByName(sZLESKLADIL_NAZWA).AsString,
                     True, taRightJustify, 100, uftFloat {uftString});
      if IndexOfFieldName( sZLEIL_BLAD+'_'+oQuery.FieldByName(sZLESKLADIL_ID).AsString ) = -1 then
        AddRequired( sZLEIL_BLAD+'_'+
                     oQuery.FieldByName(sZLESKLADIL_ID).AsString, 'M',
                     'Bd ' + oQuery.FieldByName(sZLESKLADIL_NAZWA).AsString,
                     False, taRightJustify, 100, uftString );
      oQuery.Next;
    end;
    //wyrzucenie kolumn ju nie potrzebnych
    for iIndex := Count-1 downto 0 do begin
      if (Pos( sZLEIL_ILOSC, Items[iIndex].FieldName) > 0)and
         (not oQuery.Locate( sZLESKLADIL_ID,
                             Copy( Items[iIndex].FieldName,
                                   Length(sZLEIL_ILOSC+'_')+1,
                                   Length(Items[iIndex].FieldName)), [] )) then begin
        Delete(iIndex);
      end else
      if (Pos( sZLEIL_BLAD, Items[iIndex].FieldName) > 0)and
         (not oQuery.Locate( sZLESKLADIL_ID,
                             Copy( Items[iIndex].FieldName,
                                   Length(sZLEIL_BLAD+'_')+1,
                                   Length(Items[iIndex].FieldName)), [] )) then begin
        Delete(iIndex);
      end;
    end;
  end;
end;

procedure TZLEKontrolaRealizacjiIlosciowejDataModule.GetKeys;
begin
//  inherited;
  with FKeys do begin
    AddPrimary(sZLEZLECENIEPOZ_ID);
    Add(sASOASORT_ID);
    if not (TUniForm(Self.Owner).Parameters.Values['ZLEGRUPOWANIEDANYCH']=sTak) then
       Add(sUNIOKRES_ID);
  end;
end;

function TZLEKontrolaRealizacjiIlosciowejDataModule.GetTableName: string;
begin
  result := sZLEIL;
end;

procedure TZLEKontrolaRealizacjiIlosciowejDataModule.ReOpenDataSets;
var iOkresID, iAsortID, iZlePozID: Integer;
begin
  iOkresID  := 0;
  if not (TUniForm(Self.Owner).Parameters.Values['ZLEGRUPOWANIEDANYCH']=sTak) then
     iOkresID  := 0;
     
  iAsortID  := 0;
  iZlePozID := 0;
  if ActiveQuery <> nil then begin
    if not (TUniForm(Self.Owner).Parameters.Values['ZLEGRUPOWANIEDANYCH']=sTak) then
       iOkresID  := ActiveQuery.FieldByName(sUNIOKRES_ID).AsInteger;
    iAsortID  := ActiveQuery.FieldByName(sASOASORT_ID).AsInteger;
    iZlePozID := ActiveQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
  end;
  inherited;

  if Owner is TZLEKontrolaRealizacjiIlosciowejDBGridForm then
     TZLEKontrolaRealizacjiIlosciowejDBGridForm(Owner).UstalWidocznosc();

  if ActiveQuery <> nil then
    if TUniForm(Self.Owner).Parameters.Values['ZLEGRUPOWANIEDANYCH']=sTak then begin
        ActiveQuery.Locate( sZLEZLECENIEPOZ_ID+';'+sASOASORT_ID,
                            VarArrayOf([iZlePozID,iAsortID]), []);

    end else begin
        ActiveQuery.Locate( sZLEZLECENIEPOZ_ID+';'+sUNIOKRES_ID+';'+sASOASORT_ID,
                            VarArrayOf([iZlePozID,iOkresID,iAsortID]), []);
    end;
end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiIlosciowejDataModule,
                            'Modu danych dla kontroli ilociowej', sZLEModulID );

end.
