unit ZLEKontrolaRealizacjiRecznaWartosciowaSelectFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLEKontrolaRealizacjiRecznaSelectFormUnit, Menus, UNIComponentsUnit, Db,
  StdCtrls, ToolWin, ComCtrls, ExtCtrls, UNIDBConstComboBoxUnit;

type
  TZLEKontrolaRealizacjiRecznaWartosciowaSelectForm = class(TZLEKontrolaRealizacjiRecznaSelectForm)
  private
    { Private declarations }
  protected
    procedure WczytajSkladnikiKontroli(oSkladniki, oWartosci: TConstStringList); override;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;

{ TZLEKontrolaRealizacjiRecznaWartosciowaSelectForm }

procedure TZLEKontrolaRealizacjiRecznaWartosciowaSelectForm.WczytajSkladnikiKontroli;
var oQuery: TUNIQuery;
begin
  oQuery := nil;

  try
    oQuery := ZLEDM.ZLEOdpytajODane( sZLEWART,
                                     sZLEALIAS_WART_SKLADWART_ID+';'+
                                     sZLEALIAS_SKLADWART_NAZWA+';'+
                                     sZLEALIAS_WART_WARTOSC,
                                     '(@'+sZLEALIAS_WART_OKRES_ID+'='+Parameters.Values[sUNIOKRES_ID]+')and'+
                                     '(@'+sZLEALIAS_WART_ZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID]+')and'+
                                     '(@'+sZLEALIAS_SKLADWART_RODZAJ+'='+QuotedStr(cZLERodzajSklad_RecznyID)+')',
                                     false );
    if oQuery <> nil then with oQuery do begin
      while not Eof do begin
        oSkladniki.Add( FieldByName(sZLESKLADWART_NAZWA).AsString,
                        FieldByName(sZLESKLADWART_ID).AsString );
        if not FieldByName(sZLEWART_WARTOSC).IsNull then
          oWartosci.Add( FieldByName(sZLEWART_WARTOSC).AsString,
                         FieldByName(sZLESKLADWART_ID).AsString );
        Next;
      end;
    end;
  finally
    if oQuery <> nil then oQuery.Free;
  end;
  inherited;
end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiRecznaWartosciowaSelectForm,
                            'Edycja skadnika wartociowego dla realizacji',
                            sZLEModulID );

end.
