unit ZLEParametryTreeFormUnit;

{ Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who        What
---------------------------------------------------------------------------------------------
2009-09-04 kdudkowski Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIParametersTreeFormUnit, Menus, UNIComponentsUnit, ComCtrls, ExtCtrls,
  ToolWin, StdCtrls;

type
  TZLEParametryTreeForm = class(TUNIParametersTreeForm)
  protected
    procedure InternalOpen; override;
  end;


implementation
uses
  ZLEDefUnit,
  FormManagerUnit,
  KeyManagerUnit;

{$R *.DFM}

{ TZLEParametryTreeForm }




procedure TZLEParametryTreeForm.InternalOpen;
var
  oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty;
  if parameters <> nil then
    oParams.Assign(parameters);
  AddParametersForm('Zlecenia', 'TZLEParametrySelectForm', oParams);
end;

initialization
  FormManager.RegisterForm(TZLEParametryTreeForm, sZLEModulID);

end.
