unit ZLEPlRozDefUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When         Who      What
---------------------------------------------------------------------------------------------
2006-10-05 Tomjen     Utworzone
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEPlRozDefDataModule = class(TUNIDataModule)
  private
 //   idx: integer;
 //   procedure ChangeMasterKey;
  protected
    procedure GetKeys; override;
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    procedure ReOpenDataSets; override;
  end;


implementation

uses ZLEDefUnit, SQLManagerUnit, UNIStaleUnit, QueryBuilderUnit, PLLIDefUnit;

{$R *.DFM}

{ TZLEPlRozDefDataModule }

{procedure TZLEPlRozDefDataModule.ChangeMasterKey;
begin
  GridJoinDefs.ExchangeCondition(idx,'AK.'+MasterKeyValues[0],true);
end;}

procedure TZLEPlRozDefDataModule.GetKeys;
begin
    with FKeys do begin
        Clear;
        AddPrimary(sZLEPlRozDef_ID);
    end;
end;

function TZLEPlRozDefDataModule.GetTableName: string;
begin
  Result:=sZLEPlRozDef;
end;

procedure TZLEPlRozDefDataModule.InitializeGridQueryDefs;
begin
  with GridColDefs do begin
    Clear;
    Add(sPLROZDEF_SYMBOL     ,'P' , 'Symbol' , true, true, taLeftJustify , 100);
    Add(sPLROZDEF_NAZWA      ,'P' , 'Nazwa'  , true, true, taLeftJustify , 200);
    AddRequiredAndUnvisible(sZLEPLROZDEF_ID, 'Z', '');
    AddRequiredAndUnvisible(sPLROZDEF_ID, 'Z', '');

  end;  // with GridColDefs
  with GridTabDefs do begin
    Clear;
    Add('Z' , GetTableName);
    Add('P' , sPLROZDEF);

  end;  // with GridTabDefs
  with GridJoinDefs do Begin
    Clear;
    AddExpres('Z.' + sPLROZDEF_ID + ' = P.' + sPLROZDEF_ID, qjkInner, false);
  end;  // with GridJoinDefs
  inherited;

end;

procedure TZLEPlRozDefDataModule.ReOpenDataSets;
begin
 // ChangeMasterKey;
  inherited;
end;

end.
