unit ZLERaportEditDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2010-09-08 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, ExtCtrls, UNIComponentsUnit, Db, DBTables, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  UNIStaleUnit, UNIDataModuleUnit;

type
  TZLERaportEditDBGridForm = class(TUNIDBGridForm)
  protected
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
  public
    procedure InternalOpen(); override;
  end;

var
  ZLERaportEditDBGridForm: TZLERaportEditDBGridForm;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  SecurityManagerUnit,
  KeyManagerUnit,
  ZLEDefUnit,
  ZleRaportEditUnit,
  UNISysDefUnit;

function TZleRaportEditDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZleRaportEditDataModule.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZleRaportEditDBGridForm.InternalOpen;
begin
  if Parameters <> nil then
     if Parameters.Values[cFORM_CAPTION] <> '' then
        Caption := Parameters.Values[cFORM_CAPTION];
  inherited;
end;

procedure TZleRaportEditDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(False);
    Switch_Open_HotKey(False);
    Switch_New_HotKey(False);
    Switch_Delete_HotKey(False);
  end;
end;

initialization
  FormManager.RegisterForm( TZleRaportEditDBGridForm, 'Lista raportw do poprawy', sZLEModulID );
end.
