unit ZLESkladnikKontroliIlosciowejDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLESkladnikKontroliDBGridFormUnit, Db, DBTables, UNIComponentsUnit,
  URDataSet, UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls,
  DBCtrls, ToolWin, ExtCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZLESkladnikKontroliIlosciowejDBGridForm = class(TZLESkladnikKontroliDBGridForm)
  private
    procedure InitializeControls();
  protected
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
  public
    procedure InternalOpen(); override;
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  SecurityManagerUnit,
  ZLEDefUnit,
  ZLESkladnikKontroliIlosciowejUnit;
  
{ TZLESkladnikKontroliIlosciowejDBGridForm }

function TZLESkladnikKontroliIlosciowejDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLESkladnikKontroliIlosciowejDataModule.CreateOpen( Self, DefaultMasterKeyValues, AOpenMode ); 
end;

procedure TZLESkladnikKontroliIlosciowejDBGridForm.InitializeControls;
begin

end;

procedure TZLESkladnikKontroliIlosciowejDBGridForm.InternalOpen;
begin
  InitializeControls();

  inherited;

  FNazwaKlasy := cKlasaSkladnikIlosciowy;

end;

procedure TZLESkladnikKontroliIlosciowejDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_SKL_KONTR_IL_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_SKL_KONTR_IL_DOPISZ));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_SKL_KONTR_IL_ZMIEN));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_SKL_KONTR_IL_USUN));
  end;
end;

initialization
  FormManager.RegisterForm( TZLESkladnikKontroliIlosciowejDBGridForm,
                            'Lista skadnikw kontroli ilociowej',
                            sZLEModulID );

end.
