unit ZLETypZleceniaDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
2005-12-20 Tomjen   Pola uzytkownika
2007-07-31 Adam     Pole sZLETYPZLEC_PRODUKCYJNE
2007-09-26 Adam     Moliwo czenia z zasobami wymuszana dla zlece produkcyjnych
2008-01-16 gdeyk    Ustawienie wymagalnoci pola wykonawca dla typw zlece z systemu SANIPOR
2008-03-12 Adam     Pole sZLETYPZLEC_WYMAG_RECEP
2012-06-12 Adam     Parametr Typ automatycznie tworzonego zapotrzebowania
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, DBCtrls, Mask, ZLEDefUnit,
  UNIDBConstComboBoxUnit, UNISimpleEditorUnit;

type
  TZLETypZleceniaDBDetailForm = class(TUNIDBDetailForm)
    InformacjeOgolnePanel: TUNIPanel;
    SymbolLabel: TUNILabel;
    NazwaLabel: TUNILabel;
    NumeratorLabel: TUNILabel;
    SymbolDBEdit: TUNIDBEdit;
    NazwaDBEdit: TUNIDBEdit;
    NumeratorDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    GrupujacyDBCheckBox: TUNIDBCheckBox;
    TypGrupyLabel: TUNILabel;
    TypGrupyDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    TypGrupyNazwaLabel: TUNILabel;
    ModulLabel: TUNILabel;
    ModulDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    ModulNazwaLabel: TUNILabel;
    ParametryPageControl: TUNIPageControl;
    SkladnikiKontroliTabSheet: TTabSheet;
    KontrolaKosztowPanel: TUNIPanel;
    KontrolaKosztowGroupBox: TUNIGroupBox;
    KontrolaKosztowDBCheckBox: TUNIDBCheckBox;
    KontrolaKosztowOkresowaDBCheckBox: TUNIDBCheckBox;
    SkladnikiKontroliKosztowGroupBox: TUNIGroupBox;
    KontrolaKosztowContaindFormPanel: TUNIPanel;
    RightKontrolaKosztowPanel: TUNIPanel;
    DodajSkladnikKosztowButton: TUNIButton;
    UsunSkladnikKosztowButton: TUNIButton;
    KontrolaIlosciowaSplitter: TUNISplitter;
    KontrolaRealizacjiPanel: TUNIPanel;
    KontrolaRealizacjiGroupBox: TUNIGroupBox;
    KontrolaIlosciowaDBCheckBox: TUNIDBCheckBox;
    KontrolaIlosciowaOkresowaDBCheckBox: TUNIDBCheckBox;
    SkladnikiKontroliIlosciowejGroupBox: TUNIGroupBox;
    KontrolaIlosciContaindFormPanel: TUNIPanel;
    RightKontrolaIlosciPanel: TUNIPanel;
    DodajSkladnikIlosciButton: TUNIButton;
    UsunSkladnikIlosciButton: TUNIButton;
    RemontyTabSheet: TTabSheet;
    ParametryOgolneTabSheet: TTabSheet;
    ParametryRemontyGroupBox: TUNIGroupBox;
    NieruchomoscLabel: TUNILabel;
    BudynekLabel: TUNILabel;
    LokalLabel: TUNILabel;
    KlatkaLabel: TUNILabel;
    UlicaLabel: TUNILabel;
    ZasobLabel: TUNILabel;
    ElementSieciLabel: TUNILabel;
    NieruchomoscDBConstComboBox: TUNIDBConstComboBox;
    BudynekDBConstComboBox: TUNIDBConstComboBox;
    LokalDBConstComboBox: TUNIDBConstComboBox;
    KlatkaDBConstComboBox: TUNIDBConstComboBox;
    UlicaDBConstComboBox: TUNIDBConstComboBox;
    ZasobDBConstComboBox: TUNIDBConstComboBox;
    ElementSieciDBConstComboBox: TUNIDBConstComboBox;
    ParametryOgolneGroupBox: TUNIGroupBox;
    WykonawcaLabel: TUNILabel;
    OpisLabel: TUNILabel;
    WykonawcaDBConstComboBox: TUNIDBConstComboBox;
    OpisDBConstComboBox: TUNIDBConstComboBox;
    WydzialLabel: TUNILabel;
    WydzialDBConstComboBox: TUNIDBConstComboBox;
    ZasobyDBCheckBox: TUNIDBCheckBox;
    ParametryPozycjiTabSheet: TTabSheet;
    RegulaLabel: TUNILabel;
    PowiazaniePozycjiLabel: TUNILabel;
    PowiazanieDBConstComboBox: TUNIDBConstComboBox;
    RegulaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    PoziomINFLabel: TUNILabel;
    PoziomINFDBConstComboBox: TUNIDBConstComboBox;
    ElementINFDBCheckBox: TUNIDBCheckBox;
    DomyslaNazwaZleceniaLabel: TUNILabel;
    DomyslnaNazwaZleceniaDBEdit: TUNIDBEdit;
    DomDataOtwDBCheckBox: TUNIDBCheckBox;
    NaPodstDokMagDBCheckBox: TUNIDBCheckBox;
    UwagiDBCheckBox: TUNIDBCheckBox;
    ProdukcyjneDBCheckBox: TUNIDBCheckBox;
    RecepturaDBCheckBox: TUNIDBCheckBox;
    SuffixDefinicjaGroupBox: TUNIGroupBox;
    SuffixPanel: TUNIPanel;
    PolaUzNewTabSheet: TTabSheet;
    PolaUzPozNewTabSheet: TTabSheet;
    PolaUzNewPanel: TUNIPanel;
    PolaUzPozNewPanel: TUNIPanel;
    OddzialPanel: TUNIPanel;
    OddzialLabel: TUNILabel;
    OddzialNazwaLabel: TUNILabel;
    OddzialDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    ZmienSkladnikKosztowButton: TUNIButton;
    ZmienSkladnikIlosciButton: TUNIButton;
    PojazdLabel: TUNILabel;
    PojazdDBConstComboBox: TUNIDBConstComboBox;
    ProcentUELabel: TUNILabel;
    ProcentUEDBConstComboBox: TUNIDBConstComboBox;
    SkladnikElemSieciLabel: TUNILabel;
    SkladnikElemSieciDBConstComboBox: TUNIDBConstComboBox;
    BramaLabel: TUNILabel;
    BramaDBConstComboBox: TUNIDBConstComboBox;
    RejonLabel: TUNILabel;
    RejonDBConstComboBox: TUNIDBConstComboBox;
    ElemInfZleceniaDBCheckBox: TUNIDBCheckBox;
    PoziomINFZlecLabel: TUNILabel;
    PoziomInfZlecDBConstComboBox: TUNIDBConstComboBox;
    PunktLabel: TUNILabel;
    PunktDBConstComboBox: TUNIDBConstComboBox;
    UprawnieniUzytkownicyTabSheet: TTabSheet;
    WlaczObslugeUprawnionychPanel: TUNIPanel;
    AuthorisedUsersUNIDBCheckBox: TUNIDBCheckBox;
    AuthorisedUsersPanel: TUNIPanel;
    AuthorisedUsersControlPanel: TUNIPanel;
    AddUserButton: TUNIButton;
    DeleteUserButton: TUNIButton;
    WyslijDoSystemuPartneraDBCheckBox: TUNIDBCheckBox;
    UmowaLabel: TUNILabel;
    UmowaDBConstComboBox: TUNIDBConstComboBox;
    ZAOGroupBox: TUNIGroupBox;
    UNILabel1: TUNILabel;
    ZAOZapotrzTypLookupAliasEdit: TUNILookupAliasEdit;
    LZAOZapotrzTypLabel: TUNILabel;
    procedure DodajSkladnikKosztowButtonClick(Sender: TObject);
    procedure DodajSkladnikIlosciButtonClick(Sender: TObject);
    procedure UsunSkladnikKosztowButtonClick(Sender: TObject);
    procedure UsunSkladnikIlosciButtonClick(Sender: TObject);
    function NumeratorDBLookupAliasEditGetDataField: String;
    function NumeratorDBLookupAliasEditGetQuery: TUNIQuery;
    procedure NumeratorDBLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure NumeratorDBLookupAliasEditDelKey(Sender: TObject);
    procedure KontrolaKosztowDBCheckBoxClick(Sender: TObject);
    procedure KontrolaIlosciowaDBCheckBoxClick(Sender: TObject);
    function TypGrupyDBLookupAliasEditGetDataField: String;
    procedure TypGrupyDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function TypGrupyDBLookupAliasEditGetQuery: TUNIQuery;
    procedure GrupujacyDBCheckBoxClick(Sender: TObject);
    procedure TypGrupyDBLookupAliasEditDelKey(Sender: TObject);
    function TypGrupyDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    function ModulDBLookupAliasEditGetDataField: String;
    function ModulDBLookupAliasEditGetQuery: TUNIQuery;
    procedure ModulDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function ModulDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure ParametrDBConstComboBoxChange(Sender: TObject);
    procedure ModulDBLookupAliasEditDelKey(Sender: TObject);
    function RegulaDBLookupAliasEditGetDataField: String;
    function RegulaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure RegulaDBLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure ElementINFDBCheckBoxClick(Sender: TObject);
    procedure NaPodstDokMagDBCheckBoxClick(Sender: TObject);
    procedure UwagiDBCheckBoxClick(Sender: TObject);
    procedure ProdukcyjneDBCheckBoxClick(Sender: TObject);
    function OddzialDBLookupAliasEditGetQuery: TUNIQuery;
    procedure OddzialDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function OddzialDBLookupAliasEditGetDataField: String;
    procedure OddzialDBLookupAliasEditDelKey(Sender: TObject);
    function OddzialDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure ZmienSkladnikKosztowButtonClick(Sender: TObject);
    procedure ZmienSkladnikIlosciButtonClick(Sender: TObject);
    procedure ElemInfZleceniaDBCheckBoxClick(Sender: TObject);
    procedure PoziomInfZlecDBConstComboBoxChange(Sender: TObject);
    procedure AddUserButtonClick(Sender: TObject);
    procedure DeleteUserButtonClick(Sender: TObject);
    procedure ZAOZapotrzTypLookupAliasEditButtonClick(Sender: TObject);
    procedure ZAOZapotrzTypLookupAliasEditDelKey(Sender: TObject);
    function ZAOZapotrzTypLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
  private
    {Defincja suffixu}
    qMnem:               TUNIQuery;
    sSuffix:             String;
    iDlugText:           Integer;
    bWywolaniezPoziom:   Boolean;
    bWywolaniezParametr: Boolean;
    bInit:               Boolean;
    iAuthorisedUsersFormIdx: Integer;
    FRichEdit1:          TUNISimpleEditorRichEdit;
    FOperationList1:     TUNIStringList;
    Pozycja1 : Integer;

    iKontrolaKosztowFormIndex: Integer;
    iKontrolaIlosciFormIndex: Integer;

    //iSuffixFormIndex: Integer;
    iPolaUzNewFormIndex: Integer;
    iPolaUzPozNewFormIndex: Integer;
    oSkladnikiKontroliKosztow: TListaSkladnikowKontroli;
    oSkladnikiKontroliIlosci: TListaSkladnikowKontroli;

    {Funkcje do obslugi suffixw}
    function  GetFunctionsList1(const oCurrFunction: TUNIFunction;
                               var   sWholeCurrParam: string;
                               var   sCurrWord: string;
                               const sPrevWord: string;
                               const cSeparator: char;
                               var   sWordToInsert: string;
                               bShowList: boolean): TUNIStringList;
    procedure GetAdditionalHint1(const oCurrFunction: TUNIFunction;
                                const sWholeCurrParam: string;
                                var sAdditionalHint: string);
    function  GetCurrWordHint1 (const asCurrWord: string;
                               const aiCurrWordPos: integer;
                               const aiCurrWordLen: integer): string;

    procedure RichEventOnEnter1(oSender: TObject);
    procedure RichEventOnExit1(oSender: TObject);
    procedure RichEditChange1(Sender: TObject);
    function  CheckRegula1( bBezKomentarzy: Boolean = false): Boolean;

    procedure StworzListy1;
    procedure UsunListy1;

    procedure InitializeControls();
    procedure AddContainedForms();
    procedure SetDefaults();
    procedure GetAddedUsers();
    procedure WczytajSkladnikiKosztow( );
    procedure WczytajSkladnikiIlosciowe( );
    procedure DodajSkladnikKosztow( PrimaryID: Integer;
                                    Symbol, Nazwa, Rodzaj, Regula: String;
                                    Stan: TStanSkladnikaKontroli;
                                    iKolejnosc: Integer );
    procedure DodajSkladnikIlosciowy( PrimaryID: Integer;
                                      Symbol, Nazwa, Rodzaj, Regula: String;
                                      Stan: TStanSkladnikaKontroli;
                                      iKolejnosc: Integer );
    procedure RefreshCheckBox();
    procedure UstawPowiazanieZZasobami();
    procedure ShowZapotrzTyp(
                          const ac_oAliasSrc: TDataSet
              );

  protected
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
    procedure BeforeShow(); override;
    procedure UstawWlasciwosci1;
    procedure GetPositionAndParentForContainedForm( const nr:integer ; var APosition: TRect ; var AParent: TWinControl ; var AAlign:TAlign); override;
    procedure AssignProperties; override;
    function  GetPropertyValue( APropertyName: String ): String; override;
    procedure SetFormProperties(); override;
(*************************************
    procedure InitializeObjectFields(); virtual;
    procedure SelectButtonPressed; override;
**************************************)

  public
    FRegula1: string;
    FDlugosc: Integer;

    function Validate(): Boolean; override;
    procedure UstawRegule1(sRegula1: string);
    destructor Destroy(); override;
    property NoweSkladnikiKontroliKosztow: TListaSkladnikowKontroli read oSkladnikiKontroliKosztow;
    property NoweSkladnikiKontroliIlosci: TListaSkladnikowKontroli read oSkladnikiKontroliIlosci;
    //property SuffixFormIndex: Integer read iSuffixFormIndex;
    property PolaUzNewFormIndex: Integer read iPolaUzNewFormIndex;
    property PolaUzPozNewFormIndex: Integer read iPolaUzPozNewFormIndex;
    property Regula1: string read FRegula1 write UstawRegule1;
    property AuthorisedUsersFormIdx: Integer read iAuthorisedUsersFormIdx;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  KeyManagerUnit,
  SecurityManagerUnit,
  UNIDBGridFormUnit,
  UNIDataManagerUnit,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  ASODefUnit,
  FKDefUnit,
{$ifdef build_all}
  ASODataManagerUnit,
  ZAODataManagerUnit,
{$else}
  ASODataManagerExtUnit,
  ZAODataManagerExtUnit,
{$endif} //build_all
  MAGDefUnit,
  BOKDefUnit,
  INFDefUnit,
  REMDefUnit,
  SANDefUnit,
  UNIINTDefUnit,
  SQLManagerUnit,
  ZLEDataManagerUnit,
  ZLEPoleZmWskDBGridFormUnit,
  ZLETypZleceniaUnit,
  ZLESkladnikKontroliWartosciowejDBGridFormUnit,
  ZLESkladnikKontroliIlosciowejDBGridFormUnit,
  ZLETypZleceniaUsersDBGridFormUnit,
  ZAODefUnit,
  LWPDefUnit;

{ TZLETypZleceniaDBDetailForm }
function TZLETypZleceniaDBDetailForm.CheckRegula1(bBezKomentarzy: Boolean = false): Boolean;
var
  sZnaki :string;
  iIndex, iIloscSkladnikow : Integer;
  fSkladniki: TSplit;

  function SprawdzApostrofy(sText: String): Boolean;
  var
    k, iIloscApostrofow: Integer;
  begin
    result := False;
    iIloscApostrofow := 0;
    for k := 1 to length(sText) do begin
       if sText[k] = '''' then  Inc(iIloscApostrofow);
    end;

    if ((iIloscApostrofow mod 2) = 0) {and (iIloscApostrofow > 0)} then
        result := True;
  end;

begin
  result := False;
  {Kontrola skadnikw}
  sZnaki := FRichEdit1.Text;
  // sZnaki:= StringReplace( sZnaki,' ','',[rfReplaceAll]);
  sZnaki:= StringReplace( sZnaki,#13,'',[rfReplaceAll]);
  sZnaki:= StringReplace( sZnaki,#10,'',[rfReplaceAll]);
//     sZnaki:= AnsiUpperCase( Args);

  if sZnaki = '' then begin
     result := True;
     //Komunikat(cWarning, 'Brak definicji budowy sownika skadnikw');
     Exit;
  end else begin
    try
      iIloscSkladnikow := 0;
      iDlugText := 0;
      fSkladniki := TSplit.Create(sZnaki, ',', '');
      for iIndex := 0 to fSkladniki.Count - 1 do
      begin
         if copy(Trim(fSkladniki[iIndex]), 1, 1) = '''' then begin
           if SprawdzApostrofy(Trim(fSkladniki[iIndex])) then begin
              Inc(iIloscSkladnikow);
              iDlugText := iDlugText + length(Trim(fSkladniki[iIndex])) - 2; {ODEJMUJEMY DWA APOSTROFY}
              Continue;
           end else begin
              Komunikat(cWarning, 'Bdna definicja. Niepoprawna ilo apostrofw');
              if FRichEdit1.Enabled then FRichEdit1.SetFocus;
              iDlugText := 0;
              Exit;
           end;
         end else begin
           Inc(iIloscSkladnikow);
           Continue;
         end;
      end;
      if iIloscSkladnikow <> fSkladniki.Count then begin
         Komunikat(cWarning, 'Bdna definicja. Niepoprawna ilo skadnikw');
         if FRichEdit1.Enabled then FRichEdit1.SetFocus;
         iDlugText := 0;
         Exit;
      end;

    finally
      FreeAndNil(fSkladniki);
    end;

    FRegula1 := sZnaki;
  end;

  result := True;
  if not bBezKomentarzy then Komunikat(cInformation, 'Regua jest poprawna');
end;

procedure TZLETypZleceniaDBDetailForm.UstawRegule1(sRegula1: string);
begin
  FRegula1 := sRegula1;
  if OpenMode in [omNew, omEdit] then
     DMAQFbN(sZLETYPZLEC_SUFFIX).AsString := FRegula1;
//  FRichEdit1.Text := Regula1;
end;

procedure TZLETypZleceniaDBDetailForm.UstawWlasciwosci1;
var
  rProp: TUNISimpleEditorRichEditProperties;
begin
  ZeroMemory(Addr(rProp), sizeof(rProp));
  rProp.pFun1   := GetFunctionsList1;
  rProp.pFun2   := GetAdditionalHint1;
  rProp.pFun3   := GetCurrWordHint1;
  rProp.oParent := SuffixPanel; //Label.Parent;
  rProp.iTop    := 0; //+20;
  rProp.iLeft   := 0; //SkladoweLabel.Left;
  rProp.iWidth  := SuffixPanel.Width; // - (2 * SkladoweLabel.Left);
  rProp.iHeight := SuffixPanel.Height;// - 20; // TUNIPanel(DekretacjaCenaZeroCheckBox.Parent).Height - 20;// DekretacjaCenaZeroCheckBox.Height*3;
  rProp.bWordWrap := true;
  FRichEdit1 := TUNISimpleEditorRichEdit.Create(self);

  {Skadniki mona edytowa gdy nie ma jeszcze tabeli ani mnemonika utworzonego}
  if (OpenMode = omEdit) then
     FRichEdit1.Enabled := True;
  StworzListy1;
  FRichEdit1.SetProperties(rProp);

  FRichEdit1.TabOrder := 0;
  FRichEdit1.Visible := true;
  FRichEdit1.RealOnEnter := RichEventOnEnter1;
  FRichEdit1.RealOnExit := RichEventOnExit1;
  FRichEdit1.OnChange := RichEditChange1;

  FRichEdit1.Text := DMAQFbN(sZLETYPZLEC_SUFFIX).AsString;
  //SkladoweLabel.FocusControl := FRichEdit1;

end;

procedure TZLETypZleceniaDBDetailForm.StworzListy1;
var
  q, q2: TUNIQuery;
  sTmp, sSQL: String;

  iIdx2: Integer;
  sMnem: String;

  procedure Dopisz(ii: Integer);
  begin
     sMnem := cslZLE_INFMnemoniki[ii];
     iIdx2 := FOperationList1.IndexOf(sMnem);
     if iIdx2 = -1 then
        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
  end;
begin
  FOperationList1 := TUNIStringList.Create;
  if DMAQFbN(sZLETYPZLEC_ID).AsString = '' then Exit;

  {Dostpne mnemoniki do budowy sownika kryterium}
  {Na poczatek bez oddzialu}
  {if vWielofirmowosc or vWieloodzialowosc then
     FOperationList1.AddObject('ODZ', TUNIFunction.Create('ODZ', [''], ''));}

  {Dokadamy mnemoniki infrastruktury}
  sSQL := 'SELECT DISTINCT ' +
               sZLETYPZLEC_LOKAL_A + ', ' +
               sZLETYPZLEC_ZASOB_A + ', ' +
               sZLETYPZLEC_KLATKA_A + ', ' +
               sZLETYPZLEC_BUDYNEK_A + ', ' +
               sZLETYPZLEC_WYDZIAL_A + ', ' +
               sZLETYPZLEC_NIERUCHOMOSC_A + ', ' +
               sZLETYPZLEC_SIECELEMENT_A + ' ' +
          'FROM %s ';

  if DMAQFbN(sZLETYPZLEC_ID).AsString <> '' then
     sSQL := sSQL +  'WHERE ' + sZLETYPZLEC_ID + ' = ' + IntToStr(DMAQFBN(sZLETYPZLEC_ID).AsInteger);

  q2 := SQLManager.CreateQuery(sSQL, [sZLETYPZLEC]);
  try
    q2.Open;
    if not q2.IsEmpty then begin
       {Parametry remontow}
       if q2.FieldByName(sZLETYPZLEC_LOKAL_A).AsString        <> 'A' then Dopisz(0);
       if q2.FieldByName(sZLETYPZLEC_ZASOB_A).AsString        <> 'A' then Dopisz(1);
       if q2.FieldByName(sZLETYPZLEC_KLATKA_A).AsString       <> 'A' then Dopisz(2);
       if q2.FieldByName(sZLETYPZLEC_BUDYNEK_A).AsString      <> 'A' then Dopisz(4);
       if q2.FieldByName(sZLETYPZLEC_NIERUCHOMOSC_A).AsString <> 'A' then Dopisz(5);
       if q2.FieldByName(sZLETYPZLEC_SIECELEMENT_A).AsString  <> 'A' then Dopisz(9);
       if q2.FieldByName(sZLETYPZLEC_WYDZIAL_A).AsString  = cZLEAktywnosc_WymaganyID then begin
          sMnem := 'JED';
          iIdx2 := FOperationList1.IndexOf(sMnem);
          if iIdx2 = -1 then
             FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
       end;

    end;
  finally
    if q2 <> nil then FreeAndNil(q2);
  end;

  sTmp := '';
  sSQL :=  'SELECT DISTINCT ' +
              'DEF.' + sFKMNEMONIKI_ID + ', ' +
              'FM.'  + sFKMNEMONIKI_TABELA + ', ' +
              'FM.'  + sFKMNEMONIKI_DLUGOSC + ', ' +
              'FM.'  + sFKMNEMONIKI_MNEMONIK + ' ' +
           'FROM %s DEF, %s FM, %s WSK ' +
           'WHERE ' +
              'WSK.' + sUNIPOLAUZDEF_ID + ' = DEF.' + sUNIPOLAUZDEF_ID + ' AND ' +
              'DEF.' + sFKMNEMONIKI_ID  + ' = FM.'  + sFKMNEMONIKI_ID + ' AND ' +
              'DEF.' + sUNIPOLAUZDEF_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + ' AND ';

  if DMAQFbN(sZLETYPZLEC_ID).AsString <> '' then
     sSQL := sSQL +  'WSK.' + sUNIPOLAUZWSK_FUNKID + ' = ' + IntToStr(DMAQFBN(sZLETYPZLEC_ID).AsInteger) + ' AND ';

  sSQL := sSQL +  'FM.' + sFKMNEMONIKI_INDEKS + ' = 0 ' +
                  'ORDER BY ' + sFKMNEMONIKI_MNEMONIK;

  q := SQLManager.CreateQuery(sSQL, [sUNIPOLAUZDEF, sFKMNEMONIKI, sUNIPOLAUZWSK]);

  try
      q.Open;
      if q <> nil then
         While not q.Eof do begin
            sMnem := q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
            iIdx2 := FOperationList1.IndexOf(sMnem);
            if iIdx2 = -1 then
               FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));

            q.Next;
         end;
  finally
    if q <> nil then FreeAndNil(q);
  end;
end;

procedure TZLETypZleceniaDBDetailForm.UsunListy1;
var
  i: integer;
begin
  if FOperationList1 <> nil then begin
    for i:=0 to FOperationList1.Count-1 do begin
      FOperationList1.Objects[i].Free;
    end;
    FreeAndNil(FOperationList1);
  end;
end;

function TZLETypZleceniaDBDetailForm.GetFunctionsList1(
  const oCurrFunction: TUNIFunction; var sWholeCurrParam,
  sCurrWord: string; const sPrevWord: string; const cSeparator: char;
  var sWordToInsert: string; bShowList: boolean): TUNIStringList;
begin
  result := nil;
  if oCurrFunction = nil then begin
    result := FOperationList1
  end else if bShowList then begin
    if oCurrFunction <> nil then begin
      result := FOperationList1
    end;  // if oCurrFunction <> nil
  end;
end;

procedure TZLETypZleceniaDBDetailForm.GetAdditionalHint1(
  const oCurrFunction: TUNIFunction; const sWholeCurrParam: string;
  var sAdditionalHint: string);
begin

end;

function TZLETypZleceniaDBDetailForm.GetCurrWordHint1(
  const asCurrWord: string; const aiCurrWordPos,
  aiCurrWordLen: integer): string;
begin

end;

procedure TZLETypZleceniaDBDetailForm.RichEditChange1(Sender: TObject);
begin
  FRegula1 := FRichEdit1.Text;
end;

procedure TZLETypZleceniaDBDetailForm.RichEventOnEnter1(oSender: TObject);
begin
  SelectButton.Default := false;
  CancelButton.Cancel := false;
  sSuffix := DMAQFbN(sZLETYPZLEC_SUFFIX).AsString; //DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString;
end;

procedure TZLETypZleceniaDBDetailForm.RichEventOnExit1(oSender: TObject);
begin
  SelectButton.Default := true;
  CancelButton.Cancel := true;
  FRichEdit1.PlainText := true;

  try
    if sSuffix <> FRichEdit1.Text then begin
      if CheckRegula1(True) then begin
         UstawRegule1(FRichEdit1.Text);
      end;
    end;
  finally
    FRichEdit1.PlainText := false;
  end;

  if OpenMode in [omNew, omEdit] then
     DMAQFbN(sZLETYPZLEC_SUFFIX).AsString := FRegula1;
  //DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString := FRegula1;

  {if sSkladniki <> DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString then
     UstawSlowniki();}
end;

procedure TZLETypZleceniaDBDetailForm.AddContainedForms;
var oParamsKoszty, oParamsIlosci{, oParamsPolaUz, oParamsPolaUzPoz}: TKeyValues;
    omOpenMode: TOpenMode;
    iOpenMode:TOpenMode;
begin
  oParamsKoszty := TKeyValues.CreateEmpty();
  oParamsIlosci := TKeyValues.CreateEmpty();

  omOpenMode := omList or omContained or omVirtual or omReadOnly;

  with FContainedForms do begin
    //lista kontroli kosztw
    with oParamsKoszty do begin
      Add(cFORM_CAPTION+'='+'Skadniki kontroli wartociowej');
      Add(sZLETYPZLEC_ID+'='+DMAQFbN(sZLETYPZLEC_ID).AsString);
      Add(sUNIODDZIAL_ID+'='+DMAQFbN(sUNIODDZIAL_ID).AsString);
    end;
    iKontrolaKosztowFormIndex := 0;
    AddObject( 'Kontrola kosztw',
               FormManager.OpenDBGrid( Self, cKlasaSkladnikWartosciowy+cSuffixKlasyDBGrid,
                                       omOpenMode, oParamsKoszty ) );

    //lista kontroli ilociowej
    with oParamsIlosci do begin
      Add(cFORM_CAPTION+'='+'Skadniki kontroli ilociowej');
      Add(sZLETYPZLEC_ID+'='+DMAQFbN(sZLETYPZLEC_ID).AsString);
      Add(sUNIODDZIAL_ID+'='+DMAQFbN(sUNIODDZIAL_ID).AsString);
    end;
    iKontrolaIlosciFormIndex := 1;
    AddObject( 'Kontrola ilociowa',
               FormManager.OpenDBGrid( Self, cKlasaSkladnikIlosciowy+cSuffixKlasyDBGrid,
                                       omOpenMode, oParamsIlosci ) );

    //iSuffixFormIndex := 4;

    iOpenMode := omList or omVirtual or omContained;
    if((OpenMode = omView) or (OpenMode = omDelete)) then
      iOpenMode := iOpenMode or omReadOnly;

    iPolaUzNewFormIndex := 2;
    AddObject(
        'PolaUzNew',
        UNISYSDM.UNIPokazIObsluzPrzypisaniePolUzytkownika(
          Self,
          cPolaUZ_ZLEZlecenie,
          DMAQFBN(sZLETYPZLEC_ID).AsInteger,
          iOpenMode
        )
    );

    iPolaUzPozNewFormIndex := 3;
    AddObject(
        'PolaUzPozNew',
        UNISYSDM.UNIPokazIObsluzPrzypisaniePolUzytkownika(
          Self,
          cPolaUZ_ZLEPozycja,
          DMAQFBN(sZLETYPZLEC_ID).AsInteger,
          iOpenMode
        )
    );

    iAuthorisedUsersFormIdx := 4;
    AddObject('' , FormManager.OpenDBGrid(Self,
                                          'TZLETypZleceniaUsersDBGridForm',
                                          iOpenMode,
                                          TKeyValues.CreateFromLine(sZLETYPZLEC_ID+'='+DMAQFbN(sZLETYPZLEC_ID).AsString)));
    DeleteUserButton.Enabled := SecurityManager.SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN_UPR) and (TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).DataModule.ActiveQuery.RecordCount > 0);
  end;
end;

function TZLETypZleceniaDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLETypZleceniaDataModule.CreateOpen( Self, DefaultMasterKeyValues, AOpenMode );
end;

procedure TZLETypZleceniaDBDetailForm.GetPositionAndParentForContainedForm(
  const nr: integer; var APosition: TRect; var AParent: TWinControl;
  var AAlign: TAlign);
begin
  if nr = iKontrolaKosztowFormIndex then begin  //kontrola kosztw
    AParent := KontrolaKosztowContaindFormPanel;
    APosition := KontrolaKosztowContaindFormPanel.ClientRect;
    AAlign := alClient;
  end else
  if nr = iKontrolaIlosciFormIndex then begin  //kontrola iloci
    AParent := KontrolaIlosciContaindFormPanel;
    APosition := KontrolaIlosciContaindFormPanel.ClientRect;
    AAlign := alClient;
  end else
  {if nr = iSuffixFormIndex then begin
    AParent   := SuffixPanel;
    APosition := SuffixPanel.ClientRect;
    AAlign    := alClient;
  end else}
  if nr = iPolaUzNewFormIndex then begin
      AParent   := PolaUzNewPanel;
      APosition := PolaUzNewPanel.ClientRect;
      AAlign    := alClient;
  end else
  if nr = iPolaUzPozNewFormIndex then begin
      AParent   := PolaUzPozNewPanel;
      APosition := PolaUzPozNewPanel.ClientRect;
      AAlign    := alClient;
  end else
  if nr = iAuthorisedUsersFormIdx then begin
      AParent   := AuthorisedUsersPanel;
      APosition := AuthorisedUsersPanel.ClientRect;
      AAlign    := alClient;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.InitializeControls;
begin
  //podpicie pl do kontrolek
  SymbolDBEdit.DataField := sZLETYPZLEC_SYMBOL;
  NazwaDBEdit.DataField := sZLETYPZLEC_NAZWA;
  DomyslnaNazwaZleceniaDBEdit.DataField := sZLETYPZLEC_DOM_NAZWA;
  DomDataOtwDBCheckBox.DataField := sZLETYPZLEC_DOM_DATA_OTW;
  GrupujacyDBCheckBox.DataField := sZLETYPZLEC_GRUPUJACE;
  KontrolaKosztowDBCheckBox.DataField := sZLETYPZLEC_KOSZTY;
  KontrolaKosztowOkresowaDBCheckBox.DataField := sZLETYPZLEC_KOSZTY_OKRES;
  KontrolaIlosciowaDBCheckBox.DataField := sZLETYPZLEC_ILOSCI;
  KontrolaIlosciowaOkresowaDBCheckBox.DataField := sZLETYPZLEC_ILOSCI_OKRES;
  UwagiDBCheckBox.DataField := sZLETYPZLEC_UWAGI;
  NaPodstDokMagDBCheckBox.DataField := sZLETYPZLEC_ILOSCI_ASOMAG;
  ZasobyDBCheckBox.DataField := sZLETYPZLEC_ZASOBY;
  with ProdukcyjneDBCheckBox do begin
    DataField     := sZLETYPZLEC_PRODUKCYJNE;
    ValueChecked  := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked:= sUNICONST_ALTERNATYWA_NIE;
    Visible       := DataManagers.Available(sLWPModulID);
  end;
  with RecepturaDBCheckBox do begin
    DataField     := sZLETYPZLEC_WYMAG_RECEP;
    ValueChecked  := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked:= sUNICONST_ALTERNATYWA_NIE;
    Visible       := DataManagers.Available(sLWPModulID) and ProdukcyjneDBCheckBox.Checked;
  end;

  RegulaDBLookupAliasEdit.Visible := DataManagers.Available(sASOModulID);
  RegulaLabel.Visible := DataManagers.Available(sASOModulID);
  NaPodstDokMagDBCheckBox.Visible := DataManagers.Available(sMAGModulID);

  //wczytanie moliwych wartoci checkbox'w
  with DomDataOtwDBCheckBox do begin
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;
  with GrupujacyDBCheckBox do begin
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;
  with KontrolaKosztowDBCheckBox do begin
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;
  with KontrolaKosztowOkresowaDBCheckBox do begin
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;
  with KontrolaIlosciowaDBCheckBox do begin
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;
  with KontrolaIlosciowaOkresowaDBCheckBox do begin
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;
  with ZasobyDBCheckBox do begin
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;
  with UwagiDBCheckBox do begin
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;
  with NaPodstDokMagDBCheckBox do begin
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;

  with AuthorisedUsersUNIDBCheckBox do begin
    ValueChecked := sTAK;
    ValueUnchecked := sNIE;
  end;

  WyslijDoSystemuPartneraDBCheckBox.Visible := DataManagers.Available(sUNIINTModulID);
  with WyslijDoSystemuPartneraDBCheckBox do begin
    DataField     := sZLETYPZLEC_WYSYLANIE_UNIINT;
    ValueChecked := sTAK;
    ValueUnchecked := sNIE;
  end;

  //parametry oglne
  with WykonawcaDBConstComboBox do begin
    DataField := sZLETYPZLEC_WYKONAWCA_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with WydzialDBConstComboBox do begin
    DataField := sZLETYPZLEC_WYDZIAL_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with OpisDBConstComboBox do begin
    DataField := sZLETYPZLEC_OPIS_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with PojazdDBConstComboBox do begin
    DataField := sZLETYPZLEC_POJAZD_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with ProcentUEDBConstComboBox do begin
    DataField := sZLETYPZLEC_PROCENT_UE_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with PunktDBConstComboBox do begin
    DataField := sZLETYPZLEC_PUNKT_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with UmowaDBConstComboBox do begin
    DataField := sZLETYPZLEC_UMOWA_A;
    Items.Assign(cslZLEAktywnosc);
    //Visible := DataManagers.Available(sBOKModulID); //Umowy z poziomu remontw?
  end;

  //parametry pozycji
  with PowiazanieDBConstComboBox do begin
    DataField := sZLETYPZLEC_TABPOWIAZANA;
    Items.Assign( cslZLETabelePowiazane );
    if not DataManagers.Available(sBOKModulID) then
      Items.Delete(cslZLETabelePowiazane.IndexOfSkrot(sBOKSPRAWA));
  end;
  if DataManagers.Available(sINFModulID) then begin
    with ElementINFDBCheckBox do begin
      ValueChecked := sUNICONST_ALTERNATYWA_TAK;
      ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
      DataField := sZLETYPZLEC_ELEMENTINF;
    end;
    with PoziomINFDBConstComboBox do begin
      DataField := sZLETYPZLEC_POZIOMINF;
      Items.Assign( cslINFRodzajObiektu );
      if not vInfBramy then
        Items.Delete( Items.IndexOf( sINFCONST_OBIEKT_BRAMA_TEXT ));
      if not vWspolnoty then
        Items.Delete( Items.IndexOf( sINFCONST_OBIEKT_WSPOLNOTA_TEXT ));
      // jeli nie istnia na licie cslINFRodzajObiektu
      // skadnik elementu sieci, to go dopisujemy
      if Items.IndexOf(sINFCONST_OBIEKT_SKLADNIKELSIECI_TEXT) = -1 then
         Items.AddObject(sINFCONST_OBIEKT_SKLADNIKELSIECI_TEXT, TConstItem.Create(sINFCONST_OBIEKT_SKLADNIKELSIECI));
    end;

    //Zakadka Elementy infrastruktury
    with ElemInfZleceniaDBCheckBox do begin
      ValueChecked := sUNICONST_ALTERNATYWA_TAK;
      ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
      DataField := sZLETYPZLEC_ZLEC_ELEMINF;
    end;
    with PoziomInfZlecDBConstComboBox do begin
      DataField := sZLETYPZLEC_ZLEC_POZINF;
      Items.Assign( cslINFRodzajObiektu );
      if not vInfBramy then
        Items.Delete( Items.IndexOf( sINFCONST_OBIEKT_BRAMA_TEXT ));
      if not vWspolnoty then
        Items.Delete( Items.IndexOf( sINFCONST_OBIEKT_WSPOLNOTA_TEXT ));
      // jeli nie istnia na licie cslINFRodzajObiektu
      // skadnik elementu sieci, to go dopisujemy
      if Items.IndexOf(sINFCONST_OBIEKT_SKLADNIKELSIECI_TEXT) = -1 then
         Items.AddObject(sINFCONST_OBIEKT_SKLADNIKELSIECI_TEXT, TConstItem.Create(sINFCONST_OBIEKT_SKLADNIKELSIECI));
    end;

  end else begin
    //Zakadka parametry pozycji
    ElementINFDBCheckBox.Enabled := False;
    PoziomINFLabel.Enabled := False;
    PoziomINFDBConstComboBox.Enabled := False;

    //Zakadka parametry infrastruktury
    ElemInfZleceniaDBCheckBox.Enabled := False;
    PoziomINFZlecLabel.Enabled := False;
    PoziomInfZlecDBConstComboBox.Enabled := False;
  end;

  //parametry remonty
  with NieruchomoscDBConstComboBox do begin
    DataField := sZLETYPZLEC_NIERUCHOMOSC_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with BudynekDBConstComboBox do begin
    DataField := sZLETYPZLEC_BUDYNEK_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with LokalDBConstComboBox do begin
    DataField := sZLETYPZLEC_LOKAL_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with KlatkaDBConstComboBox do begin
    DataField := sZLETYPZLEC_KLATKA_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with UlicaDBConstComboBox do begin
    DataField := sZLETYPZLEC_ULICA_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with ZasobDBConstComboBox do begin
    DataField := sZLETYPZLEC_ZASOB_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with ElementSieciDBConstComboBox do begin
    DataField := sZLETYPZLEC_SIECELEMENT_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with SkladnikElemSieciDBConstComboBox do begin
    DataField := sZLETYPZLEC_SKLADELEMSIECI_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with BramaDBConstComboBox do begin
    DataField := sZLETYPZLEC_BRAMA_A;
    Items.Assign( cslZLEAktywnosc );
  end;
  with RejonDBConstComboBox do begin
    DataField := sZLETYPZLEC_REJON_A;
    Items.Assign( cslZLEAktywnosc );
  end;

  //inicjalizacja obiektw potrzebnych do przechowywania dodanych skadnikw
  oSkladnikiKontroliKosztow := TListaSkladnikowKontroli.Create();
  oSkladnikiKontroliIlosci := TListaSkladnikowKontroli.Create();

  TypGrupyNazwaLabel.Caption := '';
  ModulNazwaLabel.Caption := '';
  ModulDBLookupAliasEdit.aReadOnly := True;
  RemontyTabSheet.TabVisible := DataManagers.Available(sINFModulID); {sREMModulID}

  OddzialNazwaLabel.Caption := '';
  OddzialPanel.Visible := vWieloodzialowosc or (vWielofirmowosc and UNISYSDM.vWielofirmowoscWieleFirm);
  if (vWielofirmowosc and UNISYSDM.vWielofirmowoscWieleFirm) then
     OddzialLabel.Caption := 'Firma';

  AuthorisedUsersUNIDBCheckBox.Enabled := SecurityManager.SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN_UPR);
  AddUserButton.Enabled := SecurityManager.SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN_UPR);
  DeleteUserButton.Enabled := SecurityManager.SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN_UPR);

  ParametryPageControl.ActivePage := SkladnikiKontroliTabSheet;
  LZAOZapotrzTypLabel.Caption := '';
  if(ZAODM.Available) then begin
    with ZAOZapotrzTypLookupAliasEdit do begin
      AliasManager      := ZAODM.AliasManager;
      Alias_ID          := sZAOAlias_ZapotrzebowanieTyp_Id;
      Alias_Name        := sZAOAlias_ZapotrzebowanieTyp_Symbol;
      AdditionalAliases := sZAOAlias_ZapotrzebowanieTyp_Nazwa;
    end;
  end else
    ZAOGroupBox.Visible  := false;
end;

procedure TZLETypZleceniaDBDetailForm.InternalOpen;
begin
{ TODO -ogdeyk -cframework : Nie moe by tak e kontrolki TDBComboBox w trybie omView pozwalaj zmienia swoj warto }
  bInit := True;
  try
    InitializeControls();

    if Parameters.Values[cFORM_CAPTION] <> '' then begin
      Caption := Parameters.Values[cFORM_CAPTION];
    end;

    qMnem := nil;
    bWywolaniezPoziom   := False;
    bWywolaniezParametr := False;

    inherited;

    if ((OpenMode = omDelete) or (OpenMode = omView)) then
      AuthorisedUsersControlPanel.Visible := False;

    //dodanie form osadzonych
    AddContainedForms();

    WczytajSkladnikiKosztow();
    WczytajSkladnikiIlosciowe();

    //ustawienie wartoci domylnych
    if OpenMode = omNew then SetDefaults();

    //odwiezenie dostpnoci CheckBox'w
    RefreshCheckBox();

    //ustawienie parametrw wymaganych w zalenoci od moduw
    if (DMAQFbN(sUNIMODULZSI_ID).AsInteger = cSANModulZSI_ID) then
      WykonawcaDBConstComboBox.Enabled := False;
  finally
    bInit := False;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.BeforeShow();
var
  oQuery:   TUNIQuery;
  sAliasy:  string;
  sWarunek: string;
begin
  sSuffix := '';
  inherited;

  Pozycja1   := 0;
  if ZLEDM.vZLENumeratorExt then begin
     UstawWlasciwosci1;
     FRichEdit1.TabOrder := 0;
  end;

  UstawPowiazanieZZasobami();

  if(not DMAQFbN(sZAOZAPOTRZTYP_ID).IsNull) then begin
    UNIDajAliasyZLookupa(ZAOZapotrzTypLookupAliasEdit, sAliasy, sWarunek);
    oQuery  := ZAODM.ZAOOdpytajODane(sZAOZAPOTRZTYP,
      sAliasy,
      '@' + sZAOAlias_ZapotrzebowanieTyp_Id + ' = ' + DMAQFbN(sZAOZAPOTRZTYP_ID).AsString,
      false
    );
    if(oQuery <> nil) then begin
      try
        ShowZapotrzTyp(oQuery);
      finally
        FreeAndNil(oQuery);
      end;
    end;
  end;  // if(not DMAQFbN(sZAOZAPOTRZTYP_ID).IsNull)

end;

procedure TZLETypZleceniaDBDetailForm.SetDefaults;
begin
  //inne wartoci domylne
  (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
  try
    DMAQFbN( sUNIMODULZSI_ID ).AsString := Parameters.Values[sUNIMODULZSI_ID];

    DMAQFbN( sZLETYPZLEC_DOM_DATA_OTW ).AsString   := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_DOM_DATA_OTW );
    DMAQFbN( sZLETYPZLEC_GRUPUJACE ).AsString      := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_GRUPUJACE );
    DMAQFbN( sZLETYPZLEC_KOSZTY ).AsString         := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_KOSZTY );
    DMAQFbN( sZLETYPZLEC_KOSZTY_OKRES ).AsString   := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_KOSZTY_OKRES );
    DMAQFbN( sZLETYPZLEC_ILOSCI ).AsString         := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_ILOSCI );
    DMAQFbN( sZLETYPZLEC_ILOSCI_OKRES ).AsString   := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_ILOSCI_OKRES );
    DMAQFbN( sZLETYPZLEC_ILOSCI_ASOMAG ).AsString  := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_ILOSCI_ASOMAG );
    DMAQFbN( sZLETYPZLEC_UWAGI ).AsString          := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_UWAGI );
    if (DMAQFbN( sUNIMODULZSI_ID ).AsInteger = cSANModulZSI_ID) then
       DMAQFbN( sZLETYPZLEC_WYKONAWCA_A ).AsString  := cZLEAktywnosc_WymaganyID
    else
       DMAQFbN( sZLETYPZLEC_WYKONAWCA_A ).AsString    := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_WYKONAWCA_A );
    DMAQFbN( sZLETYPZLEC_WYDZIAL_A ).AsString      := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_WYDZIAL_A );
    DMAQFbN(sZLETYPZLEC_WLACZUPRAWNIENIA).AsString := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_WLACZUPRAWNIENIA);

    if ZLEDM.vZLENarzuty and ZLEDM.vZLEPoziomNarzutowJednOrg then begin
       DMAQFbN(sZLETYPZLEC_WYDZIAL_A).AsString  := cZLEAktywnosc_WymaganyID;
       WydzialDBConstComboBox.ReadOnly := True;  //Zablokowanie edycji pola
    end;

    DMAQFbN( sZLETYPZLEC_OPIS_A ).AsString         := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_OPIS_A );
    DMAQFbN( sZLETYPZLEC_NIERUCHOMOSC_A ).AsString := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_NIERUCHOMOSC_A );
    DMAQFbN( sZLETYPZLEC_BUDYNEK_A ).AsString      := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_BUDYNEK_A );
    DMAQFbN( sZLETYPZLEC_LOKAL_A ).AsString        := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_LOKAL_A );
    DMAQFbN( sZLETYPZLEC_KLATKA_A ).AsString       := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_KLATKA_A );
    DMAQFbN( sZLETYPZLEC_ULICA_A ).AsString        := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_ULICA_A );
    DMAQFbN( sZLETYPZLEC_ZASOB_A ).AsString        := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_ZASOB_A );
    DMAQFbN( sZLETYPZLEC_SIECELEMENT_A ).AsString  := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_SIECELEMENT_A );
    DMAQFbN( sZLETYPZLEC_ZASOBY ).AsString         := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_ZASOBY );
    DMAQFbN( sZLETYPZLEC_TABPOWIAZANA ).AsString   := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_TABPOWIAZANA );
    DMAQFbN( sZLETYPZLEC_PRODUKCYJNE ).AsString    := sNie;
    DMAQFbN( sZLETYPZLEC_WYMAG_RECEP ).AsString    := sNie;
    DMAQFbN( sZLETYPZLEC_POJAZD_A ).AsString       := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_POJAZD_A );
    DMAQFbN( sZLETYPZLEC_PUNKT_A ).AsString        := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_PUNKT_A );
    DMAQFbN( sZLETYPZLEC_UMOWA_A ).AsString        := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_UMOWA_A );
    DMAQFbN( sZLETYPZLEC_WYSYLANIE_UNIINT ).AsString := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_WYSYLANIE_UNIINT );
    DMAQFbN( sZLETYPZLEC_PROCENT_UE_A ).AsString   := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_PROCENT_UE_A );
    DMAQFbN(sZLETYPZLEC_SKLADELEMSIECI_A).AsString := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_SKLADELEMSIECI_A );
    DMAQFbN( sZLETYPZLEC_BRAMA_A ).AsString        := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_BRAMA_A );
    DMAQFbN( sZLETYPZLEC_REJON_A ).AsString        := UNISysDM.DajDefaultPola( sZLETYPZLEC, sZLETYPZLEC_REJON_A );

    {Oddzia/Firma}
    if vWielofirmowosc and (UNISYSDM.vWielofirmowoscWieleFirm or ZLEDM.vZLEWspolneZlecenia) then begin
       DMAQFbN(sUNIODDZIAL_ID).AsInteger := vAktywnaFirma;
    end;

    FDlugosc := 0;
    iDlugText := 0;
    //ZLEDM.vZLESuffixDefinicja := '';

  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;
end;

function TZLETypZleceniaDBDetailForm.Validate: Boolean;
begin
  result := inherited Validate();

  if not result then Exit;

  if (not CheckRegula1(True)) then begin
     result := False;
     if (OpenMode in [omNew, omEdit]) and FRichEdit1.Visible and FRichEdit1.Enabled then
        FRichEdit1.SetFocus;
     Exit;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.DodajSkladnikKosztowButtonClick(
  Sender: TObject);
var oParams: TKeyValues;
    vForm: TUNIDBGridForm;
    iIndex: Integer;
    Stan: TStanSkladnikaKontroli;
    iKolejny: Integer;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty;
  iKolejny := oSkladnikiKontroliKosztow.GetNextKolejnosc();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Skadniki kontroli wartociowej');
    Add(sZLETYPSKLADW_KOLEJNOSC+'='+IntToStr(iKolejny));
  end;
  vForm := FormManager.OpenDBGrid( Self, cKlasaSkladnikWartosciowy+cSuffixKlasyDBGrid,
                                   omLookup+omMultiSelect, oParams );
  try
    if vForm.ModalResult = mrOK then begin
      if Length(vForm.DBGrid.MarkedRows) = 0 then vForm.DBGrid.Mark;
      for iIndex := Low(vForm.DBGrid.MarkedRows) to High(vForm.DBGrid.MarkedRows) do begin
        try
          Stan := sskNowy;
          if oSkladnikiKontroliKosztow.Add( Stan, vForm.DBGrid.MarkedRows[iIndex], iKolejny) <> -1 then
            with vForm.DataModule.ActiveQuery do begin
              Locate( vForm.DataModule.Keys.GetPrimaryKey, vForm.DBGrid.MarkedRows[iIndex], []);
              DodajSkladnikKosztow( vForm.DBGrid.MarkedRows[iIndex],
                                    FieldByName( sZLESKLADWART_SYMBOL ).AsString,
                                    FieldByName( sZLESKLADWART_NAZWA ).AsString,
                                    FieldByName( sZLESKLADWART_RODZAJ ).AsString,
                                    FieldByName( sZLESKLADWART_REGULA ).AsString,
                                    Stan,
                                    iKolejny);
            end;
        except
          on EStringListError do
          else raise;
        end;
      end
    end;
  finally
    if vForm <> nil then vForm.Free;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.DodajSkladnikIlosciButtonClick(
  Sender: TObject);
var oParams: TKeyValues;
    vForm: TUNIDBGridForm;
    iIndex: Integer;
    Stan: TStanSkladnikaKontroli;
    iKolejny: Integer;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty;
  iKolejny := oSkladnikiKontroliIlosci.GetNextKolejnosc();

  with oParams do begin
    Add(cFORM_CAPTION+'='+'Skadniki kontroli ilociowej');
    Add(sZLETYPSKLADW_KOLEJNOSC+'='+IntToStr(iKolejny));
  end;

  vForm := FormManager.OpenDBGrid( Self, cKlasaSkladnikIlosciowy+cSuffixKlasyDBGrid,
                                   omLookup+omMultiSelect, oParams );
  try
    if vForm.ModalResult = mrOK then begin
      if Length(vForm.DBGrid.MarkedRows) = 0 then vForm.DBGrid.Mark;
      for iIndex := Low(vForm.DBGrid.MarkedRows) to High(vForm.DBGrid.MarkedRows) do begin
        try
          Stan := sskNowy;
          if oSkladnikiKontroliIlosci.Add( Stan, vForm.DBGrid.MarkedRows[iIndex], iKolejny) <> -1 then
            with vForm.DataModule.ActiveQuery do begin
              Locate( vForm.DataModule.Keys.GetPrimaryKey, vForm.DBGrid.MarkedRows[iIndex], []);
              DodajSkladnikIlosciowy( vForm.DBGrid.MarkedRows[iIndex],
                                      FieldByName( sZLESKLADIL_SYMBOL ).AsString,
                                      FieldByName( sZLESKLADIL_NAZWA ).AsString,
                                      FieldByName( sZLESKLADIL_RODZAJ ).AsString,
                                      FieldByName( sZLESKLADIL_REGULA ).AsString,
                                      Stan,
                                      iKolejny);
            end;
        except
          on EStringListError do
          else raise;
        end;
      end
    end;
  finally
    if vForm <> nil then vForm.Free;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.DeleteUserButtonClick(Sender: TObject);
begin
  inherited;
  if iAuthorisedUsersFormIdx > -1 then
     if ContainedForms[iAuthorisedUsersFormIdx].ClassType = TZLETypZleceniaUsersDBGridForm then
        TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).Delete;
end;

destructor TZLETypZleceniaDBDetailForm.Destroy;
begin
  if qMnem <> nil then FreeAndNil(qMnem);
  UsunListy1;
  FreeAndNil(FRichEdit1);

  if oSkladnikiKontroliKosztow <> nil then oSkladnikiKontroliKosztow.Free;
  if oSkladnikiKontroliIlosci <> nil then oSkladnikiKontroliIlosci.Free;
  inherited;
end;

procedure TZLETypZleceniaDBDetailForm.WczytajSkladnikiIlosciowe;
var Stan: TStanSkladnikaKontroli;
begin
  with (ContainedForms[iKontrolaIlosciFormIndex] as TUNIDBGridForm).DataModule.ActiveQuery do begin
    First;
    Stan := sskIstniejacy;
    while not Eof do begin
      oSkladnikiKontroliIlosci.Add( Stan, FieldByName(sZLESKLADIL_ID).AsInteger, FieldByName(sZLETYPSKLADIL_KOLEJNOSC).AsInteger);
      Next;
    end;
    First;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.WczytajSkladnikiKosztow;
var Stan: TStanSkladnikaKontroli;
begin
  with (ContainedForms[iKontrolaKosztowFormIndex] as TUNIDBGridForm).DataModule.ActiveQuery do begin
    First;
    Stan := sskIstniejacy;
    while not Eof do begin
      oSkladnikiKontroliKosztow.Add( Stan, FieldByName(sZLESKLADWART_ID).AsInteger, FieldByName(sZLETYPSKLADW_KOLEJNOSC).AsInteger);
      Next;
    end;
    First;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.DodajSkladnikKosztow( PrimaryID: Integer;
                                                            Symbol, Nazwa, Rodzaj, Regula: String;
                                                            Stan: TStanSkladnikaKontroli;
                                                            iKolejnosc: Integer);
begin
  with DataModule.ContainedDataModules[iKontrolaKosztowFormIndex].ActiveQuery as TVirtualDataSet do begin
    try
      VState := vsInternalInsert;
      Append;
      FieldByName( sZLESKLADWART_ID ).AsInteger := PrimaryID;
      FieldByName( sZLESKLADWART_SYMBOL ).AsString := Symbol;
      FieldByName( sZLESKLADWART_NAZWA ).AsString := Nazwa;
      FieldByName( sZLESKLADWART_RODZAJ ).AsString := Rodzaj;
      FieldByName( sZLESKLADWART_REGULA ).AsString := Regula;
      if FindField(sZLETYPSKLADW_KOLEJNOSC) <> nil then
         FieldByName( sZLETYPSKLADW_KOLEJNOSC ).AsInteger := iKolejnosc;
      if Stan = sskNowy then UpdateModifiedRecordFlagsForAddedRecord();
      Post;
    finally
      VState := vsNormal;
    end;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.DodajSkladnikIlosciowy(
  PrimaryID: Integer; Symbol, Nazwa, Rodzaj, Regula: String;
  Stan: TStanSkladnikaKontroli;
  iKolejnosc: Integer );
begin
  with DataModule.ContainedDataModules[iKontrolaIlosciFormIndex].ActiveQuery as TVirtualDataSet do begin
    try
      VState := vsInternalInsert;
      Append;
      FieldByName( sZLESKLADIL_ID ).AsInteger := PrimaryID;
      FieldByName( sZLESKLADIL_SYMBOL ).AsString := Symbol;
      FieldByName( sZLESKLADIL_NAZWA ).AsString := Nazwa;
      FieldByName( sZLESKLADIL_RODZAJ ).AsString := Rodzaj;
      FieldByName( sZLESKLADIL_REGULA ).AsString := Regula;

      if FindField(sZLETYPSKLADIL_KOLEJNOSC) <> nil then
         FieldByName( sZLETYPSKLADIL_KOLEJNOSC ).AsInteger := iKolejnosc;
      if Stan = sskNowy then UpdateModifiedRecordFlagsForAddedRecord()
      else if Stan = sskIstniejacy then
        ModifiedRecordsFlagsList.SetRecordFlag(mrfNotModified);
      Post;
    finally
      VState := vsNormal;
    end;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.UsunSkladnikKosztowButtonClick(
  Sender: TObject);
begin
  with (ContainedForms[iKontrolaKosztowFormIndex] as TUNIDBGridForm).DataModule.ActiveQuery do begin
    oSkladnikiKontroliKosztow.Delete( FieldByName(sZLESKLADWART_ID).AsInteger );
    Delete();
  end;
end;

procedure TZLETypZleceniaDBDetailForm.UsunSkladnikIlosciButtonClick(
  Sender: TObject);
begin
  with (ContainedForms[iKontrolaIlosciFormIndex] as TUNIDBGridForm).DataModule.ActiveQuery do begin
    oSkladnikiKontroliIlosci.Delete( FieldByName(sZLESKLADIL_ID).AsInteger );
    Delete();
  end;
end;

function TZLETypZleceniaDBDetailForm.NumeratorDBLookupAliasEditGetDataField: String;
begin
  result := sUNIAUTNUM_ID;
end;

function TZLETypZleceniaDBDetailForm.NumeratorDBLookupAliasEditGetQuery: TUNIQuery;
var
    oMnem: TUNIQuery;
    sMnemonik  : String;
begin
  if ((ZLEDM.vZLEWymaganyOddzial and vWieloodzialowosc) or
      (ZLEDM.vZLENumeratorExt and ZLEDM.vZLEOsobnaNum)) and
     (not (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = -1)))  then begin
      {if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = -1) then begin
         Komunikat(cWarning, 'Ustawiono rozszerzon obsug numeratorw,'#13+
                             'ale nie zosta zdefiniowany sownik numeratorw'#13+
                             'Ustaw w parametrach sownik prefiksw dla numeratora');
         Exit;
      end;}

      if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then
           sMnemonik := sMnemonikZLEPrefix
      else
      if ZLEDM.vZLENumeratorExt and vWielofirmowosc and (ZLEDM.vZLEPrefixSlownikID = 1) then
           sMnemonik := sMnemonikFirmy
      else sMnemonik := sMnemonikOddzialy;

      oMnem := SQLManager.CreateQuery(
        'SELECT ' +
           sFKMNEMONIKI_ID +
        ' FROM ' +
           SQLManager.GetTableName(sFKMNEMONIKI) +
        ' WHERE ' +
           sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(sMnemonik) + ' AND ' +
           sFKMNEMONIKI_INDEKS + ' = 0');

      try
        oMnem.Open;
        result := UNISysDM.UNIPokazIObsluzAutomatyNum( sUNINUMERATORModuluZlecen,
                                           UNISysDM.vMaxDLSymboluZle,
                                           sUNICONST_ALTERNATYWA_TAK,
                                           sUNISYSALIAS_Numerator_ID+';'+
                                           sUNISYSALIAS_Numerator_Nazwa,
                                           '', False, 0,
                                           (ZLEDM.vZLENumeratorExt and vWielofirmowosc and (ZLEDM.vZLEPrefixSlownikID = 1)) { tu zmiana byo False - NieFirmowy - false},
                                           True,
                                           oMnem.FieldByName(sFKMNEMONIKI_ID).AsInteger{,
                                           sUNISysAutomatyNumerowaniaMnemonikTryb_BrakCheckboxa} );
      finally
        if oMnem <> nil then FreeAndNil(oMnem);
      end;
 end else begin
     result := UNISysDM.UNIPokazIObsluzAutomatyNum( sUNINUMERATORModuluZlecen,
                                       UNISysDM.vMaxDLSymboluZle,
                                       sUNICONST_ALTERNATYWA_TAK,
                                       sUNISYSALIAS_Numerator_ID+';'+
                                           sUNISYSALIAS_Numerator_Nazwa,
                                           '', False, 0, False {NieFirmowy - false}
                                       {,false - unikalnosc wzorca});
 end;
end;

procedure TZLETypZleceniaDBDetailForm.NumeratorDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with NumeratorDBLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sUNISYSALIAS_Numerator_ID;
    Alias_Name := sUNISYSALIAS_Numerator_Nazwa;
    AdditionalCondition := '@'+sUNISYSALIAS_Numerator_Kod+'='+QuotedStr(sUNINUMERATORModuluZlecen);
  end;
end;

procedure TZLETypZleceniaDBDetailForm.NumeratorDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  with NumeratorDBLookupAliasEdit do begin
    if OpenMode in [omNew, omEdit] then
       DMAQFbN(OnGetDataField()).Clear;
    Text := '';
  end;
end;

procedure TZLETypZleceniaDBDetailForm.KontrolaKosztowDBCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  RefreshCheckBox();
end;

procedure TZLETypZleceniaDBDetailForm.KontrolaIlosciowaDBCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  RefreshCheckBox();
end;

procedure TZLETypZleceniaDBDetailForm.RefreshCheckBox;
begin
  //ustawienie dostpnoci typw grupujcych
  GrupujacyDBCheckBoxClick(nil);

  //ustawienie aktywnoci skadnikw kosztowych
  KontrolaKosztowOkresowaDBCheckBox.Enabled := KontrolaKosztowDBCheckBox.Checked;
  SkladnikiKontroliKosztowGroupBox.Enabled := KontrolaKosztowDBCheckBox.Checked;
  DodajSkladnikKosztowButton.Enabled := KontrolaKosztowDBCheckBox.Checked;
  ZmienSkladnikKosztowButton.Enabled := KontrolaKosztowDBCheckBox.Checked;
  UsunSkladnikKosztowButton.Enabled := KontrolaKosztowDBCheckBox.Checked;

  //ustawienie aktywnoci skadnikw ilociowych
  KontrolaIlosciowaOkresowaDBCheckBox.Enabled := KontrolaIlosciowaDBCheckBox.Checked;
  SkladnikiKontroliIlosciowejGroupBox.Enabled := KontrolaIlosciowaDBCheckBox.Checked;
  DodajSkladnikIlosciButton.Enabled := KontrolaIlosciowaDBCheckBox.Checked;
  ZmienSkladnikIlosciButton.Enabled := KontrolaIlosciowaDBCheckBox.Checked;
  UsunSkladnikIlosciButton.Enabled := KontrolaIlosciowaDBCheckBox.Checked;

  //ElemInfZleceniaDBCheckBox.Checked :=
  //parametry pozycji
  ElementINFDBCheckBoxClick(Self);
  ElemInfZleceniaDBCheckBoxClick(Self);
end;

procedure TZLETypZleceniaDBDetailForm.UstawPowiazanieZZasobami();
begin
  if(DataManagers.Available(sLWPModulID)) then begin
    ZasobyDBCheckBox.Enabled  := (not ProdukcyjneDBCheckBox.Checked);
    if((OpenMode in [omNew, omEdit]) and ProdukcyjneDBCheckBox.Checked and (not ZasobyDBCheckBox.Checked)) then
      DMAQFbN(ZasobyDBCheckBox.DataField).AsString  := sTak;
  end;  // if(DataManagers.Available(sLWPModulID))
end;

procedure TZLETypZleceniaDBDetailForm.ShowZapotrzTyp(
  const ac_oAliasSrc: TDataSet
);
begin
  ZAOZapotrzTypLookupAliasEdit.Text := ac_oAliasSrc.Fields[1].AsString;
  LZAOZapotrzTypLabel.Caption       := ac_oAliasSrc.Fields[2].AsString;
end;

procedure TZLETypZleceniaDBDetailForm.GetAddedUsers;
var
  b: TBookMark;
  s: string;
begin
  b := TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).DataModule.ActiveQuery.GetBookMark;
  s := '';
  try
    TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).DataModule.ActiveQuery.DisableControls;
    TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).DataModule.ActiveQuery.First;
    while not TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).DataModule.ActiveQuery.EOF do begin
      s := s + TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).DataModule.ActiveQuery.FieldByName(sSMUSER_ID).AsString + ',';
      TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).DataModule.ActiveQuery.Next;
    end;
    TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).DataModule.ActiveQuery.GotoBookMark(b);
  finally
    TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).DataModule.ActiveQuery.EnableControls;
    TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).DataModule.ActiveQuery.FreeBookMark(b);
  end;
  if Length(s) > 0 then s := Copy(s, 1, Length(s) - 1);
  if Self.Parameters = Nil then Self.Parameters := TKeyValues.CreateEmpty;
  Self.Parameters.Values[sZLETYPZLECUSERS + 'EXCLUDED'] := s;
end;

procedure TZLETypZleceniaDBDetailForm.AddUserButtonClick(Sender: TObject);
begin
  inherited;
  GetAddedUsers;
  if iAuthorisedUsersFormIdx > -1 then
    if ContainedForms[iAuthorisedUsersFormIdx].ClassType = TZLETypZleceniaUsersDBGridForm then
      TZLETypZleceniaUsersDBGridForm(ContainedForms[iAuthorisedUsersFormIdx]).New;
end;

procedure TZLETypZleceniaDBDetailForm.AssignProperties;
begin
  inherited;
  Properties.AddProperty( 'PH', GetPropertyValue );
end;

function TZLETypZleceniaDBDetailForm.GetPropertyValue(
  APropertyName: String): String;
begin
  if APropertyName = 'PH' then result := IntToStr(KontrolaRealizacjiPanel.Height)
  else result := inherited GetPropertyValue( APropertyName );
end;

procedure TZLETypZleceniaDBDetailForm.SetFormProperties;
var s: String;
begin
  inherited;
  s := Properties['PH'];
  if s <> '' then KontrolaRealizacjiPanel.Height := StrToInt(s);
end;

function TZLETypZleceniaDBDetailForm.TypGrupyDBLookupAliasEditGetDataField: String;
begin
  result := sZLETYPZLEC_TYP_GRUPY_ID;
end;

procedure TZLETypZleceniaDBDetailForm.TypGrupyDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with TypGrupyDBLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_TYPZLECENIA_ID;
    Alias_Name := sZLEALIAS_TYPZLECENIA_SYMBOL;
    AdditionalAliases := sZLEALIAS_TYPZLECENIA_KOSZTY+';'+
                         sZLEALIAS_TYPZLECENIA_KOSZTY_OKRES+';'+
                         sZLEALIAS_TYPZLECENIA_ILOSCI+';'+
                         sZLEALIAS_TYPZLECENIA_ILOSCI_OKRES+';'+
                         sZLEALIAS_TYPZLECENIA_NAZWA;
    AdditionalCondition := '(@'+sZLEALIAS_TYPZLECENIA_GRUPUJACE+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK)+')';
  end;
end;

function TZLETypZleceniaDBDetailForm.TypGrupyDBLookupAliasEditGetQuery: TUNIQuery;
var iFirmaID, iModulID: Integer;
begin
  iFirmaID := 0;
  iModulID := 0;

  if vWieloodzialowosc then iFirmaID := DMAQFbN(sUNIODDZIAL_ID).AsInteger
  else if vWielofirmowosc then iFirmaID := vAktywnaFirma;

  if Parameters.Values[sUNIMODULZSI_ID] <> '' then
    iModulID := StrToInt(Parameters.Values[sUNIMODULZSI_ID]);

  result := ZLEDM.ZLEPokazIObsluzTypZlecenia( sZLEALIAS_TYPZLECENIA_ID+';'+
                                              sZLEALIAS_TYPZLECENIA_SYMBOL+';'+
                                              sZLEALIAS_TYPZLECENIA_KOSZTY+';'+
                                              sZLEALIAS_TYPZLECENIA_KOSZTY_OKRES+';'+
                                              sZLEALIAS_TYPZLECENIA_ILOSCI+';'+
                                              sZLEALIAS_TYPZLECENIA_ILOSCI_OKRES+';'+
                                              sZLEALIAS_TYPZLECENIA_NAZWA,
                                              '(@'+sZLEALIAS_TYPZLECENIA_GRUPUJACE+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK)+')and'+
                                              '(@'+sZLEALIAS_TYPZLECENIA_ID+'<>'+DMAQFbN(sZLETYPZLEC_ID).AsString+')',
                                              True, False, iModulID,
                                              DMAQFbN(sZLETYPZLEC_TYP_GRUPY_ID).AsInteger, iFirmaID );
end;

procedure TZLETypZleceniaDBDetailForm.GrupujacyDBCheckBoxClick(
  Sender: TObject);
begin
//zlecenia grupujce mog nalee do grupy
//  TypGrupyDBLookupAliasEdit.aReadOnly := GrupujacyDBCheckBox.Checked;
end;

procedure TZLETypZleceniaDBDetailForm.TypGrupyDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  with TypGrupyDBLookupAliasEdit do begin
    if OpenMode in [omNew, omEdit] then
       DMAQFbN(OnGetDataField()).Clear;
    Text := '';
  end;
  TypGrupyNazwaLabel.Caption := '';
end;

function TZLETypZleceniaDBDetailForm.TypGrupyDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := False;
  if AliasSrc <> nil then with AliasSrc do begin
    TypGrupyNazwaLabel.Caption := FieldByName(sZLETYPZLEC_NAZWA).AsString;
    if OpenMode in [omNew,omEdit] then begin
      DMAQFbN(sZLETYPZLEC_KOSZTY).AsString := FieldByName(sZLETYPZLEC_KOSZTY).AsString;
      DMAQFbN(sZLETYPZLEC_KOSZTY_OKRES).AsString := FieldByName(sZLETYPZLEC_KOSZTY_OKRES).AsString;
      DMAQFbN(sZLETYPZLEC_ILOSCI).AsString := FieldByName(sZLETYPZLEC_ILOSCI).AsString;
      DMAQFbN(sZLETYPZLEC_ILOSCI_OKRES).AsString := FieldByName(sZLETYPZLEC_ILOSCI_OKRES).AsString;
    end;
    result := True;
  end;
end;

function TZLETypZleceniaDBDetailForm.ModulDBLookupAliasEditGetDataField: String;
begin
  result := sUNIMODULZSI_ID;
end;

function TZLETypZleceniaDBDetailForm.ModulDBLookupAliasEditGetQuery: TUNIQuery;
var iFirmaID: Integer;
begin
  iFirmaID := 0;
  if vWieloodzialowosc and (Parameters.Values[sUNIODDZIAL_ID]<>'') then
    iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID])
  else if vWielofirmowosc then iFirmaID := vAktywnaFirma;
  
  result := UNISysDM.UNIPokazIObsluzDane( sUNIMODULZSI,
                                          '(@'+sUNISYSALIAS_ModulZSI_Czy_Aktywny+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK)+')and'+
                                          '(@'+sUNISYSALIAS_ModulZSI_Czy_DOS+'='+QuotedStr(sUNICONST_ALTERNATYWA_NIE)+')',
                                          false, false,
                                          sUNISYSALIAS_ModulZSI_ID+';'+
                                          sUNISYSALIAS_ModulZSI_Kod+';'+
                                          sUNISYSALIAS_ModulZSI_Nazwa,
                                          iFirmaID,
                                          DMAQFbN(sUNIMODULZSI_ID).AsString );
end;

procedure TZLETypZleceniaDBDetailForm.ModulDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ModulDBLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sUNISYSALIAS_ModulZSI_ID;
    Alias_Name := sUNISYSALIAS_ModulZSI_Kod;
    AdditionalAliases := sUNISYSALIAS_ModulZSI_Nazwa;
  end;
end;

function TZLETypZleceniaDBDetailForm.ModulDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    ModulNazwaLabel.Caption := AliasSrc.FieldByName(sUNIMODULZSI_NAZWA).AsString;
  end;
  result := true;
end;

procedure TZLETypZleceniaDBDetailForm.ParametrDBConstComboBoxChange(
  Sender: TObject);
var iIndex: Integer;
begin
  //inherited;
  if bInit then Exit;
  if (Sender as TUNIDBConstComboBox).ItemID = cZLEAktywnosc_NieAktywnyID then Exit;

  for iIndex := 0 to ParametryRemontyGroupBox.ControlCount-1 do begin
    if (ParametryRemontyGroupBox.Controls[iIndex] is TUNIDBConstComboBox)and
       ((Sender as TUNIDBConstComboBox) <> ParametryRemontyGroupBox.Controls[iIndex]) then begin
      (ParametryRemontyGroupBox.Controls[iIndex] as TUNIDBConstComboBox).ItemID := cZLEAktywnosc_NieAktywnyID;
    end;
  end;

  if not bWywolaniezPoziom then begin
    if not ElemInfZleceniaDBCheckBox.Checked then
       ElemInfZleceniaDBCheckBox.Checked := True;

    bWywolaniezParametr := True;
    try
      if      Sender = LokalDBConstComboBox  then
         PoziomInfZlecDBConstComboBox.ItemID := '0'
      else if Sender = ZasobDBConstComboBox  then
         PoziomInfZlecDBConstComboBox.ItemID := '1'
      else if Sender  = KlatkaDBConstComboBox  then
         PoziomInfZlecDBConstComboBox.ItemID := '2'
      else if Sender  = BramaDBConstComboBox then
         PoziomInfZlecDBConstComboBox.ItemID := '3'
      else if Sender  = BudynekDBConstComboBox then
         PoziomInfZlecDBConstComboBox.ItemID := '4'
      else if Sender = NieruchomoscDBConstComboBox then
         PoziomInfZlecDBConstComboBox.ItemID := '5'
      else if Sender = RejonDBConstComboBox then
         PoziomInfZlecDBConstComboBox.ItemID := '7'
      else if Sender = UlicaDBConstComboBox then
         PoziomInfZlecDBConstComboBox.ItemID := '8'
      else if Sender = ElementSieciDBConstComboBox then
         PoziomInfZlecDBConstComboBox.ItemID := '9'
      else if Sender = SkladnikElemSieciDBConstComboBox then
         PoziomInfZlecDBConstComboBox.ItemID := '11';
      //else nieznany poziom??
    finally
      bWywolaniezParametr := False;
    end;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.PoziomInfZlecDBConstComboBoxChange(
  Sender: TObject);
//var iIndex: Integer;
begin
  //inherited;
  if not (bInit or bWywolaniezParametr) then begin
    bWywolaniezPoziom := True;
    try
      if (Sender as TUNIDBConstComboBox).ItemID = '0'  then begin
         if LokalDBConstComboBox.ItemID = cZLEAktywnosc_NieAktywnyID then
            LokalDBConstComboBox.ItemID := cZLEAktywnosc_OpcjonalnyID;
      end else
      if (Sender as TUNIDBConstComboBox).ItemID = '1'  then begin
         if ZasobDBConstComboBox.ItemID = cZLEAktywnosc_NieAktywnyID then
            ZasobDBConstComboBox.ItemID := cZLEAktywnosc_OpcjonalnyID;
      end else
      if (Sender as TUNIDBConstComboBox).ItemID = '2'  then begin
         if KlatkaDBConstComboBox.ItemID = cZLEAktywnosc_NieAktywnyID then
            KlatkaDBConstComboBox.ItemID := cZLEAktywnosc_OpcjonalnyID;
      end else
      if (Sender as TUNIDBConstComboBox).ItemID = '3'  then begin
         if BramaDBConstComboBox.ItemID = cZLEAktywnosc_NieAktywnyID then
            BramaDBConstComboBox.ItemID := cZLEAktywnosc_OpcjonalnyID;
      end else
      if (Sender as TUNIDBConstComboBox).ItemID = '4'  then begin
         if BudynekDBConstComboBox.ItemID = cZLEAktywnosc_NieAktywnyID then
            BudynekDBConstComboBox.ItemID := cZLEAktywnosc_OpcjonalnyID;
      end else
      if (Sender as TUNIDBConstComboBox).ItemID = '5'  then begin
         if NieruchomoscDBConstComboBox.ItemID = cZLEAktywnosc_NieAktywnyID then
            NieruchomoscDBConstComboBox.ItemID := cZLEAktywnosc_OpcjonalnyID;
      end else
      if (Sender as TUNIDBConstComboBox).ItemID = '7'  then begin
         if RejonDBConstComboBox.ItemID = cZLEAktywnosc_NieAktywnyID then
            RejonDBConstComboBox.ItemID := cZLEAktywnosc_OpcjonalnyID;
      end else
      if (Sender as TUNIDBConstComboBox).ItemID = '8'  then begin
         if UlicaDBConstComboBox.ItemID = cZLEAktywnosc_NieAktywnyID then
            UlicaDBConstComboBox.ItemID := cZLEAktywnosc_OpcjonalnyID;
      end else
      if (Sender as TUNIDBConstComboBox).ItemID = '9'  then begin
         if ElementSieciDBConstComboBox.ItemID = cZLEAktywnosc_NieAktywnyID then
            ElementSieciDBConstComboBox.ItemID := cZLEAktywnosc_OpcjonalnyID;
      end else
      if (Sender as TUNIDBConstComboBox).ItemID = '11'  then begin
         if SkladnikElemSieciDBConstComboBox.ItemID = cZLEAktywnosc_NieAktywnyID then
            SkladnikElemSieciDBConstComboBox.ItemID := cZLEAktywnosc_OpcjonalnyID;
      end;

    finally
      bWywolaniezPoziom := False;
    end;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.ModulDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  with ModulDBLookupAliasEdit do begin
    Clear;
    if OpenMode in [omNew, omEdit] then
       DMAQFbN(DataField).Clear;
    ModulNazwaLabel.Caption := '';
  end;
end;

function TZLETypZleceniaDBDetailForm.RegulaDBLookupAliasEditGetDataField: String;
begin
  result := sASOREG_ID;
end;

function TZLETypZleceniaDBDetailForm.RegulaDBLookupAliasEditGetQuery: TUNIQuery;
begin
  result := nil;
  if DataManagers.Available(sASOModulID) then begin
    result := ASODM.PokazIObsluzReguly( sASOAlias_Reg_ID+';'+
                                        sASOAlias_Modul_Nazwa,
                                        '@'+sASOAlias_Reg_Aktywna+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK),
                                        True, False, sASOREG_ID+'='+DMAQFbN(sASOREG_ID).AsString );
  end;
end;

procedure TZLETypZleceniaDBDetailForm.RegulaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if DataManagers.Available(sASOModulID) then begin
    with RegulaDBLookupAliasEdit do begin
      AliasManager := ASODM.AliasManager;
      Alias_ID := sASOAlias_Reg_ID;
      Alias_Name := sASOAlias_Modul_Nazwa;
      AdditionalCondition := '@'+sASOAlias_Reg_Aktywna+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK);
    end;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.ElementINFDBCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  if ElementINFDBCheckBox.Checked then begin
    PoziomINFLabel.Enabled := True;
    PoziomINFDBConstComboBox.Enabled := True;
  end else begin
    PoziomINFLabel.Enabled := False;
    PoziomINFDBConstComboBox.Enabled := False;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.ElemInfZleceniaDBCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  if ElemInfZleceniaDBCheckBox.Checked then begin
    PoziomINFZlecLabel.Enabled := True;
    PoziomInfZlecDBConstComboBox.Enabled := True;
  end else begin
    PoziomINFZlecLabel.Enabled := False;
    PoziomInfZlecDBConstComboBox.Enabled := False;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.NaPodstDokMagDBCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  { ---- }
end;

procedure TZLETypZleceniaDBDetailForm.UwagiDBCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  { --- }
end;

procedure TZLETypZleceniaDBDetailForm.ProdukcyjneDBCheckBoxClick(
  Sender: TObject);
begin
    // dla zlece produkcyjnych wymuszana jest moliwo czenia zlecenia z zasobami
  if(DataModule <> nil) then
    UstawPowiazanieZZasobami();
  RecepturaDBCheckBox.Visible := ProdukcyjneDBCheckBox.Checked;
end;

function TZLETypZleceniaDBDetailForm.OddzialDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWar: String;
begin
  result  := nil;
  if not OpenMode in [omNew,omEdit] then exit;

  if not DMAQFbN(sUNIODDZIAL_ID).IsNull then
     sWar:=sUNIODDZIAL_ID+'='+DMAQFbN(sUNIODDZIAL_ID).AsString
  else
    sWar:='';

  Result:=UNISysDM.UNIPokazIObsluzDane( sUNIODDZIAL, '', True, False,
                                        sUNISYSALIAS_Oddzial_ID+';'+
                                        sUNISYSALIAS_Oddzial_Symbol+';'+
                                        sUNISYSALIAS_Oddzial_Nazwa,
                                        vAktywnaFirma, sWar);
end;

procedure TZLETypZleceniaDBDetailForm.OddzialDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  inherited;
  if vWieloodzialowosc or vWielofirmowosc then begin
    with OddzialDBLookupAliasEdit do begin
      AliasManager := UNISysDM.AliasManager;
      Alias_ID := sUNISYSALIAS_Oddzial_ID;
      Alias_Name := sUNISYSALIAS_Oddzial_Symbol;
      AdditionalAliases := sUNISYSALIAS_Oddzial_Nazwa;
    end;
  end;
end;

function TZLETypZleceniaDBDetailForm.OddzialDBLookupAliasEditGetDataField: String;
begin
  result := sUNIODDZIAL_ID;
end;

function TZLETypZleceniaDBDetailForm.OddzialDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := True;
  if AliasSrc <> nil then begin
    OddzialDBLookupAliasEdit.Hint := AliasSrc.FieldByName(sUNIODDZIAL_NAZWA).AsString;
    OddzialNazwaLabel.Caption := AliasSrc.FieldByName(sUNIODDZIAL_NAZWA).AsString;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.OddzialDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  { ---- -}
end;

procedure TZLETypZleceniaDBDetailForm.ZmienSkladnikKosztowButtonClick(
  Sender: TObject);
var oParams: TKeyValues;
    vForm: TUNIDBDetailForm;
begin
  inherited;

  oParams := TKeyValues.CreateEmpty;
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Skadniki kontroli wartociowej');
    oParams.Values[sZLETYPSKLADW_KOLEJNOSC] := IntToStr(oSkladnikiKontroliKosztow.GetKolejnosc(TZLESkladnikKontroliWartosciowejDBGridForm(ContainedForms[iKontrolaKosztowFormIndex]).DMAQFbN(sZLESKLADWART_ID).AsInteger));
    //oParams.Add(cIDforForm + '=' + IntToStr(ac_iId));
  end;
  try
    vForm := FormManager.OpenDBDetail((ContainedForms[iKontrolaKosztowFormIndex] as TZLESkladnikKontroliWartosciowejDBGridForm), 'TZLESkladnikKontroliWartosciowejDBDetailForm',
                                     omEdit+omShowModal+omHidden{Lookup+omMultiSelect}, oParams );
    if vForm.ShowModal = mrOK then begin
       if oParams.Values[sZLETYPSKLADW_KOLEJNOSC] <> '' then begin
          if oSkladnikiKontroliKosztow.GetKolejnosc(TZLESkladnikKontroliWartosciowejDBGridForm(ContainedForms[iKontrolaKosztowFormIndex]).DMAQFbN(sZLESKLADWART_ID).AsInteger) <> StrToInt(oParams.Values[sZLETYPSKLADW_KOLEJNOSC]) then begin
             oSkladnikiKontroliKosztow.SetKolejnosc(TZLESkladnikKontroliWartosciowejDBGridForm(ContainedForms[iKontrolaKosztowFormIndex]).DMAQFbN(sZLESKLADWART_ID).AsInteger, StrToInt(oParams.Values[sZLETYPSKLADW_KOLEJNOSC]));
          end;
       end;
    end;
  finally
    if vForm <> nil then FreeAndNil(vForm);
  end;
end;

procedure TZLETypZleceniaDBDetailForm.ZmienSkladnikIlosciButtonClick(
  Sender: TObject);
var oParams: TKeyValues;
    vForm: TUNIDBDetailForm;
begin
  inherited;

  oParams := TKeyValues.CreateEmpty;
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Skadniki kontroli ilociowej');
    Add(sZLETYPSKLADIL_KOLEJNOSC + '=' + IntToStr(oSkladnikiKontroliIlosci.GetKolejnosc(TZLESkladnikKontroliIlosciowejDBGridForm(ContainedForms[iKontrolaIlosciFormIndex]).DMAQFbN(sZLESKLADIL_ID).AsInteger)));
    //oParams.Add(cIDforForm + '=' + IntToStr(ac_iId));
  end;
  try
    vForm := FormManager.OpenDBDetail((ContainedForms[iKontrolaIlosciFormIndex] as TZLESkladnikKontroliIlosciowejDBGridForm), 'TZLESkladnikKontroliIlosciowejDBDetailForm',
                                     omEdit+omShowModal+omHidden{Lookup+omMultiSelect}, oParams );
    if vForm.ShowModal = mrOK then begin
       if oParams.Values[sZLETYPSKLADIL_KOLEJNOSC] <> '' then begin
          if oSkladnikiKontroliIlosci.GetKolejnosc(TZLESkladnikKontroliIlosciowejDBGridForm(ContainedForms[iKontrolaIlosciFormIndex]).DMAQFbN(sZLESKLADIL_ID).AsInteger) <> StrToInt(oParams.Values[sZLETYPSKLADIL_KOLEJNOSC]) then begin
             oSkladnikiKontroliIlosci.SetKolejnosc(TZLESkladnikKontroliIlosciowejDBGridForm(ContainedForms[iKontrolaIlosciFormIndex]).DMAQFbN(sZLESKLADIL_ID).AsInteger, StrToInt(oParams.Values[sZLETYPSKLADIL_KOLEJNOSC]));
          end;
       end;
    end;
  finally
    if vForm <> nil then FreeAndNil(vForm);
  end;
end;

procedure TZLETypZleceniaDBDetailForm.ZAOZapotrzTypLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery:   TUNIQuery;
  sAliasy:  string;
  sWarunek: string;
begin
  UNIDajAliasyZLookupa(ZAOZapotrzTypLookupAliasEdit, sAliasy, sWarunek);
  oQuery  := ZAODM.ZAOPokazIObsluzDane(sZAOZAPOTRZTYP,
    sAliasy, sWarunek,
    false, true, false, DMAQFbN(sZAOZAPOTRZTYP_ID).AsString
  );
  if(oQuery <> nil) then begin
    try
      ZAOZapotrzTypLookupAliasEditSetData(oQuery);
    finally
      FreeAndNil(oQuery);
    end;
  end;
end;

procedure TZLETypZleceniaDBDetailForm.ZAOZapotrzTypLookupAliasEditDelKey(
  Sender: TObject);
begin
  DMAQFbN(sZAOZAPOTRZTYP_ID).Clear();
  ZAOZapotrzTypLookupAliasEdit.Clear();
  LZAOZapotrzTypLabel.Caption := '';
end;

function TZLETypZleceniaDBDetailForm.ZAOZapotrzTypLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  DMAQFbN(sZAOZAPOTRZTYP_ID).AsInteger  := AliasSrc.Fields[0].AsInteger;
  ShowZapotrzTyp(AliasSrc);
  result  := true;
end;

initialization
  FormManager.RegisterForm( TZLETypZleceniaDBDetailForm, 'Typ zlecenia', sZLEModulID );
end.
