unit ZleZasobyPracaDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-11-13 Tomjen   Utworzone
2008-07-09 Adam     Dodany status rekordu
2008-10-20 Adam     Dodana kontrola utworzenia rekordw wyceny zlecenia
2010-02-22 Adam     Rejestracja pracy osb poprzez ECP
2010-03-22 Adam     Dodane pole "Typ raportu"
2010-05-24 Adam     Zapamitywanie ostatnio podanego typu raportu
2010-11-04 Tomjen   Dooenie obsugi skadnika czasu pracy na formatce
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, DBCtrls, Mask, UNIDateEditUnit, UNIDBDateEditUnit,
  UNIStaleUnit, UNIDataModuleUnit, UNIGodzEdit, UNIDBConstComboBoxUnit,
  UNIFormUnit, KeyManagerUnit, UNIDBGridFormUnit;

type
  TZLEZasobyPracaDBDetailForm = class(TUNIDBDetailForm)
    RaportTypPanel: TUNIPanel;
    MainPanel: TUNIPanel;
    DataLabel: TUNILabel;
    DataDBDateEdit: TUNIDBDateEdit;
    ZlecenieLabel: TUNILabel;
    ZlecenieSymbolDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    ZlecenieNazwaLabel: TUNILabel;
    ZakladkiPageControl: TUNIPageControl;
    OsobyTabSheet: TTabSheet;
    BrakiTabSheet: TTabSheet;
    OsobyPanel: TUNIPanel;
    BrakiPanel: TUNIPanel;
    UzytkownikPanel: TUNIPanel;
    DopiszButton: TUNIButton;
    UsunButton: TUNIButton;
    PrzyciskiPanel: TUNIPanel;
    Dopisz2Button: TUNIButton;
    Usun2Button: TUNIButton;
    ProdukcjaPanel: TUNIPanel;
    ZuzyciePaliwaPanel: TUNIPanel;
    PracaPanel: TUNIPanel;
    ElemPlanuProdButton: TUNIButton;
    ElemPlanuProdLabel: TUNILabel;
    UsunElemPlanProdButton: TUNIButton;
    CzasPracyLabel: TUNILabel;
    UNILabel4: TUNILabel;
    IloscPracyDBEdit: TUNIDBEdit;
    PozycjaZleceniaPanel: TUNIPanel;
    StawkaPanel: TUNIPanel;
    ZasobPanel: TUNIPanel;
    PozycjaRecepturyPanel: TUNIPanel;
    RecepPozLabel: TUNILabel;
    RecepPozDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    RecepPozOpisLabel: TUNILabel;
    ZmianaPanel: TUNIPanel;
    ZmianaLabel: TUNILabel;
    ZmianaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    ZmianaOpisLabel: TUNILabel;
    ZasobLabel: TUNILabel;
    ZasobDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    OsobaPanel: TUNIPanel;
    StawkaLabel: TUNILabel;
    StawkaDBEdit: TUNIDBEdit;
    PozycjaZleceniaLabel: TUNILabel;
    PozycjaLookupAliasEdit: TUNILookupAliasEdit;
    AsortymentLabel: TUNILabel;
    AsortymentSymbolDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    AsortymentNazwaLabel: TUNILabel;
    OsobaLabel: TUNILabel;
    OsobaSymbolDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    OsobaNazwaLabel: TUNILabel;
    EwidencjaZuzPaliwaLabel: TUNILabel;
    EwidencjaZuzPaliwaDBEdit: TUNIDBEdit;
    RodzajECPRadioGroup: TUNIRadioGroup;
    LWycena1Label: TUNILabel;
    LWycena2Label: TUNILabel;
    OpisPanel: TUNIPanel;
    OpisLabel: TUNILabel;
    OpisMemo: TUNIMemo;
    EwidStatusPanel: TUNIPanel;
    EwidStatusLabel: TUNILabel;
    StatusDBConstComboBox: TUNIDBConstComboBox;
    IloscDBEdit: TUNIDBEdit;
    CzasPracyGodzEdit: TUNIGodzEdit;
    UNILabel1: TUNILabel;
    RaportTypLookupAliasEdit: TUNILookupAliasEdit;
    SkladnikCzasuPanel: TUNIPanel;
    SkladnikCzasuLabel: TUNILabel;
    SkladnikCzasuPracyDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    SkladnikOpisLabel: TUNILabel;
    UwagiLabel: TUNILabel;
    UwagiDBMemo: TUNIDBMemo;
    DataDoLabel: TUNILabel;
    DataDoDBDateEdit: TUNIDBDateEdit;
    CzasPracyRazemGodzEdit: TUNIGodzEdit;
    IloscGodzinRazemDBEdit: TUNIDBEdit;
    RazemLabel: TUNILabel;
    StanowiskoLabel: TUNILabel;
    StanowiskoDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    procedure ZasobDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function ZasobDBLookupAliasEditGetQuery: TUNIQuery;
    procedure ZasobDBLookupAliasEditDelKey(Sender: TObject);
    function ZasobDBLookupAliasEditGetDataField: String;
    function ZasobDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure ZlecenieSymbolDBLookupAliasEditInitAliasInfo(
      Sender: TObject);
    function ZlecenieSymbolDBLookupAliasEditGetQuery: TUNIQuery;
    function ZlecenieSymbolDBLookupAliasEditGetDataField: String;
    procedure ZlecenieSymbolDBLookupAliasEditDelKey(Sender: TObject);
    function ZlecenieSymbolDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure ZmianaDBLookupAliasEditDelKey(Sender: TObject);
    function ZmianaDBLookupAliasEditGetDataField: String;
    function ZmianaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure ZmianaDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function ZmianaDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    {procedure PlanProdElemDBLookupAliasEditDelKey(Sender: TObject);
    function PlanProdElemDBLookupAliasEditGetDataField: String;
    function PlanProdElemDBLookupAliasEditGetQuery: TUNIQuery;
    procedure PlanProdElemDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function PlanProdElemDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;}
    procedure ElemPlanuProdButtonClick(Sender: TObject);
    procedure DopiszButtonClick(Sender: TObject);
    procedure UsunButtonClick(Sender: TObject);
    procedure Dopisz2ButtonClick(Sender: TObject);
    procedure Usun2ButtonClick(Sender: TObject);
    procedure UsunElemPlanProdButtonClick(Sender: TObject);
    procedure RecepPozDBLookupAliasEditDelKey(Sender: TObject);
    function RecepPozDBLookupAliasEditGetDataField: String;
    function RecepPozDBLookupAliasEditGetQuery: TUNIQuery;
    procedure RecepPozDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function RecepPozDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure OsobaSymbolDBLookupAliasEditDelKey(Sender: TObject);
    function OsobaSymbolDBLookupAliasEditGetDataField: String;
    function OsobaSymbolDBLookupAliasEditGetQuery: TUNIQuery;
    function OsobaSymbolDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure OsobaSymbolDBLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure PozycjaLookupAliasEditButtonClick(Sender: TObject);
    function PozycjaLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure AsortymentSymbolDBLookupAliasEditDelKey(Sender: TObject);
    function AsortymentSymbolDBLookupAliasEditGetDataField: String;
    function AsortymentSymbolDBLookupAliasEditGetQuery: TUNIQuery;
    procedure AsortymentSymbolDBLookupAliasEditInitAliasInfo(
      Sender: TObject);
    function AsortymentSymbolDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure RodzajECPRadioGroupClick(Sender: TObject);
    procedure DataDBDateEditDateChange(Sender: TObject);
    procedure PozycjaLookupAliasEditExit(Sender: TObject);
    procedure PozycjaLookupAliasEditDelKey(Sender: TObject);
    procedure DataDBDateEditEnter(Sender: TObject);
    procedure RaportTypLookupAliasEditButtonClick(Sender: TObject);
    procedure RaportTypLookupAliasEditDelKey(Sender: TObject);
    function RaportTypLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure ZlecenieSymbolDBLookupAliasEditEnter(Sender: TObject);
    procedure SkladnikCzasuPracyDBLookupAliasEditDelKey(Sender: TObject);
    function SkladnikCzasuPracyDBLookupAliasEditGetDataField: String;
    function SkladnikCzasuPracyDBLookupAliasEditGetQuery: TUNIQuery;
    procedure SkladnikCzasuPracyDBLookupAliasEditInitAliasInfo(
      Sender: TObject);
    function SkladnikCzasuPracyDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure CzasPracyGodzEditExit(Sender: TObject);
    procedure IloscDBEditExit(Sender: TObject);
  private
    FZakladkaOsobyFormIndex: Integer;
    FZakladkaBrakiFormIndex: Integer;
    FDataPocz, FDataKonc: TDateTime;
    FRecepturaID: Integer;
    FOldZlecID : Integer;
    bPlanProdChange: Boolean;
    iOsobaOld: Integer;
    bZmianaZasobu: Boolean;
    iZasobOldID: Integer;
    m_oGridOsob:  TUNIDBGridForm;
    m_bOsobyKDECP:boolean;
    m_sRapotTyp:  string;
    iFormECP_ID : Integer;

    procedure InicjujPlanProdElem();
    procedure WyswietlRodzajECP(sRodzajECP: String);
    procedure SetDefaults;
    procedure SetFieldFormat();
    procedure AddContainedForms();
    //function  SaOsobyBezKDECP():  boolean;
    procedure InitializeControls();
    procedure WyznaczRodzajFormatkiECP();
  protected
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure BeforeShow; override;
    procedure AssignProperties(); override;
    function  GetPropertyValue(
                        a_sPropertyName:  string
              ):  string; override;
    procedure InternalOpen; override;
    procedure GetPositionAndParentForContainedForm( const nr:integer;
                                                    var APosition: TRect;
                                                    var AParent: TWinControl;
                                                    var AAlign:TAlign); override;
  public
    FRodzajECP: string;
    procedure SelectButtonPressed; override;
    function Validate(): Boolean; override;
    procedure DopiszOsobe();
    procedure UsunOsobe();
    procedure DopiszBrak();
    procedure UsunBrak();
    procedure UstawOkres(dData: TDate);
    //procedure GetParametersForForm(a_oForm: TUNIForm; a_oParameters: TKeyValues); override;
    property  ZakladkaOsobyFormIndex: integer read FZakladkaOsobyFormIndex;
    property  ZakladkaBrakiFormIndex: integer read FZakladkaBrakiFormIndex;
    property  RodzajECP: String read FRodzajECP;
    property  bOsobyKDECP: Boolean read m_bOsobyKDECP;
  end;

implementation

uses
  Dodatki,
  FormManagerUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  UNISysDefUnit,
  SystemDefUnit,
  UNISysDataManagerUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLEZasobyPracaUnit,
  ZLESzczegoloweKosztyDBGridUnit,
  KDPRADefUnit,
  KDECPDefUnit,
  KDECPDataManagerExtUnit,
  KDDefUnit,
  KDDataManagerExtUnit,
  LWPDataManagerExtUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  SPDefUnit,
  FKDefUnit,
  LWPDefUnit,
  UniqueKeyUnit,
  ZLEOsobyDBGridFormUnit,
  ZLEZasobyPracaDBGridFormUnit,
  ZLEZasobyBrakiDBGridFormUnit,
  SPDataManagerExtUnit;

{$R *.DFM}

(**************************
procedure TZLEZasobyPracaDBDetailForm.GetParametersForForm(
  a_oForm:              TUNIForm;
  a_oParameters:        TKeyValues
);
begin
  {if((LowerCase(a_oForm.ClassName) = 'tzaozapotrzebowaniepozzleceniedbgridform') or
  (LowerCase(a_oForm.ClassName) = 'tzamzamowieniepozzleceniedbgridform') or
  (LowerCase(a_oForm.ClassName) = 'tzamzapytaniepozzleceniedbgridform') or
  (LowerCase(a_oForm.ClassName) = 'tzlezleceniematerialdbgridform')) then
    a_oParameters.Values[sZLEZLECENIE_ID] := DMAQFbN(sZLEZLECENIE_ID).AsString
  else}
    inherited;
end;
**************************)

const
  csPropTypRaportu  = 'TYPR';

procedure TZLEZasobyPracaDBDetailForm.WyznaczRodzajFormatkiECP();
begin
  iFormECP_ID := cZLEFormatkaBrakID;
  {
    //Formatka Osb osadzona na RCP zasobw
    cZLEFormatkaBrakID     = 0;
    cZLEFormatkaOsobyID    = 1;
    cZLEFormatkaKadryECPID = 2;
    cZLEFormatkaListaRCPID = 3;
  }

  {OmNew - Parameters.Values[sZLEZASOBYPRACA_FORMECP_ID],
   OmEdit, OmDelete, OmView - DMAQFbN(sZLEZASOBYPRACA_FORMECP_ID).AsInteger}
  if (DMAQFbN(sZLECONST_RODZAJECP_ID).AsString <> cZLERodzajECP_ProdukcjaID) then begin
     iFormECP_ID := cZLEFormatkaBrakID; //Brak  formatki osadzonej
     Exit;
  end;

  if (OpenMode = OmNew) and
     (TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_FORMECP_ID] <> '') then begin
    try
      iFormECP_ID := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_FORMECP_ID]);
    except
      iFormECP_ID := 0;
    end;
  end else begin
    iFormECP_ID := DMAQFbN(sZLEZASOBYPRACA_FORMECP_ID).AsInteger;
  end;

  // Nie ma jeszcze danych dla tej formatki - ustalam formatk wg parametrw
  if iFormECP_ID = 0 then begin
     iFormECP_ID := cZLEFormatkaOsobyID;
     if DataManagers.Available(sKDECPModulID) then begin
       if ZLEDM.vZLERozliczanieAkorduECPWlaczone then
         iFormECP_ID := cZLEFormatkaListaRCPID
       else if ZLEDM.vZLEWysylanieECPWlaczone then
         iFormECP_ID := cZLEFormatkaKadryECPID;
     end;
  end;

  //Dla OmEdit zapisujemy FormECP_ID w momencie zapisu danych do bazy.
  if OpenMode = OmNew then
    DMAQFbN(sZLEZASOBYPRACA_FORMECP_ID).AsInteger := iFormECP_ID;
end;

function TZLEZasobyPracaDBDetailForm.Validate: Boolean;
begin
  result := inherited Validate();
  if result then begin
     {Sprawdzenie daty}
     if DataManagers.Available(sLWPModulID) then
        if not DMAQFbN(sLWPPLANPRODEL_ID).IsNull then begin
           if (FDataPocz > 0) and (FDataKonc > 0) then begin
              if (DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime < FDataPocz) or
                 (DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime > FDataKonc) then begin
                 result := False;
                 Komunikat(cWarning, 'Data niezgodna z wybranym planem produkcji');
                 DataDBDateEdit.SetFocus;
                 Exit;
              end;
           end;
        end;
     if Result and (ZLEDM.vZLEDataBlokadyECP > 0) then begin
        if Trunc(DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime) < ZLEDM.vZLEDataBlokadyECP then begin
           result := False;
           Komunikat(cWarning, 'Data wczeniejsza od daty blokady');
           DataDBDateEdit.SetFocus;
           Exit;
        end;
     end;
  end;

  if result then begin
     {Sprawdzamy czy data do > data}
     if (not DMAQFbN(sZLEZASOBYPRACA_DATA_DO).IsNull) and (DMAQFbN(sZLEZASOBYPRACA_DATA_DO).AsDateTime < DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime) then begin
        Komunikat(cWarning, 'Data do jest wczesniejsza od daty. Popraw dane');
        result := False;
        DataDoDBDateEdit.SetFocus;
     end;
  end;

  if result then begin
     {Sprawdzamy czy wypenione zostao jedno z pl: osoba albo zasb}
     if DMAQFbN(sKDOSOBA_ID).IsNull and DMAQFbN(sZLEZASOB_ID).IsNull then begin
        Komunikat(cWarning, 'Przynajmniej jedno z pl osoba lub zasb musi by uzupenione!');
        result := False;
        OsobaSymbolDBLookupAliasEdit.SetFocus();
     end;
  end;

end;
procedure TZLEZasobyPracaDBDetailForm.SetDefaults;
var
  iIlosc: Integer;
  sTmp: String;
  sZleZlecenieID: String;
begin
  (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
  try

    {Rodzaj Ewidencji}
    if TUNIDBGridForm(Owner).Parameters.Values[sZLECONST_RODZAJECP_ID] <> '' then
       DMAQFbN(sZLECONST_RODZAJECP_ID).AsString := TUNIDBGridForm(Owner).Parameters.Values[sZLECONST_RODZAJECP_ID]
    else
    if Parameters.Values[sZLECONST_RODZAJECP_ID] <> '' then
       DMAQFbN(sZLECONST_RODZAJECP_ID).AsString := Parameters.Values[sZLECONST_RODZAJECP_ID]
    else
       DMAQFbN(sZLECONST_RODZAJECP_ID).AsString := cZLERodzajECP_ProdukcjaID;

    WyswietlRodzajECP(DMAQFBN(sZLECONST_RODZAJECP_ID).AsString);

    {Data}
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_DATA] = '' then
          DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime := Date
    else  DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime := StrToDate(TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_DATA]);

    if DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime > 0 then
       UstawOkres(DataDBDateEdit.Date);

    {Zasb}
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_ID] <> '' then begin
      DMAQFbN(sZLEZASOB_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_ID]);

      if not DMAQFbN(sZLEZASOB_ID).IsNull then begin
         ZasobDBLookupAliasEdit.InitiateData(DMAQFbN(sZLEZASOB_ID).AsInteger);
         if (Parameters.Values[sZLECONST_RODZAJECP_ID] = cZLERodzajECP_OsobaID) and
            (DMAQFbN(sZLECONST_RODZAJECP_ID).AsString = cZLERodzajECP_OsobaID) then begin
            DMAQFbN(sZLECONST_RODZAJECP_ID).AsString := cZLERodzajECP_ZasobID;
            WyswietlRodzajECP(DMAQFBN(sZLECONST_RODZAJECP_ID).AsString);
         end;
      end;
    end;

    {Zlecenie}
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_ID] <> '' then begin
      DMAQFbN(sZLEZLECENIE_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_ID]);

       if not DMAQFbN(sZLEZLECENIE_ID).IsNull then
          ZlecenieSymbolDBLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIE_ID).AsInteger);
    end;

    {Pozycja receptury}
    if(DataManagers.Available(sLWPModulID)) then begin
      if TUNIDBGridForm(Owner).Parameters.Values[sLWPRECEPPOZ_ID] <> '' then begin
        DMAQFbN(sLWPRECEPPOZ_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sLWPRECEPPOZ_ID]);

         if not DMAQFbN(sLWPRECEPPOZ_ID).IsNull then begin
            RecepPozOpisLabel.Caption := '';
            {Inicjacja Pozycji receptury}
            RecepPozDBLookupAliasEdit.InitiateData(DMAQFbN(sLWPRECEPPOZ_ID).AsInteger);
         end;
      end;
    end else  // if(DataManagers.Available(sLWPModulID))
      RecepPozDBLookupAliasEdit.Visible := false;

    {Zmiana}
    if TUNIDBGridForm(Owner).Parameters.Values[sKDZMIANYDEF_ID] <> '' then
      DMAQFbN(sKDZMIANYDEF_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sKDZMIANYDEF_ID]);

    {Jednostka org.}
    if TUNIDBGridForm(Owner).Parameters.Values[sUNIJEDNOSTKAORG_ID] <> '' then
      DMAQFbN(sUNIJEDNOSTKAORG_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sUNIJEDNOSTKAORG_ID]);

    if(DataManagers.Available(sLWPModulID)) then begin
      {Element Planu Produkcji}
      if TUNIDBGridForm(Owner).Parameters.Values[sLWPPLANPRODEL_ID] <> '' then
        DMAQFbN(sLWPPLANPRODEL_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sLWPPLANPRODEL_ID]);
      if not DMAQFbN(sLWPPLANPRODEL_ID).IsNull then
         InicjujPlanProdElem();
    end else begin  // if(DataManagers.Available(sLWPModulID))
      ElemPlanuProdButton.Visible := false;
      UsunElemPlanProdButton.Visible  := false;
    end;

    {Czas pracy}
    {if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY] <> '' then
         DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY]);}
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY_NOM] <> '' then begin
      if not ZLEDM.vZLEFormatGodzinLiczba then
         DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsInteger :=  StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY_NOM])
      else
         DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat :=
            Zaokraglij(StrToFloat(TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY_NOM]), UNIGetFracFromValueFormat(12.6 {ASODM.vAsoFormatCeny}));
    end else begin
       DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat := 0;
    end;

    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY] <> '' then begin
      if not ZLEDM.vZLEFormatGodzinLiczba then
         DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsInteger :=  StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY])
      else
         DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat :=
            Zaokraglij(StrToFloat(TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY]), UNIGetFracFromValueFormat(12.6 {ASODM.vAsoFormatCeny}));
    end else begin
       DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat := 0;
    end;

    {Ilo pracy}
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_IL_PRACY] <> '' then begin
       sTmp := TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_IL_PRACY];
       if pos(ThousandSeparator, sTmp) > 0 then
          sTmp := ZZBStrTran(sTmp, ThousandSeparator, '', iIlosc);
       DMAQFbN(sZLEZASOBYPRACA_IL_PRACY).AsFloat := Zaokraglij(StrToFloat(sTmp), UNIGetFracFromValueFormat(12.2 {ASODM.vAsoFormatCeny}));
    end;

    {Status}
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_STATUS] <> '' then
         DMAQFbN(sZLEZASOBYPRACA_STATUS).AsString := TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_STATUS]
    else DMAQFbN(sZLEZASOBYPRACA_STATUS).AsString := cZLEConstZasobPracaStatus_WprowadzonyID;

    {Poz. zlecenia}
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIEPOZ_ID] <> '' then begin
      {Kontrola czy pozycja jest z tego samego zlecenia przekazanego w parametrach}
      sZleZlecenieID := SQLManager.OpenQueryWithResult('SELECT ' + sZLEZLECENIE_ID + ' ' +
                                          'FROM %s ' +
                                          'WHERE ' + sZLEZLECENIEPOZ_ID + '=' + TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIEPOZ_ID],
                                          [sZLEZLECENIEPOZ]);
      if sZleZlecenieID = IntToStr(DMAQFbN(sZLEZLECENIE_ID).AsInteger) then begin
        DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIEPOZ_ID]);

        if not DMAQFbN(sZLEZLECENIEPOZ_ID).IsNull then
           PozycjaLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger);
      end;
    end;

    {Osoba}
    if TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_ID] <> '' then begin
      DMAQFbN(sKDOSOBA_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_ID]);

       if not DMAQFbN(sKDOSOBA_ID).IsNull then
          OsobaSymbolDBLookupAliasEdit.InitiateData(DMAQFbN(sKDOSOBA_ID).AsInteger);
    end;

    {Asortyment}
    if DataManagers.Available(sASOModulID) and (TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_ID] <> '') then begin
      DMAQFbN(sASOASORT_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_ID]);

       if not DMAQFbN(sASOASORT_ID).IsNull then
          AsortymentSymbolDBLookupAliasEdit.InitiateData(DMAQFbN(sASOASORT_ID).AsInteger);
    end;

    {Okres}
    if (TUNIDBGridForm(Owner).Parameters.Values['PARAM_' + sUNIOKRES_ID] <> '') then begin
      {Zakadam, e okres jest zgodny z data i nie trzeba tego kontrolowac}
      DMAQFbN(sUNIOKRES_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values['PARAM_' + sUNIOKRES_ID]);
    end;

    {Zuycie paliwa}
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_ZUZ_PALIWA] <> '' then begin
       sTmp := TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_ZUZ_PALIWA];
       if pos(ThousandSeparator, sTmp) > 0 then
          sTmp := ZZBStrTran(sTmp, ThousandSeparator, '', iIlosc);
       DMAQFbN(sZLEZASOBYPRACA_ZUZ_PALIWA).AsFloat := Zaokraglij(StrToFloat(sTmp), UNIGetFracFromValueFormat(12.2 {ASODM.vAsoFormatCeny}));
    end;

    {Stawka}
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_STAWKA] <> '' then begin
       sTmp := TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_STAWKA];
       if pos(ThousandSeparator, sTmp) > 0 then
          sTmp := ZZBStrTran(sTmp, ThousandSeparator, '', iIlosc);
       DMAQFbN(sZLEZASOBYPRACA_STAWKA).AsFloat := Zaokraglij(StrToFloat(sTmp), UNIGetFracFromValueFormat(12.2 {ASODM.vAsoFormatCeny}));
    end;
    if(DataManagers.Available(sLWPModulID)) then begin
      m_sRapotTyp := Properties[csPropTypRaportu];
      if(Length(m_sRapotTyp) > 0) then
        DMAQFbN(sLWPRAPORTPRODTYP_ID).AsInteger := StrToInt(m_sRapotTyp);
    end else  // if(DataManagers.Available(sLWPModulID))
      m_sRapotTyp := '';

    if (ZLEDM.vZLEWysylanieECPWlaczone or ZLEDM.vZLEWysylanieRozliczECPWlaczone) and
       (ZLEDM.vZLESkladnikECPDomyslnyID > 0) and
       (DMAQFbN(sZLECONST_RODZAJECP_ID).AsString <> cZLERodzajECP_ProdukcjaID) then begin
       DMAQFbN(sKDSKLADNIKCZASU_ID).AsInteger := ZLEDM.vZLESkladnikECPDomyslnyID;
       SkladnikCzasuPracyDBLookupAliasEdit.InitiateData(DMAQFbN(sKDSKLADNIKCZASU_ID).AsInteger);
    end;

    if TUNIDBGridForm(Owner).FormIsContained then begin
       if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_EL_NAD_ID] <> '' then begin
         DMAQFbN(sZLEZASOBYPRACA_EL_NAD_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_EL_NAD_ID]);
       end;
    end;

    WyznaczRodzajFormatkiECP();
  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.SetFieldFormat;
begin
//  (DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatIlosci);
//  (DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY) as TNumericField).EditFormat    := UNIGetMaskFromFormat(ASODM.vAsoFormatIlosci, True);
  (DMAQFbN(sZLEZASOBYPRACA_IL_PRACY) as TNumericField).DisplayFormat   := UNIGetMaskFromFormat(12.2 {ASODM.vAsoFormatIlosci});
  (DMAQFbN(sZLEZASOBYPRACA_IL_PRACY) as TNumericField).EditFormat      := UNIGetMaskFromFormat(12.2 {ASODM.vAsoFormatIlosci}, True);
end;

procedure TZLEZasobyPracaDBDetailForm.SelectButtonPressed;
begin
  if Owner is TUNIDBGridForm then begin
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_DATA]       := DateToStr(DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime);
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_ID]               := DMAQFbN(sZLEZASOB_ID).AsString;
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_SYMBOL]           := ZasobDBLookupAliasEdit.Text;
    TUNIDBGridForm(Owner).Parameters.Values[sKDZMIANYDEF_ID]            := DMAQFbN(sKDZMIANYDEF_ID).AsString;
    TUNIDBGridForm(Owner).Parameters.Values[sLWPRECEPPOZ_ID]            := DMAQFbN(sLWPRECEPPOZ_ID).AsString;
    TUNIDBGridForm(Owner).Parameters.Values[sLWPPLANPRODEL_ID]          := DMAQFbN(sLWPPLANPRODEL_ID).AsString;
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_ID]            := DMAQFbN(sZLEZLECENIE_ID).AsString;
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIEPOZ_ID]         := DMAQFbN(sZLEZLECENIEPOZ_ID).AsString;
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_SYMBOL]        := ZlecenieSymbolDBLookupAliasEdit.Text;
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_NAZWA]         := ZlecenieNazwaLabel.Caption;
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY_NOM] := IntToStr(DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsInteger);
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY] := IntToStr(DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsInteger);
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_IL_PRACY]   := UNIFloatToFormatStr(12.2 {ASODM.vAsoFormatIlosci}, DMAQFbN(sZLEZASOBYPRACA_IL_PRACY).AsFloat);
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_STATUS]     := DMAQFbN(sZLEZASOBYPRACA_STATUS).AsString;
    TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_ID]                := DMAQFbN(sKDOSOBA_ID).AsString;
    TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_ID]               := DMAQFbN(sASOASORT_ID).AsString;
    TUNIDBGridForm(Owner).Parameters.Values['PARAM_' + sUNIOKRES_ID]    := DMAQFbN(sUNIOKRES_ID).AsString;
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_ZUZ_PALIWA] := UNIFloatToFormatStr(12.2 {ASODM.vAsoFormatIlosci}, DMAQFbN(sZLEZASOBYPRACA_ZUZ_PALIWA).AsFloat);
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOBYPRACA_STAWKA]     := UNIFloatToFormatStr(12.2 {ASODM.vAsoFormatIlosci}, DMAQFbN(sZLEZASOBYPRACA_STAWKA).AsFloat);

    TUNIDBGridForm(Owner).Parameters.Values[sUNIJEDNOSTKAORG_ID]        := DMAQFbN(sUNIJEDNOSTKAORG_ID).AsString;
    TUNIDBGridForm(Owner).Parameters.Values[sZLECONST_RODZAJECP_ID]     := DMAQFbN(sZLECONST_RODZAJECP_ID).AsString;
  end;

  if (OpenMode = OmEdit) and (DMAQFbN(sZLECONST_RODZAJECP_ID).AsString = cZLERodzajECP_ProdukcjaID) then
    DMAQFbN(sZLEZASOBYPRACA_FORMECP_ID).AsInteger := iFormECP_ID;
  inherited;
end;

procedure TZLEZasobyPracaDBDetailForm.IloscDBEditExit(Sender: TObject);
begin
  inherited;
  if (OpenMode in [omNew, omEdit]) and ((not ZLEDM.vZLEWysylanieECPWlaczone) or (not DataDoDBDateEdit.Visible) or (DMAQFbN(sKDOSOBA_ID).IsNull)) then begin
     if DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat  <> DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat then
        DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat := DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat;
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.InicjujPlanProdElem();
var
  sWarunek: String;
  oQuery: TUNIQuery;
  iIdx: Integer;
begin
  {Ustawienie PartiaLabel oraz Zakresu dat dla elementu planu produkcji
   na podstawie LWPPLANPRODEL_ID}
  if DataManagers.Available(sLWPModulID) then begin
     if not DMAQFbN(sLWPPLANPRODEL_ID).IsNull then begin
        sWarunek := '';
        if DMAQFbN(sLWPPLANPRODEL_ID).AsString <> '' then
           sWarunek := '@' + sLWPAlias_PlanProdEl_Id  + '=' + DMAQFbN(sLWPPLANPRODEL_ID).AsString;

        RecepPozDBLookupAliasEdit.Enabled := False;

        try
           oQuery := LWPDM.LWPOdpytajODane(sLWPPLANPRODEL,
                                      sLWPAlias_PlanProdEl_Id + ';' +
                                      sLWPAlias_PlanProdEl_Typ + ';' +
                                      sLWPAlias_PlanProd_ID +';' +
                                      sLWPAlias_PlanProdEl_DataPocz + ';' +
                                      sLWPAlias_PlanProdEl_DataKonc{ + ';' +
                                      sLWPAlias_ZleZlecenie_ID + ';' +
                                      sLWPAlias_RecepturaPoz_Id + ';' +
                                      sLWPALIAS_ZLEZLECENIE_SYMBOL + ';' +
                                      sLWPALIAS_ZLEZLECENIE_Nazwa + ';' +
                                      sLWPALIAS_ZLEZASOB_ID + ';' +
                                      sLWPALIAS_ZLEZASOB_NAZWA},
                                      sWarunek,
                                      True);

           if (oQuery <> nil) and (not oQuery.IsEmpty) then begin
              iIdx := cslLWPPlanElemTyp.IndexOfSkrot(oQuery.FieldByName(sLWPPLANPRODEL_TYP).AsString);
              ElemPlanuProdLabel.Caption := 'Element planu nie wybrany';
              if iIdx >= 0 then
                 ElemPlanuProdLabel.Caption := cslLWPPlanElemTyp.Strings[iIdx];

              FDataPocz := oQuery.FieldByName(sLWPPLANPRODEL_DATA_POCZ).AsDateTime;
              FDataKonc := oQuery.FieldByName(sLWPPLANPRODEL_DATA_KONC).AsDateTime;
           end;
        finally
           if oQuery <> nil then FreeAndNil(oQuery);
        end;
     end;
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.BeforeShow;
var
  bMoznaEdytowac: boolean;
  oQuery:         TUNIQuery;
begin
  inherited;
  InicjujPlanProdElem();
  bMoznaEdytowac  :=
        (OpenMode in [omNew]) or
        (DMAQFbN(sZLEZASOBYPRACA_STATUS).AsString = cZLEConstZasobPracaStatus_WprowadzonyID) or
        (not ZLEDM.UtworzonyRekordWyceny(
          DMAQFbN(sZLEZLECENIE_ID).AsInteger,
          DMAQFbN(sZLEZASOB_ID).AsInteger,
          DMAQFbN(sLWPRECEPPOZ_ID).AsInteger
        ));

  LWycena1Label.Visible := (not bMoznaEdytowac);
  LWycena2Label.Visible := (not bMoznaEdytowac);

  ZlecenieSymbolDBLookupAliasEdit.Enabled := (OpenMode in [omNew, omEdit]) and bMoznaEdytowac;
  if m_bOsobyKDECP and ZlecenieSymbolDBLookupAliasEdit.Enabled then
     if not m_oGridOsob.DataModule.ActiveQuery.IsEmpty() then
        ZlecenieSymbolDBLookupAliasEdit.Enabled := False;

  ZasobDBLookupAliasEdit.Enabled          := ZlecenieSymbolDBLookupAliasEdit.Enabled;
  RecepPozDBLookupAliasEdit.Enabled       := ZlecenieSymbolDBLookupAliasEdit.Enabled and DataManagers.Available(sLWPModulID);
  StatusDBConstComboBox.Enabled := (OpenMode in [omNew, omEdit]) and bMoznaEdytowac;

  WyswietlRodzajECP(DMAQFBN(sZLECONST_RODZAJECP_ID).AsString);

  DopiszButton.Enabled := OpenMode in [omNew, omEdit];
  UsunButton.Enabled := UsunButton.Enabled and (OpenMode in [omNew, omEdit]);
  Dopisz2Button.Enabled := OpenMode in [omNew, omEdit];
  Usun2Button.Enabled := Usun2Button.Enabled and (OpenMode in [omNew, omEdit]);
  if(RaportTypPanel.Visible and (not DMAQFbN(sLWPRAPORTPRODTYP_ID).IsNull)) then begin
    oQuery  := LWPDM.LWPOdpytajODane(sLWPRAPORTPRODTYP,
      sLWPAlias_RaportProdTyp_Symbol, '@' + sLWPAlias_RaportProdTyp_Id + ' = ' + DMAQFbN(sLWPRAPORTPRODTYP_ID).AsString,
      false
    );
    if(oQuery <> nil) then
      RaportTypLookupAliasEdit.Text := oQuery.Fields[0].AsString;
    FreeAndNil(oQuery);
  end;  // if(RaportTypPanel.Visible)
end;

function TZLEZasobyPracaDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLEZasobyPracaDataModule.CreateOpen( self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZLEZasobyPracaDBDetailForm.CzasPracyGodzEditExit(Sender: TObject);
begin
  inherited;
  if (OpenMode in [omNew, omEdit]) and ((not ZLEDM.vZLEWysylanieECPWlaczone) or (not DataDoDBDateEdit.Visible) or (DMAQFbN(sKDOSOBA_ID).IsNull)) then begin
     if DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat  <> DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat then begin
        DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat := DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat;
        CzasPracyRazemGodzEdit.Inicjuj;
     end;
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.AssignProperties();
begin
  inherited;
  Properties.AddProperty(csPropTypRaportu, GetPropertyValue);
end;

function  TZLEZasobyPracaDBDetailForm.GetPropertyValue(
  a_sPropertyName:  string
):  string;
begin
  if(a_sPropertyName = csPropTypRaportu) then
    result  := m_sRapotTyp
  else
    result  := inherited GetPropertyValue(a_sPropertyName);
end;

procedure TZLEZasobyPracaDBDetailForm.InternalOpen;
begin
  bZmianaZasobu := False;
  bPlanProdChange := False;
  FRodzajECP := 'P'; //Domyslna wartosc
  InitializeControls();
  inherited;
  SetFieldFormat();
  if OpenMode = omNew then SetDefaults()
  else WyznaczRodzajFormatkiECP();

    //dodanie form osadzonych
  AddContainedForms();
  {if Owner is TZLESzczegoloweKosztyDBGridForm then
    ZlecenieSymbolDBLookupAliasEdit.aReadOnly := True;}

  if not ZLEDM.vZLEFormatGodzinLiczba then begin
     CzasPracyGodzEdit.Inicjuj; //W innym przypadku aktywny jest zwyky IloscDBEdit
     CzasPracyRazemGodzEdit.Inicjuj;
  end;

  if not DMAQFbN(sZLEZLECENIEPOZ_ID).IsNull then
     PozycjaLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger);

  if Owner is TZLESzczegoloweKosztyDBGridForm then
    ZlecenieSymbolDBLookupAliasEdit.aReadOnly := True;
end;

procedure TZLEZasobyPracaDBDetailForm.GetPositionAndParentForContainedForm(
  const nr: integer; var APosition: TRect; var AParent: TWinControl;
  var AAlign: TAlign);
begin
  if nr = FZakladkaOsobyFormIndex then begin
    AParent := OsobyPanel;
    APosition := OsobyPanel.ClientRect;
    AAlign := alClient;
  end else
  if nr = FZakladkaBrakiFormIndex then begin
    AParent := BrakiPanel;
    APosition := BrakiPanel.ClientRect;
    AAlign := alClient;
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.AddContainedForms;
var
  oParamsOsoby: TKeyValues;
  oParamsBraki: TKeyValues;
  omOpenMode: TOpenMode;
begin
  //Osadzone formatki s tylko dla produkcji
  if (RodzajECP <> cZLERodzajECP_ProdukcjaID) then Exit;

  omOpenMode := omList or omContained or omVirtual;

  if OpenMode in [omView, omDelete] then
     omOpenMode := omOpenMode or omReadOnly;

  with FContainedForms do begin

    //ZleOsoby
    FZakladkaOsobyFormIndex := 0;
    m_oGridOsob := nil;
(***********************************
    if((not KDECPDM.Available) or SaOsobyBezKDECP() or (not ZLEDM.vZLEWysylanieECPWlaczone)) then begin
    end else {if (KDECPDM.Available) and ZLEDM.vZLEWysylanieECPWlaczone then} begin
    end;
************************************)

    if iFormECP_ID = cZLEFormatkaOsobyID then begin
      oParamsOsoby := TKeyValues.CreateEmpty();
      with oParamsOsoby do begin
        Add(sZLEZasobyPraca_ID+'='+DMAQFbN(sZLEZasobyPraca_ID).AsString);
      end;
      m_oGridOsob   := FormManager.OpenDBGrid(self,TZLEOsobyDBGridForm.ClassName, omOpenMode, oParamsOsoby);
      m_bOsobyKDECP := false;
    end else
    if iFormECP_ID = cZLEFormatkaKadryECPID then begin
      m_oGridOsob   := KDECPDM.KDECPDajGridaCzasuPracyExt(
        Self,
        sZRODLO_ZLECENIA,
        DMAQFbN(sZLEZASOBYPRACA_ID).AsInteger,
        omList or omContained or omVirtual or omMultiSelect or iifn(not (OpenMode in [omNew, omEdit]), omReadOnly, 0),
        TKeyValues.CreateAs(
          [
            sKDCZAS_DATA    + '=' + IntToStr(Trunc(DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime)),
            sKDCZAS_GODZINY + '=480',  // 8 godzin zamienione na minuty
            sKDSKLADNIKCZASU_ID + '=' + iifs(ZLEDM.vZLESkladnikECPDomyslnyID >= 0,IntToStr(ZLEDM.vZLESkladnikECPDomyslnyID), '')
          ]
        )
      );
      m_bOsobyKDECP := true;
    end else
    if iFormECP_ID = cZLEFormatkaListaRCPID then begin
      //Lista ECP Zlece - Akord
      oParamsOsoby := TKeyValues.CreateEmpty();
      with oParamsOsoby do begin
        Add(sZLEZasobyPraca_EL_NAD_ID+'='+DMAQFbN(sZLEZasobyPraca_ID).AsString);
        Add(sZLECONST_RODZAJECP_ID + '=' + cZLERodzajECP_OsobaID);
      end;
      m_oGridOsob   := FormManager.OpenDBGrid(self,TZLEZasobyPracaDBGridForm.ClassName, omOpenMode, oParamsOsoby);
      m_bOsobyKDECP := false;
    end else begin
      Komunikat(cWarning, 'Nieprawidowa warto dla FORMECP');
      Abort;
    end;

    if (m_oGridOsob <> nil) then  AddObject('Osoby', m_oGridOsob);

    //ZleZasobyBraki
    oParamsBraki := TKeyValues.CreateEmpty();
    with oParamsBraki do begin
      Add(sZLEZasobyPraca_ID+'='+DMAQFbN(sZLEZasobyPraca_ID).AsString);
    end;
    FZakladkaBrakiFormIndex := 1;
    AddObject('Braki', FormManager.OpenDBGrid(self,TZLEZasobyBrakiDBGridForm.ClassName, omOpenMode, oParamsBraki));
  end;
end;

(**
function  TZLEZasobyPracaDBDetailForm.SaOsobyBezKDECP():  boolean;
var
  oQuery: TUNIQuery;
begin
  oQuery  := SQLManager.CreateQuery(
    'SELECT 1' +
    ' FROM %s ZO' +
    ' WHERE ' +
      'ZO.' + sZLEZASOBYPRACA_ID + ' = ' + DMAQFbN(sZLEZASOBYPRACA_ID).AsString +
      ' AND ROWNUM = 1',
    [sZLEOSOBY]
  );
  try
    oQuery.Open();
    result  := (not oQuery.IsEmpty());
  finally
    FreeAndNil(oQuery);
  end;
end;
**)

procedure TZLEZasobyPracaDBDetailForm.InitializeControls;
begin
  if Parameters <> nil then begin
    if Parameters.Values[cFORM_CAPTION] <> '' then
       Caption := Parameters.Values[cFORM_CAPTION];

    if Parameters.Values[sZLECONST_RODZAJECP_ID] <> '' then
       FRodzajECP := Parameters.Values[sZLECONST_RODZAJECP_ID];
  end;

  UwagiDBMemo.DataField := sZLEZASOBYPRACA_UWAGI;

  //AsortymentIndeksDBLookupAliasEdit.EditMask := ASODM.vAsoMaskaIndeksu+';0;_';
  OsobaNazwaLabel.Caption := '';
  ZlecenieNazwaLabel.Caption := '';
  AsortymentNazwaLabel.Caption := '';

  with PozycjaLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_ZLECENIEPOZ_ID;
    Alias_Name := sZLEALIAS_ZLECENIEPOZ_LP;

    AdditionalAliases := {sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
                         sZLEALIAS_ZLECENIEPOZ_OPIS+';'+}
                         sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID;


  end;

  if not DataManagers.Available(sASOModulID) then begin
     AsortymentSymbolDBLookupAliasEdit.Visible := False;
     AsortymentLabel.Visible := False;
     AsortymentNazwaLabel.Visible := False;
  end;

  ElemPlanuProdButton.Enabled := DataManagers.Available(sLWPModulID);
  UsunElemPlanProdButton.Enabled := DataManagers.Available(sLWPModulID);
  RecepPozDBLookupAliasEdit.Enabled := DataManagers.Available(sLWPModulID);

  ZmianaOpisLabel.Caption := '';
  ZlecenieNazwaLabel.Caption := '';
  ElemPlanuProdLabel.Caption := '';
  RecepPozOpisLabel.Caption := '';
  if ElemPlanuProdButton.Enabled then
     ElemPlanuProdLabel.Caption := 'Element planu nie wybrany';
  FZakladkaOsobyFormIndex := -1;
  FZakladkaBrakiFormIndex := -1;
  FRecepturaID := -1;
  FOldZlecID := -1;
  FDataPocz := 0;
  FDataKonc := 0;
  iFormECP_ID := 0; //Brak formatki osadzonej
  StatusDBConstComboBox.Items.Assign(cslZLEConstZasobPracaStatus);
  StatusDBConstComboBox.DataField := sZLEZASOBYPRACA_STATUS;
  StatusDBConstComboBox.Enabled := (OpenMode in [omNew, omEdit]);
  RodzajECPRadioGroup.Enabled := False; //(OpenMode = omNew);


  if ZLEDM.vZLEFormatGodzinLiczba then begin
     CzasPracyGodzEdit.Visible := False;
     IloscDBEdit.Visible := True;
     CzasPracyRazemGodzEdit.Visible := False;
     IloscGodzinRazemDBEdit.Visible := True;
  end else begin
     CzasPracyGodzEdit.Visible := True;
     IloscDBEdit.Visible := False;
     CzasPracyRazemGodzEdit.Visible := True;
     IloscGodzinRazemDBEdit.Visible := False;
  end;

  if ZLEDM.vZLEZLECENIEROZL_ZUZPALIWA then begin
     EwidencjaZuzPaliwaDBEdit.Enabled := True;
  end else EwidencjaZuzPaliwaDBEdit.Enabled := False;

  with PozycjaLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_ZLECENIEPOZ_ID;
    Alias_Name := sZLEALIAS_ZLECENIEPOZ_LP;

    AdditionalAliases := sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
                         sZLEALIAS_ZLECENIEPOZ_OPIS+';'+
                         sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID;

    if not (OpenMode in [omNew, omEdit]) then
       aReadOnly := True;

    if ZLEDM.vZLEWymaganaPozycjaEwid then
       aAllowEmpty := False;
  end;

  with OpisMemo do begin
    Text := Parameters.Values[sZLEZLECENIEPOZ_OPIS];
    ReadOnly := True;
  end;
  if(DataManagers.Available(sLWPModulID)) then begin
    with RaportTypLookupAliasEdit do begin
      AliasManager  := LWPDM.AliasManager;
      Alias_ID      := sLWPAlias_RaportProdTyp_Id;
      Alias_Name    := sLWPAlias_RaportProdTyp_Symbol;
    end;
  end;  // if(DataManagers.Available(sLWPModulID))
end;

procedure TZLEZasobyPracaDBDetailForm.ZasobDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ZasobDBLookupAliasEdit do begin
    AliasManager      := ZLEDM.AliasManager;
    Alias_ID          := sZLEAlias_ZLEZasob_ID;
    Alias_Name        := sZLEAlias_ZLEZasob_Symbol;
    AdditionalAliases := sZLEALIAS_ZLEZASOB_NAZWA+ ';' +
                         sZLEALIAS_ZLEZASOB_STAWKA+';'+
                         sZLEALIAS_ZLEZASOB_RODZAJ+';'+
                         sZLEALIAS_RODZAJZASOBU_V+';'+
                         sZLEALIAS_ZLEZASOB_KDOSOBA_ID+';'+
                         sZLEALIAS_ZLEZASOB_UNIJEDNOSTKAORG_ID;
  end;
end;

function TZLEZasobyPracaDBDetailForm.ZasobDBLookupAliasEditGetQuery: TUNIQuery;
var
//  iFirmaId: integer;
  oPar: TKeyValues;
begin
{
  iFirmaId := 0;
  if UNISysDM.vWielofirmowosc then
     iFirmaID := UNISysDM.vAktywnaFirma;
  if (not UNISysDM.vWielofirmowosc) and (Parameters <> nil) then
     if (UNISysDM.vWieloodzialowosc) and (Parameters.Values[sUNIODDZIAL_ID] <> '') then
        iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID]);
}

  try
    oPar := TKeyValues.CreateEmpty;
    if ZLEDM.vZLEOgraniczonaListaZasobow and (DMAQFbN(sZLEZLECENIE_ID).AsString <> '') then
       oPar.Add(sZLEZLECENIE_ID + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString);

    Result := ZLEDM.ZLEPokazIObsluzdane(sZLEZASOB,
                                      sZLEALIAS_ZLEZASOB_ID+ ';' +
                                      sZLEALIAS_ZLEZASOB_SYMBOL + ';' +
                                      sZLEALIAS_ZLEZASOB_NAZWA+ ';' +
                                      sZLEALIAS_ZLEZASOB_STAWKA+';'+
                                      sZLEALIAS_ZLEZASOB_RODZAJ+';'+
                                      sZLEALIAS_RODZAJZASOBU_V+';'+
                                      sZLEALIAS_ZLEZASOB_UNIJEDNOSTKAORG_ID+';'+
                                      sZLEALIAS_ZLEZASOB_KDOSOBA_ID,
                                      '',
                                      false,
                                      False,
                                      cZLEModulZSI_ID,
                                      DMAQFbN(sZLEZASOB_ID).AsInteger,
                                      0,
                                      '',
                                      nil,
                                      nil,
                                      oPar
                                      );

(**
  Result := ZLEDM.ZLEPokazIObsluzdane(sZLEZASOB,
                                      sZLEALIAS_ZLEZASOB_ID + ';' + sZLEALIAS_ZLEZASOB_SYMBOL,
                                      '',
                                      False,
                                      False,
                                      cZLEModulZSI_ID,
                                      DMAQFbN(sZLEZASOB_ID).AsInteger,
                                      iFirmaId
                                      );
**)
  finally
   // if oPar <> nil then FreeAndNil(oPar);
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.ZasobDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  ZasobDBLookupAliasEdit.Text := '';
  if OpenMode in [omNew, omEdit] then begin
    DMAQFbN(sZLEZASOB_ID).Clear;
    iZasobOldID := 0;

    //Wyczyszczenie Jednostki Org.
    if not DMAQFbN(sUNIJEDNOSTKAORG_ID).IsNull then
      DMAQFbN(sUNIJEDNOSTKAORG_ID).Clear;

    if ((Parameters.Values[sZLECONST_RODZAJECP_ID] = cZLERodzajECP_OsobaID) or
        (Parameters.Values[sZLECONST_RODZAJECP_ID] = cZLERodzajECP_ZasobID)) then begin
        DMAQFbN(sZLECONST_RODZAJECP_ID).AsString := cZLERodzajECP_OsobaID;
        WyswietlRodzajECP(DMAQFBN(sZLECONST_RODZAJECP_ID).AsString);
    end;
  end;
end;

function TZLEZasobyPracaDBDetailForm.ZasobDBLookupAliasEditGetDataField: String;
begin
  Result := sZLEZASOB_ID;
end;

function TZLEZasobyPracaDBDetailForm.ZasobDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
var
  oQuery: TUNIQuery;
begin
  inherited;
  bZmianaZasobu := True;
  if (AliasSrc <> nil) and (OpenMode in [omNew, omEdit]) and ZasobDBLookupAliasEdit.Initialized then begin
     {Podpowiadanie stawki dla zasobu}
     if (OpenMode = omNew) and (iZasobOldID <> DMAQFbN(sZLEZASOB_ID).AsInteger) then begin
       iZasobOldID := DMAQFbN(sZLEZASOB_ID).AsInteger;
       {Odszukanie w Zasobach Stawki dla zasobu (MAX)}
       oQuery := SQLManager.CreateQuery('SELECT ' + ' MAX(' + sZLEZASOB_STAWKA + ') AS ' + sZLEZASOB_STAWKA + ' ' +
                                        'FROM %s ' +
                                        'WHERE ' + sZLEZASOB_ID + ' = ' + IntToStr(DMAQFbN(sZLEZASOB_ID).AsInteger),
                                        [sZLEZASOB]);


       try
         oQuery.Open;
         if (not oQuery.IsEmpty) and (DMAQFbN(sZLEZASOBYPRACA_STAWKA).AsFloat <> oQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat) then
            DMAQFbN(sZLEZASOBYPRACA_STAWKA).AsFloat := Zaokraglij(oQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat, UNIGetFracFromValueFormat(ASODM.vAsoFormatCeny));
       finally
         if oQuery <> nil then FreeAndNil(oQuery);
       end;
     end;

     if AliasSrc.FieldByName(sUNIJEDNOSTKAORG_ID).AsInteger > 0 then
       DMAQFbN(sUNIJEDNOSTKAORG_ID).AsInteger := AliasSrc.FieldByName(sUNIJEDNOSTKAORG_ID).AsInteger
     else DMAQFbN(sUNIJEDNOSTKAORG_ID).Clear;

     if ((Parameters.Values[sZLECONST_RODZAJECP_ID] = cZLERodzajECP_OsobaID) or
         (Parameters.Values[sZLECONST_RODZAJECP_ID] = cZLERodzajECP_ZasobID)) then begin

        DMAQFbN(sZLECONST_RODZAJECP_ID).AsString := cZLERodzajECP_ZasobID;
        WyswietlRodzajECP(DMAQFBN(sZLECONST_RODZAJECP_ID).AsString);

       if AliasSrc.FieldByName(sKDOsoba_ID).AsInteger > 0 then begin
          if DMAQFbN(sKDOSOBA_ID).AsInteger <> AliasSrc.FieldByName(sKDOsoba_ID).AsInteger then
             OsobaSymbolDBLookupAliasEdit.InitiateData(AliasSrc.FieldByName(sKDOSOBA_ID).AsInteger);
        end else begin
          DMAQFbN(sKDOSOBA_ID).Clear;
          OsobaSymbolDBLookupAliasEdit.Text := '';
          OsobaNazwaLabel.Caption := '';
       end;
     end;
  end;
  bZmianaZasobu := False;
  Result := True;
end;

procedure TZLEZasobyPracaDBDetailForm.ZlecenieSymbolDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ZlecenieSymbolDBLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_Zlecenie_ID;
    Alias_Name := sZLEALIAS_Zlecenie_Symbol;
    AdditionalAliases := sZLEALIAS_Zlecenie_Nazwa + ';'+
                         sZLEALIAS_ZLECENIE_JEDNORG_ID;
    if(DataManagers.Available(sLWPModulID)) then
      AdditionalAliases := AdditionalAliases + ';' + sZLEALIAS_RECEPTURANAGL_ID;
  end;
end;

function TZLEZasobyPracaDBDetailForm.ZlecenieSymbolDBLookupAliasEditGetQuery: TUNIQuery;
var
  iFirmaId: integer;
  sAtr: String;
  oPar: TKeyValues;
begin
  iFirmaId := 0;

  if UNISysDM.vWielofirmowosc then
    iFirmaID := UNISysDM.vAktywnaFirma;

  if (Parameters <> nil) and (not UNISysDM.vWielofirmowosc) then
     if (UNISysDM.vWieloodzialowosc) and  (Parameters.Values[sUNIODDZIAL_ID] <> '') then
        iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID]);

  sAtr := sZLEALIAS_ZLECENIE_ID + ';' +
    sZLEALIAS_ZLECENIE_SYMBOL + ';' +
    sZLEALIAS_ZLECENIE_NAZWA +';'+
    sZLEALIAS_ZLECENIE_JEDNORG_ID;

  if DataManagers.Available(sLWPModulID) then
    sAtr := sAtr + ';' + sZLEALIAS_RECEPTURANAGL_ID;

  oPar := TKeyValues.CreateEmpty();
  oPar.Add(cZLELista_Optymalizacja + '=' + IntToStr(cZLELista_WylaczPrzyciski + cZLELista_WylaczPolaUzytk));

  Result := ZLEDM.ZLEPokazIObsluzZlecenia(
    sAtr,
    '',
    false,
    False,
    cZLEModulZSI_ID,
    DMAQFbN(sZLEZLECENIE_ID).AsInteger,
    iFirmaId,
    nil,
    nil,
    oPar
  );
end;

function TZLEZasobyPracaDBDetailForm.ZlecenieSymbolDBLookupAliasEditGetDataField: String;
begin
  Result := sZLEZLECENIE_ID;
end;

procedure TZLEZasobyPracaDBDetailForm.ZlecenieSymbolDBLookupAliasEditDelKey(
  Sender: TObject);
var
   sListaPKTmp, sListaMnem: String;
   oParams: TKeyValues;
begin
  if OpenMode in [omNew, omEdit] then begin
    ZlecenieSymbolDBLookupAliasEdit.Text := '';
    ZlecenieNazwaLabel.Caption := '';
    DMAQFbN(sZLEZLECENIE_ID).Clear;
    FOldZlecID := -1;
    FRecepturaID := -1;

    {Czyszczymy rwnie pozycj zlecenia}
    DMAQFbN(sZLEZLECENIEPOZ_ID).Clear;
    PozycjaLookupAliasEdit.Text := '';
    if m_bOsobyKDECP then begin
       sListaMnem := KDECPDM.KDECPDajListeMnemonikow(sZRODLO_ZLECENIA);
       sListaPKTmp := '';
       {Obecnie obsugiwane mnemoniki: sMnemonikJednostkaOrg, sMnemonikZlecenie}
       if sListaMnem <> '' then begin
         if Pos(sMnemonikJednostkaOrg, sListaMnem) > 0 then
            sListaPKTmp := sMnemonikJednostkaOrg + '=';
         if Pos(sMnemonikZlecenie, sListaMnem) > 0 then begin
            if sListaPKTmp <> '' then sListaPKTmp := sListaPKTmp + ',';
            sListaPKTmp := sListaPKTmp + sMnemonikZlecenie + '=';
         end;
       end;

       oParams := TKeyValues.CreateAs([sListaPK + '=' + sListaPKTmp]);
       KDECPDM.KDECPPodmienParametryGridaCzasuPracyExt(m_oGridOsob, oParams);
       FreeAndNil(oParams);
    end;
  end;
end;

function TZLEZasobyPracaDBDetailForm.ZlecenieSymbolDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
var
  oParams: TKeyValues;
  sListaPKTmp, sListaMnem: String;
begin
  if AliasSrc <> nil then begin


    ZlecenieNazwaLabel.Caption := AliasSrc.FieldByName(sZLEZLECENIE_NAZWA).AsString;
    if ZlecenieSymbolDBLookupAliasEdit.Initialized then begin
      if FOldZlecID <> AliasSrc.FieldByName(sZLEZLECENIE_ID).AsInteger then begin
        if not bPlanProdChange then begin
           DMAQFbN(sLWPRECEPPOZ_ID).Clear();
           RecepPozDBLookupAliasEdit.Text := '';
           RecepPozOpisLabel.Caption := '';
        end;
        DMAQFbN(sZLEZLECENIEPOZ_ID).Clear;
        PozycjaLookupAliasEdit.Text := '';
        FOldZlecID := AliasSrc.FieldByName(sZLEZLECENIE_ID).AsInteger;
      end;
    end;

    if (m_bOsobyKDECP) then begin
       sListaMnem := KDECPDM.KDECPDajListeMnemonikow(sZRODLO_ZLECENIA);
       sListaPKTmp := '';
       {Obecnie obsugiwane mnemoniki: sMnemonikJednostkaOrg, sMnemonikZlecenie}
       if sListaMnem <> '' then begin
         if Pos(sMnemonikJednostkaOrg, sListaMnem) > 0 then
            sListaPKTmp := sMnemonikJednostkaOrg + '=' + IntToStr_ZeroToEmpty(AliasSrc.FieldByName(sUNIJEDNOSTKAORG_ID).AsInteger);
         if Pos(sMnemonikZlecenie, sListaMnem) > 0 then begin
            if sListaPKTmp <> '' then sListaPKTmp := sListaPKTmp + ',';
            sListaPKTmp := sListaPKTmp + sMnemonikZlecenie + '=' + IntToStr_ZeroToEmpty(AliasSrc.FieldByName(sZLEZLECENIE_ID).AsInteger);
         end;
       end;

       oParams := TKeyValues.CreateAs([sListaPK + '=' + sListaPKTmp]);
       KDECPDM.KDECPPodmienParametryGridaCzasuPracyExt(m_oGridOsob, oParams);
       FreeAndNil(oParams);
    end;

    if DataManagers.Available(sLWPModulID) then
       FRecepturaID := AliasSrc.FieldByName(sLWPRECEPTURA_ID).AsInteger;
  end;
  Result := True;
end;

procedure TZLEZasobyPracaDBDetailForm.ZmianaDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  if OpenMode in [omNew, omEdit] then begin
    ZmianaDBLookupAliasEdit.Text := '';
    DMAQFbN(sKDZMIANYDEF_ID).Clear;
  end;
end;

function TZLEZasobyPracaDBDetailForm.ZmianaDBLookupAliasEditGetDataField: String;
begin
  result := sKDZMIANYDEF_ID;
end;

function TZLEZasobyPracaDBDetailForm.ZmianaDBLookupAliasEditGetQuery: TUNIQuery;
begin
  Result := UNISysDM.KDPokazIObsluzKalendarz(sKDZMIANYDEF,
                                             sUNISysKDAlias_ZmianyDefId + ';' +
                                             sUNISysKDAlias_ZmianyDefSymbol + ';' +
                                             sUNISysKDAlias_ZmianyDefGodzPoczatek + ';' +
                                             sUNISysKDAlias_ZmianyDefGodzKoniec,
                                             '',
                                             False,
                                             False,
                                             False {bPracownik: Boolean},
                                             DMAQFbN(sKDZMIANYDEF_ID).AsInteger);
end;

procedure TZLEZasobyPracaDBDetailForm.ZmianaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ZmianaDBLookupAliasEdit do begin
    AliasManager := UNISYSDM.AliasManager;
    Alias_ID := sUNISysKDAlias_ZmianyDefId;
    Alias_Name := sUNISysKDAlias_ZmianyDefSymbol;
    AdditionalAliases := sUNISysKDAlias_ZmianyDefGodzPoczatek + ';' + sUNISysKDAlias_ZmianyDefGodzKoniec;
  end;
end;

function TZLEZasobyPracaDBDetailForm.ZmianaDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  if AliasSrc <> nil then begin
     ZmianaOpisLabel.Caption := WyznaczGodzine(AliasSrc.FieldByName(sKDZMIANYDEF_Godz_Poczatek).AsFloat) + ' - ' + WyznaczGodzine(AliasSrc.FieldByName(sKDZMIANYDEF_Godz_Koniec).AsFloat);
  end;
  Result := True;
end;

{procedure TZLEZasobyPracaDBDetailForm.PlanProdElemDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  if OpenMode in [omNew, omEdit] then begin
    PlanProdElemDBLookupAliasEdit.Text := '';
    DMAQFbN(sLWPPLANPRODEL_ID).Clear;
  end;
end;

function TZLEZasobyPracaDBDetailForm.PlanProdElemDBLookupAliasEditGetDataField: String;
begin
  result := sLWPPLANPRODEL_ID;
end; }

{function TZLEZasobyPracaDBDetailForm.PlanProdElemDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWarunek: String;
begin
  sWarunek := '';
  if DMAQFbN(sLWPPLANPRODEL_ID).AsString <> '' then
     sWarunek := '@' + sLWPAlias_PlanProdEl_Id  + '=' + DMAQFbN(sLWPPLANPRODEL_ID).AsString;

  Result := LWPDM.LWPPokazIObsluzDane(sLWPPLANPRODEL,
                                      sLWPAlias_PlanProdEl_Id + ';' +
                                      sLWPAlias_PlanProdEl_Typ + ';' +
                                      sLWPAlias_PlanProd_ID +';' +
                                      sLWPAlias_PlanProd_DataPocz + ';' +
                                      sLWPAlias_PlanProd_DataKonc + ';' +
                                      sLWPALIAS_ZLEZASOB_ID + ';' +
                                      sLWPALIAS_ZLEZASOB_NAZWA,
                                      '',
                                      False,
                                      True, //bWybor
                                      False, //bWyborWielu
                                      sWarunek);
end; }

{procedure TZLEZasobyPracaDBDetailForm.PlanProdElemDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with PlanProdElemDBLookupAliasEdit do begin
    AliasManager := LWPDM.AliasManager;
    Alias_ID := sUNISysKDAlias_ZmianyDefId;
    Alias_Name := sUNISysKDAlias_ZmianyDefSymbol;
    AdditionalAliases := sUNISysKDAlias_ZmianyDefGodzPoczatek;
  end;
end;

function TZLEZasobyPracaDBDetailForm.PlanProdElemDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  Result := True;
end;  }

procedure TZLEZasobyPracaDBDetailForm.ElemPlanuProdButtonClick(Sender: TObject);
var
  sWarunek: String;
  oQuery: TUNIQuery;
  iIdx: Integer;
begin
  if not (OpenMode in [omNew, omEdit]) then Exit;

  sWarunek := '';
  if DMAQFbN(sLWPPLANPRODEL_ID).AsString <> '' then
     sWarunek := '@' + sLWPAlias_PlanProdEl_Id  + '=' + DMAQFbN(sLWPPLANPRODEL_ID).AsString;

  try
    oQuery := LWPDM.LWPPokazIObsluzDane(sLWPPLANPRODEL,
                                        sLWPAlias_PlanProdEl_Id + ';' +
                                        sLWPAlias_PlanProdEl_Typ + ';' +
                                        sLWPAlias_PlanProd_ID +';' +
                                        sLWPAlias_PlanProdEl_DataPocz + ';' +
                                        sLWPAlias_PlanProdEl_DataKonc + ';' +
                                        sLWPAlias_ZleZlecenie_ID + ';' +
                                        sLWPAlias_RecepturaPoz_Id + ';' +
                                        sLWPALIAS_ZLEZLECENIE_SYMBOL + ';' +
                                        sLWPALIAS_ZLEZLECENIE_Nazwa + ';' +
                                        sLWPALIAS_ZLEZASOB_ID{ + ';' +
                                        sLWPALIAS_ZLEZASOB_SYMBOL},
                                        '',
                                        False,
                                        True, //bWybor
                                        False, //bWyborWielu
                                        sWarunek);
    if (oQuery <> nil) and (not oQuery.IsEmpty) then begin
       DMAQFbN(sLWPPLANPRODEL_ID).AsInteger := oQuery.FieldByName(sLWPPLANPRODEL_ID).AsInteger;

       if oQuery.FieldByName(sZLEZASOB_ID).IsNull then begin
          DMAQFbN(sZLEZASOB_ID).Clear();
          ZasobDBLookupAliasEdit.Text := '';
       end else begin
          DMAQFbN(sZLEZASOB_ID).AsInteger  := oQuery.FieldByName(sZLEZASOB_ID).AsInteger;
          ZasobDBLookupAliasEdit.InitiateData(DMAQFbN(sZLEZASOB_ID).AsInteger);
       end;

       if oQuery.FieldByName(sLWPRECEPPOZ_ID).IsNull then begin
          DMAQFbN(sLWPRECEPPOZ_ID).Clear();
          RecepPozDBLookupAliasEdit.Enabled := False;
          {Inicjacja Pozycji receptury}
          RecepPozDBLookupAliasEdit.Text := '';
          RecepPozOpisLabel.Caption := '';
       end else begin
          DMAQFbN(sLWPRECEPPOZ_ID).AsInteger   := oQuery.FieldByName(sLWPRECEPPOZ_ID).AsInteger;
          RecepPozDBLookupAliasEdit.Enabled := False;
          RecepPozOpisLabel.Caption := '';
          {Inicjacja Pozycji receptury}
          RecepPozDBLookupAliasEdit.InitiateData(DMAQFbN(sLWPRECEPPOZ_ID).AsInteger);
       end;

       bPlanProdChange := True;
       if oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger > 0 then begin
          DMAQFbN(sZLEZLECENIE_ID).AsInteger := oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
          ZlecenieSymbolDBLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIE_ID).AsInteger);
       end else begin
          DMAQFbN(sZLEZLECENIE_ID).Clear;
          ZlecenieSymbolDBLookupAliasEdit.Text := '';
          ZlecenieNazwaLabel.Caption := '';
          FOldZlecID := -1;
          FRecepturaID := -1;
       end;
       bPlanProdChange := False;

       iIdx := cslLWPPlanElemTyp.IndexOfSkrot(oQuery.FieldByName(sLWPPLANPRODEL_TYP).AsString);
       ElemPlanuProdLabel.Caption := '';
       if iIdx >= 0 then
          ElemPlanuProdLabel.Caption := cslLWPPlanElemTyp.Strings[iIdx];

       FDataPocz := oQuery.FieldByName(sLWPPLANPRODEL_DATA_POCZ).AsDateTime;
       FDataKonc := oQuery.FieldByName(sLWPPLANPRODEL_DATA_KONC).AsDateTime;
    end;
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.DopiszButtonClick(Sender: TObject);
begin
   inherited;
   DopiszOsobe();
end;

procedure TZLEZasobyPracaDBDetailForm.UsunButtonClick(Sender: TObject);
begin
  inherited;
  UsunOsobe();
end;

procedure TZLEZasobyPracaDBDetailForm.Dopisz2ButtonClick(Sender: TObject);
begin
  inherited;
  DopiszBrak();
end;

procedure TZLEZasobyPracaDBDetailForm.Usun2ButtonClick(Sender: TObject);
begin
  inherited;
  UsunBrak();
end;

procedure TZLEZasobyPracaDBDetailForm.DopiszOsobe();
var
  q: TUNIQuery;
  sWarunek: String;
  v: TUNIDBGridForm;
begin
  if(m_bOsobyKDECP) then begin
    m_oGridOsob.NewMenuItemClick(nil);
    if(m_oGridOsob.DataModule.ActiveQuery.IsEmpty()) then begin
      UsunButton.Enabled  := false;
      //ZlecenieSymbolDBLookupAliasEdit.Enabled := True;
    end else begin
      UsunButton.Enabled  := true;
      ZlecenieSymbolDBLookupAliasEdit.Enabled := False;
    end;
  end else begin
    sWarunek := '';
    v:= ContainedForms[FZakladkaOsobyFormIndex] as TUNIDBGridForm;
    q := UNISysDM.KDPokazIObsluzPracownika( self, '', sKDAlias_OsobaID+';'+
                                           sKDAlias_OsobaImie + ';' +
                                           sKDAlias_OsobaNazwisko,
                                           false, false,
                                           0 {DMAQFbN(sKDOSOBA_ID).AsInteger},
                                           vAktywnaFirma,
                                           '', '',
                                           nil,
                                           ZLEDM.vZLEECPPracownicyWieleFirm,
                                           True{bPokazJednostke});
    try
      if q <> Nil then
        if not q.FieldByName(sKDOSOBA_ID).IsNull then
          if v.DataModule.ActiveQuery.Locate(sKDOSOBA_ID, q.FieldByName(sKDOSOBA_ID).Value, []) then
            Komunikat(cWarning, 'Osoba wystpuje ju na licie')
          else
            with v.DataModule.ActiveQuery as TVirtualDataSet do begin
              VState := vsInternalInsert;
              try
                Append;

                FieldByName(sZLEOsoby_ID).Value:= UniqueKey[sZLEOSOBY];
                FieldByName(sKDOSOBA_ID).AsInteger:= q.FieldByName(sKDOSOBA_ID).AsInteger;
                FieldByName(sZLEZasobyPraca_ID).AsInteger := DMAQFbN(sZLEZasobyPraca_ID).AsInteger;

                SetTechnicalFieldsOnInsert;
                UpdateModifiedRecordFlagsForAddedRecord;

                FieldByName(sKDOsoba_Imie).AsString := q.FieldByName(sKDOSOBA_IMIE).AsString;
                FieldByName(sKDOsoba_Nazwisko).AsString := q.FieldByName(sKDOSOBA_Nazwisko).AsString;

                Post;
              finally
                VState := vsNormal;
              end;
            end;
    finally
      if q <> nil then FreeAndNil(q);
    end;
    (ContainedForms[FZakladkaOsobyFormIndex] as TZLEOsobyDBGridForm).UstawPrzyciski;
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.UsunOsobe();
var
  bMoznaEdytowac: boolean;
begin
  if(m_bOsobyKDECP) then begin
    m_oGridOsob.DeleteMenuItemClick(nil);
    if(m_oGridOsob.DataModule.ActiveQuery.IsEmpty()) then  begin
      UsunButton.Enabled  := false;
      bMoznaEdytowac  :=
        (OpenMode in [omNew]) or
        (DMAQFbN(sZLEZASOBYPRACA_STATUS).AsString = cZLEConstZasobPracaStatus_WprowadzonyID) or
        (not ZLEDM.UtworzonyRekordWyceny(
          DMAQFbN(sZLEZLECENIE_ID).AsInteger,
          DMAQFbN(sZLEZASOB_ID).AsInteger,
          DMAQFbN(sLWPRECEPPOZ_ID).AsInteger
        ));

      ZlecenieSymbolDBLookupAliasEdit.Enabled := (OpenMode in [omNew, omEdit]) and bMoznaEdytowac;
    end else
      UsunButton.Enabled  := true;
  end else begin
    (ContainedForms[FZakladkaOsobyFormIndex] as TZLEOsobyDBGridForm).DataModule.Delete;
    (ContainedForms[FZakladkaOsobyFormIndex] as TZLEOsobyDBGridForm).UstawPrzyciski;
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.DopiszBrak();
begin
  (ContainedForms[FZakladkaBrakiFormIndex] as TZleZasobyBrakiDBGridForm).Dopisz();
end;

procedure TZLEZasobyPracaDBDetailForm.UsunBrak();
begin
  (ContainedForms[FZakladkaBrakiFormIndex] as TZleZasobyBrakiDBGridForm).Usun();
end;

procedure TZLEZasobyPracaDBDetailForm.UsunElemPlanProdButtonClick(
  Sender: TObject);
begin
  inherited;
  if (OpenMode in [omEdit, omNew]) and DataManagers.Available(sLWPModulID) then begin
     DMAQFbN(sLWPPLANPRODEL_ID).Clear();
     ElemPlanuProdLabel.Caption := 'Element planu nie wybrany';
     RecepPozDBLookupAliasEdit.Enabled := True;
     FDataPocz := 0;
     FDataKonc := 0;
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.RecepPozDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  if (OpenMode in [omNew, omEdit]) and DataManagers.Available(sLWPModulID) then begin
    RecepPozDBLookupAliasEdit.Text := '';
    RecepPozOpisLabel.Caption := '';
    DMAQFbN(sLWPRECEPPOZ_ID).Clear();
  end;
end;

function TZLEZasobyPracaDBDetailForm.RecepPozDBLookupAliasEditGetDataField: String;
begin
   result := sLWPRECEPPOZ_ID;
end;

function TZLEZasobyPracaDBDetailForm.RecepPozDBLookupAliasEditGetQuery: TUNIQuery;
var
 sWar : String;
begin
  sWar := '';
  result := nil;

  if not DataManagers.Available(sLWPModulID) then exit;

  if (not DMAQFbN(sZLEZLECENIE_ID).IsNUll) and (FRecepturaID > 0) then begin
     sWar := '@' + sLWPAlias_Receptura_Id + '=' + IntToStr(FRecepturaID);
  {end else begin}

  end;

  {if DMAQFbN(sLWPRECEPPOZ_ID).AsString <> '' then
    sWar := '@' + sLWPAlias_RecepturaPoz_Id + '=' + DMAQFbN(sLWPRECEPPOZ_ID).AsString;}

  Result := LWPDM.LWPPokazIObsluzDane(sLWPRECEPPOZ,
                                      sLWPAlias_RecepturaPoz_Id + ';' +
                                      sLWPAlias_RecepturaPoz_Kolejnosc + ';' +
                                      sLWPAlias_FazaProdukcji_Id +';' +
                                      sLWPAlias_FazaProdukcji_Symbol,
                                      {sLWPAlias_RecepturaPoz_Opis,}
                                      sWar,
                                      false,
                                      True,
                                      False{,
                                      sWar});

end;

procedure TZLEZasobyPracaDBDetailForm.RecepPozDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if DataManagers.Available(sLWPModulID) then begin
    with RecepPozDBLookupAliasEdit do begin
      AliasManager := LWPDM.AliasManager;
      Alias_ID := sLWPAlias_RecepturaPoz_Id;
      Alias_Name := sLWPAlias_RecepturaPoz_Kolejnosc;
      AdditionalAliases := sLWPAlias_FazaProdukcji_Id +';' + sLWPAlias_FazaProdukcji_Symbol; // sLWPAlias_RecepturaPoz_Opis

      if RecepPozDBLookupAliasEdit.Initialized then
        if (not DMAQFbN(sZLEZLECENIE_ID).IsNUll) and (FRecepturaID > 0) then
           AdditionalCondition  := '@' + sLWPAlias_Receptura_Id + ' = ' + IntToStr(FRecepturaID);
    end;
  end;
end;

function TZLEZasobyPracaDBDetailForm.RecepPozDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  if AliasSrc <> nil then
     RecepPozOpisLabel.Caption := AliasSrc.FieldByName(sLWPFAZAPROD_SYMBOL).AsString;
  Result := True;
end;

procedure TZLEZasobyPracaDBDetailForm.OsobaSymbolDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  OsobaSymbolDBLookupAliasEdit.Text := '';
  OsobaNazwaLabel.Caption := '';
  if OpenMode in [omNew, omEdit] then begin
    if iOsobaOld <> DMAQFbN(sKDOSOBA_ID).AsInteger then
       iOsobaOld := 0;
    DMAQFbN(sKDOSOBA_ID).Clear;
  end;
end;

function TZLEZasobyPracaDBDetailForm.OsobaSymbolDBLookupAliasEditGetDataField: String;
begin
  Result := sKDOSOBA_ID;
end;

function TZLEZasobyPracaDBDetailForm.OsobaSymbolDBLookupAliasEditGetQuery: TUNIQuery;
var
  iFirmaId: integer;
begin
  iFirmaId := 0;
  if (UNISysDM.vWieloodzialowosc) and (Parameters.Values[sUNIODDZIAL_ID] <> '') then
    iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID])
  else if UNISysDM.vWielofirmowosc then
    iFirmaID := UNISysDM.vAktywnaFirma;

(**
  if vWielofirmowosc and
     ((Self.Owner as TUniSysKDOsobaDBGridForm).Tryb in [0, 1]) and
     ((Self.Owner as TUniSysKDOsobaDBGridForm).Parameters.Values[csParamUNIWszyscyPracownicy] = sTak) then
     GridTabDefs.Add('ODZ', sUNIODDZIAL);

    function KDPokazIObsluzPracownika( sWarunek, sAtrybuty: string;
                   bWyborWielu, bBlokada: boolean;
                   iLocateID: integer = 0;
                   iFirma: integer = 0;
                   sModulId: String = '';
                   oSelectedId: TStringList = nil): TUNIQuery;


**)


  Result := UNISysDM.KDPokazIObsluzPracownika(
    self, '',
    sKDAlias_OsobaID + ';' + sKDAlias_OsobaSymbol + ';' + sKDAlias_OsobaNazwa,
    False,
    False,
    DMAQFbN(sKDOSOBA_ID).AsInteger,
    iFirmaID, sZLEModulID,'',
    nil,
    ZLEDM.vZLEECPPracownicyWieleFirm,
    True{bPokazJednostke}
    );
end;

function TZLEZasobyPracaDBDetailForm.OsobaSymbolDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
var
  oQuery: TUNIQuery;
begin
  if AliasSrc <> nil then begin
    if (OpenMode = omNew) and
      (iOsobaOld <> DMAQFbN(sKDOSOBA_ID).AsInteger) then begin
      iOsobaOld := DMAQFbN(sKDOSOBA_ID).AsInteger;
      {Odszukanie w Zasobach Stawki dla pracownika (MAX)}
      oQuery := SQLManager.CreateQuery('SELECT ' + ' MAX(' + sZLEZASOB_STAWKA + ') AS ' + sZLEZASOB_STAWKA + ' ' +
                                        'FROM %s ' +
                                        'WHERE ' + sKDOSOBA_ID + ' = ' + IntToStr(DMAQFbN(sKDOSOBA_ID).AsInteger),
                                        [sZLEZASOB]);


      try
         oQuery.Open;
         if (not oQuery.IsEmpty) and (DMAQFbN(sZLEZASOBYPRACA_STAWKA).AsFloat <> oQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat) then
            DMAQFbN(sZLEZASOBYPRACA_STAWKA).AsFloat := Zaokraglij(oQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat, UNIGetFracFromValueFormat(ASODM.vAsoFormatCeny));
      finally
        if oQuery <> nil then FreeAndNil(oQuery);
      end;
    end;

    if (OpenMode in [omNew, omEdit]) and
        OsobaSymbolDBLookupAliasEdit.Initialized and
       (not bZmianaZasobu) and
       (not DMAQFbN(sZLEZASOB_ID).IsNull) and
       (not AliasSrc.FieldByName(sKDOSOBA_ID).IsNull) then begin
        DMAQFbN(sZLEZASOB_ID).Clear;
        iZasobOldID := 0;
        ZasobDBLookupAliasEdit.Text := '';
        DMAQFbN(sZLECONST_RODZAJECP_ID).AsString := cZLERodzajECP_OsobaID;
        WyswietlRodzajECP(DMAQFBN(sZLECONST_RODZAJECP_ID).AsString);
    end;

    OsobaNazwaLabel.Caption := AliasSrc.FieldByName(sKDOSOBA_NAZWA).AsString;
  end;
  Result := True;
end;

procedure TZLEZasobyPracaDBDetailForm.OsobaSymbolDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with OsobaSymbolDBLookupAliasEdit do begin
    if DataManagers.Available(sKDModulID) then begin
      AliasManager := KDDM.AliasManager;
    end else begin
      AliasManager := UNISysDM.AliasManager;
    end;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaSymbol;
    AdditionalAliases := sKDAlias_OsobaNazwa;
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.PozycjaLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery: TUniQuery;
  sWarunek: String;
begin
  sWarunek := '';
  if DMAQFbN(sZLEZLECENIE_ID).AsString <> '' then
     sWarunek := '@' + sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString
  else begin
     Komunikat(cInformation, 'Wybierz najpierw zlecenie');
     Exit;
  end;

  oQuery := ZLEDM.ZLEPokazIObsluzDane( sZLEZLECENIEPOZ,
                                       sZLEALIAS_ZLECENIEPOZ_ID+';'+
                                       sZLEALIAS_ZLECENIEPOZ_LP+';'+
                                      // sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
                                      // sZLEALIAS_ZLECENIEPOZ_OPIS+';'+
                                       sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID,
                                       sWarunek,
                                       True, True );
  try
    if oQuery <> nil then
       PozycjaLookupAliasEditSetData(oQuery);
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;
end;

function TZLEZasobyPracaDBDetailForm.PozycjaLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
     if OpenMode in [omNew, omEdit] then begin
        DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger :=  AliasSrc.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
        PozycjaLookupAliasEdit.Text := AliasSrc.FieldByName(sZLEZLECENIEPOZ_LP).AsString;
     //   AsortymentSymbolDBLookupAliasEdit.InitiateData(StrToIntDef(Parameters.Values[sASOASORT_ID],0));
     end;
  end;
  result  := true;
end;

procedure TZLEZasobyPracaDBDetailForm.AsortymentSymbolDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  if DataManagers.Available(sASOModulID) then begin
    AsortymentSymbolDBLookupAliasEdit.Text := '';
    AsortymentNazwaLabel.Caption := '';
    if OpenMode in [omNew, omEdit] then begin
      DMAQFbN(sASOASORT_ID).Clear;
  //    DMAQFbN(sASOASORT_INDEKS).Clear;
    end;
  end;
end;

function TZLEZasobyPracaDBDetailForm.AsortymentSymbolDBLookupAliasEditGetDataField: String;
begin
  Result := sASOASORT_ID;
end;

function TZLEZasobyPracaDBDetailForm.AsortymentSymbolDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWhere: String;
begin
  result  := nil;
  if not DataManagers.Available(sASOModulID) then Exit;

  if ZLEDM.vZLEAsoReg_ID <= 0 then begin
    Komunikat(cInformation, 'Nie zdefiniowano reguy asortymentowej dla moduu zlece.');
    Exit;
  end;
  if DMAQFbN(sASOASORT_ID).IsNull then begin
    if AsortymentSymbolDBLookupAliasEdit.Text = '' then begin
      sWhere := '';
    end else begin
      sWhere := sASOASORT_SYMBOL + ' LIKE ''' + AsortymentSymbolDBLookupAliasEdit.Text + '%''';
    end;
  end else
    sWhere := '@'+sASOAlias_Asort_ID+'='+IntToStr(DMAQFbN(sASOASORT_ID).AsInteger);
  Result := ASODM.PokazIObsluzAsortyment( sASOAlias_Asort_ID + ';' +
                                          sASOAlias_Asort_Symbol + ';' +
                                          sASOAlias_Asort_Indeks + ';' +
                                          sASOAlias_Asort_Nazwa,
                                          '',
                                          False,
                                          False,
                                          sWhere,
                                          ZLEDM.vZLEAsoReg_ID
                                        );
end;

procedure TZLEZasobyPracaDBDetailForm.AsortymentSymbolDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if DataManagers.Available(sASOModulID) then begin
    with AsortymentSymbolDBLookupAliasEdit do begin
      AliasManager := ASODM.AliasManager;
      Alias_ID := sASOAlias_Asort_ID;
      Alias_Name := sASOAlias_Asort_Symbol;
      AdditionalAliases := sASOAlias_Asort_Indeks + ';' + sASOAlias_Asort_Nazwa;
    end;
  end;
end;

function TZLEZasobyPracaDBDetailForm.AsortymentSymbolDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if DataManagers.Available(sASOModulID) then begin
    if AliasSrc <> nil then begin
      AsortymentNazwaLabel.Caption := AliasSrc.FieldByName(sASOASORT_NAZWA).AsString;
   //   DMAQFbN(sASOASORT_INDEKS).AsString := AliasSrc.FieldByName(sASOASORT_INDEKS).AsString;
    end;
  end;
  Result := True;
end;

procedure TZLEZasobyPracaDBDetailForm.RodzajECPRadioGroupClick(
  Sender: TObject);
var
  s:string;
begin
  inherited;

  if (OpenMode in [omNew, omEdit]) then begin
    case RodzajECPRadioGroup.ItemIndex of
     0: s := cZLERodzajECP_ProdukcjaID;
     1: s := cZLERodzajECP_OsobaID;
     2: s := cZLERodzajECP_ZasobID;
     3: s := cZLERodzajECP_RozliczID;
    end;
    if DMAQFbN(sZLECONST_RODZAJECP_ID).AsString <> s then
       DMAQFbN(sZLECONST_RODZAJECP_ID).AsString := s;

    WyswietlRodzajECP(DMAQFbN(sZLECONST_RODZAJECP_ID).AsString);
  end;

end;

procedure TZLEZasobyPracaDBDetailForm.WyswietlRodzajECP(sRodzajECP: String);
var
  bJestLWP, bJestECP: Boolean;
begin
   bJestLWP := DataManagers.Available(sLWPModulID);
   bJestECP := {DataManagers.Available(sKDPRAModulID) and} (ZLEDM.vZLEWysylanieECPWlaczone or ZLEDM.vZLEWysylanieRozliczECPWlaczone) and (sRodzajECP <> cZLERodzajECP_ProdukcjaID);

  {Wczenie odpowiednich panelw}
  if (sRodzajECP = cZLERodzajECP_OsobaID) or (sRodzajECP = cZLERodzajECP_ZasobID) then begin
    if sRodzajECP = cZLERodzajECP_OsobaID then
         RodzajECPRadioGroup.ItemIndex := 1
    else RodzajECPRadioGroup.ItemIndex := 2;

    ProdukcjaPanel.Visible := False;
    PozycjaZleceniaPanel.Visible := True;
    PozycjaZleceniaPanel.Height := 60;
    if ZLEDM.vZLEWymaganaPozycjaEwid then
       PozycjaLookupAliasEdit.aAllowEmpty := False;

    OpisPanel.Visible := False;
    PozycjaRecepturyPanel.Visible := False;
    OsobaPanel.Visible := True;
    ZasobPanel.Visible := True;
    ZmianaPanel.Visible := False;
    DataDoDBDateEdit.Visible := True;
    DataDoLabel.Visible := True;

    if bJestECP then begin
       SkladnikCzasuPanel.Visible := True;
       SkladnikCzasuPracyDBLookupAliasEdit.aAllowEmpty := False;
    end else begin
       SkladnikCzasuPanel.Visible := False;
       SkladnikCzasuPracyDBLookupAliasEdit.aAllowEmpty := True;
    end;

    StawkaPanel.Visible := True;
    PracaPanel.Visible := True;
    EwidStatusPanel.Visible := True;
    ZuzyciePaliwaPanel.Visible := False;
    ZakladkiPageControl.Visible := False;
    Self.Height := PracaPanel.Height +
                   PozycjaZleceniaPanel.Height +
                   StawkaPanel.Height +
                   ZasobPanel.Height +
                   OsobaPanel.Height +
                   MainPanel.Height +
                   SelectPanel.Height + 40;

    if bJestECP then
       Self.Height := Self.Height + SkladnikCzasuPanel.Height;
  end else
  if sRodzajECP = cZLERodzajECP_RozliczID then begin
    RodzajECPRadioGroup.ItemIndex := 3;
    ProdukcjaPanel.Visible := False;
    PozycjaZleceniaPanel.Visible := True;
    PozycjaZleceniaPanel.Height := 145;
    if ZLEDM.vZLEWymaganaPozycjaEwid then
       PozycjaLookupAliasEdit.aAllowEmpty := False;

    OpisPanel.Visible := True;
    PozycjaRecepturyPanel.Visible := False;
    OsobaPanel.Visible := False;
    ZasobPanel.Visible := True;
    ZmianaPanel.Visible := False;
    DataDoDBDateEdit.Visible := False;
    DataDoLabel.Visible := False;

    if bJestECP then begin
       SkladnikCzasuPanel.Visible := True;
       SkladnikCzasuPracyDBLookupAliasEdit.aAllowEmpty := False;
    end else begin
       SkladnikCzasuPanel.Visible := False;
       SkladnikCzasuPracyDBLookupAliasEdit.aAllowEmpty := True;
    end;

    StawkaPanel.Visible := True;
    PracaPanel.Visible := True;
    EwidStatusPanel.Visible := True;
    ZuzyciePaliwaPanel.Visible := ZLEDM.vZLEZLECENIEROZL_ZUZPALIWA;
    ZakladkiPageControl.Visible := False;

    Self.Height := PracaPanel.Height +
                   PozycjaZleceniaPanel.Height +
                   StawkaPanel.Height +
                   ZasobPanel.Height +
                   MainPanel.Height +
                   SelectPanel.Height + 40;

    if bJestECP then
       Self.Height := Self.Height + SkladnikCzasuPanel.Height;
    if ZLEDM.vZLEZLECENIEROZL_ZUZPALIWA then
        Self.Height :=  Self.Height +  ZuzyciePaliwaPanel.Height;

  end else begin
  //if sRodzajECP = cZLERodzajECP_ProdukcjaID then begin
    RodzajECPRadioGroup.ItemIndex := 0;
    ProdukcjaPanel.Visible := bJestLWP;
    PozycjaZleceniaPanel.Visible := False;

    //Wyczenie wymagalnosci pozycji zlecenia
    PozycjaLookupAliasEdit.aAllowEmpty := True;

    OpisPanel.Visible := False;
    PozycjaRecepturyPanel.Visible := bJestLWP;
    OsobaPanel.Visible := False;
    ZasobPanel.Visible := True;
    ZmianaPanel.Visible := True;
    DataDoDBDateEdit.Visible := False;
    DataDoLabel.Visible := False;

    SkladnikCzasuPanel.Visible := False;
    SkladnikCzasuPracyDBLookupAliasEdit.aAllowEmpty := True;

    StawkaPanel.Visible := False;
    PracaPanel.Visible := True;
    EwidStatusPanel.Visible := True;
    ZuzyciePaliwaPanel.Visible := False;
    ZakladkiPageControl.Visible := True;
    RaportTypPanel.Visible      := bJestLWP;

    if bJestLWP then begin
       Self.Height :=  ProdukcjaPanel.Height +
                       PracaPanel.Height +
                       StawkaPanel.Height +
                       ZasobPanel.Height +
                       ZakladkiPageControl.Height +
                       PozycjaRecepturyPanel.Height +
                       ZmianaPanel.Height+
                       MainPanel.Height +
                       RaportTypPanel.Height +
                       SelectPanel.Height + 40;
    end else begin
       Self.Height := PracaPanel.Height +
                      StawkaPanel.Height +
                      ZasobPanel.Height +
                      ZakladkiPageControl.Height +
                      ZmianaPanel.Height +
                      MainPanel.Height +
                      SelectPanel.Height + 40;
    end;
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.DataDBDateEditDateChange(
  Sender: TObject);
var
  oParams:  TKeyValues;
begin
  UstawOkres(DataDBDateEdit.Date);
  if(m_bOsobyKDECP) then begin
    oParams := TKeyValues.CreateAs([sKDCZAS_DATA + '=' + IntToStr(Trunc(DataDBDateEdit.Date))]);
    KDECPDM.KDECPPodmienParametryGridaCzasuPracyExt(m_oGridOsob, oParams);
    FreeAndNil(oParams);
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.UstawOkres(dData: TDate);
var
  iRokID: Integer;
  q: TUNIQuery;
begin
  if not (OpenMode in [omNew, omEdit]) then Exit;
  iRokID := -1;
  q := UniSysDataManager.UNIPodajRokObrachunkowy(dData, sUNISYSALIAS_Rok_ID);
  try
    if q = Nil then begin
      Komunikat(cInformation, Format('Data "%d" jest niezgodna ze zdefiniowanymi latami obrachunkowymi' ,[dData]));
    end else
      iRokID := q.Fields[0].AsInteger;
  finally
    FreeAndNil(q);
  end;
  q := UNISysDataManager.UNIPodajOkresObrachunkowy(
    iRokID,
    dData,
    sUNISYSALIAS_Okres_Obrachunkowy_ID + ';' + sUNISYSALIAS_Poczatek_Okresu_Obrachunkowego + ';' + sUNISYSALIAS_Koniec_Okresu_Obrachunkowego
  );
  try
    if q = Nil then begin
      Komunikat(cInformation, Format('Data "%d" jest niezgodna ze zdefiniowanymi okresami obrachunkowymi' ,[dData]));
    end else
      if OpenMode in [omNew, omEdit] then
        begin
          DMAQFbN(sUNIOKRES_ID).AsInteger := q.Fields[0].AsInteger;
        end;
  finally
    FreeAndNil(q);
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.PozycjaLookupAliasEditExit(
  Sender: TObject);
var
  oQuery: TUNIQuery;
  sWarunek: String;
begin
  inherited;
  if PozycjaLookupAliasEdit.Text <> '' then begin
     if DMAQFbN(sZLEZLECENIE_ID).IsNull then begin
        Komunikat(cError, 'Brak wypenionego zlecenia');
        if ZlecenieSymbolDBLookupAliasEdit.Enabled then
           ZlecenieSymbolDBLookupAliasEdit.SetFocus();
        Exit;
     end;

     if not (OpenMode in [omEdit, omNew]) then Exit;


     sWarunek := '(@' + sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString +')' +
               ' AND (@' + sZLEALIAS_ZLECENIEPOZ_LP + ' = ' + QuotedStr(Trim(PozycjaLookupAliasEdit.Text))+') ';

     oQuery := ZLEDM.ZLEOdpytajODane( sZLEZLECENIEPOZ,
                                       sZLEALIAS_ZLECENIEPOZ_ID+';'+
                                       sZLEALIAS_ZLECENIEPOZ_LP+';'+
                                      // sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
                                      // sZLEALIAS_ZLECENIEPOZ_OPIS+';'+
                                       sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID,
                                       sWarunek,
                                       True);
     try
       if oQuery <> nil then
          PozycjaLookupAliasEditSetData(oQuery)
       else begin
          Komunikat(cWarning, 'Nie ma takiej pozycji we wskazanym zleceniu');
          if PozycjaLookupAliasEdit.Enabled then PozycjaLookupAliasEdit.SetFocus();
          Exit;
       end;
     finally
       if oQuery <> nil then FreeAndNil(oQuery);
     end;
  end else begin
     PozycjaLookupAliasEdit.OnDelKey(self);
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.PozycjaLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  if OpenMode in [omNew, omEdit] then begin
     DMAQFbN(sZLEZLECENIEPOZ_ID).Clear();
     PozycjaLookupAliasEdit.Text := '';
  end;
end;

procedure TZLEZasobyPracaDBDetailForm.DataDBDateEditEnter(Sender: TObject);
begin
  if(m_bOsobyKDECP) then
    DataDBDateEdit.ReadOnly := (not m_oGridOsob.DataModule.ActiveQuery.IsEmpty());
end;

procedure TZLEZasobyPracaDBDetailForm.RaportTypLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery:   TUNIQuery;
  sAliasy:  string;
  sWarunek: string;
begin
  UNIDajAliasyZLookupa(RaportTypLookupAliasEdit, sAliasy, sWarunek);
  oQuery  := LWPDM.LWPPokazIObsluzDane(sLWPRAPORTPRODTYP,
    sAliasy, sWarunek, false, true, false,
    DMAQFbN(sLWPRAPORTPRODTYP_ID).AsString
  );
  if(oQuery <> nil) then begin
    RaportTypLookupAliasEditSetData(oQuery);
    FreeAndNil(oQuery);
  end;  // if(oQuery <> nil)
end;

procedure TZLEZasobyPracaDBDetailForm.RaportTypLookupAliasEditDelKey(
  Sender: TObject);
begin
  DMAQFbN(sLWPRAPORTPRODTYP_ID).Clear();
  RaportTypLookupAliasEdit.Clear();
  m_sRapotTyp := '';
end;

function TZLEZasobyPracaDBDetailForm.RaportTypLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  DMAQFbN(sLWPRAPORTPRODTYP_ID).AsInteger := AliasSrc.Fields[0].AsInteger;
  m_sRapotTyp := AliasSrc.Fields[0].AsString;
  RaportTypLookupAliasEdit.Text           := AliasSrc.Fields[1].AsString;
  result  := true;
end;

procedure TZLEZasobyPracaDBDetailForm.ZlecenieSymbolDBLookupAliasEditEnter(
  Sender: TObject);
begin
  inherited;
  {if m_bOsobyKDECP then begin
    ZlecenieSymbolDBLookupAliasEdit.aReadOnly := (not m_oGridOsob.DataModule.ActiveQuery.IsEmpty());
    ZlecenieSymbolDBLookupAliasEdit
  end;}
end;

procedure TZLEZasobyPracaDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  SkladnikOpisLabel.Caption := '';
end;

function TZLEZasobyPracaDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditGetDataField: String;
begin
  result := sKDSKLADNIKCZASU_ID;
end;

function TZLEZasobyPracaDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditGetQuery: TUNIQuery;
begin
  Result := nil;
  if not DataManagers.Available(sKDPRAModulID) then Exit;

  Result := KDDM.KDPokazIObsluzDane(sKDSKLADNIKCZASU,
                                     sKDAlias_SKLADNIKCZASU_ID + ';' +
                                     sKDAlias_SKLADNIKCZASU_SYMBOL + ';' +
                                     sKDAlias_SKLADNIKCZASU_NAZWA,
                                     '@' + sKDAlias_SKLADNIKCZASU_ID + ' IN (SELECT ' + sKDSKLADNIKCZASU_ID + ' ' +
                                                                            'FROM ' + SQLManager.GetTableName(sZLESKLADNIKIECPDEF) + ') AND '
                                                                            + sKDSKLADNIKCZASU_TYPPOLA1 + ' = ' + QuotedStr(sTYPPOLA_GODZINY),
                                     true,
                                     false,
                                     UNISYSDM.vAktywnaFirma);
end;

procedure TZLEZasobyPracaDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if DataManagers.Available(sKDPRAModulID) then begin
    with SkladnikCzasuPracyDBLookupAliasEdit do begin
      AliasManager := KDDM.AliasManager;
      Alias_ID := sKDAlias_SKLADNIKCZASU_ID;
      Alias_Name := sKDAlias_SKLADNIKCZASU_SYMBOL;
      AdditionalAliases := sKDAlias_SKLADNIKCZASU_NAZWA;
      AdditionalCondition := '@' + sKDAlias_SKLADNIKCZASU_ID + ' IN (SELECT ' + sKDSKLADNIKCZASU_ID + ' ' +
                                                                    'FROM ' + SQLManager.GetTableName(sZLESKLADNIKIECPDEF) + ') AND '
                                                                            + sKDSKLADNIKCZASU_TYPPOLA1 + ' = ' + QuotedStr(sTYPPOLA_GODZINY);
    end;
  end;
end;

function TZLEZasobyPracaDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  if AliasSrc <> nil then begin
     SkladnikOpisLabel.Caption := AliasSrc.FieldByName(sKDSKLADNIKCZASU_NAZWA).AsString;
  end;
  result := True;
end;

initialization
  FormManager.RegisterForm(TZleZasobyPracaDBDetailForm, 'Rejestracja czasu pracy zasobw', sZLEModulID);
end.
